/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2006-2015 by GJ Business Division
 *                   RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2016-2019 by TOPPERS PROJECT Educational Working Group.
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

#ifndef _COMDEFS_H_
#define _COMDEFS_H_
#include <sys_defs.h>

/*
 *	comdefs.h -- rom Monitor Common Definitions
 */

/*	Prompt		*/

#define ERROR_PROMPT		'?'

/*	Command Mode	*/

#define CMDMODE_ADDR		'a'
#define CMDMODE_ENTER		'e'
#define CMDMODE_DUMP		'd'

/*	Data Size	*/

#define DATA_SIZE_BYTE		1
#define DATA_SIZE_WORD		2
#define DATA_SIZE_LONG		4

/*	Command		*/

#define COMMAND_END		'.'
#define CMDSTR_HELP		('?' << 8)	/* help */

/*	Error Code	*/

#define ERR_NO_COMMAND		0x01

#ifndef _MACRO_ONLY
/*
 *  Type Definitions
 */
#ifdef _int8_
typedef	_int8_				VB;		/* ޤʤ8ӥåȤ */
#endif /* _int8_ */
#ifdef _int16_
typedef	unsigned _int16_ 	UH;		/* ̵16ӥå */
typedef	_int16_				VH;		/* ޤʤ16ӥåȤ */
#endif /* _int16_ */
typedef	unsigned _int32_	UW;		/* ̵32ӥå */
typedef	_int32_				VW;		/* ޤʤ32ӥåȤ */
typedef	void				*VP;	/* ޤʤΤؤΥݥ */
typedef unsigned int		UINT;	/* ʥ̵ */


/*
 *	External Functions
 */

extern void Disable(void);
extern void Enable(void);
#if defined(NOT_DEFVECTORTYPE) || defined(USE_EXECDISABLE)
extern void execDisable(void);
#else
#define execDisable()
#endif
extern void SetVector(void *v);

extern unsigned char Byte2HexASCII(unsigned char c);
extern unsigned long HexASCII2Long(char **ps, int size);
extern void SendCharCount(char c, int count);
extern void SkipBlanks(char **ps);
extern char *ReciveLine(int sid, int rid);
extern void InitRecLine(int id);
extern void MoveLongInc(unsigned long *d, unsigned long *s, int len);

#endif	/* _MACRO_ONLY */
#endif	/* of #ifndef _COMDEFS_H_ */
