/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2015-2017 by TOPPERS PROJECT Educational Working Group.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: sdcard.c,v 1.0 2016/11/05 15:24:33 roi Exp $
 */
/*
 *  CycolneV HPS SDMMCɥ饤
 */
#include "sys_defs.h"
#include <string.h>
#include "sil.h"
#include "sdmmc.h"

#define sil_orw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) | (b))
#define sil_andw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) & ~(b))
#define sil_modw_mem(a, b, c)	sil_wrw_mem((a), (sil_rew_mem(a) & (~b)) | (c))

#define MIN(a, b) ((a) > (b) ? (b) : (a))

#ifndef SDMMC_CLOCK
#define SDMMC_CLOCK                     200000000
#endif
#ifndef SDMMC_REQUEST_BPS
#define SDMMC_REQUEST_BPS               12500000
#endif

/*
 *  ꥻåȥޥ͡㡼ѥॢ
 */
#define SDMMC_RESET_TMO_INIT            8192

/*
 *  SDMMC⥸塼ꥻåѥॢ
 */
#define SDMMC_MAX_T_POLL_COUNT          8192
#define SDMMC_TMO_WAITER                500
#define SDMMC_CMDTIMEOUT                1000
#define SD_MAX_VOLT_TRIAL               0x0000FFFF

#define SDMMC_BLOCKSIZE                 512
#define SDMMC_DMA_SEGMENT_SIZE          SDMMC_BLOCKSIZE
#define SDMMC_DMA_DESC_COUNT            64

/*
 *  RESPONSE1顼
 */
#define SD_OCR_ERROR                    0xFDFFE008

/*
 *  ɥ
 */
#define SD_HIGH_CAPACITY                0x40000000
#define SD_STD_CAPACITY                 0x00000000

/*
 *  
 */
#define SDMMC_INT_STATUS_ALL            0x0001FFFF
#define SDMMC_DMA_INT_STATUS_ALL        0x00000337

/*
 *  SD-CARDǡĹ
 */
#define SCR_LENGTH                      8
#define SYSTEM_STATUS_LENGTH            64

/*
 *  FIFOΥȥꥣ
 */
#define SDMMC_FIFO_NUM_ENTRIES          1024
#define SDMMC_DESC_COUNT                ((SDMMC_FIFO_NUM_ENTRIES*4)/SDMMC_BLOCKSIZE)

/*
 *  WRITEԤ
 */
#define SDMMC_WRITE_DELAY_TIME          30	/* ms */


#define CCC_CLASS_10                    (1<<10)

#define SDMMC_CSD_SPEED_RATE_MSK        0x00000007
#define SDMMC_CSD_SPEED_TIME_MSK        0x00000078
#define SDMMC_CSD_CCC_MSK               0xFFF00000
#define SDMMC_CSD_SPEED_RATE_GET(val)   ((val & SDMMC_CSD_SPEED_RATE_MSK) >> 0)
#define SDMMC_CSD_SPEED_TIME_GET(val)   ((val & SDMMC_CSD_SPEED_TIME_MSK) >> 3)
#define SDMMC_CSD_CCC_GET(val)          ((val & SDMMC_CSD_CCC_MSK) >> 20)

#define SDMMC_SWITCH_FUNC_MODE_CHECK    (0UL << 31)

#define SDMMC_HIGH_SPEED_BUS_SPEED      1
#define SDMMC_UHS_SDR25_BUS_SPEED       1
#define SDMMC_UHS_SDR50_BUS_SPEED       2
#define SDMMC_UHS_SDR104_BUS_SPEED      3
#define SDMMC_UHS_DDR50_BUS_SPEED       4

#define SDMMC_SD_MODE_HIGH_SPEED        (1 << SDMMC_HIGH_SPEED_BUS_SPEED)
#define SDMMC_SD_MODE_UHS_SDR25         (1 << SDMMC_UHS_SDR25_BUS_SPEED)
#define SDMMC_SD_MODE_UHS_SDR50         (1 << SDMMC_UHS_SDR50_BUS_SPEED)
#define SDMMC_SD_MODE_UHS_SDR104        (1 << SDMMC_UHS_SDR104_BUS_SPEED)
#define SDMMC_SD_MODE_UHS_DDR50         (1 << SDMMC_UHS_DDR50_BUS_SPEED)

#define SDMMC_DMA_PBL_1                 0x0		/* 1 transfer unit    */
#define SDMMC_DMA_PBL_4                 0x1		/* 4 transfer units   */
#define SDMMC_DMA_PBL_8                 0x2		/* 8 transfer units   */
#define SDMMC_DMA_PBL_16                0x3     /* 16 transfer units  */
#define SDMMC_DMA_PBL_32                0x4		/* 32 transfer units  */
#define SDMMC_DMA_PBL_64                0x5		/* 64 transfer units  */
#define SDMMC_DMA_PBL_128               0x6		/* 128 transfer units */
#define SDMMC_DMA_PBL_256               0x7		/* 256 transfer units */


static uint8_t               sbuffer[128] __attribute__ ((aligned (CACHE_LINE_SIZE)));

static SDMMC_Handle_t SDHandle;

#define ALT_SDMMC_DMA_BUF_DESC_CACHE_SIZE (((SDMMC_DMA_DESC_COUNT*sizeof(SDMMC_DMA_BUF_DESC_t)) + CACHE_LINE_SIZE - 1) & ~(CACHE_LINE_SIZE-1))

static ER sdmmc_sendcommand(SDMMC_Handle_t *hsd, uint32_t cmd, uint32_t arg, ER (*func)(SDMMC_Handle_t *, uint32_t));
static ER sdmmc_checkrep1(SDMMC_Handle_t *hsd, uint32_t Cmd);
static ER sdmmc_checkrep2(SDMMC_Handle_t *hsd, uint32_t Cmd);
static ER sdmmc_checkrep3(SDMMC_Handle_t *hsd, uint32_t Cmd);
static ER sdmmc_checkrep6(SDMMC_Handle_t *hsd, uint32_t Cmd);
static ER sdmmc_cmd_wait(SDMMC_Handle_t *hsd);

/*
 *  SDMMCåͭȽ
 */
static bool_t
sdmmc_clk_is_enabled(void)
{
	bool_t status = sil_rew_mem((uint32_t *)(TADR_CLKMGR_PERPLL_BASE+TOFF_CLKMGR_PERPLL_EN));

	if((status & CLKMGR_PERPLL_EN_SDMMCCLK) != 0)
		return true;
	else
		return false;
}


/*
 *  DMA̵
 */
static void
sdmmc_dma_disable(SDMMC_Handle_t *hsd)
{
	if(hsd->dma_enable){
		sil_andw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_CTL), SDMMC_CTL_USE_INTERNAL_DMAC);
		sil_andw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_BMOD), SDMMC_BMOD_DE);
		hsd->dma_enable = false;
	}
}

/*
 *  SD/MMCѥ֥å
 */
static bool_t
sdmmc_card_pwr_is_on(SDMMC_Handle_t *hsd)
{
	if((sil_rew_mem((uint32_t *)(hsd->base+TOFF_SDMMC_PWREN)) & SDMMC_PWREN_POWER_EN) != 0)
		return true;
	else
		return false;
}

/*
 *  SDMMCѥա
 */
static void
sdmmc_card_pwr_off(SDMMC_Handle_t *hsd)
{
	if(!sdmmc_card_pwr_is_on(hsd))
		return;

	/*
	 *  SD/MMC_enableꥢ
	 */
	sil_andw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_PWREN), SDMMC_PWREN_POWER_EN);

	/*
	 *  SDMMCߥơꥢ
	 */
	sil_wrw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_RINTSTS), SDMMC_INT_STATUS_ALL);

	/*
	 *  RCAΰ򥯥ꥢ
	 */
	hsd->RCA = 0;
}

/*
 *  ƥ ɡǡӥ
 */
static bool_t
sdmmc_is_busy(SDMMC_Handle_t *hsd)
{
	if((sil_rew_mem((uint32_t *)(hsd->base+TOFF_SDMMC_STAT)) & SDMMC_STAT_DATA_BUSY) != 0)
		return true;
	else
		return false;
}

/*
 *  ƥ ɡɥ
 */
static bool_t
sdmmc_is_idle(SDMMC_Handle_t *hsd)
{
	uint32_t mmc_state = sil_rew_mem((uint32_t *)(hsd->base+TOFF_SDMMC_STAT)) & SDMMC_STAT_CMD_FSM_STATES;
	uint32_t dma_state = sil_rew_mem((uint32_t *)(hsd->base+TOFF_SDMMC_IDSTS)) & SDMMC_IDSTS_FSM;

    if(mmc_state != 0 || dma_state != 0)
		return false;
	else
		return true;
}

/*
 *  åե졼
 */
static ER
sdmmc_card_clk_div_set(SDMMC_Handle_t *hsd, const uint32_t clk_div)
{
    uint32_t low_power_mode;
    ER ercd = E_OK;

    if(sdmmc_is_busy(hsd))
		return E_SYS;

	/*
	 *  ѥå֤
	 */
	low_power_mode = sil_rew_mem((uint32_t *)(hsd->base+TOFF_SDMMC_CLKENA)) & SDMMC_CLKENA_CCLK_LOW_POWER;

    /*
	 *  cclk_enableӥå̵
	 */
	sil_wrw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_CLKENA), 0);
	ercd = sdmmc_sendcommand(hsd, MCI_CLK, 0x0, NULL);
	if(ercd != E_OK){
		sys_printf("SDMMC:alt_sdmmc_card_clk_disable failed\n");
		return ercd;
	}

	/*
	 *  sdmmc_clk_enable̵
	 */
	sil_andw_mem((uint32_t *)(TADR_CLKMGR_PERPLL_BASE+TOFF_CLKMGR_PERPLL_EN), CLKMGR_PERPLL_EN_SDMMCCLK);

	/*
	 *  drvsel samplsel
	 */
    if(clk_div == 0){
        /*  50 MHz*/
		sil_wrw_mem((uint32_t *)(TADR_SYSMGR_BASE+TOFF_SYSMGR_SDMMC_CTL),
									SYSMGR_SDMMC_CTL_SMPLSEL_E_DEGREES90 | SYSMGR_SDMMC_CTL_DRVSEL_E_DEGREES90);
	}
	else{
        /*  25MHz and lower*/
		sil_wrw_mem((uint32_t *)(TADR_SYSMGR_BASE+TOFF_SYSMGR_SDMMC_CTL),
									SYSMGR_SDMMC_CTL_SMPLSEL_E_DEGREES180 | SYSMGR_SDMMC_CTL_DRVSEL_E_DEGREES180);
	}

    /*
	 *  sdmmc_clk_enableͭ
	 */
	sil_orw_mem((uint32_t *)(TADR_CLKMGR_PERPLL_BASE+TOFF_CLKMGR_PERPLL_EN), CLKMGR_PERPLL_EN_SDMMCCLK);
	sil_wrw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_CLKDIV), (clk_div & SDMMC_CLKDIV_CLK_DIVR0));

    /*
	 * å֥͡
	 */
	sil_wrw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_CLKENA), low_power_mode | SDMMC_CLKENA_CCLK_EN);
	return sdmmc_sendcommand(hsd, MCI_CLK, 0x0, NULL);
}


/*
 *  SD̵ͭå
 */
bool_t
sdmmc_sense(int id)
{
	SDMMC_Handle_t *hsd = &SDHandle;

	if(hsd->status == SDMMC_STATUS_NONE)
		return false;
	if((sil_rew_mem((uint32_t *)(TADR_SDMMC1_BASE+TOFF_SDMMC_STAT)) & SDMMC_STAT_DATA_3_STAT) != 0)
		return true;
	else if(hsd->status == SDMMC_STATUS_ACTIVATE)
		return true;
	else
		return false;
}

/*
 *  SDMMC
 *  parameter1  ̤
 */
void
sdmmc_init(intptr_t exinf)
{
	memset(&SDHandle, 0, sizeof(SDMMC_Handle_t));
    if(!sdmmc_clk_is_enabled()){
		sys_printf("SDMMC:sdmmc_init: no clock !\n");
		return;
    }
	SDHandle.base   = TADR_SDMMC1_BASE;
	SDHandle.status = SDMMC_STATUS_INIT;
}

/*
 *  SDMMCλ
 */
void
sdmmc_deinit(int id)
{
    /*
	 *  SD/MMC⥸塼ꥻå
	 */
	sil_orw_mem((uint32_t *)(TADR_RSTMGR_BASE+TOFF_RSTMGR_PERMODRST), RSTMGR_PERMODRST_SDMMC);
	SDHandle.status = SDMMC_STATUS_NONE;
}

/*
 *  SDMMC饤ȥץƥȽ
 *  parameter1  SDɥϥɥ
 *  result      if true, write protected.
 */
bool_t
sdmmc_card_is_write_protected(SDMMC_Handle_t *hsd)
{
	if((sil_rew_mem((uint32_t *)(hsd->base+TOFF_SDMMC_WRTPRT)) & SDMMC_WRTPRT_WR_PROTECT) != 0)
		return true;
	else
		return false;
}

/*
 *  SD/MMCХ
*/
static void
sdmmc_bus_width_set(SDMMC_Handle_t *hsd, uint16_t width)
{
	switch (width){
	case SDMMC_BUS_WIDE_8B:
		sil_wrw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_CTYPE), SDMMC_CTYPE_CARD_WIDTH1);
		break;
	case SDMMC_BUS_WIDE_4B:
		sil_wrw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_CTYPE), SDMMC_CTYPE_CARD_WIDTH2);
		break;
	case SDMMC_BUS_WIDE_1B:
		sil_wrw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_CTYPE), 0x0);
		break;
	default:
		break;
    }
}

/*
 *  ֥å
 */
static uint16_t
sdmmc_block_size_get(SDMMC_Handle_t *hsd)
{
	return (sil_rew_mem((uint32_t *)(hsd->base+TOFF_SDMMC_BLKSIZ)) & SDMMC_BLKSIZ_BLOCK_SIZE);
}

/*
 *  ֥å
 */
static void
sdmmc_block_size_set(SDMMC_Handle_t *hsd, uint16_t block_size)
{
	sil_wrw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_BLKSIZ), (block_size & SDMMC_BLKSIZ_BLOCK_SIZE));
}

/*
 *  žХȿ
 */
static void
sdmmc_byte_count_set(SDMMC_Handle_t *hsd, uint32_t count)
{
	sil_wrw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_BYTCNT), count);
}

/*
 *  FIFOꥻå
 */
static ER
sdmmc_fifo_reset(SDMMC_Handle_t *hsd)
{
    uint32_t timeout = SDMMC_MAX_T_POLL_COUNT;

	/*
	 *  ꥻå׵
	 */
	sil_orw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_CTL), SDMMC_CTL_FIFO_RST);

    /*
	 *  ꥻåȽλԤ
	 */
	while((sil_rew_mem((uint32_t *)(hsd->base+TOFF_SDMMC_CTL)) & SDMMC_CTL_FIFO_RST) != 0){
		timeout--;
		if(timeout == 0)
			return E_TMOUT;
	}
	return E_OK;
}

/*
 *  FIFOȤ֤
 */
static int32_t
sdmmc_fifo_count(SDMMC_Handle_t *hsd)
{
	int32_t fifocount = sil_rew_mem((uint32_t *)(hsd->base+TOFF_SDMMC_STAT));
	return (fifocount & SDMMC_STAT_FIFO_COUNT) >> 17;
}


/*
 *  硼ȥ쥹ݥ󥹤Ф
 */
static uint32_t
sdmmc_read_short_response(SDMMC_Handle_t *hsd)
{
	return sil_rew_mem((uint32_t *)(hsd->base+TOFF_SDMMC_RESP0));
}

/*
 *  󥰥쥹ݥ󥹤Ф
 */
static void
sdmmc_read_long_response(SDMMC_Handle_t *hsd, uint32_t *response)
{
	response[3] = sil_rew_mem((uint32_t *)(hsd->base+TOFF_SDMMC_RESP0));
	response[2] = sil_rew_mem((uint32_t *)(hsd->base+TOFF_SDMMC_RESP1));
	response[1] = sil_rew_mem((uint32_t *)(hsd->base+TOFF_SDMMC_RESP2));
	response[0] = sil_rew_mem((uint32_t *)(hsd->base+TOFF_SDMMC_RESP3));
}

/*
 *  ɤ߹ߥåۡ
 */
static void
sdmmc_card_rd_threshold_enable(SDMMC_Handle_t *hsd, uint32_t threshold)
{
	uint32_t temp = (threshold << 16) & SDMMC_CARDTHRCTL_CARDRDTHRESHOLD;
	sil_wrw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_CARDTHRCTL), (temp | SDMMC_CARDTHRCTL_CARDRDTHREN));
}

/*
 *  SRCɤ߹
 */
static ER
sdmmc_card_scr_get(SDMMC_Handle_t *hsd, uint32_t* scr_reg)
{
    ER ercd = E_OK;
    uint16_t prev_blk_size = sdmmc_block_size_get(hsd);

	sdmmc_block_size_set(hsd, SCR_LENGTH);
	sdmmc_byte_count_set(hsd, SCR_LENGTH);

	/*
	 *  FIFOꥻå
	 */
    ercd = sdmmc_fifo_reset(hsd);
	if(ercd != E_OK)
		return ercd;

    sdmmc_card_rd_threshold_enable(hsd, SCR_LENGTH/4);
	hsd->pBuffPtr  = sbuffer;
	hsd->XferCount = SCR_LENGTH;

    /*
	 *  CMD55(ڥ׵)
	 */
	ercd = sdmmc_sendcommand(hsd, MCI_CMD55, (hsd->RCA << 16), sdmmc_checkrep1);
	if(ercd != E_OK)
		return ercd;

    /*
	 *  ACMD51(ž׵)
	 */
	ercd = sdmmc_sendcommand(hsd, MCI_ACMD51, 0, sdmmc_checkrep1);
	if(ercd != E_OK)
		return ercd;

	/*
	 *  ǡžλԤ
	 */
    ercd = sdmmc_wait_transfar(hsd, SDMMC_CMDTIMEOUT);
	if(ercd != E_OK)
		return ercd;
	memcpy(scr_reg, sbuffer, SCR_LENGTH);

	/*
	 *  ֥åꥹȥ
	 */
    sdmmc_block_size_set(hsd, prev_blk_size);
	return ercd;
}

/*
 *  ֥å
 */
static ER
sdmmc_card_block_size_set(SDMMC_Handle_t *hsd, const uint16_t blocksize)
{
	ER ercd = E_OK;
	/*
	 *  CMD16:֥å
	 */
	ercd = sdmmc_sendcommand(hsd, MCI_CMD16, (uint32_t)blocksize, sdmmc_checkrep1);
    if(ercd != E_OK)
		return ercd;

	/*
	 *  ȥ֥å
	 */
	sdmmc_block_size_set(hsd, blocksize);
	return ercd;
}

/*
 *  åե󥯥
 */
static ER
sdmmc_card_switch_function(SDMMC_Handle_t *hsd, uint32_t function_arg, uint8_t * switch_status)
{
	ER ercd = E_OK;
	uint16_t prev_blk_size = sdmmc_block_size_get(hsd);

	/*
	 *  ֥åȥХȥȤ64
	 */
	sdmmc_block_size_set(hsd, SYSTEM_STATUS_LENGTH);
	sdmmc_byte_count_set(hsd, SYSTEM_STATUS_LENGTH);

	/*
	 *  FIFOꥻå
	 */
	ercd = sdmmc_fifo_reset(hsd);
	if(ercd != E_OK)
		return ercd;

    sdmmc_card_rd_threshold_enable(hsd, SYSTEM_STATUS_LENGTH/4);
	hsd->pBuffPtr  = sbuffer;
	hsd->XferCount = SYSTEM_STATUS_LENGTH;

	/*
	 *  CMD6
	 */
	ercd = sdmmc_sendcommand(hsd, MCI_CMD6, function_arg, sdmmc_checkrep1);
	if(ercd != E_OK)
		return ercd;

	/*
	 *  žλԤ
	 */
    ercd = sdmmc_wait_transfar(hsd, SDMMC_CMDTIMEOUT);
    sdmmc_block_size_set(hsd, prev_blk_size);
	return ercd;
}

/*
 *  SDMMCץ
 */
SDMMC_Handle_t *
sdmmc_open(int id)
{
	ER ercd = E_OK;
	SDMMC_Handle_t *hsd = &SDHandle;
	volatile uint32_t timeout = SDMMC_RESET_TMO_INIT;
	uint32_t validvoltage = 0;
    uint32_t response = 0;
	uint32_t sdtype = SD_STD_CAPACITY;
    uint32_t clk_div = SDMMC_CLOCK / (4 * 2 * SDMMC_REQUEST_BPS);

    if(sdmmc_clk_is_enabled() != true){
		return NULL;
    }

	hsd->base       = TADR_SDMMC1_BASE;
    hsd->cardtype   = SD_CARD_NOTDETECT;
	hsd->BusWide    = SDMMC_BUS_WIDE_4B;
	hsd->RetryCount = 32;
	hsd->ErrorCode  = 0;
	hsd->RCA        = 0;
	hsd->istatus    = 0;
	hsd->SdCmd      = 0;
	hsd->dma_enable = false;

    /*
	 *  SDŸ
	 */
    if(sdmmc_card_pwr_is_on(hsd)){
        sdmmc_card_pwr_off(hsd);
    }

    /*
	 *  SD/MMC⥸塼ꥻå
	 */
	sil_orw_mem((uint32_t *)(TADR_RSTMGR_BASE+TOFF_RSTMGR_PERMODRST), RSTMGR_PERMODRST_SDMMC);
    /*  Wait while SD/MMC module is reseting*/
    while (timeout--)
        ;
	sil_andw_mem((uint32_t *)(TADR_RSTMGR_BASE+TOFF_RSTMGR_PERMODRST), RSTMGR_PERMODRST_SDMMC);

	/*
	 *  ɡѥ
	 */
	sil_orw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_PWREN), SDMMC_PWREN_POWER_EN);

	/*
	 *  SD/MMC DMA̵
	 */
	sdmmc_dma_disable(hsd);

    /* Enable default clock for alt_sdmmc_command_send to work*/
	sil_wrw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_CLKENA), SDMMC_CLKENA_CCLK_EN);
	ercd = sdmmc_sendcommand(hsd, MCI_CLK, 0x0, NULL);

    /*
	 *  Х򣱤
	 */
    sdmmc_bus_width_set(hsd, SDMMC_BUS_WIDE_1B);

    ercd = sdmmc_card_clk_div_set(hsd, clk_div);
	if(ercd != E_OK){
		sys_printf("SDMMC:sdmmc_card_clk_div_set failed\n");
		return NULL;
    }

	/*
	 *  CMD0: GO IDLE STATE
	 */
	ercd = sdmmc_sendcommand(hsd, MCI_CMD0, 0x0, NULL);
	if(ercd != E_OK)
		return NULL;
	ercd = sdmmc_cmd_wait(hsd);
	if(ercd != E_OK){
		sys_printf("SDMMC:open go command failed\n");
		return NULL;
	}

	/*
	 *  CMD8: SEND IF COND
	 */
	ercd = sdmmc_sendcommand(hsd, MCI_CMD8, 0x1AA, sdmmc_checkrep1);
	if(ercd != E_OK)
		hsd->ErrorCode = SDMMC_ERROR_NONE;
	else{
        response = sdmmc_read_short_response(hsd);
		if(response == 0x1AA){
            hsd->cardtype = SD_CARD_V20;
			sdtype        = SD_HIGH_CAPACITY;
		}
	}

    timeout = SD_MAX_VOLT_TRIAL;
	/*
	 * CMD55
	 */
	ercd = sdmmc_sendcommand(hsd, MCI_CMD55, 0, sdmmc_checkrep1);
	if(ercd == E_OK){
		/*
		 *  SDCARD:VOLTAGEγǧ
		 */
		while(validvoltage == 0 && timeout > 0){
			/* SEND CMD55 APP_CMD with RCA as 0 */
			ercd = sdmmc_sendcommand(hsd, MCI_CMD55, 0, sdmmc_checkrep1);
			if(ercd != E_OK){
				return NULL;
			}
			/*
			 * 0x8010000CMD41
			 */
			ercd = sdmmc_sendcommand(hsd, MCI_ACMD41, (0x80100000 | sdtype), sdmmc_checkrep3);
			if(ercd != E_OK){
				return NULL;
			}
			/*
			 * 쥹ݥ󥹤ܥơ
			 */
			response = sdmmc_read_short_response(hsd);
			validvoltage = (((response >> 31) == 1) ? 1 : 0);
			timeout--;
		}
		if(timeout == 0){
			sys_printf("SDMMC:open voltale timeout failed\n");
			return NULL;
		}

		if((response & SD_HIGH_CAPACITY) == SD_HIGH_CAPACITY){
			/*
			 *  HC-SDCARD
			 */
			hsd->cardtype = SD_CARD_HC;
		}
	}
	if(ercd != E_OK)
		return NULL;
	hsd->status = SDMMC_STATUS_READY;
	return hsd;
}

/*
 *  SDMMC
 */
ER
sdmmc_close(SDMMC_Handle_t *hsd)
{
	if(hsd == NULL)
		return E_PAR;

	/*
	 *  SDMMC߶ػ
	 */
	sil_andw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_INTMSK), SDMMC_INT_STATUS_ALL);
	sdmmc_dma_disable(hsd);

    /*
	 *  CardŸ
	 */
    sdmmc_card_pwr_off(hsd);
	hsd->status = SDMMC_STATUS_INIT;
    return E_OK;
}

/*
 *  CIDμ
 *  SDCMD2,MMCCMD1Υ쥹ݥ󥹼
 *  parameter1  hsd: SDMMCϥɥ
 *  return      ER
 */
ER
sdmmc_checkCID(SDMMC_Handle_t *hsd)
{
	ER ercd  = E_OK;
	uint32_t i;

	if(hsd->cardtype == SD_IO_CARD)
		return E_OK;
	for(i = 0 ; i < hsd->RetryCount ; i++){
	    /*
		 *  CMD2
		 */
		ercd = sdmmc_sendcommand(hsd, MCI_CMD2, 0, sdmmc_checkrep2);
		if(ercd == E_OK){
		    sdmmc_read_long_response(hsd, &hsd->CID[0]);
			return E_OK;
		}
		sil_dly_nse(2000);
	}
	return ercd;
}

/*
 *  Хɥ쥹(RCA)μ
 *  parameter1  hsd: SDMMCϥɥ
 *  return      ER
 */
ER
sdmmc_setaddress(SDMMC_Handle_t *hsd)
{
	ER ercd = E_OK;
	int i;
	if(hsd->cardtype == SD_CARD_V11 || hsd->cardtype == SD_CARD_V20 ||
		hsd->cardtype == SD_IO_COMBO_CARD || hsd->cardtype == SD_CARD_HC){

		for(i = 0 ; i < hsd->RetryCount ; i++){
			/*
			 *  CMD3RCA
			 */
			ercd = sdmmc_sendcommand(hsd, MCI_CMD3, 0, sdmmc_checkrep6);
			if(ercd == E_OK){
			    /*
				 *  CMD10CID
				 */
				ercd = sdmmc_sendcommand(hsd, MCI_CMD10, (hsd->RCA << 16), sdmmc_checkrep1);
				return E_OK;
			}
			sil_dly_nse(2000);
		}
	}
    hsd->RCA = 1;
	return ercd;
}

/*
 *  CSD(Card Specific DATA)μ
 *  parameter1  hsd: SDMMCϥɥ
 *  return      ER
 */
ER
sdmmc_sendCSD(SDMMC_Handle_t *hsd)
{
	ER ercd = E_OK;
	int i;

	if(hsd->cardtype == SD_IO_CARD)
		return E_OK;
	for(i = 0 ; i < hsd->RetryCount ; i++){
		/*
		 *  CMD9CSD׵
		 */
		ercd = sdmmc_sendcommand(hsd, MCI_CMD9, (uint32_t)(hsd->RCA << 16), sdmmc_checkrep2);
		if(ercd == E_OK){
			/*
			 *  CSD
			 */
		    sdmmc_read_long_response(hsd, &hsd->CSD[0]);
			return E_OK;
		}
		sil_dly_nse(2000);
	}
    return ercd;
}

/*
 *  SDɤξ
 *  parameter1  hsd: SDMMCϥɥ
 *  parameter2  pCardInfo: ɥե¤ΤؤΥݥ
 *  return      ER
 */
ER
sdmmc_getcardinfo(SDMMC_Handle_t *hsd, SDMMC_CardInfo_t *pCardInfo)
{
	uint32_t rate_unit;
	uint32_t time_val;
	ER ercd = E_OK;
	uint32_t devicesize;
	uint8_t  blocklen, mul;

	hsd->CCC  = SDMMC_CSD_CCC_GET(hsd->CSD[1]);
    rate_unit = SDMMC_CSD_SPEED_RATE_GET(hsd->CSD[0]);
    time_val  = SDMMC_CSD_SPEED_TIME_GET(hsd->CSD[0]);
	if(time_val == 0 || rate_unit > 3)
		return E_SYS;

	pCardInfo->cardtype = (uint8_t)(hsd->cardtype);
	pCardInfo->RCA      = (uint16_t)(hsd->RCA);

	if(hsd->cardtype == SD_CARD_V11 || hsd->cardtype == SD_CARD_V20){
		/* ֥åĹ */
		blocklen       = (uint8_t)((hsd->CSD[1] & 0x000F0000) >> 16);
		devicesize = (hsd->CSD[1] & 0x000003FF) << 2;
		devicesize |= (hsd->CSD[2] & 0xC0000000) >> 30;
		mul = (hsd->CSD[2] & 0x00038000) >> 15;
		pCardInfo->capacity  = (devicesize + 1) ;
		pCardInfo->capacity *= (1 << (mul + 2));
		pCardInfo->blocksize = 1 << (blocklen);
		pCardInfo->capacity *= pCardInfo->blocksize;
	}
	else if(hsd->cardtype == SD_CARD_HC){
		devicesize = (hsd->CSD[1] & 0x0000003F) << 16;
		devicesize |= (hsd->CSD[2] & 0xFFFF0000) >> 16;
		pCardInfo->capacity  = (uint64_t)(devicesize + 1) << 19 /* 512 * 1024*/;
		pCardInfo->blocksize = SDMMC_BLOCKSIZE;
	}
	else{
		pCardInfo->capacity  = 0;
		pCardInfo->blocksize = SDMMC_BLOCKSIZE;
		ercd = E_OBJ;
	}

	pCardInfo->maxsector = pCardInfo->capacity / SDMMC_BLOCKSIZE;
	pCardInfo->status    = (uint8_t)((hsd->CSD[3] >> 8) & 0xff);
	hsd->block_size      = pCardInfo->blocksize;
	return ercd;
}

/*
 *  SELECT_CARDޥɤ
 *  parameter1  hsd: SDMMCϥɥ
 *  return      ER
 */
ER
sdmmc_select_card(SDMMC_Handle_t *hsd, uint64_t addr)
{
	ER  ercd = E_OK;
	int i;

	for(i = 0 ; i < hsd->RetryCount ; i++){
		/*
		 *  CMD7 ɥ쥯
		 */
		ercd = sdmmc_sendcommand(hsd, MCI_CMD7, (uint32_t)addr, sdmmc_checkrep1);
		if(ercd == E_OK)
			return E_OK;
		sil_dly_nse(2000);
	}
	return ercd;
}

/*
 *  SDMMCե졼
 *  parameter1  hsd: SDMMCϥɥ
 *  return      ER
 */
ER
sdmmc_configuration(SDMMC_Handle_t *hsd)
{
	ER ercd = E_OK;
	int i;

	for(i = 0 ; i < hsd->RetryCount ; i++){
		/*
		 *  CMD13 ơ
		 */
		ercd = sdmmc_sendcommand(hsd, MCI_CMD13, (hsd->RCA << 16), sdmmc_checkrep1);
	    if(ercd == E_OK)
			break;
		sil_dly_nse(2000);
    }
	if(ercd != E_OK)
		return ercd;

	/*
	 *  SRCɤ߹
	 */
	ercd = sdmmc_card_scr_get(hsd, &hsd->SCR[0]);
	if(ercd != E_OK)
		return ercd;

	/*
	 *  CCCǧ
	 */
	hsd->high_speed = false;
	if(!(hsd->CCC & CCC_CLASS_10))	/*  version 1.01 or ! Class 10*/
        return E_OK;

	/*
	 *  åơ
	 */
	ercd = sdmmc_card_switch_function(hsd, SDMMC_SWITCH_FUNC_MODE_CHECK, sbuffer);
	if(ercd == E_OK){
		if(sbuffer[13] & SDMMC_SD_MODE_HIGH_SPEED){
			hsd->high_speed = true;
		}
	}
	return E_OK;
}

/*
 *  WIDE BUS
 *  parameter1  hsd: SDMMCϥɥ
 *  return      ER
 */
ER
sdmmc_set_widebus(SDMMC_Handle_t *hsd)
{
	uint32_t set_width_arg;
	ER ercd = E_OK;

	if((hsd->SCR[0] & (hsd->BusWide<<8)) == 0){
		hsd->BusWide = SDMMC_BUS_WIDE_1B;
	}
	switch (hsd->BusWide){
	case SDMMC_BUS_WIDE_8B:
		set_width_arg = 0x3;
		break;
	case SDMMC_BUS_WIDE_4B:
		set_width_arg = 0x2;
		break;
	case SDMMC_BUS_WIDE_1B:
		set_width_arg = 0x0;
		break;
	default:
		return E_PAR;
    }

	/*
	 *  CMD55(APPEDޥ׵
	 */
	ercd = sdmmc_sendcommand(hsd, MCI_CMD55, (hsd->RCA << 16), sdmmc_checkrep1);
    if(ercd != E_OK)
		return ercd;

	/*
	 *  WIDE BUSACMD6ޥ
	 */
	ercd = sdmmc_sendcommand(hsd, MCI_ACMD6, set_width_arg, sdmmc_checkrep1);
    if(ercd != E_OK)
		return ercd;
	/*
	 *  ȥѥХ
	 */
    sdmmc_bus_width_set(hsd, hsd->BusWide);
    return ercd;
}

/*
 *  ǡREAD/WRITEž
 */
static ER
sdmmc_transfer(SDMMC_Handle_t *hsd, uint64_t start_addr, uint32_t buffer[], const size_t buf_len)
{
	ER ercd = E_OK;
	uint32_t block_count;
	uint32_t byte_count;

	ercd = sdmmc_card_block_size_set(hsd, hsd->block_size);
	if(ercd != E_OK)
		return ercd;

    /*
	 *  ž֥åȡХȥȻ
	 */
    block_count = buf_len / hsd->block_size;
    byte_count = block_count * hsd->block_size;

    /*  reset FIFO*/
    ercd = sdmmc_fifo_reset(hsd);
	if(ercd != E_OK)
        return ercd;

	sdmmc_byte_count_set(hsd, byte_count);
    sdmmc_card_rd_threshold_enable(hsd, SDMMC_BLOCKSIZE/4);

	hsd->pBuffPtr  = (uint8_t *)buffer;
	hsd->XferCount = byte_count;
	if(ercd != E_OK)
		return ercd;

    /*
	 *  READ/WRITEޥ
	 */
    if(hsd->cardtype == SD_CARD_HC)
		ercd = sdmmc_sendcommand(hsd, hsd->SdCmd, start_addr / hsd->block_size, sdmmc_checkrep1);
	else
		ercd = sdmmc_sendcommand(hsd, hsd->SdCmd, start_addr, sdmmc_checkrep1);
	return ercd;
}

/*
 *  SDMMC֥åREAD
 *  parameter1  hsd: SDMMCϥɥ
 *  parameter2  pbuf: ɤ߽ФǡǼΰΥݥ(uint32_t)
 *  parameter3  ReadAddr: ɾɤ߽Ф
 *  parameter4  blocksize: ֥å
 *  parameter5  num: ɤ߽Ф֥å
 *  return      ER
 */
ER
sdmmc_blockread(SDMMC_Handle_t *hsd, void *dest, uint64_t ReadAddr, uint32_t blocksize, uint32_t num)
{
	ER ercd = E_OK;
	uint32_t tnum;
	uint32_t cnum = num;

	if(hsd == NULL || num == 0)
		return E_PAR;
	if(blocksize != hsd->block_size)
		return E_PAR;
	if((ReadAddr % hsd->block_size) != 0)
		return E_PAR;
	if(hsd->status != SDMMC_STATUS_READY)
		return E_OBJ;
	if(!sdmmc_is_idle(hsd))
		return E_SYS;
	hsd->status = SDMMC_STATUS_ACTIVATE;
	if(num == 1)
		hsd->SdCmd = MCI_CMD17;
	else
		hsd->SdCmd = MCI_CMD18;
	while(cnum > 0){
		tnum = MIN(SDMMC_DESC_COUNT, cnum);
		ercd = sdmmc_transfer(hsd, ReadAddr, dest, blocksize * tnum);
		if(ercd != E_OK)
			break;
		ReadAddr += blocksize * tnum;
		cnum -= tnum;
		if(cnum > 0)
			ercd = sdmmc_wait_transfar(hsd, SDMMC_CMDTIMEOUT);
		if(ercd != E_OK)
			break;
	}
	if(ercd != E_OK)
		hsd->status = SDMMC_STATUS_READY;
	return ercd;
}

/*
 *  SDMMC֥åWRITE
 *  parameter1  hsd: SDMMCϥɥ
 *  parameter2  pbuf: ߥǡǼΰΥݥ(uint32_t)
 *  parameter3  WritedAddr: ɾν񤭹߰
 *  parameter4  blocksize: ֥å
 *  parameter5  num: ߥ֥å
 *  return      ER
 */
ER
sdmmc_blockwrite(SDMMC_Handle_t *hsd, void *src, uint64_t WriteAddr, uint32_t blocksize, uint32_t num)
{
	ER ercd = E_OK;

	if(hsd == NULL || num == 0)
		return E_PAR;
	if(blocksize != hsd->block_size)
		return E_PAR;
	if((WriteAddr % hsd->block_size) != 0)
		return E_PAR;
	if(hsd->status != SDMMC_STATUS_READY)
		return E_OBJ;
	if(!sdmmc_is_idle(hsd))
		return E_SYS;
	hsd->status = SDMMC_STATUS_ACTIVATE;
	if(num == 1)
		hsd->SdCmd = MCI_CMD24;
	else
		hsd->SdCmd = MCI_CMD25;
	ercd = sdmmc_transfer(hsd, WriteAddr, src, blocksize * num);
	if(ercd != E_OK)
		hsd->status = SDMMC_STATUS_READY;
	return ercd;
}

/*
 *  SDMMC֥åžλԤ
 *  parameter1  hsd: SDMMCϥɥ
 *  parameter2  Timeout: ॢ(1msec)
 *  return      ER
 */
ER
sdmmc_wait_transfar(SDMMC_Handle_t *hsd, uint32_t Timeout)
{
	ER ercd = E_TMOUT;

	if(hsd == NULL)
		return E_PAR;
	if(hsd->status < SDMMC_STATUS_READY)
		return E_OBJ;
	while (--Timeout){
		/*
		 *  顼ȯå
		 */
		if(hsd->ErrorCode != SDMMC_ERROR_NONE){
			ercd = E_SYS;
			break;
		}

		/*
		 *  SDMMCžå
		 */
		if(hsd->XferCount == 0){
			ercd = E_OK;
			break;
		}
		sil_dly_nse(1000*1000);
	}

	Timeout = SDMMC_TMO_WAITER;
	while(!sdmmc_is_idle(hsd) && --Timeout){
		sil_dly_nse(1000*1000);
	}
	if(Timeout == 0){
		sys_printf("SDMMC:Timed out waiting for SDMMC to become idle\n");
		ercd = E_TMOUT;
	}
	if(hsd->SdCmd == MCI_CMD18 || hsd->SdCmd == MCI_CMD25){
		/*
		 *  ޥ֥åžʤCMD12
		 */
		ercd = sdmmc_sendcommand(hsd, MCI_CMD12, 0, sdmmc_checkrep1);
	}
	if((hsd->SdCmd & SDMMC_CMD_RD_WR) != 0)
		sil_dly_nse(SDMMC_WRITE_DELAY_TIME*1000*1000);
	hsd->status = SDMMC_STATUS_READY;
    return ercd;
}

/*
 *  SDMMCߥϥɥ
 */
void
sdmmc_hps_handler(uint32_t icciar, void * context)
{
	SDMMC_Handle_t *hsd = &SDHandle;
	uint32_t istatus, dstatus;
	istatus = sil_rew_mem((uint32_t *)(hsd->base+TOFF_SDMMC_MINTSTS));
	dstatus = sil_rew_mem((uint32_t *)(hsd->base+TOFF_SDMMC_IDSTS));
	uint32_t level, freespace, fullspace, temp;
	volatile uint8_t *p;
	int      i;

	if(istatus != 0){
		hsd->istatus   |= istatus;
		hsd->ErrorCode |= istatus & SDMMC_ERROR_MASK;
		if((istatus & SDMMC_INTSTS_TXDR) != 0){
			if(hsd->XferCount > 0 && hsd->pBuffPtr != NULL){
		        level = sdmmc_fifo_count(hsd);

		        /*
				 *  TX FIFO
				 */
	            freespace = SDMMC_FIFO_NUM_ENTRIES - level;
	            freespace = MIN(hsd->XferCount / 4, freespace);
	            for(i = 0; i < freespace; i++){
					p = (volatile uint8_t *)hsd->pBuffPtr;
					temp = (p[3]<<24) | (p[2]<< 16) | (p[1]<<8) | p[0];
					sil_wrw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_DATA), temp);
					hsd->pBuffPtr += 4;
	            }
	            hsd->XferCount -= freespace * 4;
			}
			else
				sil_andw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_INTMSK), SDMMC_INTSTS_TXDR);
		}
		if((hsd->istatus & (SDMMC_INTSTS_RXDR | SDMMC_INTSTS_DTO)) != 0){
	        level = sdmmc_fifo_count(hsd);
			fullspace = MIN(hsd->XferCount / 4, level);
			if(hsd->XferCount > 0 && hsd->pBuffPtr != NULL){
	            for(i = 0; i < fullspace; i++){
					p = (volatile uint8_t *)hsd->pBuffPtr;
					temp = sil_rew_mem((uint32_t *)(hsd->base+TOFF_SDMMC_DATA));
					p[0] = temp & 0xff;
					p[1] = (temp >> 8) & 0xff;
					p[2] = (temp >> 16) & 0xff;
					p[3] = (temp >> 24);
					hsd->pBuffPtr += 4;
	            }
	            hsd->XferCount -= fullspace * 4;
				level -= fullspace;
			}
			if(hsd->XferCount == 0 && level > 0){
	            for(i = 0; i < level; i++){
					temp = sil_rew_mem((uint32_t *)(hsd->base+TOFF_SDMMC_DATA));
				}
			}
		}
		/*
		 *  SDMMCߥơꥢ
		 */
		sil_wrw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_RINTSTS), istatus);
	}
	if(dstatus != 0){
		hsd->dstatus |= dstatus;
		/*
		 *  SDMMC-DMAߥơꥢ
		 */
		sil_wrw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_IDSTS), dstatus);
	}
}

/*
 * SDMMCޥ
 */
static ER
sdmmc_sendcommand(SDMMC_Handle_t *hsd, uint32_t cmd, uint32_t arg, ER (*func)(SDMMC_Handle_t *, uint32_t))
{
    /*  Create interrupt mask by command configurations*/
    uint32_t int_mask = SDMMC_INTSTS_RE             /*  Response error*/
                      | SDMMC_INTSTS_BAR            /*  Response timeout*/
                      | SDMMC_INTSTS_CD             /*  Card detect (CD) interrupt*/
                      | SDMMC_INTSTS_HLE            /*  Hardware Locked Write Error*/
                      | SDMMC_INTSTS_CMD;           /*  Command done (CD) interrupt*/
    ER ercd = E_OK;
	uint32_t cmd_index = cmd & CMD_INDEX;
	uint32_t timeout = SDMMC_TMO_WAITER;

	int_mask |= SDMMC_INTSTS_DTO		/*  Data transfer over*/
			  | SDMMC_INTSTS_RCRC		/*  Response CRC error*/
			  | SDMMC_INTSTS_DCRC		/*  Data CRC error*/
			  | SDMMC_INTSTS_HTO		/*  Data starvation by host timeout*/
			  | SDMMC_INTSTS_FRUN		/*  FIFO underrun/overrun error*/
			  | SDMMC_INTSTS_EBE;		/*  End-bit error*/

	if((cmd & SDMMC_CMD_RD_WR) != 0){
		int_mask |= SDMMC_INTSTS_TXDR	/*  Transmit FIFO data request (TXDR)*/
				  | SDMMC_INTSTS_HLE;	/*  Hardware locked write error (HLE)*/
	}
	else{
		int_mask |= SDMMC_INTSTS_RXDR	/*  Receive FIFO data request (RXDR)*/
				  | SDMMC_INTSTS_SBE;	/*  Start-bit error (SBE)*/
	}

	if(cmd_index != CMD_INDEX){
        while (sdmmc_is_busy(hsd) && timeout--){
			sil_dly_nse(1000*1000);
		}
	}

	/*
	 *  SDMMCߥơꥢ
	 */
	hsd->istatus = 0;
	sil_wrw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_RINTSTS), SDMMC_INT_STATUS_ALL);

	/*
	 *  SDMMC
	 */
	sil_orw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_CTL), SDMMC_CTL_INT_EN);
	sil_wrw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_INTMSK), int_mask);

    /*
	 *  ޥɤȰ
	 */
	sil_wrw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_CMDARG), arg);
    sil_wrw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_CMD), cmd);
    sil_wrw_mem((uint32_t *)(hsd->base+TOFF_SDMMC_CMD), cmd | SDMMC_CMD_START_CMD);

	/*
	 *  åХ
	 */
	if(cmd_index == CMD_INDEX){
		timeout = SDMMC_TMO_WAITER;
		ercd = E_TMOUT;
		while (--timeout){
			uint32_t cmd_register = sil_rew_mem((uint32_t *)(hsd->base+TOFF_SDMMC_CMD));
			/*
			 *  顼å
			 */
	        if(hsd->ErrorCode != SDMMC_ERROR_NONE){
				ercd = E_SYS;
				break;
			}

			/*
			 *  ޥɥȥå
			 */
			if((cmd_register & SDMMC_CMD_START_CMD) == 0){
				ercd = E_OK;
				break;
			}
			sil_dly_nse(1000*1000);
		}
		return ercd;
    }

    /*
	 *  ޥԤ
	 */
	if(func != NULL){
		ercd = sdmmc_cmd_wait(hsd);
		if(ercd == E_OK)
			func(hsd, cmd);
	}
	return ercd;
}

/*
 *  R1쥹ݥ
 */
static ER
sdmmc_checkrep1(SDMMC_Handle_t *hsd, uint32_t Cmd)
{
	uint32_t respValue;
	/*
	 *  쥹ݥ󥹣Υ顼å
	 */
	respValue = sdmmc_read_short_response(hsd);
	if((respValue & SD_OCR_ERROR) == 0)
		return E_OK;
	else
		return E_SDCOM;
}

/*
 *  R2쥹ݥ
 */
static ER
sdmmc_checkrep2(SDMMC_Handle_t *hsd, uint32_t Cmd)
{
	return E_OK;
}

/*
 *  R3쥹ݥ
 */
static ER
sdmmc_checkrep3(SDMMC_Handle_t *hsd, uint32_t Cmd)
{
	return E_OK;
}

/*
 *  R6쥹ݥ
 */
static ER
sdmmc_checkrep6(SDMMC_Handle_t *hsd, uint32_t Cmd)
{
	uint32_t respValue;

	/*
	 *  쥹ݥ󥹣γǧ
	 */
	respValue = sdmmc_read_short_response(hsd);
    hsd->RCA = (uint16_t) (respValue >> 16);
	return E_OK;
}

/*
 *  ޥžλԤ
 */
static ER
sdmmc_cmd_wait(SDMMC_Handle_t *hsd)
{
	ER ercd = E_TMOUT;
    uint32_t timeout = SDMMC_CMDTIMEOUT;

	while(timeout > 0){
		/*
		 *  SDMMC顼å
		 */
		if(hsd->ErrorCode != SDMMC_ERROR_NONE){
			ercd = E_SYS;
			break;
        }

        /*
		 *  ޥžλԤ
		 */
		if(hsd->istatus & SDMMC_INTSTS_CMD){
			ercd = E_OK;
			break;
		}
		sil_dly_nse(1000*1000);
		timeout--;
	}
	hsd->istatus &= ~SDMMC_INTSTS_CMD;
	return ercd;
}


