
#ifndef _SYS_DEFS_H_
#define _SYS_DEFS_H_

/*	Values	*/

#define TARGET_CPU_STR		"LONGAN-NANO"

/* endian */
#define SIL_ENDIAN      0		/* LITTLE ENDIAN */

/*	Address		*/
#define RAM_BASE        0x20000000
#define RAM_SIZE        (32*1024)
#define VECTOR_SIZE		(87*4)
#define CLOAD_ADDRESS   0x08000000

/*
 *  ԤΤ
 *  ϥåȿ˰¸롣
 */
#define    SIL_DLY_TIM1     34
#define    SIL_DLY_TIM2     30

/*	Default Values	*/

#define MAX_INT_NUM     87
#define DEF_DUMP_LENGTH	256
#define MonitorVector   CLOAD_ADDRESS
#define UserVector      RAM_BASE
#define NOT_INITDECT
#define NOT_DEFVECTORTYPE

/*
 *  å
 */
#define SYSTEM_CLOCK_PLL_HXTAL  108000000	/* system clock */
#define HXTAL_VALUE             8000000		/* the external speed crystal oscillator in Hz */
#define IRC8M_VALUE             8000000		/* 8MHz RC oscillator */
#define IRC40K_VALUE            40000
#define LXTAL_VALUE             32768
#define USE_MCYCLE

#ifndef _MACRO_ONLY
/*
 *  ѥ¸Υǡ
 */
#define	_int8_		char		/* 8ӥåȤ	*/
#define	_int16_		short		/* 16ӥåȤ	*/
#define	_int32_		int			/* 32ӥåȤ	*/
#define	_int64_		long long	/* 64ӥåȤ	*/

/*
 *  ROMMONǻѤ뷿
 */
typedef _int32_     int32_t;
typedef long		intptr_t;	/* ݥ󥿤ǼǤդ */

/*
 *  ѥγĥǽΤΥޥ
 */
#define	Inline          static inline

typedef	int                 ID;			/* ֥ȤIDֹ */
typedef	int                 ER;			/* 顼 */
typedef int                 bool_t;		/*  */

#ifndef NULL
#define NULL                0			/* ̵ݥ */
#endif /* NULL */

#ifndef true
#define true                1			/*  */
#endif /* true */

#ifndef false
#define false               0			/*  */
#endif /* false */

/*
 *  SDMMCĥ顼
 */
#define E_OK                0			/* ｪλ */
#define E_SYS               (-5)		/* ƥ२顼 */
#define E_PAR               (-17)		/* ѥ᡼顼 */
#define E_OBJ               (-41)		/* ֥Ⱦ֥顼 */
#define E_TMOUT             (-50)		/* ݡ󥰼Ԥޤϥॢ */
#define E_SDCOM             (-80)		/* ޥɥ顼 */

#endif	/* _MACRO_ONLY */

#include "sil.h"
#include "gd32vf103.h"
#include "riscv_encoding.h"

#ifndef _MACRO_ONLY

/*
 *  ECLICͥ٥Х
 */
#define ECLIC_PRIGROUP_LEVEL0_PRIO4        0    /* 0 bits for level 4 bits for priority */
#define ECLIC_PRIGROUP_LEVEL1_PRIO3        1    /* 1 bits for level 3 bits for priority */
#define ECLIC_PRIGROUP_LEVEL2_PRIO2        2    /* 2 bits for level 2 bits for priority */
#define ECLIC_PRIGROUP_LEVEL3_PRIO1        3    /* 3 bits for level 1 bits for priority */
#define ECLIC_PRIGROUP_LEVEL4_PRIO0        4    /* 4 bits for level 0 bits for priority */

typedef struct {
	uint32_t SYSCLK_Frequency;	/*  SYSCLK clock frequency expressed in Hz */
	uint32_t AHB_Frequency;		/*  AHB clock frequency expressed in Hz */
	uint32_t APB1_Frequency;	/*  APB1 clock frequency expressed in Hz */
	uint32_t APB2_Frequency;	/*  APB2 clock frequency expressed in Hz */
}RCU_ClocksTypeDef;

typedef void (*function_ptr_t) (void);

extern unsigned int   cpu_frequency;
extern function_ptr_t vector_base[];

extern int sys_printf(const char * format, ...);
extern void sys_putc(char c);
extern void put_hex(char a, int val);
extern void trap_entry(void);

extern void RCC_GetClocksFreq(RCU_ClocksTypeDef *pclk);
extern void eclic_mode_enable(void);
extern void eclic_priority_group_set(uint32_t prigroup);
extern void eclic_init (void);
extern void eclic_irq_enable(uint32_t source, uint8_t level, uint8_t priority);
extern void eclic_irq_disable(uint32_t source);
extern uint8_t eclic_get_irq_priority(uint32_t source);

#endif	/* _MACRO_ONLY */

/*	Serial Channels		*/

#define MAX_SERIAL		1
#define DEF_MON_SERIAL	0


/* serial definitions */

#define DEFAULT_SPEED		115200

#endif	/* SYS_DEFS_H_ */

