/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2016-2019 by TOPPERS PROJECT Educational Working Group.
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 *	rommon Serial Functions
 */
#include "comdefs.h"
#include <sil.h>
#include "serial.h"

#ifndef WDOG_RESET
#define WDOG_RESET()
#endif

/*
 *	Seiral Data
 */
#if !defined(NOINT_UARTRX)
char *SCIRXWritePtr[MAX_SERIAL];
char *SCIRXReadPtr[MAX_SERIAL];
char *SCIRXBuffBase[MAX_SERIAL];
char *SCIRXBuffLimit[MAX_SERIAL];
char SCIRXBuffer[MAX_SERIAL][DEF_SCIRX_BUFF_SIZE];
volatile unsigned char SCIRXBuffCount[MAX_SERIAL];
#endif	/* NOINT_UARTRX */

#if !defined(NOINT_UARTTX)
char *SCITXWritePtr[MAX_SERIAL];
char *SCITXReadPtr[MAX_SERIAL];
char *SCITXBuffBase[MAX_SERIAL];
char *SCITXBuffLimit[MAX_SERIAL];
char SCITXBuffer[MAX_SERIAL][DEF_SCITX_BUFF_SIZE];
volatile unsigned char SCITXBuffCount[MAX_SERIAL];
#endif /* NOINT_UARTTX */

volatile unsigned char SCIRXFlowCntrl[MAX_SERIAL];
volatile unsigned char SCITXFlowCntrl[MAX_SERIAL];
unsigned char SCIRXXOFF[MAX_SERIAL];

/*
 *	Initialize Serial Channel
 *
 *		Input:	er3: Serial Channel #
 */

void InitSerial(int id)
{
#if !defined(NOINT_UARTRX)
	SCIRXBuffCount[id] = 0;
	SCIRXBuffBase[id]  = &SCIRXBuffer[id][0];
	SCIRXReadPtr[id]   = &SCIRXBuffer[id][0];
	SCIRXWritePtr[id]  = &SCIRXBuffer[id][0];
	SCIRXBuffLimit[id] = &SCIRXBuffer[id+1][0];
#endif	/* NOINT_UARTRX */

#if !defined(NOINT_UARTTX)
	SCITXBuffCount[id] = 0;
	SCITXBuffBase[id]  = &SCITXBuffer[id][0];
	SCITXReadPtr[id]   = &SCITXBuffer[id][0];
	SCITXWritePtr[id]  = &SCITXBuffer[id][0];
	SCITXBuffLimit[id] = &SCITXBuffer[id+1][0];
#endif	/* NOINT_UARTTX */
	SCIRXFlowCntrl[id] = 0;
	SCIRXXOFF[id]      = 0;
	SCITXFlowCntrl[id] = 0;
	InitSIO(id);
}

#if !defined(NOINT_UARTRX)
/*
 *	SCI Common Intrrupt Handler: Recive Data Full
 *  Input: id: Serial Channel #
 */
void ComInterRX(int id)
{
	unsigned short val;
	char           c;

	val = GetRxData(id);
	if(CHKRXDATA & val){
		c = val & 0xff;
#ifndef USE_HARDFLOW
		if(c == ('S'-'@')){
			SCITXFlowCntrl[id] = c;
		}
		else if(c == ('Q'-'@')){
			SCITXFlowCntrl[id] = 0;
#if !defined(NOINT_UARTTX)
			EnableITX(id);
#endif	/* NOINT_UARTTX */
		}
		else{
#endif	/* !USE_HARDFLOW */
			*SCIRXWritePtr[id]++ = c;
			if(SCIRXWritePtr[id] >= SCIRXBuffLimit[id])
				SCIRXWritePtr[id] = SCIRXBuffBase[id];
			if(SCIRXBuffCount[id] < DEF_SCIRX_BUFF_SIZE)
				SCIRXBuffCount[id]++;
			if(SCIRXBuffCount[id] >= SCI_HIGH_WMARK){
				if(SCIRXFlowCntrl[id] == 0){
					SCIRXFlowCntrl[id] = 'S'-'@';
#ifdef USE_HARDFLOW
					SetRTS(id, 0);
#else
					SCIRXXOFF[id] = 'S'-'@';
#endif
#if !defined(NOINT_UARTTX)
					EnableITX(id);
#endif	/* NOINT_UARTTX */
				}
			}
#ifndef USE_HARDFLOW
		}
#endif	/* NOINT_UARTTX */
	}
}
#endif	/* NOINT_UARTRX */

#if !defined(NOINT_UARTTX)
/*
 *	SCI Common Intrrupt Handler: Transmit Data Empty
 *  Input:	id: Serial Channel #
 */
void ComInterTX(int id)
{
	char c;

	if((c = SCIRXXOFF[id]) != 0){
		SCIRXXOFF[id] = 0;
		SendTX(id, c);
	}
	else if(SCITXBuffCount[id] > 0){
		c = *SCITXReadPtr[id]++;
		if(SCITXReadPtr[id] >= SCITXBuffLimit[id])
			SCITXReadPtr[id] = SCITXBuffBase[id];
		SendTX(id, c);
		SCITXBuffCount[id]--;
	}
	else
		DisableITX(id);
}
#endif	/* NOINT_UARTTX */

#ifdef USE_HARDFLOW
void ComInterCTS(int id, int val)
{
	if(val == 0)
		SCITXFlowCntrl[id] = 1;
	else{
#if !defined(NOINT_UARTTX)
		if(SCITXFlowCntrl[id] != 0 && SCITXBuffCount[id] > 0)
			EnableITX(id);
#endif
		SCITXFlowCntrl[id] = 0;
	}
}
#endif	/* USE_HARDFLOW */

/*
 *	Send Character
 *  Input:  arg1: Serial Channel #
 *          arg2: Character sent
 */

void SendChar(int id, char c)
{
#if !defined(NOINT_UARTTX)
	if(id < 0)
		return;
	while(SCITXBuffCount[id] >= DEF_SCITX_BUFF_SIZE){}

	*SCITXWritePtr[id]++ = c;
	if(SCITXWritePtr[id] >= SCITXBuffLimit[id])
		SCITXWritePtr[id] = SCITXBuffBase[id];
	Disable();
	SCITXBuffCount[id]++;
	if(SCITXFlowCntrl[id] == 0){
		EnableITX(id);
	}
	Enable();
#else	/* NOINT_UARTTX */
	char c2;

	if(id < 0)
		return;
	while(SCITXFlowCntrl[id] != 0){
		sil_dly_nse(1000);
	}
	if((c2 = SCIRXXOFF[id]) != 0){
		SCIRXXOFF[id] = 0;
		SendTXWait(id);
		SendTX(id, c2);
	}
	SendTXWait(id);
	SendTX(id, c);
#endif	/* NOINT_UARTTX */
}

/*
 *	Recive Character
 *  Input:  arg1: Serial Channel #
 *  Output:	Character received, 0 if no data
 */
char ReciveChar(int id)
{
	char c = 0;
	WDOG_RESET();
#if !defined(NOINT_UARTRX)
	if(SCIRXBuffCount[id] > 0){
		Disable();
		SCIRXBuffCount[id]--;
		Enable();

		if(SCIRXBuffCount[id] <= SCI_LOW_WMARK && SCIRXFlowCntrl[id]){
			SCIRXFlowCntrl[id] = 0;
			Disable();
#ifdef USE_HARDFLOW
			SetRTS(id, 1);
#else
			SCIRXXOFF[id] = 'Q'-'@';
#endif
#ifndef NOINT_UARTTX
			EnableITX(id);
#endif	/* NOINT_UARTTX */
			Enable();
		}
		c = *SCIRXReadPtr[id]++;
		if(SCIRXReadPtr[id] >= SCIRXBuffLimit[id])
			SCIRXReadPtr[id] = SCIRXBuffBase[id];
	}
#else	/* NOINT_UARTRX */
	unsigned short tmp = GetRxData(id);
	if(tmp & CHKRXDATA)
		c = (unsigned char)tmp;
#endif	/* NOINT_UARTRX */
	return c;
}

