
#ifndef _SYS_DEFS_H_
#define _SYS_DEFS_H_

/*	Values	*/

#if BOARDNO == 1
#define TARGET_CPU_STR		"STM32-E407"
#define Serial_IRQHandler	USART3_IRQHandler
#elif BOARDNO == 0
#define TARGET_CPU_STR		"STM32F4-Discovery"
#define Serial_IRQHandler	USART2_IRQHandler
#elif BOARDNO == 2
#define TARGET_CPU_STR		"STM32F429-board"
#define Serial_IRQHandler	USART1_IRQHandler
#elif BOARDNO == 3
#define TARGET_CPU_STR		"STM32F401 Nucleo"
#define Serial_IRQHandler	USART2_IRQHandler
#elif BOARDNO == 4
#define TARGET_CPU_STR		"STM32F446 Nucleo-64"
#define Serial_IRQHandler	USART2_IRQHandler
#elif BOARDNO == 5
#define TARGET_CPU_STR		"STM32F446 Nucleo-144"
#define Serial_IRQHandler	USART3_IRQHandler
#else
#error	"NOT SOPPORT BOARD !"
#endif

/* endian */
#define SIL_ENDIAN      0		/* LITTLE ENDIAN */

/*	Address		*/
#define RAM_BASE        0x20000000
#define RAM_SIZE        (128*1024)
#define VECTOR_SIZE		(4*8)
#define FIQ_DATA_SIZE   256
#define STACKINT        (RAM_BASE+RAM_SIZE-FIQ_DATA_SIZE)	/* ߥåν */
#define STACKTOP        (STACKINT-256)						/* 桼åν */

/*
 *  ԤΤ
 *  ϥåȿ˰¸롣
 */
#if BOARDNO == 3
#define SIL_DLY_TIM1    100
#define SIL_DLY_TIM2    102
#elif BOARDNO == 4 || BOARDNO == 5
#define SIL_DLY_TIM1    50
#define SIL_DLY_TIM2    74
#else
#define SIL_DLY_TIM1    200
#define SIL_DLY_TIM2    24
#endif

/*	Default Values	*/

#define MAX_INT_NUM     82
#define DEF_DUMP_LENGTH	256
#define NOT_INITDECT
#define RESET_VECTOR    1

#ifndef TOPPERS_MACRO_ONLY
/*
 *  ѥ¸Υǡ
 */
#define	_int8_		char		/* 8ӥåȤ	*/
#define	_int16_		short		/* 16ӥåȤ	*/
#define	_int32_		int			/* 32ӥåȤ	*/

/*
 *  ѥγĥǽΤΥޥ
 */
#define	Inline          static inline

typedef struct {
	unsigned int SYSCLK_Frequency;	/*  SYSCLK clock frequency expressed in Hz */
	unsigned int HCLK_Frequency;	/*  HCLK clock frequency expressed in Hz */
	unsigned int PCLK1_Frequency;	/*  PCLK1 clock frequency expressed in Hz */
	unsigned int PCLK2_Frequency;	/*  PCLK2 clock frequency expressed in Hz */
}RCC_ClocksTypeDef;

extern void SetVector(void *addr);
extern void RCC_GetClocksFreq(RCC_ClocksTypeDef* RCC_Clocks);
extern int sys_printf(const char * format, ...);
extern void sys_putc(int c);

#endif	/* TOPPERS_MACRO_ONLY */

/*	Serial Channels		*/

#if BOARDNO == 1
#define MAX_SERIAL		2
#else
#define MAX_SERIAL		1
#endif
#define DEF_MON_SERIAL	0

#include "stm32f4xx.h"

/* serial definitions */

#define DEFAULT_SPEED		115200

#endif	/* SYS_DEFS_H_ */

