/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2015-2019 by Roi Takeuchi
 *
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: $
 */
/**
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; COPYRIGHT 2015 STMicroelectronics</center></h2>
  *
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted provided that the following conditions are met:
  *   1. Redistributions of source code must retain the above copyright notice,
  *      this list of conditions and the following disclaimer.
  *   2. Redistributions in binary form must reproduce the above copyright notice,
  *      this list of conditions and the following disclaimer in the documentation
  *      and/or other materials provided with the distribution.
  *   3. Neither the name of STMicroelectronics nor the names of its contributors
  *      may be used to endorse or promote products derived from this software
  *      without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
  ******************************************************************************
  */

#include "sys_defs.h"
#include "sil.h"

#define sil_orw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) | (b))
#define sil_andw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) & ~(b))
#define sil_modw_mem(a, b, c)	sil_wrw_mem((a), (sil_rew_mem(a) & (~b)) | (c))

#define PLL_M      (HSE_VALUE / 1000000)/* Possible value 0 and 63 */
#if BOARDNO == 1
#define PLL_N      400
#else
#define PLL_N      432
#endif
/* USB OTG FS, SDIO and RNG Clock =  PLL_VCO / PLLQ */
#define PLL_Q      9
#if BOARDNO == 1 || BOARDNO == 3
#define PLL_R      7
#else
#define PLL_R      0
#endif

/*
 *  TIMEOUT VALUES
 */
#define CLOCKSWITCH_TIMEOUT_VALUE  ((uint32_t)5000*1000) /* 5 s    */ 
#define HSE_TIMEOUT_VALUE          ((uint32_t)5000*1000)  /* Time out for HSE start up, in ms */
#define PLL_TIMEOUT_VALUE          ((uint32_t)100*1000)	/* 100 ms */
#define PLLSAI_TIMEOUT_VALUE       (100*1000)			/* Timeout value fixed to 100 ms  */
#define PWR_OVERDRIVE_TIMEOUT_VALUE  (1000*1000)


/*
 *  RCC_PLLP_Clock_Divider PLLP Clock Divider
 */
#define RCC_PLLP_DIV2                  ((uint32_t)0x00000002)
#define RCC_PLLP_DIV4                  ((uint32_t)0x00000004)
#define RCC_PLLP_DIV6                  ((uint32_t)0x00000006)
#define RCC_PLLP_DIV8                  ((uint32_t)0x00000008)

/*
 *  RCC_APB1_APB2_Clock_Source RCC APB1/APB2 Clock Source
 */
#define RCC_HCLK_DIV1                    RCC_CFGR_PPRE1_DIV1
#define RCC_HCLK_DIV2                    RCC_CFGR_PPRE1_DIV2
#define RCC_HCLK_DIV4                    RCC_CFGR_PPRE1_DIV4
#define RCC_HCLK_DIV8                    RCC_CFGR_PPRE1_DIV8
#define RCC_HCLK_DIV16                   RCC_CFGR_PPRE1_DIV16

/*
 *  RCC_AHB_Clock_Source RCC AHB Clock Source
 */
#define RCC_SYSCLK_DIV1                  RCC_CFGR_HPRE_DIV1
#define RCC_SYSCLK_DIV2                  RCC_CFGR_HPRE_DIV2
#define RCC_SYSCLK_DIV4                  RCC_CFGR_HPRE_DIV4
#define RCC_SYSCLK_DIV8                  RCC_CFGR_HPRE_DIV8
#define RCC_SYSCLK_DIV16                 RCC_CFGR_HPRE_DIV16
#define RCC_SYSCLK_DIV64                 RCC_CFGR_HPRE_DIV64
#define RCC_SYSCLK_DIV128                RCC_CFGR_HPRE_DIV128
#define RCC_SYSCLK_DIV256                RCC_CFGR_HPRE_DIV256
#define RCC_SYSCLK_DIV512                RCC_CFGR_HPRE_DIV512

#define RCC_CLK48SOURCE_PLL              0x00000000
#define RCC_CLK48SOURCE_PLLSAIP          RCC_DCKCFGR2_CK48MSEL

#define RCC_PLLSAIP_DIV2                 0x00000000
#define RCC_PLLSAIP_DIV4                 0x00000001
#define RCC_PLLSAIP_DIV6                 0x00000002
#define RCC_PLLSAIP_DIV8                 0x00000003

/*
 *  CORTEX_MPU_Region_Enable CORTEX MPU Region Enable
 */
#define MPU_REGION_ENABLE     ((uint8_t)0x01)
#define MPU_REGION_DISABLE    ((uint8_t)0x00)

/*
 *  CORTEX_MPU_Instruction_Access CORTEX MPU Instruction Access
 */
#define MPU_INSTRUCTION_ACCESS_ENABLE      ((uint8_t)0x00)
#define MPU_INSTRUCTION_ACCESS_DISABLE     ((uint8_t)0x01)

/*
 *  CORTEX_MPU_Access_Cacheable CORTEX MPU Instruction Access Cacheable
 */
#define MPU_ACCESS_CACHEABLE         ((uint8_t)0x01)
#define MPU_ACCESS_NOT_CACHEABLE     ((uint8_t)0x00)

/*
 *  CORTEX_MPU_Access_Bufferable CORTEX MPU Instruction Access Bufferable
 */
#define MPU_ACCESS_BUFFERABLE         ((uint8_t)0x01)
#define MPU_ACCESS_NOT_BUFFERABLE     ((uint8_t)0x00)

/*
 *  CORTEX_MPU_Access_Shareable CORTEX MPU Instruction Access Shareable
 */
#define MPU_ACCESS_SHAREABLE        ((uint8_t)0x01)
#define MPU_ACCESS_NOT_SHAREABLE    ((uint8_t)0x00)

/* Cache Size ID Register Macros */
#define CCSIDR_WAYS(x)         (((x) & SCB_CCSIDR_ASSOCIATIVITY_Msk) >> SCB_CCSIDR_ASSOCIATIVITY_Pos)
#define CCSIDR_SETS(x)         (((x) & SCB_CCSIDR_NUMSETS_Msk      ) >> SCB_CCSIDR_NUMSETS_Pos      )
#define CCSIDR_LSSHIFT(x)      (((x) & SCB_CCSIDR_LINESIZE_Msk     ) /*>> SCB_CCSIDR_LINESIZE_Pos*/ )


const uint8_t APBAHBPrescTable[16] = {0, 0, 0, 0, 1, 2, 3, 4, 1, 2, 3, 4, 6, 7, 8, 9};
uint32_t SystemCoreClock;          /*!< System Clock Frequency (Core Clock) */
int usb_result;


/*
 *  USB CLOCK CONFIGURATION
 */
void USB_RCC_PeriphCLKConfig(unsigned int pllsan, unsigned int pllsaip)
{
	unsigned int tickstart = 0U;
	unsigned int pllsaiq = 0U;

    /* Configure the CLK48 clock source */
    sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_DCKCFGR2), RCC_DCKCFGR2_CK48MSEL, RCC_CLK48SOURCE_PLLSAIP);

    /* Disable PLLSAI Clock */
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_PLLSAION);

    tickstart = 0;
    /* Wait till PLLSAI is disabled */
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_PLLSAIRDY) != 0){
		if(tickstart  > PLLSAI_TIMEOUT_VALUE){
			/* return in case of Timeout detected */
			usb_result = 0;
			return;
		}
		sil_dly_nse(1000);
		tickstart++;
    }

	/* In Case of PLLI2S is selected as source clock for CLK48 */ 
	/* Read PLLSAIQ value from PLLI2SCFGR register (this value is not need for SAI configuration) */
	pllsaiq = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLSAICFGR)) & (RCC_PLLSAICFGR_PLLSAIQ | RCC_PLLSAICFGR_PLLSAIR);
	/* Configure the PLLSAI division factors */
	/* PLLSAI_VCO = f(VCO clock) = f(PLLSAI clock input) * (PLLI2SN/PLLSAIM) */
	/* 48CLK = f(PLLSAI clock output) = f(VCO clock) / PLLSAIP */
	pllsaiq |= (pllsan << 6)  | (pllsaip << 16);
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLSAICFGR), pllsaiq);

	/* Enable PLLSAI Clock */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_PLLSAION);

	tickstart = 0;
	/* Wait till PLLSAI is ready */
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & (RCC_CR_PLLSAIRDY)) == 0){
		if( tickstart > PLLSAI_TIMEOUT_VALUE){
			/* return in case of Timeout detected */
			usb_result = 0;
			return;
		}
		sil_dly_nse(1000);
		tickstart++;
	}
	usb_result = 1;
	return;
}

#if RAM_EXEC == 0
/*
 *  Configure the MPU attributes as Write Through for SRAM1/2.
 *  note   The Base Address is 0x20010000 since this memory interface is the AXI.
 *         The Region Size is 256KB, it is related to SRAM1 and SRAM2  memory size.
 */
static void MPU_Config(void)
{
	/* Disable the MPU */
	sil_andw_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_SHCSR), SCB_SHCSR_MEMFAULTENA_Msk);
	sil_andw_mem((uint32_t *)(TADR_MPU_BASE+TOFF_MPU_CTRL), MPU_CTRL_ENABLE_Msk);

	/* Set the Region number */
	sil_wrw_mem((uint32_t *)(TADR_MPU_BASE+TOFF_MPU_RNR), MPU_REGION_NUMBER0);

#if BOARDNO == 1 || BOARDNO == 3
	sil_wrw_mem((uint32_t *)(TADR_MPU_BASE+TOFF_MPU_RBAR), 0x20020000);
	sil_wrw_mem((uint32_t *)(TADR_MPU_BASE+TOFF_MPU_RASR),
				((MPU_INSTRUCTION_ACCESS_ENABLE << MPU_RASR_XN_Pos)   |
                 (MPU_REGION_FULL_ACCESS        << MPU_RASR_AP_Pos)   |
                 (MPU_TEX_LEVEL0                << MPU_RASR_TEX_Pos)  |
                 (MPU_ACCESS_NOT_SHAREABLE      << MPU_RASR_S_Pos)    |
                 (MPU_ACCESS_CACHEABLE          << MPU_RASR_C_Pos)    |
                 (MPU_ACCESS_NOT_BUFFERABLE     << MPU_RASR_B_Pos)    |
                 (0x00                          << MPU_RASR_SRD_Pos)  |
                 (MPU_REGION_SIZE_512KB         << MPU_RASR_SIZE_Pos) |
                 (MPU_REGION_ENABLE             << MPU_RASR_ENABLE_Pos)));
#else
	sil_wrw_mem((uint32_t *)(TADR_MPU_BASE+TOFF_MPU_RBAR), 0x20010000);
	sil_wrw_mem((uint32_t *)(TADR_MPU_BASE+TOFF_MPU_RASR),
				((MPU_INSTRUCTION_ACCESS_ENABLE << MPU_RASR_XN_Pos)   |
                 (MPU_REGION_FULL_ACCESS        << MPU_RASR_AP_Pos)   |
                 (MPU_TEX_LEVEL0                << MPU_RASR_TEX_Pos)  |
                 (MPU_ACCESS_NOT_SHAREABLE      << MPU_RASR_S_Pos)    |
                 (MPU_ACCESS_CACHEABLE          << MPU_RASR_C_Pos)    |
                 (MPU_ACCESS_NOT_BUFFERABLE     << MPU_RASR_B_Pos)    |
                 (0x00                          << MPU_RASR_SRD_Pos)  |
                 (MPU_REGION_SIZE_256KB         << MPU_RASR_SIZE_Pos) |
                 (MPU_REGION_ENABLE             << MPU_RASR_ENABLE_Pos)));
#endif

	/* Enable the MPU */
	sil_wrw_mem((uint32_t *)(TADR_MPU_BASE+TOFF_MPU_CTRL), (MPU_PRIVILEGED_DEFAULT | MPU_CTRL_ENABLE_Msk));
	sil_orw_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_SHCSR), SCB_SHCSR_MEMFAULTENA_Msk);
}

/*
 *  System Clock Configuration
 *        The system Clock is configured as follow : 
 *            System Clock source            = PLL (HSE)
 *            SYSCLK(Hz)                     = 216000000/200000000
 *            HCLK(Hz)                       = 216000000/200000000
 *            AHB Prescaler                  = 1
 *            APB1 Prescaler                 = 4
 *            APB2 Prescaler                 = 2
 *            HSE Frequency(Hz)              = 25000000
 *            PLL_M                          = 25
 *            PLL_N                          = 432/400
 *            PLL_P                          = 2
 *            PLL_Q                          = 9
 *            PLL_R                          = 0/7
 *            VDD(V)                         = 3.3
 *            Main regulator output voltage  = Scale1 mode
 *            Flash Latency(WS)              = 7
 */
static void SystemClock_Config(void)
{
	uint32_t tickstart = 0;
	volatile uint32_t tmpreg;

	/* Enable HSE Oscillator and activate PLL with HSE as source */
	/*------------------------------- HSE Configuration ------------------------*/
	/* Reset HSEON and HSEBYP bits before configuring the HSE --------------*/
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_HSEBYP);
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_HSEON);

	/* Wait till HSE is disabled */  
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_HSERDY) != 0){
		if(tickstart > HSE_TIMEOUT_VALUE){
			while(1) { ; }
		}
		sil_dly_nse(1000);
		tickstart++;
	}

	/* Set the new HSE configuration ---------------------------------------*/
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_HSEON);
#if BOARDNO == 2 || BOARDNO == 3	/* nucleo */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_HSEBYP);
#else
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_HSEBYP);
#endif
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_HSEON);

	tickstart = 0;
	/* Check the HSE State */
	/* Wait till HSE is ready */
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_HSERDY) == 0){
		if(tickstart > HSE_TIMEOUT_VALUE){
			while(1) { ; }
		}
		sil_dly_nse(1000);
		tickstart++;
	}

	/*-------------------------------- PLL Configuration -----------------------*/
	/* Check the parameters */
	tickstart = 0;
	/* Disable the main PLL. */
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_PLLON);

	/* Wait till PLL is ready */  
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_PLLRDY) != 0){
		if(tickstart > PLL_TIMEOUT_VALUE){
			while(1) { ; }
		}
		sil_dly_nse(1000);
		tickstart++;
	}
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLCFGR), (0x20000000 | PLL_M | (PLL_N << 6) | ((RCC_PLLP_DIV2 >> 1) -1) << 16)
			 | RCC_PLLCFGR_PLLSRC_HSE | (PLL_Q << 24) | (PLL_R << 28));

	/* Enable the main PLL. */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_PLLON);
	tickstart = 0;

	/* Wait till PLL is ready */  
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_PLLRDY) == 0){
		if(tickstart > PLL_TIMEOUT_VALUE){
			while(1) { ; }
		}
		sil_dly_nse(1000);
		tickstart++;
	}


	tickstart = 0;
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB1ENR), RCC_APB1ENR_PWREN);
	/* Delay after an RCC peripheral clock enabling */
	tmpreg = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB1ENR)) & RCC_APB1ENR_PWREN;
	(void)(tmpreg);

	/* Enable the Over-drive to extend the clock frequency to 216 MHz */
	sil_orw_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR1), PWR_CR1_ODEN);

	while((sil_rew_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CSR1)) & PWR_CSR1_ODRDY) != PWR_CSR1_ODRDY){
		if(tickstart > PWR_OVERDRIVE_TIMEOUT_VALUE){
			while(1) { ; }
		}
		sil_dly_nse(1000);
    	tickstart++;
	}

	/* Enable the Over-drive switch */
	sil_orw_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR1), PWR_CR1_ODSWEN);

	/* Get tick */
	tickstart = 0;
	while((sil_rew_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CSR1)) & PWR_CSR1_ODSWRDY) != PWR_CSR1_ODSWRDY){
		if(tickstart > PWR_OVERDRIVE_TIMEOUT_VALUE){
			while(1) { ; }
		}
		sil_dly_nse(1000);
		tickstart++;
	}

#if BOARDNO == 2 || BOARDNO == 3	/* nucleo */
	USB_RCC_PeriphCLKConfig(384, RCC_PLLSAIP_DIV8);
#else
	USB_RCC_PeriphCLKConfig(192, RCC_PLLSAIP_DIV4);
#endif

  /* To correctly read data from FLASH memory, the number of wait states (LATENCY) 
     must be correctly programmed according to the frequency of the CPU clock 
     (HCLK) and the supply voltage of the device. */
  
	/* Increasing the CPU frequency */
	if(FLASH_ACR_LATENCY_7WS > (sil_rew_mem((uint32_t *)(TADR_FLASH_R_BASE+TOFF_FLASH_ACR)) & FLASH_ACR_LATENCY)){
		/* Program the new number of wait states to the LATENCY bits in the FLASH_ACR register */
		sil_modw_mem((uint32_t *)(TADR_FLASH_R_BASE+TOFF_FLASH_ACR), FLASH_ACR_LATENCY, FLASH_ACR_LATENCY_7WS);

		/* Check that the new number of wait states is taken into account to access the Flash
		memory by reading the FLASH_ACR register */
		if((sil_rew_mem((uint32_t *)(TADR_FLASH_R_BASE+TOFF_FLASH_ACR)) & FLASH_ACR_LATENCY) != FLASH_ACR_LATENCY_7WS){
			while(1) { ; }
		}

		/*-------------------------- HCLK Configuration --------------------------*/
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), RCC_CFGR_HPRE, RCC_SYSCLK_DIV1);

		/*------------------------- SYSCLK Configuration ---------------------------*/ 
		/* PLL is selected as System Clock Source */
		/* Check the PLL ready flag */
		if((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_PLLRDY) == 0){
			while(1) { ; }
		}

		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), RCC_CFGR_SW, RCC_CFGR_SW_PLL);
		while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & RCC_CFGR_SWS) != RCC_CFGR_SWS_PLL){
			if(tickstart > CLOCKSWITCH_TIMEOUT_VALUE){
				while(1) { ; }
			}
			sil_dly_nse(1000);
			tickstart++;
		}
	}
	/* Decreasing the CPU frequency */
	else{
		/*-------------------------- HCLK Configuration --------------------------*/
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), RCC_CFGR_HPRE, RCC_SYSCLK_DIV1);

		/*------------------------- SYSCLK Configuration -------------------------*/
		/* PLL is selected as System Clock Source */
		/* Check the PLL ready flag */
		if((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_PLLRDY) == 0){
			while(1) { ; }
		}

		while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & RCC_CFGR_SWS) != RCC_CFGR_SWS_PLL){
			if(tickstart > CLOCKSWITCH_TIMEOUT_VALUE){
				while(1) { ; }
			}
			sil_dly_nse(1000);
			tickstart++;
		}

		/* Program the new number of wait states to the LATENCY bits in the FLASH_ACR register */
		sil_modw_mem((uint32_t *)(TADR_FLASH_R_BASE+TOFF_FLASH_ACR), FLASH_ACR_LATENCY, FLASH_ACR_LATENCY_7WS);

		/* Check that the new number of wait states is taken into account to access the Flash
		memory by reading the FLASH_ACR register */
		if((sil_rew_mem((uint32_t *)(TADR_FLASH_R_BASE+TOFF_FLASH_ACR)) & FLASH_ACR_LATENCY) != FLASH_ACR_LATENCY_7WS){
			while(1) { ; }
		}
	}

	/*-------------------------- PCLK1 Configuration ---------------------------*/ 
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), RCC_CFGR_PPRE1, RCC_HCLK_DIV4);

	/*-------------------------- PCLK2 Configuration ---------------------------*/ 
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), RCC_CFGR_PPRE2, (RCC_HCLK_DIV2 << 3));
}
#endif

#if BOARDNO == 4 && RAM_EXEC == 0
static void MPU_ConfigPSRAM(void)
{
	/* Disable the MPU */
	sil_andw_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_SHCSR), SCB_SHCSR_MEMFAULTENA_Msk);
	sil_andw_mem((uint32_t *)(TADR_MPU_BASE+TOFF_MPU_CTRL), MPU_CTRL_ENABLE_Msk);

	/* Set the Region number */
	sil_wrw_mem((uint32_t *)(TADR_MPU_BASE+TOFF_MPU_RNR), MPU_REGION_NUMBER1);

	sil_wrw_mem((uint32_t *)(TADR_MPU_BASE+TOFF_MPU_RBAR), 0x64000000);
	sil_wrw_mem((uint32_t *)(TADR_MPU_BASE+TOFF_MPU_RASR),
				((MPU_INSTRUCTION_ACCESS_ENABLE << MPU_RASR_XN_Pos)   |
                 (MPU_REGION_FULL_ACCESS        << MPU_RASR_AP_Pos)   |
                 (MPU_TEX_LEVEL0                << MPU_RASR_TEX_Pos)  |
                 (MPU_ACCESS_SHAREABLE          << MPU_RASR_S_Pos)    |
                 (MPU_ACCESS_CACHEABLE          << MPU_RASR_C_Pos)    |
                 (MPU_ACCESS_BUFFERABLE         << MPU_RASR_B_Pos)    |
                 (0x00                          << MPU_RASR_SRD_Pos)  |
                 (MPU_REGION_SIZE_512KB         << MPU_RASR_SIZE_Pos) |
                 (MPU_REGION_ENABLE             << MPU_RASR_ENABLE_Pos)));

	/* Enable the MPU */
	sil_wrw_mem((uint32_t *)(TADR_MPU_BASE+TOFF_MPU_CTRL), (MPU_PRIVILEGED_DEFAULT | MPU_CTRL_ENABLE_Msk));
	sil_orw_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_SHCSR), SCB_SHCSR_MEMFAULTENA_Msk);
}
#endif


/*
 * Returns the SYSCLK frequency
 * note   The system frequency computed by this function is not the real 
 *        frequency in the chip. It is calculated based on the predefined 
 *        constant and the selected clock source:
 * note   If SYSCLK source is HSI, function returns values based on HSI_VALUE(*)
 * note   If SYSCLK source is HSE, function returns values based on HSE_VALUE(**)
 * note   If SYSCLK source is PLL, function returns values based on HSE_VALUE(**) 
 *         or HSI_VALUE(*) multiplied/divided by the PLL factors.         
 * no     (*) HSI_VALUE is a constant defined in stm32f7xx_hal_conf.h file (default value
 *            16 MHz) but the real value may vary depending on the variations
 *            in voltage and temperature.
 * note   (**) HSE_VALUE is a constant defined in stm32f7xx_hal_conf.h file (default value
 *            25 MHz), user has to ensure that HSE_VALUE is same as the real
 *            frequency of the crystal used. Otherwise, this function may
 *            have wrong result.
 * note   The result of this function could be not correct when using fractional
 *        value for HSE crystal.
 *
 * note   This function can be used by the user application to compute the 
 *        baudrate for the communication peripherals or configure other parameters.
 *
 * note   Each time SYSCLK changes, this function must be called to update the
 *        right SYSCLK value. Otherwise, any configuration based on this function will be incorrect.
 *
 * @retval SYSCLK frequency
 */
uint32_t RCC_GetSysClockFreq(void)
{
	uint32_t pllm = 0, pllvco = 0, pllp = 0;
	uint32_t sysclockfreq = 0;

	/* Get SYSCLK source -------------------------------------------------------*/
	switch(sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & RCC_CFGR_SWS){
	case RCC_CFGR_SWS_HSI:	  	/* HSI used as system clock source */
		sysclockfreq = HSI_VALUE;
		break;
	case RCC_CFGR_SWS_HSE:		/* HSE used as system clock  source */
		sysclockfreq = HSE_VALUE;
		break;
	case RCC_CFGR_SWS_PLL:		/* PLL used as system clock  source */
		/* PLL_VCO = (HSE_VALUE or HSI_VALUE / PLLM) * PLLN
			SYSCLK = PLL_VCO / PLLP */
		pllm = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLCFGR)) & RCC_PLLCFGR_PLLM;
		if (((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLCFGR)) & RCC_PLLCFGR_PLLSRC)) != RCC_PLLCFGR_PLLSRC_HSI){
			/* HSE used as PLL clock source */
			pllvco = (HSE_VALUE / pllm) * ((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLCFGR)) & RCC_PLLCFGR_PLLN) >> 6);
		}
		else{
			/* HSI used as PLL clock source */
			pllvco = (HSI_VALUE / pllm) * ((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLCFGR)) & RCC_PLLCFGR_PLLN) >> 6);
		}
		pllp = (((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLCFGR)) & RCC_PLLCFGR_PLLP) >> 16) + 1 ) *2;
		sysclockfreq = pllvco/pllp;
		break;
    default:
		sysclockfreq = HSI_VALUE;
		break;
	}
	return sysclockfreq;
}

/*
 * Returns the HCLK frequency
 * note   Each time HCLK changes, this function must be called to update the
 *        right HCLK value. Otherwise, any configuration based on this function will be incorrect.
 * note   The SystemCoreClock CMSIS variable is used to store System Clock Frequency 
 *        and updated within this function
 * retval HCLK frequency
 */
uint32_t RCC_GetHCLKFreq(void)
{
	SystemCoreClock = RCC_GetSysClockFreq() >> APBAHBPrescTable[(sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & RCC_CFGR_HPRE)>> 4];
	return SystemCoreClock;
}

/*
 * Returns the PCLK1 frequency
 * note   Each time PCLK1 changes, this function must be called to update the
 *        right PCLK1 value. Otherwise, any configuration based on this function will be incorrect.
 * retval PCLK2 frequency
 */
uint32_t RCC_GetPCLK1Freq(void)
{
	/* Get HCLK source and Compute PCLK2 frequency ---------------------------*/
	return (RCC_GetHCLKFreq()>> APBAHBPrescTable[(sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & RCC_CFGR_PPRE1) >> 10]);
}

/*
 * Returns the PCLK2 frequency
 * note   Each time PCLK2 changes, this function must be called to update the
 *        right PCLK2 value. Otherwise, any configuration based on this function will be incorrect.
 * retval PCLK2 frequency
 */
uint32_t RCC_GetPCLK2Freq(void)
{
	/* Get HCLK source and Compute PCLK2 frequency ---------------------------*/
	return (RCC_GetHCLKFreq()>> APBAHBPrescTable[(sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & RCC_CFGR_PPRE2) >> 13]);
}

/*
 *  Setup the microcontroller system
 *     Initialize the Embedded Flash Interface, the PLL and update the 
 *     SystemFrequency variable.
 */
void SystemInit(void)
{
#if RAM_EXEC == 0
	uint32_t reg_value;
	uint32_t ccsidr, sshift, wshift, sw;
	uint32_t sets, ways;

	/* Reset the RCC clock configuration to the default reset state ------------*/
	/* Set HSION bit */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_HSION);

	/* Reset CFGR register */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), 0x00000000);

	/* Reset HSEON, CSSON and PLLON bits */
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), (RCC_CR_PLLON | RCC_CR_CSSON | RCC_CR_HSEON));

	/* Reset PLLCFGR register */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLCFGR),
		(0x20000000 | RCC_PLLCFGR_PLLQ_2 | RCC_PLLCFGR_PLLN_7 | RCC_PLLCFGR_PLLN_6 | RCC_PLLCFGR_PLLM_4));

	/* Reset HSEBYP bit */
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_HSEBYP);

	/* Disable all interrupts */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CIR), 0x00000000);

	/* Configure the MPU attributes as Write Through */
	MPU_Config();
#if BOARDNO == 4
	MPU_ConfigPSRAM();
#endif

	/* Enable I-Cache */
	asm volatile ("dsb 0xF":::"memory");
	asm volatile ("isb 0xF":::"memory");
	sil_wrw_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_ICIALLU), 0);	/* invalidate I-Cache */
	sil_orw_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_CCR), SCB_CCR_IC_Msk);	/* enable I-Cache */
	asm volatile ("dsb 0xF":::"memory");
	asm volatile ("isb 0xF":::"memory");

	/* Enable D-Cache */
	sil_wrw_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_CSSELR), ((0UL << 1) | 0UL));	/* Level 1 data cache */
	ccsidr  = sil_rew_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_CCSIDR));
    sets    = (uint32_t)(CCSIDR_SETS(ccsidr));
    sshift  = (uint32_t)(CCSIDR_LSSHIFT(ccsidr) + 4UL);
    ways    = (uint32_t)(CCSIDR_WAYS(ccsidr));
    wshift  = (uint32_t)((uint32_t)__builtin_clz(ways) & 0x1FUL);

	asm volatile ("dsb 0xF":::"memory");
	do {                                   // invalidate D-Cache
		uint32_t tmpways = ways;
		do {
			sw = ((tmpways << wshift) | (sets << sshift));
			sil_wrw_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_DCISW), sw);

        } while(tmpways--);
    } while(sets--);
	asm volatile ("dsb 0xF":::"memory");

	sil_orw_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_CCR), SCB_CCR_DC_Msk);	/* enable D-Cache */

	asm volatile ("dsb 0xF":::"memory");
	asm volatile ("isb 0xF":::"memory");


	/* Set Interrupt Group Priority */
	reg_value = sil_rew_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_AIRCR));                /* read old register configuration    */
	reg_value &= ~((uint32_t)(SCB_AIRCR_VECTKEY_Msk | SCB_AIRCR_PRIGROUP_Msk));	/* clear bits to change               */
	reg_value  =  (reg_value                                   |
                ((uint32_t)0x5FAUL << SCB_AIRCR_VECTKEY_Pos) |
                ((NVIC_PRIORITYGROUP_4 & 0x07L) << 8));							/* Insert write key and priorty group */
	sil_wrw_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_AIRCR), reg_value);

	/* Configure the system clock to 216 MHz */
	SystemClock_Config();
#endif
	RCC_GetHCLKFreq();
}


