/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2015      by 3rd Designing Center
 *              Imageing System Development Division RICOH COMPANY, LTD.
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: stm32f7xx.h,v 1.1 2015/07/18 21:48:24 roi Exp $
 */

#ifndef _STM32F7XX_H_
#define _STM32F7XX_H_

/*
 *  Configuration of the Cortex-M7 Processor and Core Peripherals 
 */
#define __CM7_REV                 0x0000   /*!< Cortex-M7 revision r0p0                       */
#define __MPU_PRESENT             1       /*!< CM7 provides an MPU                           */
#define __NVIC_PRIO_BITS          4       /*!< CM7 uses 4 Bits for the Priority Levels       */
#define __Vendor_SysTickConfig    0       /*!< Set to 1 if different SysTick Config is used  */
#define __FPU_PRESENT             1       /*!< FPU present                                   */
#include "core_f7.h"                 /* Cortex-M7 processor and core peripherals      */

/*
 *  INTERRUPT NUMBER
 */
#define NonMaskableInt_IRQn     -14		/* 2 Non Maskable Interrupt                                          */
#define MemoryManagement_IRQn   -12		/* 4 Cortex-M7 Memory Management Interrupt                           */
#define BusFault_IRQn           -11		/* 5 Cortex-M7 Bus Fault Interrupt                                   */
#define UsageFault_IRQn         -10		/* 6 Cortex-M7 Usage Fault Interrupt                                 */
#define SVCall_IRQn             -5		/* 11 Cortex-M7 SV Call Interrupt                                    */
#define DebugMonitor_IRQn       -4		/* 12 Cortex-M7 Debug Monitor Interrupt                              */
#define PendSV_IRQn             -2		/* 14 Cortex-M7 Pend SV Interrupt                                    */
#define SysTick_IRQn            -1		/* 15 Cortex-M7 System Tick Interrupt                                */

#define WWDG_IRQn               0		/* Window WatchDog Interrupt                                         */
#define PVD_IRQn                1		/* PVD through EXTI Line detection Interrupt                         */
#define TAMP_STAMP_IRQn         2		/* Tamper and TimeStamp interrupts through the EXTI line             */
#define RTC_WKUP_IRQn           3		/* RTC Wakeup interrupt through the EXTI line                        */
#define FLASH_IRQn              4		/* FLASH global Interrupt                                            */
#define RCC_IRQn                5		/* RCC global Interrupt                                              */
#define EXTI0_IRQn              6		/* EXTI Line0 Interrupt                                              */
#define EXTI1_IRQn              7		/* EXTI Line1 Interrupt                                              */
#define EXTI2_IRQn              8		/* EXTI Line2 Interrupt                                              */
#define EXTI3_IRQn              9		/* EXTI Line3 Interrupt                                              */
#define EXTI4_IRQn              10		/* EXTI Line4 Interrupt                                              */
#define DMA1_Stream0_IRQn       11		/* DMA1 Stream 0 global Interrupt                                    */
#define DMA1_Stream1_IRQn       12		/* DMA1 Stream 1 global Interrupt                                    */
#define DMA1_Stream2_IRQn       13		/* DMA1 Stream 2 global Interrupt                                    */
#define DMA1_Stream3_IRQn       14		/* DMA1 Stream 3 global Interrupt                                    */
#define DMA1_Stream4_IRQn       15		/* DMA1 Stream 4 global Interrupt                                    */
#define DMA1_Stream5_IRQn       16		/* DMA1 Stream 5 global Interrupt                                    */
#define DMA1_Stream6_IRQn       17		/* DMA1 Stream 6 global Interrupt                                    */
#define ADC_IRQn                18		/* ADC1, ADC2 and ADC3 global Interrupts                             */
#define CAN1_TX_IRQn            19		/* CAN1 TX Interrupt                                                 */
#define CAN1_RX0_IRQn           20		/* CAN1 RX0 Interrupt                                                */
#define CAN1_RX1_IRQn           21		/* CAN1 RX1 Interrupt                                                */
#define CAN1_SCE_IRQn           22		/* CAN1 SCE Interrupt                                                */
#define EXTI9_5_IRQn            23		/* External Line[9:5] Interrupts                                     */
#define TIM1_BRK_TIM9_IRQn      24		/* TIM1 Break interrupt and TIM9 global interrupt                    */
#define TIM1_UP_TIM10_IRQn      25		/* TIM1 Update Interrupt and TIM10 global interrupt                  */
#define TIM1_TRG_COM_TIM11_IRQn 26		/* TIM1 Trigger and Commutation Interrupt and TIM11 global interrupt */
#define TIM1_CC_IRQn            27		/* TIM1 Capture Compare Interrupt                                    */
#define TIM2_IRQn               28		/* TIM2 global Interrupt                                             */
#define TIM3_IRQn               29		/* TIM3 global Interrupt                                             */
#define TIM4_IRQn               30		/* TIM4 global Interrupt                                             */
#define I2C1_EV_IRQn            31		/* I2C1 Event Interrupt                                              */
#define I2C1_ER_IRQn            32		/* I2C1 Error Interrupt                                              */
#define I2C2_EV_IRQn            33		/* I2C2 Event Interrupt                                              */
#define I2C2_ER_IRQn            34		/* I2C2 Error Interrupt                                              */  
#define SPI1_IRQn               35		/* SPI1 global Interrupt                                             */
#define SPI2_IRQn               36		/* SPI2 global Interrupt                                             */
#define USART1_IRQn             37		/* USART1 global Interrupt                                           */
#define USART2_IRQn             38		/* USART2 global Interrupt                                           */
#define USART3_IRQn             39		/* USART3 global Interrupt                                           */
#define EXTI15_10_IRQn          40		/* External Line[15:10] Interrupts                                   */
#define RTC_Alarm_IRQn          41		/* RTC Alarm (A and B) through EXTI Line Interrupt                   */
#define OTG_FS_WKUP_IRQn        42		/* USB OTG FS Wakeup through EXTI line interrupt                     */    
#define TIM8_BRK_TIM12_IRQn     43		/* TIM8 Break Interrupt and TIM12 global interrupt                   */
#define TIM8_UP_TIM13_IRQn      44		/* TIM8 Update Interrupt and TIM13 global interrupt                  */
#define TIM8_TRG_COM_TIM14_IRQn 45		/* TIM8 Trigger and Commutation Interrupt and TIM14 global interrupt */
#define TIM8_CC_IRQn            46		/* TIM8 Capture Compare Interrupt                                    */
#define DMA1_Stream7_IRQn       47		/* DMA1 Stream7 Interrupt                                            */
#define FMC_IRQn                48		/* FMC global Interrupt                                              */
#define SDMMC1_IRQn             49		/* SDMMC1 global Interrupt                                             */
#define TIM5_IRQn               50		/* TIM5 global Interrupt                                             */
#define SPI3_IRQn               51		/* SPI3 global Interrupt                                             */
#define UART4_IRQn              52		/* UART4 global Interrupt                                            */
#define UART5_IRQn              53		/* UART5 global Interrupt                                            */
#define TIM6_DAC_IRQn           54		/* TIM6 global and DAC1&2 underrun error  interrupts                 */
#define TIM7_IRQn               55		/* TIM7 global interrupt                                             */
#define DMA2_Stream0_IRQn       56		/* DMA2 Stream 0 global Interrupt                                    */
#define DMA2_Stream1_IRQn       57		/* DMA2 Stream 1 global Interrupt                                    */
#define DMA2_Stream2_IRQn       58		/* DMA2 Stream 2 global Interrupt                                    */
#define DMA2_Stream3_IRQn       59		/* DMA2 Stream 3 global Interrupt                                    */
#define DMA2_Stream4_IRQn       60		/* DMA2 Stream 4 global Interrupt                                    */
#define ETH_IRQn                61		/* Ethernet global Interrupt                                         */
#define ETH_WKUP_IRQn           62		/* Ethernet Wakeup through EXTI line Interrupt                       */
#define CAN2_TX_IRQn            63		/* CAN2 TX Interrupt                                                 */
#define CAN2_RX0_IRQn           64		/* CAN2 RX0 Interrupt                                                */
#define CAN2_RX1_IRQn           65		/* CAN2 RX1 Interrupt                                                */
#define CAN2_SCE_IRQn           66		/* CAN2 SCE Interrupt                                                */
#define OTG_FS_IRQn             67		/* USB OTG FS global Interrupt                                       */
#define DMA2_Stream5_IRQn       68		/* DMA2 Stream 5 global interrupt                                    */
#define DMA2_Stream6_IRQn       69		/* DMA2 Stream 6 global interrupt                                    */
#define DMA2_Stream7_IRQn       70		/* DMA2 Stream 7 global interrupt                                    */
#define USART6_IRQn             71		/* USART6 global interrupt                                           */
#define I2C3_EV_IRQn            72		/* I2C3 event interrupt                                              */
#define I2C3_ER_IRQn            73		/* I2C3 error interrupt                                              */
#define OTG_HS_EP1_OUT_IRQn     74		/* USB OTG HS End Point 1 Out global interrupt                       */
#define OTG_HS_EP1_IN_IRQn      75		/* USB OTG HS End Point 1 In global interrupt                        */
#define OTG_HS_WKUP_IRQn        76		/* USB OTG HS Wakeup through EXTI interrupt                          */
#define OTG_HS_IRQn             77		/* USB OTG HS global interrupt                                       */
#define DCMI_IRQn               78		/* DCMI global interrupt                                             */
#define CRYP_IRQn               79		/* CRYP crypto global interrupt                                      */
#define HASH_RNG_IRQn           80		/* Hash and Rng global interrupt                                     */
#define FPU_IRQn                81		/* FPU global interrupt                                              */
#define UART7_IRQn              82		/* UART7 global interrupt                                            */
#define UART8_IRQn              83		/* UART8 global interrupt                                            */
#define SPI4_IRQn               84		/* SPI4 global Interrupt                                             */
#define SPI5_IRQn               85		/* SPI5 global Interrupt                                             */
#define SPI6_IRQn               86		/* SPI6 global Interrupt                                             */
#define SAI1_IRQn               87		/* SAI1 global Interrupt                                             */
#define LTDC_IRQn               88		/* LTDC global Interrupt                                             */
#define LTDC_ER_IRQn            89		/* LTDC Error global Interrupt                                       */
#define DMA2D_IRQn              90		/* DMA2D global Interrupt                                           */
#define SAI2_IRQn               91		/* SAI2 global Interrupt                                             */
#define QUADSPI_IRQn            92		/* Quad SPI global interrupt                                         */
#define LPTIM1_IRQn             93		/* LP TIM1 interrupt                                                 */
#define CEC_IRQn                94		/* HDMI-CEC global Interrupt                                         */
#define I2C4_EV_IRQn            95		/* I2C4 Event Interrupt                                              */
#define I2C4_ER_IRQn            96		/* I2C4 Error Interrupt                                              */
#define SPDIF_RX_IRQn           97		/* SPDIF-RX global Interrupt                                         */

/*
 *  PERIPHERAL MEMORY MAP
 */
#define RAMITCM_BASE        0x00000000	/* Base address of :16KB RAM reserved for CPU execution/instruction accessible over ITCM   */
#define FLASHITCM_BASE      0x00200000	/* Base address of :(up to 1 MB) embedded FLASH memory  accessible over ITCM               */                       
#define FLASHAXI_BASE       0x08000000	/* Base address of : (up to 1 MB) embedded FLASH memory accessible over AXI                */                       
#define RAMDTCM_BASE        0x20000000	/* Base address of : 64KB system data RAM accessible over DTCM                             */
#define SRAM1_BASE          0x20010000	/* Base address of : 240KB RAM1 accessible over AXI/AHB                                    */
#define SRAM2_BASE          0x2004C000	/* Base address of : 16KB RAM2 accessible over AXI/AHB                                     */
#define PERIPH_BASE         0x40000000	/* Base address of : AHB/ABP Peripherals                                                   */
#define BKPSRAM_BASE        0x40024000	/* Base address of : Backup SRAM(4 KB)                                                     */
#define QSPI_BASE           0x90000000	/* Base address of : QSPI memories  accessible over AXI                                    */
#define FMC_R_BASE          0xA0000000	/* Base address of : FMC Control registers                                                 */
#define QSPI_R_BASE         0xA0001000	/* Base address of : QSPI Control  registers                                               */
#define FLASH_END           0x080FFFFF	/* FLASH end address */

#define FLASH_BASE          FLASHAXI_BASE	/* FLASH(up to 1 MB) base address in the alias region                         */

/* Peripheral memory map */
#define APB1PERIPH_BASE     PERIPH_BASE
#define APB2PERIPH_BASE     (PERIPH_BASE + 0x00010000)
#define AHB1PERIPH_BASE     (PERIPH_BASE + 0x00020000)
#define AHB2PERIPH_BASE     (PERIPH_BASE + 0x10000000)

/*
 *  TIM
 */
#define TADR_TIM2_BASE      (APB1PERIPH_BASE + 0x0000)
#define TADR_TIM3_BASE      (APB1PERIPH_BASE + 0x0400)
#define TADR_TIM4_BASE      (APB1PERIPH_BASE + 0x0800)
#define TADR_TIM5_BASE      (APB1PERIPH_BASE + 0x0C00)
#define TADR_TIM6_BASE      (APB1PERIPH_BASE + 0x1000)
#define TADR_TIM7_BASE      (APB1PERIPH_BASE + 0x1400)
#define TADR_TIM12_BASE     (APB1PERIPH_BASE + 0x1800)
#define TADR_TIM13_BASE     (APB1PERIPH_BASE + 0x1C00)
#define TADR_TIM14_BASE     (APB1PERIPH_BASE + 0x2000)
#define TADR_TIM1_BASE      (APB2PERIPH_BASE + 0x0000)
#define TADR_TIM8_BASE      (APB2PERIPH_BASE + 0x0400)
#define TADR_TIM9_BASE      (APB2PERIPH_BASE + 0x4000)
#define TADR_TIM10_BASE     (APB2PERIPH_BASE + 0x4400)
#define TADR_TIM11_BASE     (APB2PERIPH_BASE + 0x4800)
#define TOFF_TIM_CR1        0x0000		/* (RW) TIM control register 1 */
  #define TIM_CR1_CEN        0x0001		/* Counter enable */
  #define TIM_CR1_UDIS       0x0002		/* Update disable */
  #define TIM_CR1_URS        0x0004		/* Update request source */
  #define TIM_CR1_OPM        0x0008		/* One pulse mode */
  #define TIM_CR1_DIR        0x0010		/* Direction */
  #define TIM_CR1_CMS_0      0x0020		/* CMS[1:0] bit 0 */
  #define TIM_CR1_CMS_1      0x0040		/* CMS[1:0] bit 1 */
  #define TIM_CR1_ARPE       0x0080		/* Auto-reload preload enable */
  #define TIM_CR1_CKD_0      0x0100		/* CKD[1:0] bit 0 */
  #define TIM_CR1_CKD_1      0x0200		/* CKD[1:0] bit 1 */
  #define TIM_CR1_UIFREMAP   0x0800		/* UIF status bit */
#define TOFF_TIM_CR2        0x0004		/* (RW) TIM control register 2 */
  #define TIM_CR2_CCPC       0x00000001	/* Capture/Compare Preloaded Control        */
  #define TIM_CR2_CCUS       0x00000004	/* Capture/Compare Control Update Selection */
  #define TIM_CR2_CCDS       0x00000008	/* Capture/Compare DMA Selection            */
  #define TIM_CR2_OIS5       0x00010000	/* Output Idle state 4 (OC4 output) */
  #define TIM_CR2_OIS6       0x00040000	/* Output Idle state 4 (OC4 output) */
  #define TIM_CR2_MMS        0x0070		/* MMS[2:0] bits (Master Mode Selection) */
  #define TIM_CR2_MMS_0      0x0010		/* Bit 0 */
  #define TIM_CR2_MMS_1      0x0020		/* Bit 1 */
  #define TIM_CR2_MMS_2      0x0040		/* Bit 2 */
  #define TIM_CR2_MMS2       0x00F00000	/* MMS[2:0] bits (Master Mode Selection) */
  #define TIM_CR2_MMS2_0     0x00100000	/* Bit 0 */
  #define TIM_CR2_MMS2_1     0x00200000	/* Bit 1 */
  #define TIM_CR2_MMS2_2     0x00400000	/* Bit 2 */
  #define TIM_CR2_MMS2_3     0x00800000	/* Bit 2 */
  #define TIM_CR2_TI1S       0x0080		/* TI1 Selection */
  #define TIM_CR2_OIS1       0x0100		/* Output Idle state 1 (OC1 output)  */
  #define TIM_CR2_OIS1N      0x0200		/* Output Idle state 1 (OC1N output) */
  #define TIM_CR2_OIS2       0x0400		/* Output Idle state 2 (OC2 output)  */
  #define TIM_CR2_OIS2N      0x0800		/* Output Idle state 2 (OC2N output) */
  #define TIM_CR2_OIS3       0x1000		/* Output Idle state 3 (OC3 output)  */
  #define TIM_CR2_OIS3N      0x2000		/* Output Idle state 3 (OC3N output) */
  #define TIM_CR2_OIS4       0x4000		/* Output Idle state 4 (OC4 output)  */
#define TOFF_TIM_SMCR       0x0008		/* (RW) TIM slave mode control register */
  #define TIM_SMCR_SMS       0x00010007	/* SMS[2:0] bits (Slave mode selection)    */
  #define TIM_SMCR_SMS_0     0x00000001	/* Bit 0 */
  #define TIM_SMCR_SMS_1     0x00000002	/* Bit 1 */
  #define TIM_SMCR_SMS_2     0x00000004	/* Bit 2 */
  #define TIM_SMCR_SMS_3     0x00010000	/* Bit 3 */
  #define TIM_SMCR_OCCS      0x00000008	/* OCREF clear selection */
  #define TIM_SMCR_TS        0x0070		/* TS[2:0] bits (Trigger selection)        */
  #define TIM_SMCR_TS_0      0x0010		/* Bit 0 */
  #define TIM_SMCR_TS_1      0x0020		/* Bit 1 */
  #define TIM_SMCR_TS_2      0x0040		/* Bit 2 */
  #define TIM_SMCR_MSM       0x0080		/* Master/slave mode                       */
  #define TIM_SMCR_ETF       0x0F00		/* ETF[3:0] bits (External trigger filter) */
  #define TIM_SMCR_ETF_0     0x0100		/* Bit 0 */
  #define TIM_SMCR_ETF_1     0x0200		/* Bit 1 */
  #define TIM_SMCR_ETF_2     0x0400		/* Bit 2 */
  #define TIM_SMCR_ETF_3     0x0800		/* Bit 3 */
  #define TIM_SMCR_ETPS      0x3000		/* ETPS[1:0] bits (External trigger prescaler) */
  #define TIM_SMCR_ETPS_0    0x1000		/* Bit 0 */
  #define TIM_SMCR_ETPS_1    0x2000		/* Bit 1 */
  #define TIM_SMCR_ECE       0x4000		/* External clock enable     */
  #define TIM_SMCR_ETP       0x8000		/* External trigger polarity */
#define TOFF_TIM_DIER       0x000C		/* (RW) TIM DMA/interrupt enable register */
  #define TIM_DIER_UIE       0x0001		/* Update interrupt enable */
  #define TIM_DIER_CC1IE     0x0002		/* Capture/Compare 1 interrupt enable */
  #define TIM_DIER_CC2IE     0x0004		/* Capture/Compare 2 interrupt enable */
  #define TIM_DIER_CC3IE     0x0008		/* Capture/Compare 3 interrupt enable */
  #define TIM_DIER_CC4IE     0x0010		/* Capture/Compare 4 interrupt enable */
  #define TIM_DIER_COMIE     0x0020		/* COM interrupt enable */
  #define TIM_DIER_TIE       0x0040		/* Trigger interrupt enable */
  #define TIM_DIER_BIE       0x0080		/* Break interrupt enable */
  #define TIM_DIER_UDE       0x0100		/* Update DMA request enable */
  #define TIM_DIER_CC1DE     0x0200		/* Capture/Compare 1 DMA request enable */
  #define TIM_DIER_CC2DE     0x0400		/* Capture/Compare 2 DMA request enable */
  #define TIM_DIER_CC3DE     0x0800		/* Capture/Compare 3 DMA request enable */
  #define TIM_DIER_CC4DE     0x1000		/* Capture/Compare 4 DMA request enable */
  #define TIM_DIER_COMDE     0x2000		/* COM DMA request enable */
  #define TIM_DIER_TDE       0x4000		/* Trigger DMA request enable */
#define TOFF_TIM_SR         0x0010		/* (RW) TIM status register */
  #define TIM_SR_UIF         0x0001		/* Update interrupt Flag */
  #define TIM_SR_CC1IF       0x0002		/* Capture/Compare 1 interrupt Flag */
  #define TIM_SR_CC2IF       0x0004		/* Capture/Compare 2 interrupt Flag */
  #define TIM_SR_CC3IF       0x0008		/* Capture/Compare 3 interrupt Flag */
  #define TIM_SR_CC4IF       0x0010		/* Capture/Compare 4 interrupt Flag */
  #define TIM_SR_COMIF       0x0020		/* COM interrupt Flag */
  #define TIM_SR_TIF         0x0040		/* Trigger interrupt Flag */
  #define TIM_SR_BIF         0x0080		/* Break interrupt Flag */
  #define TIM_SR_CC1OF       0x0200		/* Capture/Compare 1 Overcapture Flag */
  #define TIM_SR_CC2OF       0x0400		/* Capture/Compare 2 Overcapture Flag */
  #define TIM_SR_CC3OF       0x0800		/* Capture/Compare 3 Overcapture Flag */
  #define TIM_SR_CC4OF       0x1000		/* Capture/Compare 4 Overcapture Flag */
#define TOFF_TIM_EGR        0x0014		/* (RW) TIM event generation register */
  #define TIM_EGR_UG         0x00000001	/* Update Generation */
  #define TIM_EGR_CC1G       0x00000002	/* Capture/Compare 1 Generation */
  #define TIM_EGR_CC2G       0x00000004	/* Capture/Compare 2 Generation */
  #define TIM_EGR_CC3G       0x00000008	/* Capture/Compare 3 Generation */
  #define TIM_EGR_CC4G       0x00000010	/* Capture/Compare 4 Generation              */
  #define TIM_EGR_COMG       0x00000020	/* Capture/Compare Control Update Generation */
  #define TIM_EGR_TG         0x00000040	/* Trigger Generation */
  #define TIM_EGR_BG         0x00000080	/* Break Generation */
  #define TIM_EGR_B2G        0x00000100	/* Break2 Generation */
#define TOFF_TIM_CCMR1      0x0018		/* (RW) TIM capture/compare mode register 1 */
  #define TIM_CCMR1_CC1S     0x00000003	/* CC1S[1:0] bits (Capture/Compare 1 Selection) */
  #define TIM_CCMR1_CC1S_0   0x00000001	/* Bit 0 */
  #define TIM_CCMR1_CC1S_1   0x00000002	/* Bit 1 */
  #define TIM_CCMR1_OC1FE    0x00000004	/* Output Compare 1 Fast enable                 */
  #define TIM_CCMR1_OC1PE    0x00000008	/* Output Compare 1 Preload enable              */
  #define TIM_CCMR1_OC1M     0x00010070	/* OC1M[2:0] bits (Output Compare 1 Mode)       */
  #define TIM_CCMR1_OC1M_0   0x00000010	/* Bit 0 */
  #define TIM_CCMR1_OC1M_1   0x00000020	/* Bit 1 */
  #define TIM_CCMR1_OC1M_2   0x00000040	/* Bit 2 */
  #define TIM_CCMR1_OC1M_3   0x00010000	/* Bit 3 */
  #define TIM_CCMR1_OC1CE    0x00000080	/* Output Compare 1Clear Enable                 */
  #define TIM_CCMR1_CC2S     0x00000300	/* CC2S[1:0] bits (Capture/Compare 2 Selection) */
  #define TIM_CCMR1_CC2S_0   0x00000100	/* Bit 0 */
  #define TIM_CCMR1_CC2S_1   0x00000200	/* Bit 1 */
  #define TIM_CCMR1_OC2FE    0x00000400	/* Output Compare 2 Fast enable                 */
  #define TIM_CCMR1_OC2PE    0x00000800	/* Output Compare 2 Preload enable              */
  #define TIM_CCMR1_OC2M     0x01007000	/* OC2M[2:0] bits (Output Compare 2 Mode)       */
  #define TIM_CCMR1_OC2M_0   0x00001000	/* Bit 0 */
  #define TIM_CCMR1_OC2M_1   0x00002000	/* Bit 1 */
  #define TIM_CCMR1_OC2M_2   0x00004000	/* Bit 2 */
  #define TIM_CCMR1_OC2M_3   0x01000000	/* Bit 3 */
  #define TIM_CCMR1_IC1PSC   0x000C		/* IC1PSC[1:0] bits (Input Capture 1 Prescaler) */
  #define TIM_CCMR1_IC1PSC_0 0x0004		/* Bit 0 */
  #define TIM_CCMR1_IC1PSC_1 0x0008		/* Bit 1 */
  #define TIM_CCMR1_IC1F     0x00F0		/* IC1F[3:0] bits (Input Capture 1 Filter)      */
  #define TIM_CCMR1_IC1F_0   0x0010		/* Bit 0 */
  #define TIM_CCMR1_IC1F_1   0x0020		/* Bit 1 */
  #define TIM_CCMR1_IC1F_2   0x0040		/* Bit 2 */
  #define TIM_CCMR1_IC1F_3   0x0080		/* Bit 3 */
  #define TIM_CCMR1_IC2PSC   0x0C00		/* IC2PSC[1:0] bits (Input Capture 2 Prescaler)  */
  #define TIM_CCMR1_IC2PSC_0 0x0400		/* Bit 0 */
  #define TIM_CCMR1_IC2PSC_1 0x0800		/* Bit 1 */
  #define TIM_CCMR1_IC2F     0xF000		/* IC2F[3:0] bits (Input Capture 2 Filter)       */
  #define TIM_CCMR1_IC2F_0   0x1000		/* Bit 0 */
  #define TIM_CCMR1_IC2F_1   0x2000		/* Bit 1 */
  #define TIM_CCMR1_IC2F_2   0x4000		/* Bit 2 */
  #define TIM_CCMR1_IC2F_3   0x8000		/* Bit 3 */
  #define TIM_CCMR1_OC2CE    0x00008000	/* Output Compare 2 Clear Enable */
#define TOFF_TIM_CCMR2      0x001C		/* (RW) TIM capture/compare mode register 2 */
  #define TIM_CCMR2_CC3S     0x00000003	/* CC3S[1:0] bits (Capture/Compare 3 Selection)  */
  #define TIM_CCMR2_CC3S_0   0x00000001	/* Bit 0 */
  #define TIM_CCMR2_CC3S_1   0x00000002	/* Bit 1 */
  #define TIM_CCMR2_OC3FE    0x00000004	/* Output Compare 3 Fast enable           */
  #define TIM_CCMR2_OC3PE    0x00000008	/* Output Compare 3 Preload enable        */
  #define TIM_CCMR2_OC3M     0x00010070	/* OC3M[2:0] bits (Output Compare 3 Mode) */
  #define TIM_CCMR2_OC3M_0   0x00000010	/* Bit 0 */
  #define TIM_CCMR2_OC3M_1   0x00000020	/* Bit 1 */
  #define TIM_CCMR2_OC3M_2   0x00000040	/* Bit 2 */
  #define TIM_CCMR2_OC3M_3   0x00010000	/* Bit 3 */
  #define TIM_CCMR2_OC3CE    0x00000080	/* Output Compare 3 Clear Enable */
  #define TIM_CCMR2_CC4S     0x00000300	/* CC4S[1:0] bits (Capture/Compare 4 Selection) */
  #define TIM_CCMR2_CC4S_0   0x00000100	/* Bit 0 */
  #define TIM_CCMR2_CC4S_1   0x00000200	/* Bit 1 */
  #define TIM_CCMR2_OC4FE    0x00000400	/* Output Compare 4 Fast enable    */
  #define TIM_CCMR2_OC4PE    0x00000800	/* Output Compare 4 Preload enable */
  #define TIM_CCMR2_OC4M     0x01007000	/* OC4M[2:0] bits (Output Compare 4 Mode) */
  #define TIM_CCMR2_OC4M_0   0x00001000	/* Bit 0 */
  #define TIM_CCMR2_OC4M_1   0x00002000	/* Bit 1 */
  #define TIM_CCMR2_OC4M_2   0x00004000	/* Bit 2 */
  #define TIM_CCMR2_OC4M_3   0x01000000	/* Bit 3 */
  #define TIM_CCMR2_OC4CE    0x8000		/* Output Compare 4 Clear Enable */
  #define TIM_CCMR2_IC3PSC   0x000C		/* IC3PSC[1:0] bits (Input Capture 3 Prescaler) */
  #define TIM_CCMR2_IC3PSC_0 0x0004		/* Bit 0 */
  #define TIM_CCMR2_IC3PSC_1 0x0008		/* Bit 1 */
  #define TIM_CCMR2_IC3F     0x00F0		/* IC3F[3:0] bits (Input Capture 3 Filter) */
  #define TIM_CCMR2_IC3F_0   0x0010		/* Bit 0 */
  #define TIM_CCMR2_IC3F_1   0x0020		/* Bit 1 */
  #define TIM_CCMR2_IC3F_2   0x0040		/* Bit 2 */
  #define TIM_CCMR2_IC3F_3   0x0080		/* Bit 3 */
  #define TIM_CCMR2_IC4PSC   0x0C00		/* IC4PSC[1:0] bits (Input Capture 4 Prescaler) */
  #define TIM_CCMR2_IC4PSC_0 0x0400		/* Bit 0 */
  #define TIM_CCMR2_IC4PSC_1 0x0800		/* Bit 1 */
  #define TIM_CCMR2_IC4F     0xF000		/* IC4F[3:0] bits (Input Capture 4 Filter) */
  #define TIM_CCMR2_IC4F_0   0x1000		/* Bit 0 */
  #define TIM_CCMR2_IC4F_1   0x2000		/* Bit 1 */
  #define TIM_CCMR2_IC4F_2   0x4000		/* Bit 2 */
  #define TIM_CCMR2_IC4F_3   0x8000		/* Bit 3 */
#define TOFF_TIM_CCER       0x0020		/* (RW) TIM capture/compare enable register */
  #define TIM_CCER_CC1E      0x00000001	/* Capture/Compare 1 output enable */
  #define TIM_CCER_CC1P      0x00000002	/* Capture/Compare 1 output Polarity */
  #define TIM_CCER_CC1NE     0x00000004	/* Capture/Compare 1 Complementary output enable */
  #define TIM_CCER_CC1NP     0x00000008	/* Capture/Compare 1 Complementary output Polarity */
  #define TIM_CCER_CC2E      0x00000010	/* Capture/Compare 2 output enable */
  #define TIM_CCER_CC2P      0x00000020	/* Capture/Compare 2 output Polarity */
  #define TIM_CCER_CC2NE     0x00000040	/* Capture/Compare 2 Complementary output enable */
  #define TIM_CCER_CC2NP     0x00000080	/* Capture/Compare 2 Complementary output Polarity */
  #define TIM_CCER_CC3E      0x00000100	/* Capture/Compare 3 output enable */
  #define TIM_CCER_CC3P      0x00000200	/* Capture/Compare 3 output Polarity */
  #define TIM_CCER_CC3NE     0x00000400	/* Capture/Compare 3 Complementary output enable */
  #define TIM_CCER_CC3NP     0x00000800	/* Capture/Compare 3 Complementary output Polarity */
  #define TIM_CCER_CC4E      0x00001000	/* Capture/Compare 4 output enable */
  #define TIM_CCER_CC4P      0x00002000	/* Capture/Compare 4 output Polarity */
  #define TIM_CCER_CC4NP     0x00008000	/* Capture/Compare 4 Complementary output Polarity */
  #define TIM_CCER_CC5E      0x00010000	/* Capture/Compare 5 output enable */
  #define TIM_CCER_CC5P      0x00020000	/* Capture/Compare 5 output Polarity */
  #define TIM_CCER_CC6E      0x00100000	/* Capture/Compare 6 output enable */
  #define TIM_CCER_CC6P      0x00200000	/* Capture/Compare 6 output Polarity */
#define TOFF_TIM_CNT        0x0024		/* (RW) TIM counter register */
#define TOFF_TIM_PSC        0x0028		/* (RW) TIM prescaler */
#define TOFF_TIM_ARR        0x002C		/* (RW) TIM auto-reload register */
#define TOFF_TIM_RCR        0x0030		/* (RW) TIM repetition counter register */
#define TOFF_TIM_CCR1       0x0034		/* (RW) TIM capture/compare register 1 */
#define TOFF_TIM_CCR2       0x0038		/* (RW) TIM capture/compare register 2 */
#define TOFF_TIM_CCR3       0x003C		/* (RW) TIM capture/compare register 3 */
#define TOFF_TIM_CCR4       0x0040		/* (RW) TIM capture/compare register 4 */
#define TOFF_TIM_BDTR       0x0044		/* (RW) TIM break and dead-time register */
  #define TIM_BDTR_DTG       0x000000FF	/* DTG[0:7] bits (Dead-Time Generator set-up) */
  #define TIM_BDTR_DTG_0     0x00000001	/* Bit 0 */
  #define TIM_BDTR_DTG_1     0x00000002	/* Bit 1 */
  #define TIM_BDTR_DTG_2     0x00000004	/* Bit 2 */
  #define TIM_BDTR_DTG_3     0x00000008	/* Bit 3 */
  #define TIM_BDTR_DTG_4     0x00000010	/* Bit 4 */
  #define TIM_BDTR_DTG_5     0x00000020	/* Bit 5 */
  #define TIM_BDTR_DTG_6     0x00000040	/* Bit 6 */
  #define TIM_BDTR_DTG_7     0x00000080	/* Bit 7 */
  #define TIM_BDTR_LOCK      0x00000300	/* LOCK[1:0] bits (Lock Configuration) */
  #define TIM_BDTR_LOCK_0    0x00000100	/* Bit 0 */
  #define TIM_BDTR_LOCK_1    0x00000200	/* Bit 1 */
  #define TIM_BDTR_OSSI      0x00000400	/* Off-State Selection for Idle mode */
  #define TIM_BDTR_OSSR      0x00000800	/* Off-State Selection for Run mode  */
  #define TIM_BDTR_BKE       0x00001000	/* Break enable                      */
  #define TIM_BDTR_BKP       0x00002000	/* Break Polarity                    */
  #define TIM_BDTR_AOE       0x00004000	/* Automatic Output enable           */
  #define TIM_BDTR_MOE       0x00008000	/* Main Output enable                */
  #define TIM_BDTR_BKF       0x000F0000	/* Break Filter for Break1 */
  #define TIM_BDTR_BK2F      0x00F00000	/* Break Filter for Break2 */
  #define TIM_BDTR_BK2E      0x01000000	/* Break enable for Break2 */
  #define TIM_BDTR_BK2P      0x02000000	/* Break Polarity for Break2 */
#define TOFF_TIM_DCR        0x0048		/* (RW) TIM DMA control register */
  #define TIM_DCR_DBA        0x001F		/* DBA[4:0] bits (DMA Base Address) */
  #define TIM_DCR_DBA_0      0x0001		/* Bit 0 */
  #define TIM_DCR_DBA_1      0x0002		/* Bit 1 */
  #define TIM_DCR_DBA_2      0x0004		/* Bit 2 */
  #define TIM_DCR_DBA_3      0x0008		/* Bit 3 */
  #define TIM_DCR_DBA_4      0x0010		/* Bit 4 */
  #define TIM_DCR_DBL        0x1F00		/* DBL[4:0] bits (DMA Burst Length) */
  #define TIM_DCR_DBL_0      0x0100		/* Bit 0 */
  #define TIM_DCR_DBL_1      0x0200		/* Bit 1 */
  #define TIM_DCR_DBL_2      0x0400		/* Bit 2 */
  #define TIM_DCR_DBL_3      0x0800		/* Bit 3 */
  #define TIM_DCR_DBL_4      0x1000		/* Bit 4 */
#define TOFF_TIM_DMAR       0x004C		/* (RW) TIM DMA address for full transfer */
#define TOFF_TIM_OR         0x0050		/* (RW) TIM option register */
  #define TIM_OR_TI4_RMP     0x00C0		/* TI4_RMP[1:0] bits (TIM5 Input 4 remap)             */
  #define TIM_OR_TI4_RMP_0   0x0040		/* Bit 0 */
  #define TIM_OR_TI4_RMP_1   0x0080		/* Bit 1 */
  #define TIM_OR_ITR1_RMP    0x0C00		/* ITR1_RMP[1:0] bits (TIM2 Internal trigger 1 remap) */
  #define TIM_OR_ITR1_RMP_0  0x0400		/* Bit 0 */
  #define TIM_OR_ITR1_RMP_1  0x0800		/* Bit 1 */
#define TOFF_TIM_CCMR3      0x0054		/* (RW) TIM capture/compare mode register 3 */
  #define TIM_CCMR3_OC5FE    0x00000004	/* Output Compare 5 Fast enable */
  #define TIM_CCMR3_OC5PE    0x00000008	/* Output Compare 5 Preload enable */
  #define TIM_CCMR3_OC5M     0x00010070	/* OC5M[2:0] bits (Output Compare 5 Mode) */
  #define TIM_CCMR3_OC5M_0   0x00000010	/* Bit 0 */
  #define TIM_CCMR3_OC5M_1   0x00000020	/* Bit 1 */
  #define TIM_CCMR3_OC5M_2   0x00000040	/* Bit 2 */
  #define TIM_CCMR3_OC5M_3   0x00010000	/* Bit 3 */
  #define TIM_CCMR3_OC5CE    0x00000080	/* Output Compare 5 Clear Enable */
  #define TIM_CCMR3_OC6FE    0x00000400	/* Output Compare 4 Fast enable */
  #define TIM_CCMR3_OC6PE    0x00000800	/* Output Compare 4 Preload enable */
  #define TIM_CCMR3_OC6M     0x01007000	/* OC4M[2:0] bits (Output Compare 4 Mode) */
  #define TIM_CCMR3_OC6M_0   0x00001000	/* Bit 0 */
  #define TIM_CCMR3_OC6M_1   0x00002000	/* Bit 1 */
  #define TIM_CCMR3_OC6M_2   0x00004000	/* Bit 2 */
  #define TIM_CCMR3_OC6M_3   0x01000000	/* Bit 3 */
  #define TIM_CCMR3_OC6CE    0x00008000	/* Output Compare 4 Clear Enable */
#define TOFF_TIM_CCR5       0x0058		/* (RW) TIM capture/compare mode register5 */
  #define TIM_CCR5_CCR5      0xFFFFFFFF	/* Capture/Compare 5 Value */
  #define TIM_CCR5_GC5C1     0x20000000	/* Group Channel 5 and Channel 1 */
  #define TIM_CCR5_GC5C2     0x40000000	/* Group Channel 5 and Channel 2 */
  #define TIM_CCR5_GC5C3     0x80000000	/* Group Channel 5 and Channel 3 */
#define TOFF_TIM_CCR6       0x005C		/* (RW) TIM capture/compare mode register6 */

/*
 *  LPTIMIMER
 */
#define TADR_LPTIM1_BASE    (APB1PERIPH_BASE + 0x2400)
#define TOFF_LPTIM_ISR      0x0000		/* (RW) LPTIM Interrupt and Status register */
  #define LPTIM_ISR_CMPM     0x00000001	/* Compare match                       */
  #define LPTIM_ISR_ARRM     0x00000002	/* Autoreload match                    */
  #define LPTIM_ISR_EXTTRIG  0x00000004	/* External trigger edge event         */
  #define LPTIM_ISR_CMPOK    0x00000008	/* Compare register update OK          */
  #define LPTIM_ISR_ARROK    0x00000010	/* Autoreload register update OK       */
  #define LPTIM_ISR_UP       0x00000020	/* Counter direction change down to up */
  #define LPTIM_ISR_DOWN     0x00000040	/* Counter direction change up to down */
#define TOFF_LPTIM_ICR      0x0004		/* (RW) LPTIM Interrupt Clear register */
  #define LPTIM_ICR_CMPMCF   0x00000001	/* Compare match Clear Flag                       */
  #define LPTIM_ICR_ARRMCF   0x00000002	/* Autoreload match Clear Flag                    */
  #define LPTIM_ICR_EXTTRIGCF 0x00000004 /* External trigger edge event Clear Flag         */
  #define LPTIM_ICR_CMPOKCF  0x00000008	/* Compare register update OK Clear Flag          */
  #define LPTIM_ICR_ARROKCF  0x00000010	/* Autoreload register update OK Clear Flag       */
  #define LPTIM_ICR_UPCF     0x00000020	/* Counter direction change down to up Clear Flag */
  #define LPTIM_ICR_DOWNCF   0x00000040	/* Counter direction change up to down Clear Flag */
#define TOFF_LPTIM_IER      0x0008		/* (RW) LPTIM Interrupt Enable register */
  #define LPTIM_IER_CMPMIE   0x00000001	/* Compare match Interrupt Enable                       */
  #define LPTIM_IER_ARRMIE   0x00000002	/* Autoreload match Interrupt Enable                    */
  #define LPTIM_IER_EXTTRIGIE 0x00000004 /* External trigger edge event Interrupt Enable         */
  #define LPTIM_IER_CMPOKIE  0x00000008	/* Compare register update OK Interrupt Enable          */
  #define LPTIM_IER_ARROKIE  0x00000010	/* Autoreload register update OK Interrupt Enable       */
  #define LPTIM_IER_UPIE     0x00000020	/* Counter direction change down to up Interrupt Enable */
  #define LPTIM_IER_DOWNIE   0x00000040	/* Counter direction change up to down Interrupt Enable */
#define TOFF_LPTIM_CFGR     0x000C		/* (RW) LPTIM Configuration register */
  #define LPTIM_CFGR_CKSEL   0x00000001	/* Clock selector */
  #define LPTIM_CFGR_CKPOL   0x00000006	/* CKPOL[1:0] bits (Clock polarity) */
  #define LPTIM_CFGR_CKPOL_0 0x00000002	/* Bit 0 */
  #define LPTIM_CFGR_CKPOL_1 0x00000004	/* Bit 1 */
  #define LPTIM_CFGR_CKFLT   0x00000018	/* CKFLT[1:0] bits (Configurable digital filter for external clock) */
  #define LPTIM_CFGR_CKFLT_0 0x00000008	/* Bit 0 */
  #define LPTIM_CFGR_CKFLT_1 0x00000010	/* Bit 1 */
  #define LPTIM_CFGR_TRGFLT  0x000000C0	/* TRGFLT[1:0] bits (Configurable digital filter for trigger) */
  #define LPTIM_CFGR_TRGFLT_0 0x00000040	/* Bit 0 */
  #define LPTIM_CFGR_TRGFLT_1 0x00000080	/* Bit 1 */
  #define LPTIM_CFGR_PRESC   0x00000E00	/* PRESC[2:0] bits (Clock prescaler) */
  #define LPTIM_CFGR_PRESC_0 0x00000200	/* Bit 0 */
  #define LPTIM_CFGR_PRESC_1 0x00000400	/* Bit 1 */
  #define LPTIM_CFGR_PRESC_2 0x00000800	/* Bit 2 */
  #define LPTIM_CFGR_TRIGSEL 0x0000E000	/* TRIGSEL[2:0]] bits (Trigger selector) */
  #define LPTIM_CFGR_TRIGSEL_0 0x00002000	/* Bit 0 */
  #define LPTIM_CFGR_TRIGSEL_1 0x00004000	/* Bit 1 */
  #define LPTIM_CFGR_TRIGSEL_2 0x00008000	/* Bit 2 */
  #define LPTIM_CFGR_TRIGEN  0x00060000	/* TRIGEN[1:0] bits (Trigger enable and polarity) */
  #define LPTIM_CFGR_TRIGEN_0 0x00020000	/* Bit 0 */
  #define LPTIM_CFGR_TRIGEN_1 0x00040000	/* Bit 1 */
  #define LPTIM_CFGR_TIMOUT  0x00080000	/* Timout enable           */
  #define LPTIM_CFGR_WAVE    0x00100000	/* Waveform shape          */
  #define LPTIM_CFGR_WAVPOL  0x00200000	/* Waveform shape polarity */
  #define LPTIM_CFGR_PRELOAD 0x00400000	/* Reg update mode         */
  #define LPTIM_CFGR_COUNTMODE 0x00800000	/* Counter mode enable     */     
  #define LPTIM_CFGR_ENC     0x01000000	/* Encoder mode enable     */          
#define TOFF_LPTIM_CR       0x0010		/* (RW) LPTIM Control register */
  #define LPTIM_CR_ENABLE    0x00000001	/* LPTIMer enable                 */
  #define LPTIM_CR_SNGSTRT   0x00080002	/* Timer start in single mode     */
  #define LPTIM_CR_CNTSTRT   0x00000004	/* Timer start in continuous mode */
#define TOFF_LPTIM_CMP      0x0014		/* (RW) LPTIM Compare register */
#define TOFF_LPTIM_ARR      0x0018		/* (RW) LPTIM Autoreload register */
#define TOFF_LPTIM_CNT      0x001C		/* (RW) LPTIM Counter register */
#define TOFF_LPTIM_OR       0x0020		/* (RW) LPTIM Option register */


/*
 *  REAL-TIME CLOCK
 */
#define TADR_RTC_BASE       (APB1PERIPH_BASE + 0x2800)
#define TOFF_RTC_TR         0x0000		/* (RW) RTC time register */
#define TOFF_RTC_DR         0x0004		/* (RW) RTC date register */
#define TOFF_RTC_CR         0x0008		/* (RW) RTC control register */
#define TOFF_RTC_ISR        0x000C		/* (RW) RTC initialization and status register */
#define TOFF_RTC_PRER       0x0010		/* (RW) RTC prescaler register */
#define TOFF_RTC_WUTR       0x0014		/* (RW) RTC wakeup timer register */
#define TOFF_RTC_ALRMAR     0x001C		/* (RW) RTC alarm A register */
#define TOFF_RTC_ALRMBR     0x0020		/* (RW) RTC alarm B register */
#define TOFF_RTC_WPR        0x0024		/* (RW) RTC write protection register */
#define TOFF_RTC_SSR        0x0028		/* (RW) RTC sub second register */
#define TOFF_RTC_SHIFTR     0x002C		/* (RW) RTC shift control register */
#define TOFF_RTC_TSTR       0x0030		/* (RW) RTC time stamp time register */
#define TOFF_RTC_TSDR       0x0034		/* (RW) RTC time stamp date register */
#define TOFF_RTC_TSSSR      0x0038		/* (RW) RTC time-stamp sub second register */
#define TOFF_RTC_CALR       0x003C		/* (RW) RTC calibration register */
#define TOFF_RTC_TAFCR      0x0040		/* (RW) RTC tamper and alternate function configuration register */
#define TOFF_RTC_ALRMASSR   0x0044		/* (RW) RTC alarm A sub second register */
#define TOFF_RTC_ALRMBSSR   0x0048		/* (RW) RTC alarm B sub second register */
#define TOFF_RTC_OR         0x004C		/* (RW) RTC option register */
#define TOFF_RTC_BKP0R      0x0050		/* (RW) RTC backup register 0 */
#define TOFF_RTC_BKP1R      0x0054		/* (RW) RTC backup register 1 */
#define TOFF_RTC_BKP2R      0x0058		/* (RW) RTC backup register 2 */
#define TOFF_RTC_BKP3R      0x005C		/* (RW) RTC backup register 3 */
#define TOFF_RTC_BKP4R      0x0060		/* (RW) RTC backup register 4 */
#define TOFF_RTC_BKP5R      0x0064		/* (RW) RTC backup register 5 */
#define TOFF_RTC_BKP6R      0x0068		/* (RW) RTC backup register 6 */
#define TOFF_RTC_BKP7R      0x006C		/* (RW) RTC backup register 7 */
#define TOFF_RTC_BKP8R      0x0070		/* (RW) RTC backup register 8 */
#define TOFF_RTC_BKP9R      0x0074		/* (RW) RTC backup register 9 */
#define TOFF_RTC_BKP10R     0x0078		/* (RW) RTC backup register 10 */
#define TOFF_RTC_BKP11R     0x007C		/* (RW) RTC backup register 11 */
#define TOFF_RTC_BKP12R     0x0080		/* (RW) RTC backup register 12 */
#define TOFF_RTC_BKP13R     0x0084		/* (RW) RTC backup register 13 */
#define TOFF_RTC_BKP14R     0x0088		/* (RW) RTC backup register 14 */
#define TOFF_RTC_BKP15R     0x008C		/* (RW) RTC backup register 15 */
#define TOFF_RTC_BKP16R     0x0090		/* (RW) RTC backup register 16 */
#define TOFF_RTC_BKP17R     0x0094		/* (RW) RTC backup register 17 */
#define TOFF_RTC_BKP18R     0x0098		/* (RW) RTC backup register 18 */
#define TOFF_RTC_BKP19R     0x009C		/* (RW) RTC backup register 19 */
#define TOFF_RTC_BKP20R     0x00A0		/* (RW) RTC backup register 20 */
#define TOFF_RTC_BKP21R     0x00A4		/* (RW) RTC backup register 21 */
#define TOFF_RTC_BKP22R     0x00A8		/* (RW) RTC backup register 22 */
#define TOFF_RTC_BKP23R     0x00AC		/* (RW) RTC backup register 23 */
#define TOFF_RTC_BKP24R     0x00B0		/* (RW) RTC backup register 24 */
#define TOFF_RTC_BKP25R     0x00B4		/* (RW) RTC backup register 25 */
#define TOFF_RTC_BKP26R     0x00B8		/* (RW) RTC backup register 26 */
#define TOFF_RTC_BKP27R     0x00BC		/* (RW) RTC backup register 27 */
#define TOFF_RTC_BKP28R     0x00C0		/* (RW) RTC backup register 28 */
#define TOFF_RTC_BKP29R     0x00C4		/* (RW) RTC backup register 29 */
#define TOFF_RTC_BKP30R     0x00C8		/* (RW) RTC backup register 30 */
#define TOFF_RTC_BKP31R     0x00CC		/* (RW) RTC backup register 31 */

/*
 *  WINDOW WATCHDOG
 */
#define TADR_WWDG_BASE      (APB1PERIPH_BASE + 0x2C00)
#define TOFF_WWDG_CR        0x0000		/* (RW) WWDG Control register */
#define TOFF_WWDG_CFR       0x0004		/* (RW) WWDG Configuration register */
#define TOFF_WWDG_SR        0x0008		/* (R)  WWDG Status register */

/*
 *  INDEPENDENT WATCHDOG
 */
#define TADR_IWDG_BASE      (APB1PERIPH_BASE + 0x3000)
#define TOFF_IWDG_KR        0x0000		/* (RW) IWDG Key register */
#define TOFF_IWDG_PR        0x0004		/* (RW) IWDG Prescaler register */
#define TOFF_IWDG_RLR       0x0008		/* (RW) IWDG Reload register */
#define TOFF_IWDG_SR        0x000C		/* (RW) IWDG Status register */
#define TOFF_IWDG_WINR      0x0010		/* (RW) IWDG Window register */

/*
 *  SERIAL PERIPHERAL IINTERFACE
 */
#define TADR_SPI2_BASE      (APB1PERIPH_BASE + 0x3800)
#define TADR_SPI3_BASE      (APB1PERIPH_BASE + 0x3C00)
#define TADR_SPI1_BASE      (APB2PERIPH_BASE + 0x3000)
#define TADR_SPI4_BASE      (APB2PERIPH_BASE + 0x3400)
#define TADR_SPI5_BASE      (APB2PERIPH_BASE + 0x5000)
#define TADR_SPI6_BASE      (APB2PERIPH_BASE + 0x5400)
#define TOFF_SPI_CR1        0x0000		/* (RW-16) SPI control register 1 (not used in I2S mode) */
#define TOFF_SPI_CR2        0x0004		/* (RW-16) SPI control register 2 */
#define TOFF_SPI_SR         0x0008		/* (RW-16) SPI status register */
#define TOFF_SPI_DR         0x000C		/* (RW-16) SPI data register */
#define TOFF_SPI_CRCPR      0x0010		/* (RW-16) SPI CRC polynomial register (not used in I2S mode) */
#define TOFF_SPI_RXCRCR     0x0014		/* (RW-16) SPI RX CRC register (not used in I2S mode) */
#define TOFF_SPI_TXCRCR     0x0018		/* (RW-16) SPI TX CRC register (not used in I2S mode) */
#define TOFF_SPI_I2SCFGR    0x001C		/* (RW-16) SPI_I2S configuration register */
#define TOFF_SPI_I2SPR      0x0020		/* (RW-16) SPI_I2S prescaler register */

/*
 *  SPDIF-RX INTERFACE
 */
#define TADR_SPDIFRX_BASE   (APB1PERIPH_BASE + 0x4000)
#define TOFF_SPDIFRX_CR     0x0000		/* (RW) Control register */
#define TOFF_SPDIFRX_IMR    0x0004		/* (RW) Interrupt mask register */
#define TOFF_SPDIFRX_SR     0x0008		/* (RW) Status register */
#define TOFF_SPDIFRX_IFCR   0x000C		/* (RW) Interrupt Flag Clear register */
#define TOFF_SPDIFRX_DR     0x0010		/* (RW) Data input register */
#define TOFF_SPDIFRX_CSR    0x0014		/* (RW) Channel Status register */
#define TOFF_SPDIFRX_DIR    0x0018		/* (RW) Debug Information register */


/*
 *  UNIVERSAL SYNCHRONOUS ASYNCHORONOUS RECEIVER TRANSMITTER
 */
#define TADR_USART2_BASE    (APB1PERIPH_BASE + 0x4400)
#define TADR_USART3_BASE    (APB1PERIPH_BASE + 0x4800)
#define TADR_UART4_BASE     (APB1PERIPH_BASE + 0x4C00)
#define TADR_UART5_BASE     (APB1PERIPH_BASE + 0x5000)
#define TADR_UART7_BASE     (APB1PERIPH_BASE + 0x7800)
#define TADR_UART8_BASE     (APB1PERIPH_BASE + 0x7C00)
#define TADR_USART1_BASE    (APB2PERIPH_BASE + 0x1000)
#define TADR_USART6_BASE    (APB2PERIPH_BASE + 0x1400)
#define TOFF_USART_CR1      0x0000		/* (RW) USART Control register 1 */
  #define USART_CR1_UE       0x00000001	/* USART Enable */
  #define USART_CR1_RE       0x00000004	/* Receiver Enable */
  #define USART_CR1_TE       0x00000008	/* Transmitter Enable */
  #define USART_CR1_IDLEIE   0x00000010	/* IDLE Interrupt Enable */
  #define USART_CR1_RXNEIE   0x00000020	/* RXNE Interrupt Enable */
  #define USART_CR1_TCIE     0x00000040	/* Transmission Complete Interrupt Enable */
  #define USART_CR1_TXEIE    0x00000080	/* TXE Interrupt Enable */
  #define USART_CR1_PEIE     0x00000100	/* PE Interrupt Enable */
  #define USART_CR1_PS       0x00000200	/* Parity Selection */
  #define USART_CR1_PCE      0x00000400	/* Parity Control Enable */
  #define USART_CR1_WAKE     0x00000800	/* Receiver Wakeup method */
  #define USART_CR1_M        0x10001000	/* Word length */
  #define USART_CR1_M_0      0x00001000	/* Word length - Bit 0 */
  #define USART_CR1_MME      0x00002000	/* Mute Mode Enable */
  #define USART_CR1_CMIE     0x00004000	/* Character match interrupt enable */
  #define USART_CR1_OVER8    0x00008000	/* Oversampling by 8-bit or 16-bit mode */
  #define USART_CR1_DEDT     0x001F0000	/* DEDT[4:0] bits (Driver Enable Deassertion Time) */
  #define USART_CR1_DEDT_0   0x00010000	/* Bit 0 */
  #define USART_CR1_DEDT_1   0x00020000	/* Bit 1 */
  #define USART_CR1_DEDT_2   0x00040000	/* Bit 2 */
  #define USART_CR1_DEDT_3   0x00080000	/* Bit 3 */
  #define USART_CR1_DEDT_4   0x00100000	/* Bit 4 */
  #define USART_CR1_DEAT     0x03E00000	/* DEAT[4:0] bits (Driver Enable Assertion Time)   */
  #define USART_CR1_DEAT_0   0x00200000	/* Bit 0 */
  #define USART_CR1_DEAT_1   0x00400000	/* Bit 1 */
  #define USART_CR1_DEAT_2   0x00800000	/* Bit 2 */
  #define USART_CR1_DEAT_3   0x01000000	/* Bit 3 */
  #define USART_CR1_DEAT_4   0x02000000	/* Bit 4 */
  #define USART_CR1_RTOIE    0x04000000	/* Receive Time Out interrupt enable */
  #define USART_CR1_EOBIE    0x08000000	/* End of Block interrupt enable */
  #define USART_CR1_M_1      0x10000000	/* Word length - Bit 1 */
#define TOFF_USART_CR2      0x0004		/* (RW) USART Control register 2 */
  #define USART_CR2_ADDM7    0x00000010	/* 7-bit or 4-bit Address Detectio */
  #define USART_CR2_LBDL     0x00000020	/* LIN Break Detection Length */
  #define USART_CR2_LBDIE    0x00000040	/* LIN Break Detection Interrupt Enable */
  #define USART_CR2_LBCL     0x00000100	/* Last Bit Clock pulse */
  #define USART_CR2_CPHA     0x00000200	/* Clock Phase */
  #define USART_CR2_CPOL     0x00000400	/* Clock Polarity */
  #define USART_CR2_CLKEN    0x00000800	/* Clock Enable */
  #define USART_CR2_STOP     0x00003000	/* STOP[1:0] bits (STOP bits) */
  #define USART_CR2_STOP_0   0x00001000	/* Bit 0 */
  #define USART_CR2_STOP_1   0x00002000	/* Bit 1 */
  #define USART_CR2_LINEN    0x00004000	/* LIN mode enable */
  #define USART_CR2_SWAP     0x00008000	/* SWAP TX/RX pins */
  #define USART_CR2_RXINV    0x00010000	/* RX pin active level inversion */
  #define USART_CR2_TXINV    0x00020000	/* TX pin active level inversion */
  #define USART_CR2_DATAINV  0x00040000	/* Binary data inversion */
  #define USART_CR2_MSBFIRST 0x00080000	/* Most Significant Bit First */
  #define USART_CR2_ABREN    0x00100000	/* Auto Baud-Rate Enable */
  #define USART_CR2_ABRMODE  0x00600000	/* ABRMOD[1:0] bits (Auto Baud-Rate Mode) */
  #define USART_CR2_ABRMODE_0 0x00200000	/* Bit 0 */
  #define USART_CR2_ABRMODE_1 0x00400000	/* Bit 1 */
  #define USART_CR2_RTOEN    0x00800000	/* Receiver Time-Out enable */
  #define USART_CR2_ADD      0xFF000000	/* Address of the USART node */
#define TOFF_USART_CR3      0x0008		/* (RW) USART Control register 3 */
  #define USART_CR3_EIE      0x00000001	/* Error Interrupt Enable */
  #define USART_CR3_IREN     0x00000002	/* IrDA mode Enable */
  #define USART_CR3_IRLP     0x00000004	/* IrDA Low-Power */
  #define USART_CR3_HDSEL    0x00000008	/* Half-Duplex Selection */
  #define USART_CR3_NACK     0x00000010	/* SmartCard NACK enable */
  #define USART_CR3_SCEN     0x00000020	/* SmartCard mode enable */
  #define USART_CR3_DMAR     0x00000040	/* DMA Enable Receiver  */
  #define USART_CR3_DMAT     0x00000080	/* DMA Enable Transmitter */
  #define USART_CR3_RTSE     0x00000100	/* RTS Enable */
  #define USART_CR3_CTSE     0x00000200	/* CTS Enable */
  #define USART_CR3_CTSIE    0x00000400	/* CTS Interrupt Enable */
  #define USART_CR3_ONEBIT   0x00000800	/* One sample bit method enable */
  #define USART_CR3_OVRDIS   0x00001000	/* Overrun Disable */
  #define USART_CR3_DDRE     0x00002000	/* DMA Disable on Reception Error */
  #define USART_CR3_DEM      0x00004000	/* Driver Enable Mode */
  #define USART_CR3_DEP      0x00008000	/* Driver Enable Polarity Selection */
  #define USART_CR3_SCARCNT  0x000E0000	/* SCARCNT[2:0] bits (SmartCard Auto-Retry Count) */
  #define USART_CR3_SCARCNT_0 0x00020000	/* Bit 0 */
  #define USART_CR3_SCARCNT_1 0x00040000	/* Bit 1 */
  #define USART_CR3_SCARCNT_2 0x00080000	/* Bit 2 */
#define TOFF_USART_BRR      0x000C		/* (RW) USART Baud rate register */
#define TOFF_USART_GTPR     0x0010		/* (RW) USART Guard time and prescaler register */
#define TOFF_USART_RTOR     0x0014		/* (RW) USART Receiver Time Out register */
#define TOFF_USART_RQR      0x0018		/* (RW) USART Request register */
  #define USART_RQR_ABRRQ    0x00000001	/* Auto-Baud Rate Request */
  #define USART_RQR_SBKRQ    0x00000002	/* Send Break Request */
  #define USART_RQR_MMRQ     0x00000004	/* Mute Mode Request */
  #define USART_RQR_RXFRQ    0x00000008	/* Receive Data flush Request */
  #define USART_RQR_TXFRQ    0x00000010	/* Transmit data flush Request */
#define TOFF_USART_ISR      0x001C		/* (RW) USART Interrupt and status register */
  #define USART_ISR_PE       0x00000001	/* Parity Error */
  #define USART_ISR_FE       0x00000002	/* Framing Error */
  #define USART_ISR_NE       0x00000004	/* Noise detected Flag */
  #define USART_ISR_ORE      0x00000008	/* OverRun Error */
  #define USART_ISR_IDLE     0x00000010	/* IDLE line detected */
  #define USART_ISR_RXNE     0x00000020	/* Read Data Register Not Empty */
  #define USART_ISR_TC       0x00000040	/* Transmission Complete */
  #define USART_ISR_TXE      0x00000080	/* Transmit Data Register Empty */
  #define USART_ISR_LBD      0x00000100	/* LIN Break Detection Flag */
  #define USART_ISR_CTSIF    0x00000200	/* CTS interrupt flag */
  #define USART_ISR_CTS      0x00000400	/* CTS flag */
  #define USART_ISR_RTOF     0x00000800	/* Receiver Time Out */
  #define USART_ISR_EOBF     0x00001000	/* End Of Block Flag */
  #define USART_ISR_ABRE     0x00004000	/* Auto-Baud Rate Error */
  #define USART_ISR_ABRF     0x00008000	/* Auto-Baud Rate Flag */
  #define USART_ISR_BUSY     0x00010000	/* Busy Flag */
  #define USART_ISR_CMF      0x00020000	/* Character Match Flag */
  #define USART_ISR_SBKF     0x00040000	/* Send Break Flag */
  #define USART_ISR_RWU      0x00080000	/* Receive Wake Up from mute mode Flag */
  #define USART_ISR_WUF      0x00100000	/* Wake Up from stop mode Flag */
  #define USART_ISR_TEACK    0x00200000	/* Transmit Enable Acknowledge Flag */
  #define USART_ISR_REACK    0x00400000	/* Receive Enable Acknowledge Flag */
#define TOFF_USART_ICR      0x0020		/* (RW) USART Interrupt flag Clear register */
  #define USART_ICR_PECF     0x00000001	/* Parity Error Clear Flag */
  #define USART_ICR_FECF     0x00000002	/* Framing Error Clear Flag */
  #define USART_ICR_NCF      0x00000004	/* Noise detected Clear Flag */
  #define USART_ICR_ORECF    0x00000008	/* OverRun Error Clear Flag */
  #define USART_ICR_IDLECF   0x00000010	/* IDLE line detected Clear Flag */
  #define USART_ICR_TCCF     0x00000040	/* Transmission Complete Clear Flag */
  #define USART_ICR_LBDCF    0x00000100	/* LIN Break Detection Clear Flag */
  #define USART_ICR_CTSCF    0x00000200	/* CTS Interrupt Clear Flag */
  #define USART_ICR_RTOCF    0x00000800	/* Receiver Time Out Clear Flag */
  #define USART_ICR_EOBCF    0x00001000	/* End Of Block Clear Flag */
  #define USART_ICR_CMCF     0x00020000	/* Character Match Clear Flag */
  #define USART_ICR_WUCF     0x00100000	/* Wake Up from stop mode Clear Flag */
#define TOFF_USART_RDR      0x0024		/* (RW) USART Receive Data register */
#define TOFF_USART_TDR      0x0028		/* (RW) USART Transmit Data register */

/*
 *  INTER-INTERATED CIRCUIT IINTERFACE(16)
 */
#define TADR_I2C1_BASE      (APB1PERIPH_BASE + 0x5400)
#define TADR_I2C2_BASE      (APB1PERIPH_BASE + 0x5800)
#define TADR_I2C3_BASE      (APB1PERIPH_BASE + 0x5C00)
#define TADR_I2C4_BASE      (APB1PERIPH_BASE + 0x6000)
#define TOFF_I2C_CR1        0x0000		/* (RW) I2C Control register 1 */
#define TOFF_I2C_CR2        0x0004		/* (RW) I2C Control register 2 */
#define TOFF_I2C_OAR1       0x0008		/* (RW) I2C Own address register 1 */
#define TOFF_I2C_OAR2       0x000C		/* (RW) I2C Own address register 2 */
#define TOFF_I2C_TIMINGR    0x0010		/* (RW) I2C Timing register */
#define TOFF_I2C_TIMEOUTR   0x0014		/* (RW) I2C Timeout register */
#define TOFF_I2C_ISR        0x0018		/* (RW) I2C Interrupt and status register */
#define TOFF_I2C_ICR        0x001C		/* (RW) I2C Interrupt clear register */
#define TOFF_I2C_PECR       0x0020		/* (RW) I2C PEC register */
#define TOFF_I2C_RXDR       0x0024		/* (RW) I2C Receive data register */
#define TOFF_I2C_TXDR       0x0028		/* (RW) I2C Transmit data register */  

/*
 *  CONTROLLER AREA NETWORK
 */
#define TADR_CAN1_BASE      (APB1PERIPH_BASE + 0x6400)
#define TADR_CAN2_BASE      (APB1PERIPH_BASE + 0x6800)
#define TOFF_CAN_MCR        0x0000		/* (RW) CAN master control register */
#define TOFF_CAN_MSR        0x0004		/* (R)  CAN master status register */
#define TOFF_CAN_TSR        0x0008		/* (R)  CAN transmit status register */
#define TOFF_CAN_RF0R       0x000C		/* (RW) CAN receive FIFO 0 register */
#define TOFF_CAN_RF1R       0x0010		/* (RW) CAN receive FIFO 1 register */
#define TOFF_CAN_IER        0x0014		/* (RW) CAN interrupt enable register */
#define TOFF_CAN_ESR        0x0018		/* (RW) CAN error status register */
#define TOFF_CAN_BTR        0x001C		/* (RW) CAN bit timing register */
										/* CAN TX MailBox */
#define TOFF_CAN_TIR1       0x0180		/* (RW) CAN(1) TX mailbox identifier register */
#define TOFF_CAN_TDTR1      0x0184		/* (RW) CAN(1) mailbox data length control and time stamp register */
#define TOFF_CAN_TDLR1      0x0188		/* (RW) CAN(1) mailbox data low register */
#define TOFF_CAN_TDHR1      0x018C		/* (RW) CAN(1) mailbox data high register */
#define TOFF_CAN_TIR2       0x0190		/* (RW) CAN(2) TX mailbox identifier register */
#define TOFF_CAN_TDTR2      0x0194		/* (RW) CAN(2) mailbox data length control and time stamp register */
#define TOFF_CAN_TDLR2      0x0198		/* (RW) CAN(2) mailbox data low register */
#define TOFF_CAN_TDHR2      0x019C		/* (RW) CAN(2) mailbox data high register */
#define TOFF_CAN_TIR3       0x01A0		/* (RW) CAN(3) TX mailbox identifier register */
#define TOFF_CAN_TDTR3      0x01A4		/* (RW) CAN(3) mailbox data length control and time stamp register */
#define TOFF_CAN_TDLR3      0x01A8		/* (RW) CAN(3) mailbox data low register */
#define TOFF_CAN_TDHR3      0x01AC		/* (RW) CAN(3) mailbox data high register */
										/* CAN FIFO MailBox */
#define TOFF_CAN_RIR1       0x01B0		/* (RW) CAN(1) receive FIFO mailbox identifier register */
#define TOFF_CAN_RDTR1      0x01B4		/* (RW) CAN(1) receive FIFO mailbox data length control and time stamp register */
#define TOFF_CAN_RDLR1      0x01B8		/* (RW) CAN(1) receive FIFO mailbox data low register */
#define TOFF_CAN_RDHR1      0x01BC		/* (RW) CAN(1) receive FIFO mailbox data high register */
#define TOFF_CAN_RIR2       0x01C0		/* (RW) CAN(2) receive FIFO mailbox identifier register */
#define TOFF_CAN_RDTR2      0x01C4		/* (RW) CAN(2) receive FIFO mailbox data length control and time stamp register */
#define TOFF_CAN_RDLR2      0x01C8		/* (RW) CAN(2) receive FIFO mailbox data low register */
#define TOFF_CAN_RDHR2      0x01CC		/* (RW) CAN(2) receive FIFO mailbox data high register */
#define TOFF_CAN_FMR        0x0200		/* (RW) CAN filter master register */
#define TOFF_CAN_FM1R       0x0204		/* (RW) CAN filter mode register */
#define TOFF_CAN_FS1R       0x020C		/* (RW) CAN filter scale register */
#define TOFF_CAN_FFA1R      0x0214		/* (RW) CAN filter FIFO assignment register */
#define TOFF_CAN_FA1R       0x0218		/* (RW) CAN filter activation register */
#define TOFF_CAN_FR_BASE    0x0240		/*      0x240-0x31C */
#define TOFF_CAN_FR1        0x0240		/* (RW) CAN Filter bank register 1 */
#define TOFF_CAN_FR2        0x0244		/* (RW) CAN Filter bank register 2 */

/* 
 * HDMI-CEC 
 */
#define TADR_CEC_BASE      (APB1PERIPH_BASE + 0x6C00)
#define TOFF_CEC_CR        0x0000		/* (RW) CEC control register */
#define TOFF_CEC_CFGR      0x0004		/* (RW) CEC configuration register */
#define TOFF_CEC_TXDR      0x0008		/* (RW) CEC Tx data register  */
#define TOFF_CEC_RXDR      0x000C		/* (RW) CEC Rx Data Register */
#define TOFF_CEC_ISR       0x0010		/* (RW) CEC Interrupt and Status Register */
#define TOFF_CEC_IER       0x0014		/* (RW) CEC interrupt enable register */

/*
 *  POWER CONTROL
 */
#define TADR_PWR_BASE       (APB1PERIPH_BASE + 0x7000)
#define TOFF_PWR_CR1        0x0000		/* (RW) PWR power control register */
  #define PWR_CR1_LPDS       0x00000001	/* Low-Power Deepsleep                 */
  #define PWR_CR1_PDDS       0x00000002	/* Power Down Deepsleep                */
  #define PWR_CR1_CSBF       0x00000008	/* Clear Standby Flag                  */
  #define PWR_CR1_PVDE       0x00000010	/* Power Voltage Detector Enable       */
  #define PWR_CR1_PLS        0x000000E0	/* PLS[2:0] bits (PVD Level Selection) */
  #define PWR_CR1_PLS_0      0x00000020	/* Bit 0 */
  #define PWR_CR1_PLS_1      0x00000040	/* Bit 1 */
  #define PWR_CR1_PLS_2      0x00000080	/* Bit 2 */
  #define PWR_CR1_PLS_LEV0   0x00000000	/* PVD level 0 */
  #define PWR_CR1_PLS_LEV1   0x00000020	/* PVD level 1 */
  #define PWR_CR1_PLS_LEV2   0x00000040	/* PVD level 2 */
  #define PWR_CR1_PLS_LEV3   0x00000060	/* PVD level 3 */
  #define PWR_CR1_PLS_LEV4   0x00000080	/* PVD level 4 */
  #define PWR_CR1_PLS_LEV5   0x000000A0	/* PVD level 5 */
  #define PWR_CR1_PLS_LEV6   0x000000C0	/* PVD level 6 */
  #define PWR_CR1_PLS_LEV7   0x000000E0	/* PVD level 7 */
  #define PWR_CR1_DBP        0x00000100	/* Disable Backup Domain write protection                     */
  #define PWR_CR1_FPDS       0x00000200	/* Flash power down in Stop mode                              */
  #define PWR_CR1_LPUDS      0x00000400	/* Low-power regulator in deepsleep under-drive mode          */
  #define PWR_CR1_MRUDS      0x00000800	/* Main regulator in deepsleep under-drive mode               */
  #define PWR_CR1_ADCDC1     0x00002000	/* Refer to AN4073 on how to use this bit */ 
  #define PWR_CR1_VOS        0x0000C000	/* VOS[1:0] bits (Regulator voltage scaling output selection) */
  #define PWR_CR1_VOS_0      0x00004000	/* Bit 0 */
  #define PWR_CR1_VOS_1      0x00008000	/* Bit 1 */
  #define PWR_CR1_ODEN       0x00010000	/* Over Drive enable                   */
  #define PWR_CR1_ODSWEN     0x00020000	/* Over Drive switch enabled           */
  #define PWR_CR1_UDEN       0x000C0000	/* Under Drive enable in stop mode     */
  #define PWR_CR1_UDEN_0     0x00040000	/* Bit 0                               */
  #define PWR_CR1_UDEN_1     0x00080000	/* Bit 1                               */
#define TOFF_PWR_CSR1       0x0004		/* (RW) PWR power control/status register */
  #define PWR_CSR1_WUIF      0x00000001	/* Wake up internal Flag                            */
  #define PWR_CSR1_SBF       0x00000002	/* Standby Flag                                     */
  #define PWR_CSR1_PVDO      0x00000004	/* PVD Output                                       */
  #define PWR_CSR1_BRR       0x00000008	/* Backup regulator ready                           */
  #define PWR_CSR1_BRE       0x00000200	/* Backup regulator enable                          */
  #define PWR_CSR1_VOSRDY    0x00004000	/* Regulator voltage scaling output selection ready */
  #define PWR_CSR1_ODRDY     0x00010000	/* Over Drive generator ready                       */
  #define PWR_CSR1_ODSWRDY   0x00020000	/* Over Drive Switch ready                          */
  #define PWR_CSR1_UDSWRDY   0x000C0000	/* Under Drive ready                                */
#define TOFF_PWR_CR2        0x0008		/* (RW) PWR power control register 2 */
  #define PWR_CR2_CWUPF1     0x00000001	/* Clear Wakeup Pin Flag for PA0      */
  #define PWR_CR2_CWUPF2     0x00000002	/* Clear Wakeup Pin Flag for PA2      */
  #define PWR_CR2_CWUPF3     0x00000004	/* Clear Wakeup Pin Flag for PC1      */
  #define PWR_CR2_CWUPF4     0x00000008	/* Clear Wakeup Pin Flag for PC13     */
  #define PWR_CR2_CWUPF5     0x00000010	/* Clear Wakeup Pin Flag for PI8      */
  #define PWR_CR2_CWUPF6     0x00000020	/* Clear Wakeup Pin Flag for PI11     */
  #define PWR_CR2_WUPP1      0x00000100	/* Wakeup Pin Polarity bit for PA0    */
  #define PWR_CR2_WUPP2      0x00000200	/* Wakeup Pin Polarity bit for PA2    */
  #define PWR_CR2_WUPP3      0x00000400	/* Wakeup Pin Polarity bit for PC1    */
  #define PWR_CR2_WUPP4      0x00000800	/* Wakeup Pin Polarity bit for PC13   */
  #define PWR_CR2_WUPP5      0x00001000	/* Wakeup Pin Polarity bit for PI8    */
  #define PWR_CR2_WUPP6      0x00002000	/* Wakeup Pin Polarity bit for PI11   */
#define TOFF_PWR_CSR2       0x000C		/* (RW) PWR power control/status register 2, Address offset: 0x0C */
  #define PWR_CSR2_WUPF1     0x00000001	/* Wakeup Pin Flag for PA0            */
  #define PWR_CSR2_WUPF2     0x00000002	/* Wakeup Pin Flag for PA2            */
  #define PWR_CSR2_WUPF3     0x00000004	/* Wakeup Pin Flag for PC1            */
  #define PWR_CSR2_WUPF4     0x00000008	/* Wakeup Pin Flag for PC13           */
  #define PWR_CSR2_WUPF5     0x00000010	/* Wakeup Pin Flag for PI8            */
  #define PWR_CSR2_WUPF6     0x00000020	/* Wakeup Pin Flag for PI11           */
  #define PWR_CSR2_EWUP1     0x00000100	/* Enable Wakeup Pin PA0              */
  #define PWR_CSR2_EWUP2     0x00000200	/* Enable Wakeup Pin PA2              */
  #define PWR_CSR2_EWUP3     0x00000400	/* Enable Wakeup Pin PC1              */
  #define PWR_CSR2_EWUP4     0x00000800	/* Enable Wakeup Pin PC13             */
  #define PWR_CSR2_EWUP5     0x00001000	/* Enable Wakeup Pin PI8              */
  #define PWR_CSR2_EWUP6     0x00002000	/* Enable Wakeup Pin PI11             */

/*
 *  DIGITAL TO ANALOG CONVTER
 */
#define TADR_DAC_BASE       (APB1PERIPH_BASE + 0x7400)
#define TOFF_DAC_CR         0x0000		/* (RW) DAC control register */
#define TOFF_DAC_SWTRIGR	0x0004		/* (RW) DAC software trigger register */
#define TOFF_DAC_DHR12R1    0x0008		/* (RW) DAC channel1 12-bit right-aligned data holding register */
#define TOFF_DAC_DHR12L1    0x000C		/* (RW) DAC channel1 12-bit left aligned data holding register */
#define TOFF_DAC_DHR8R1     0x0010		/* (RW) DAC channel1 8-bit right aligned data holding register */
#define TOFF_DAC_DHR12R2    0x0014		/* (RW) DAC channel2 12-bit right aligned data holding register */
#define TOFF_DAC_DHR12L2    0x0018		/* (RW) DAC channel2 12-bit left aligned data holding register */
#define TOFF_DAC_DHR8R2     0x001C		/* (RW) DAC channel2 8-bit right-aligned data holding register */
#define TOFF_DAC_DHR12RD    0x0020		/* (RW) Dual DAC 12-bit right-aligned data holding register */
#define TOFF_DAC_DHR12LD    0x0024		/* (RW) DUAL DAC 12-bit left aligned data holding register */
#define TOFF_DAC_DHR8RD     0x0028		/* (RW) DUAL DAC 8-bit right aligned data holding register */
#define TOFF_DAC_DOR1       0x002C		/* (RW) DAC channel1 data output register */
#define TOFF_DAC_DOR2       0x0030		/* (RW) DAC channel2 data output register */
#define TOFF_DAC_SR         0x0034		/* (RW) DAC status register */


/*
 *  ANALOG TO DIGITAL CONVERTER
 */
#define TADR_ADC1_BASE      (APB2PERIPH_BASE + 0x2000)
#define TADR_ADC2_BASE      (APB2PERIPH_BASE + 0x2100)
#define TADR_ADC3_BASE      (APB2PERIPH_BASE + 0x2200)
#define TOFF_ADC_SR         0x0000		/* (RW) ADC status register */
#define TOFF_ADC_CR1        0x0004		/* (RW) ADC control register 1 */
#define TOFF_ADC_CR2        0x0008		/* (RW) ADC control register 2 */
#define TOFF_ADC_SMPR1      0x000C		/* (RW) ADC sample time register 1 */
#define TOFF_ADC_SMPR2      0x0010		/* (RW) ADC sample time register 2 */
#define TOFF_ADC_JOFR1      0x0014		/* (RW) ADC injected channel data offset register 1 */
#define TOFF_ADC_JOFR2      0x0018		/* (RW) ADC injected channel data offset register 2 */
#define TOFF_ADC_JOFR3      0x001C		/* (RW) ADC injected channel data offset register 3 */
#define TOFF_ADC_JOFR4      0x0020		/* (RW) ADC injected channel data offset register 4 */
#define TOFF_ADC_HTR        0x0024		/* (RW) ADC watchdog higher threshold register */
#define TOFF_ADC_LTR        0x0028		/* (RW) ADC watchdog lower threshold register */
#define TOFF_ADC_SQR1       0x002C		/* (RW) ADC regular sequence register 1 */
#define TOFF_ADC_SQR2       0x0030		/* (RW) ADC regular sequence register 2 */
#define TOFF_ADC_SQR3       0x0034		/* (RW) ADC regular sequence register 3 */
#define TOFF_ADC_JSQR       0x0038		/* (RW) ADC injected sequence register */
#define TOFF_ADC_JDR1       0x003C		/* (RW) ADC injected data register 1 */
#define TOFF_ADC_JDR2       0x0040		/* (RW) ADC injected data register 2 */
#define TOFF_ADC_JDR3       0x0044		/* (RW) ADC injected data register 3 */
#define TOFF_ADC_JDR4       0x0048		/* (RW) ADC injected data register 4 */
#define TOFF_ADC_DR         0x004C		/* (RW) ADC regular data register */

#define TADR_ADC_BASE       (APB2PERIPH_BASE + 0x2300)
#define TOFF_ADC_CSR        0x0000		/* (RW) ADC Common status register */
#define TOFF_ADC_CCR        0x0004		/* (RW) ADC common control register */
#define TOFF_ADC_CDR        0x0008		/* (RW) ADC common regular data register for dual AND triple modes */

/*
 *  SD HOST INTERFACE
 */
#define TADR_SDMMC1_BASE    (APB2PERIPH_BASE + 0x2C00)
#define TOFF_SDIO_POWER     0x0000		/* (RW) SDIO power control register */
#define TOFF_SDIO_CLKCR     0x0004		/* (RW) SDI clock control register */
#define TOFF_SDIO_ARG       0x0008		/* (RW) SDIO argument register */
#define TOFF_SDIO_CMD       0x000C		/* (RW) SDIO command register */
#define TOFF_SDIO_RESPCMD   0x0018		/* (R)  SDIO command response register */
#define TOFF_SDIO_RESP      0x0014		/* (R)  SDIO response 1 register */
#define TOFF_SDIO_RESP2     0x0018		/* (R)  SDIO response 2 register */
#define TOFF_SDIO_RESP3     0x001C		/* (R)  SDIO response 3 register */
#define TOFF_SDIO_RESP4     0x0020		/* (R)  SDIO response 4 register */
#define TOFF_SDIO_DTIMER    0x0024		/* (RW) SDIO data timer register */
#define TOFF_SDIO_DLEN      0x0028		/* (RW) SDIO data length register */
#define TOFF_SDIO_DCTRL     0x002C		/* (RW) SDIO data control register */
#define TOFF_SDIO_DCOUNT    0x0030		/* (R)  SDIO data counter register */
#define TOFF_SDIO_STA       0x0034		/* (R)  SDIO status register */
#define TOFF_SDIO_ICR       0x0038		/* (RW) SDIO interrupt clear register */
#define TOFF_SDIO_MASK      0x003C		/* (RW) SDIO mask register */
#define TOFF_SDIO_FIFOCNT   0x0048		/* (R)  SDIO FIFO counter register */
#define TOFF_SDIO_FIFO      0x0080		/* (RW) SDIO data FIFO register */

/*
 *  SYSTEM CONFIGURATION CONTROLLER
 */
#define TADR_SYSCFG_BASE    (APB2PERIPH_BASE + 0x3800)
#define TOFF_SYSCFG_MEMRMP  0x0000		/* (RW) SYSCFG memory remap register */
#define TOFF_SYSCFG_PMC     0x0004		/* (RW) SYSCFG peripheral mode configuration register */
#define TOFF_SYSCFG_EXTICR0 0x0008		/* (RW) SYSCFG external interrupt configuration registers 0 */
#define TOFF_SYSCFG_EXTICR1 0x000C		/* (RW) SYSCFG external interrupt configuration registers 1 */
#define TOFF_SYSCFG_EXTICR2 0x0010		/* (RW) SYSCFG external interrupt configuration registers 2 */
#define TOFF_SYSCFG_EXTICR3 0x0014		/* (RW) SYSCFG external interrupt configuration registers 3 */
#define TOFF_SYSCFG_CMPCR   0x0020		/* (RW) SYSCFG Compensation cell control register */

/*
 *  EXTERNAL INTERRUPT/EVENT CONTROLLER
 */
#define TADR_EXTI_BASE      (APB2PERIPH_BASE + 0x3C00)
#define TOFF_EXTI_IMR       0x0000		/* (RW) EXTI Interrupt mask register */
#define TOFF_EXTI_EMR       0x0004		/* (RW) EXTI Event mask register */
#define TOFF_EXTI_RTSR      0x0008		/* (RW) EXTI Rising trigger selection register */
#define TOFF_EXTI_FTSR      0x000C		/* (RW) EXTI Falling trigger selection register */
#define TOFF_EXTI_SWIER     0x0010		/* (RW) EXTI Software interrupt event register */
#define TOFF_EXTI_PR        0x0014		/* (RW) EXTI Pending register */


/*
 *  GENERAL PURPOSE I/O
 */
#define TADR_GPIOA_BASE     (AHB1PERIPH_BASE + 0x0000)
#define TADR_GPIOB_BASE     (AHB1PERIPH_BASE + 0x0400)
#define TADR_GPIOC_BASE     (AHB1PERIPH_BASE + 0x0800)
#define TADR_GPIOD_BASE     (AHB1PERIPH_BASE + 0x0C00)
#define TADR_GPIOE_BASE     (AHB1PERIPH_BASE + 0x1000)
#define TADR_GPIOF_BASE     (AHB1PERIPH_BASE + 0x1400)
#define TADR_GPIOG_BASE     (AHB1PERIPH_BASE + 0x1800)
#define TADR_GPIOH_BASE     (AHB1PERIPH_BASE + 0x1C00)
#define TADR_GPIOI_BASE     (AHB1PERIPH_BASE + 0x2000)
#define TADR_GPIOJ_BASE     (AHB1PERIPH_BASE + 0x2400)
#define TADR_GPIOK_BASE     (AHB1PERIPH_BASE + 0x2800)
#define TOFF_GPIO_MODER     0x0000		/* (RW) GPIO port mode register */
  #define GPIO_MODER_MODER0  0x00000003
  #define GPIO_MODER_MODER1  0x0000000C
  #define GPIO_MODER_MODER2  0x00000030
  #define GPIO_MODER_MODER3  0x000000C0
  #define GPIO_MODER_MODER4  0x00000300
  #define GPIO_MODER_MODER5  0x00000C00
  #define GPIO_MODER_MODER6  0x00003000
  #define GPIO_MODER_MODER7  0x0000C000
  #define GPIO_MODER_MODER8  0x00030000
  #define GPIO_MODER_MODER9  0x000C0000
  #define GPIO_MODER_MODER10 0x00300000
  #define GPIO_MODER_MODER11 0x00C00000
  #define GPIO_MODER_MODER12 0x03000000
  #define GPIO_MODER_MODER13 0x0C000000
  #define GPIO_MODER_MODER14 0x30000000
  #define GPIO_MODER_MODER15 0xC0000000
#define TOFF_GPIO_OTYPER    0x0004		/* (RW) GPIO port output type register */
#define TOFF_GPIO_OSPEEDR   0x0008		/* (RW) GPIO port output speed register */
  #define GPIO_OSPEEDER_OSPEEDR0 0x00000003
  #define GPIO_OSPEEDER_OSPEEDR1 0x0000000C
  #define GPIO_OSPEEDER_OSPEEDR2 0x00000030
  #define GPIO_OSPEEDER_OSPEEDR3 0x000000C0
  #define GPIO_OSPEEDER_OSPEEDR4 0x00000300
  #define GPIO_OSPEEDER_OSPEEDR5 0x00000C00
  #define GPIO_OSPEEDER_OSPEEDR6 0x00003000
  #define GPIO_OSPEEDER_OSPEEDR7 0x0000C000
  #define GPIO_OSPEEDER_OSPEEDR8 0x00030000
  #define GPIO_OSPEEDER_OSPEEDR9 0x000C0000
  #define GPIO_OSPEEDER_OSPEEDR10 0x00300000
  #define GPIO_OSPEEDER_OSPEEDR11 0x00C00000
  #define GPIO_OSPEEDER_OSPEEDR12 0x03000000
  #define GPIO_OSPEEDER_OSPEEDR13 0x0C000000
  #define GPIO_OSPEEDER_OSPEEDR14 0x30000000
  #define GPIO_OSPEEDER_OSPEEDR15 0xC0000000
#define TOFF_GPIO_PUPDR     0x000C		/* (RW) GPIO port pull-up/pull-down register */
  #define GPIO_PUPDR_PUPDR0  0x00000003
  #define GPIO_PUPDR_PUPDR1  0x0000000C
  #define GPIO_PUPDR_PUPDR2  0x00000030
  #define GPIO_PUPDR_PUPDR3  0x000000C0
  #define GPIO_PUPDR_PUPDR4  0x00000300
  #define GPIO_PUPDR_PUPDR5  0x00000C00
  #define GPIO_PUPDR_PUPDR6  0x00003000
  #define GPIO_PUPDR_PUPDR7  0x0000C000
  #define GPIO_PUPDR_PUPDR8  0x00030000
  #define GPIO_PUPDR_PUPDR9  0x000C0000
  #define GPIO_PUPDR_PUPDR10 0x00300000
  #define GPIO_PUPDR_PUPDR11 0x00C00000
  #define GPIO_PUPDR_PUPDR12 0x03000000
  #define GPIO_PUPDR_PUPDR13 0x0C000000
  #define GPIO_PUPDR_PUPDR14 0x30000000
  #define GPIO_PUPDR_PUPDR15 0xC0000000
#define TOFF_GPIO_IDR       0x0010		/* (R)  GPIO port input data register */
#define TOFF_GPIO_ODR       0x0014		/* (RW) GPIO port output data register */
#define TOFF_GPIO_BSRR      0x0018		/* (RW) GPIO port bit set/reset low register */
#define TOFF_GPIO_LCKR      0x001C		/* (RW) GPIO port configuration lock register */
#define TOFF_GPIO_AFR0      0x0020		/* (RW) GPIO alternate function registers */
#define TOFF_GPIO_AFR1      0x0024		/* (RW) GPIO alternate function registers */

/*
 *  CRC CALCULATION UNIT
 */
#define TADR_CRC_BASE       (AHB1PERIPH_BASE + 0x3000)
#define TOFF_CRC_DR         0x0000		/* (RW) CRC Data register */
#define TOFF_CRC_IDR        0x0004		/* (RW-8) CRC Independent data register */
#define TOFF_CRC_CR         0x0008		/* (RW) CRC Control register */
#define TOFF_CRC_INIT       0x0010		/* (RW) Initial CRC value register */
#define TOFF_CRC_POL        0x0014		/* (RW) CRC polynomial register */

/*
 *  RESET AND CLOCK CONTROL
 */
#define TADR_RCC_BASE       (AHB1PERIPH_BASE + 0x3800)
#define TOFF_RCC_CR         0x0000		/* (RW) RCC clock control register */
  #define RCC_CR_HSION             0x00000001
  #define RCC_CR_HSIRDY            0x00000002
  #define RCC_CR_HSITRIM           0x000000F8
  #define RCC_CR_HSITRIM_0         0x00000008	/* Bit 0 */
  #define RCC_CR_HSITRIM_1         0x00000010	/* Bit 1 */
  #define RCC_CR_HSITRIM_2         0x00000020	/* Bit 2 */
  #define RCC_CR_HSITRIM_3         0x00000040	/* Bit 3 */
  #define RCC_CR_HSITRIM_4         0x00000080	/* Bit 4 */
  #define RCC_CR_HSICAL            0x0000FF00
  #define RCC_CR_HSICAL_0          0x00000100	/* Bit 0 */
  #define RCC_CR_HSICAL_1          0x00000200	/* Bit 1 */
  #define RCC_CR_HSICAL_2          0x00000400	/* Bit 2 */
  #define RCC_CR_HSICAL_3          0x00000800	/* Bit 3 */
  #define RCC_CR_HSICAL_4          0x00001000	/* Bit 4 */
  #define RCC_CR_HSICAL_5          0x00002000	/* Bit 5 */
  #define RCC_CR_HSICAL_6          0x00004000	/* Bit 6 */
  #define RCC_CR_HSICAL_7          0x00008000	/* Bit 7 */
  #define RCC_CR_HSEON             0x00010000
  #define RCC_CR_HSERDY            0x00020000
  #define RCC_CR_HSEBYP            0x00040000
  #define RCC_CR_CSSON             0x00080000
  #define RCC_CR_PLLON             0x01000000
  #define RCC_CR_PLLRDY            0x02000000
  #define RCC_CR_PLLI2SON          0x04000000
  #define RCC_CR_PLLI2SRDY         0x08000000
  #define RCC_CR_PLLSAION          0x10000000
  #define RCC_CR_PLLSAIRDY         0x20000000
#define TOFF_RCC_PLLCFGR    0x0004		/* (RW) RCC PLL configuration register */
  #define RCC_PLLCFGR_PLLM         0x0000003F
  #define RCC_PLLCFGR_PLLM_0       0x00000001
  #define RCC_PLLCFGR_PLLM_1       0x00000002
  #define RCC_PLLCFGR_PLLM_2       0x00000004
  #define RCC_PLLCFGR_PLLM_3       0x00000008
  #define RCC_PLLCFGR_PLLM_4       0x00000010
  #define RCC_PLLCFGR_PLLM_5       0x00000020
  #define RCC_PLLCFGR_PLLN         0x00007FC0
  #define RCC_PLLCFGR_PLLN_0       0x00000040
  #define RCC_PLLCFGR_PLLN_1       0x00000080
  #define RCC_PLLCFGR_PLLN_2       0x00000100
  #define RCC_PLLCFGR_PLLN_3       0x00000200
  #define RCC_PLLCFGR_PLLN_4       0x00000400
  #define RCC_PLLCFGR_PLLN_5       0x00000800
  #define RCC_PLLCFGR_PLLN_6       0x00001000
  #define RCC_PLLCFGR_PLLN_7       0x00002000
  #define RCC_PLLCFGR_PLLN_8       0x00004000
  #define RCC_PLLCFGR_PLLP         0x00030000
  #define RCC_PLLCFGR_PLLP_0       0x00010000
  #define RCC_PLLCFGR_PLLP_1       0x00020000
  #define RCC_PLLCFGR_PLLSRC       0x00400000
  #define RCC_PLLCFGR_PLLSRC_HSE   0x00400000
  #define RCC_PLLCFGR_PLLSRC_HSI   0x00000000
  #define RCC_PLLCFGR_PLLQ         0x0F000000
  #define RCC_PLLCFGR_PLLQ_0       0x01000000
  #define RCC_PLLCFGR_PLLQ_1       0x02000000
  #define RCC_PLLCFGR_PLLQ_2       0x04000000
  #define RCC_PLLCFGR_PLLQ_3       0x08000000
#define TOFF_RCC_CFGR       0x0008		/* (RW) RCC clock configuration register */
  #define RCC_CFGR_SW              0x00000003	/* SW[1:0] bits (System clock Switch) */
  #define RCC_CFGR_SW_0            0x00000001	/* Bit 0 */
  #define RCC_CFGR_SW_1            0x00000002	/* Bit 1 */
  #define RCC_CFGR_SW_HSI          0x00000000	/* HSI selected as system clock */
  #define RCC_CFGR_SW_HSE          0x00000001	/* HSE selected as system clock */
  #define RCC_CFGR_SW_PLL          0x00000002	/* PLL selected as system clock */
  #define RCC_CFGR_SWS             0x0000000C	/* SWS[1:0] bits (System Clock Switch Status) */
  #define RCC_CFGR_SWS_0           0x00000004	/* Bit 0 */
  #define RCC_CFGR_SWS_1           0x00000008	/* Bit 1 */
  #define RCC_CFGR_SWS_HSI         0x00000000	/* HSI oscillator used as system clock */
  #define RCC_CFGR_SWS_HSE         0x00000004	/* HSE oscillator used as system clock */
  #define RCC_CFGR_SWS_PLL         0x00000008	/* PLL used as system clock */
  #define RCC_CFGR_HPRE            0x000000F0	/* HPRE[3:0] bits (AHB prescaler) */
  #define RCC_CFGR_HPRE_0          0x00000010	/* Bit 0 */
  #define RCC_CFGR_HPRE_1          0x00000020	/* Bit 1 */
  #define RCC_CFGR_HPRE_2          0x00000040	/* Bit 2 */
  #define RCC_CFGR_HPRE_3          0x00000080	/* Bit 3 */
  #define RCC_CFGR_HPRE_DIV1       0x00000000	/* SYSCLK not divided */
  #define RCC_CFGR_HPRE_DIV2       0x00000080	/* SYSCLK divided by 2 */
  #define RCC_CFGR_HPRE_DIV4       0x00000090	/* SYSCLK divided by 4 */
  #define RCC_CFGR_HPRE_DIV8       0x000000A0	/* SYSCLK divided by 8 */
  #define RCC_CFGR_HPRE_DIV16      0x000000B0	/* SYSCLK divided by 16 */
  #define RCC_CFGR_HPRE_DIV64      0x000000C0	/* SYSCLK divided by 64 */
  #define RCC_CFGR_HPRE_DIV128     0x000000D0	/* SYSCLK divided by 128 */
  #define RCC_CFGR_HPRE_DIV256     0x000000E0	/* SYSCLK divided by 256 */
  #define RCC_CFGR_HPRE_DIV512     0x000000F0	/* SYSCLK divided by 512 */
  #define RCC_CFGR_PPRE1           0x00001C00	/* PRE1[2:0] bits (APB1 prescaler) */
  #define RCC_CFGR_PPRE1_0         0x00000400	/* Bit 0 */
  #define RCC_CFGR_PPRE1_1         0x00000800	/* Bit 1 */
  #define RCC_CFGR_PPRE1_2         0x00001000	/* Bit 2 */
  #define RCC_CFGR_PPRE1_DIV1      0x00000000	/* HCLK not divided */
  #define RCC_CFGR_PPRE1_DIV2      0x00001000	/* HCLK divided by 2 */
  #define RCC_CFGR_PPRE1_DIV4      0x00001400	/* HCLK divided by 4 */
  #define RCC_CFGR_PPRE1_DIV8      0x00001800	/* HCLK divided by 8 */
  #define RCC_CFGR_PPRE1_DIV16     0x00001C00	/* HCLK divided by 16 */
  #define RCC_CFGR_PPRE2           0x0000E000	/* PRE2[2:0] bits (APB2 prescaler) */
  #define RCC_CFGR_PPRE2_0         0x00002000	/* Bit 0 */
  #define RCC_CFGR_PPRE2_1         0x00004000	/* Bit 1 */
  #define RCC_CFGR_PPRE2_2         0x00008000	/* Bit 2 */
  #define RCC_CFGR_PPRE2_DIV1      0x00000000	/* HCLK not divided */
  #define RCC_CFGR_PPRE2_DIV2      0x00008000	/* HCLK divided by 2 */
  #define RCC_CFGR_PPRE2_DIV4      0x0000A000	/* HCLK divided by 4 */
  #define RCC_CFGR_PPRE2_DIV8      0x0000C000	/* HCLK divided by 8 */
  #define RCC_CFGR_PPRE2_DIV16     0x0000E000	/* HCLK divided by 16 */
  #define RCC_CFGR_RTCPRE          0x001F0000
  #define RCC_CFGR_RTCPRE_0        0x00010000
  #define RCC_CFGR_RTCPRE_1        0x00020000
  #define RCC_CFGR_RTCPRE_2        0x00040000
  #define RCC_CFGR_RTCPRE_3        0x00080000
  #define RCC_CFGR_RTCPRE_4        0x00100000
  #define RCC_CFGR_MCO1            0x00600000
  #define RCC_CFGR_MCO1_0          0x00200000
  #define RCC_CFGR_MCO1_1          0x00400000
  #define RCC_CFGR_I2SSRC          0x00800000
  #define RCC_CFGR_MCO1PRE         0x07000000
  #define RCC_CFGR_MCO1PRE_0       0x01000000
  #define RCC_CFGR_MCO1PRE_1       0x02000000
  #define RCC_CFGR_MCO1PRE_2       0x04000000
  #define RCC_CFGR_MCO2PRE         0x38000000
  #define RCC_CFGR_MCO2PRE_0       0x08000000
  #define RCC_CFGR_MCO2PRE_1       0x10000000
  #define RCC_CFGR_MCO2PRE_2       0x20000000
  #define RCC_CFGR_MCO2            0xC0000000
  #define RCC_CFGR_MCO2_0          0x40000000
  #define RCC_CFGR_MCO2_1          0x80000000
#define TOFF_RCC_CIR        0x000C		/* (RW) RCC clock interrupt register */
  #define RCC_CIR_LSIRDYF          0x00000001
  #define RCC_CIR_LSERDYF          0x00000002
  #define RCC_CIR_HSIRDYF          0x00000004
  #define RCC_CIR_HSERDYF          0x00000008
  #define RCC_CIR_PLLRDYF          0x00000010
  #define RCC_CIR_PLLI2SRDYF       0x00000020
  #define RCC_CIR_CSSF             0x00000080
  #define RCC_CIR_LSIRDYIE         0x00000100
  #define RCC_CIR_LSERDYIE         0x00000200
  #define RCC_CIR_HSIRDYIE         0x00000400
  #define RCC_CIR_HSERDYIE         0x00000800
  #define RCC_CIR_PLLRDYIE         0x00001000
  #define RCC_CIR_PLLI2SRDYIE      0x00002000
  #define RCC_CIR_LSIRDYC          0x00010000
  #define RCC_CIR_LSERDYC          0x00020000
  #define RCC_CIR_HSIRDYC          0x00040000
  #define RCC_CIR_HSERDYC          0x00080000
  #define RCC_CIR_PLLRDYC          0x00100000
  #define RCC_CIR_PLLI2SRDYC       0x00200000
  #define RCC_CIR_CSSC             0x00800000
#define TOFF_RCC_AHB1RSTR   0x0010		/* (RW) RCC AHB1 peripheral reset register */
  #define RCC_AHB1RSTR_GPIOARST    0x00000001
  #define RCC_AHB1RSTR_GPIOBRST    0x00000002
  #define RCC_AHB1RSTR_GPIOCRST    0x00000004
  #define RCC_AHB1RSTR_GPIODRST    0x00000008
  #define RCC_AHB1RSTR_GPIOERST    0x00000010
  #define RCC_AHB1RSTR_GPIOFRST    0x00000020
  #define RCC_AHB1RSTR_GPIOGRST    0x00000040
  #define RCC_AHB1RSTR_GPIOHRST    0x00000080
  #define RCC_AHB1RSTR_GPIOIRST    0x00000100
  #define RCC_AHB1RSTR_GPIOJRST    0x00000200
  #define RCC_AHB1RSTR_GPIOKRST    0x00000400
  #define RCC_AHB1RSTR_CRCRST      0x00001000
  #define RCC_AHB1RSTR_DMA1RST     0x00200000
  #define RCC_AHB1RSTR_DMA2RST     0x00400000
  #define RCC_AHB1RSTR_DMA2DRST    0x00800000
  #define RCC_AHB1RSTR_ETHMACRST   0x02000000
  #define RCC_AHB1RSTR_OTGHRST     0x20000000
#define TOFF_RCC_AHB2RSTR   0x0014		/* (RW) RCC AHB2 peripheral reset register */
  #define RCC_AHB2RSTR_DCMIRST     0x00000001
  #define RCC_AHB2RSTR_CRYPRST     0x00000010
  #define RCC_AHB2RSTR_HSAHRST     0x00000020
  #define RCC_AHB2RSTR_RNGRST      0x00000040
  #define RCC_AHB2RSTR_OTGFSRST    0x00000080
#define TOFF_RCC_AHB3RSTR   0x0018		/* (RW) RCC AHB3 peripheral reset register */
  #define RCC_AHB3RSTR_FSMCRST     0x00000001
  #define RCC_AHB3RSTR_QSPIRST     0x00000002
#define TOFF_RCC_APB1RSTR   0x0020		/* (RW) RCC APB1 peripheral reset register */
  #define RCC_APB1RSTR_TIM2RST     0x00000001
  #define RCC_APB1RSTR_TIM3RST     0x00000002
  #define RCC_APB1RSTR_TIM4RST     0x00000004
  #define RCC_APB1RSTR_TIM5RST     0x00000008
  #define RCC_APB1RSTR_TIM6RST     0x00000010
  #define RCC_APB1RSTR_TIM7RST     0x00000020
  #define RCC_APB1RSTR_TIM12RST    0x00000040
  #define RCC_APB1RSTR_TIM13RST    0x00000080
  #define RCC_APB1RSTR_TIM14RST    0x00000100
  #define RCC_APB1RSTR_WWDGEN      0x00000800
  #define RCC_APB1RSTR_SPI2RST     0x00008000
  #define RCC_APB1RSTR_SPI3RST     0x00010000
  #define RCC_APB1RSTR_USART2RST   0x00020000
  #define RCC_APB1RSTR_USART3RST   0x00040000
  #define RCC_APB1RSTR_UART4RST    0x00080000
  #define RCC_APB1RSTR_UART5RST    0x00100000
  #define RCC_APB1RSTR_I2C1RST     0x00200000
  #define RCC_APB1RSTR_I2C2RST     0x00400000
  #define RCC_APB1RSTR_I2C3RST     0x00800000
  #define RCC_APB1RSTR_CAN1RST     0x02000000
  #define RCC_APB1RSTR_CAN2RST     0x04000000
  #define RCC_APB1RSTR_PWRRST      0x10000000
  #define RCC_APB1RSTR_DACRST      0x20000000
  #define RCC_APB1RSTR_UART7RST    0x40000000
  #define RCC_APB1RSTR_UART8RST    0x80000000
#define TOFF_RCC_APB2RSTR   0x0024		/* (RW) RCC APB2 peripheral reset register */
  #define RCC_APB2RSTR_TIM1RST     0x00000001
  #define RCC_APB2RSTR_TIM8RST     0x00000002
  #define RCC_APB2RSTR_USART1RST   0x00000010
  #define RCC_APB2RSTR_USART6RST   0x00000020
  #define RCC_APB2RSTR_ADCRST      0x00000100
  #define RCC_APB2RSTR_SDIORST     0x00000800
  #define RCC_APB2RSTR_SPI1RST     0x00001000
  #define RCC_APB2RSTR_SYSCFGRST   0x00004000
  #define RCC_APB2RSTR_TIM9RST     0x00010000
  #define RCC_APB2RSTR_TIM10RST    0x00020000
  #define RCC_APB2RSTR_TIM11RST    0x00040000
  #define RCC_APB2RSTR_SPI5RST     0x00100000
  #define RCC_APB2RSTR_SPI6RST     0x00200000
  #define RCC_APB2RSTR_SAI1RST     0x00400000
  #define RCC_APB2RSTR_SAI2RST     0x00800000
  #define RCC_APB2RSTR_LTDCRST     0x04000000
#define TOFF_RCC_AHB1ENR    0x0030		/* (RW) RCC AHB1 peripheral clock register */
  #define RCC_AHB1ENR_GPIOAEN      0x00000001
  #define RCC_AHB1ENR_GPIOBEN      0x00000002
  #define RCC_AHB1ENR_GPIOCEN      0x00000004
  #define RCC_AHB1ENR_GPIODEN      0x00000008
  #define RCC_AHB1ENR_GPIOEEN      0x00000010
  #define RCC_AHB1ENR_GPIOFEN      0x00000020
  #define RCC_AHB1ENR_GPIOGEN      0x00000040
  #define RCC_AHB1ENR_GPIOHEN      0x00000080
  #define RCC_AHB1ENR_GPIOIEN      0x00000100
  #define RCC_AHB1ENR_GPIOJEN      0x00000200
  #define RCC_AHB1ENR_GPIOKEN      0x00000400
  #define RCC_AHB1ENR_CRCEN        0x00001000
  #define RCC_AHB1ENR_BKPSRAMEN    0x00040000
  #define RCC_AHB1ENR_CCMDATARAMEN 0x00100000
  #define RCC_AHB1ENR_DMA1EN       0x00200000
  #define RCC_AHB1ENR_DMA2EN       0x00400000
  #define RCC_AHB1ENR_ETHMACEN     0x02000000
  #define RCC_AHB1ENR_ETHMACTXEN   0x04000000
  #define RCC_AHB1ENR_ETHMACRXEN   0x08000000
  #define RCC_AHB1ENR_ETHMACPTPEN  0x10000000
  #define RCC_AHB1ENR_OTGHSEN      0x20000000
  #define RCC_AHB1ENR_OTGHSULPIEN  0x40000000
#define TOFF_RCC_AHB2ENR    0x0034		/* (RW) RCC AHB2 peripheral clock register */
  #define RCC_AHB2ENR_DCMIEN       0x00000001
  #define RCC_AHB2ENR_CRYPEN       0x00000010
  #define RCC_AHB2ENR_HASHEN       0x00000020
  #define RCC_AHB2ENR_RNGEN        0x00000040
  #define RCC_AHB2ENR_OTGFSEN      0x00000080
#define TOFF_RCC_AHB3ENR    0x0038		/* (RW) RCC AHB3 peripheral clock register */
  #define RCC_AHB3ENR_FSMCEN       0x00000001
  #define RCC_AHB3ENR_QSPIEN       0x00000002
#define TOFF_RCC_APB1ENR    0x0040		/* (RW) RCC APB1 peripheral clock enable register */
  #define RCC_APB1ENR_TIM2EN       0x00000001
  #define RCC_APB1ENR_TIM3EN       0x00000002
  #define RCC_APB1ENR_TIM4EN       0x00000004
  #define RCC_APB1ENR_TIM5EN       0x00000008
  #define RCC_APB1ENR_TIM6EN       0x00000010
  #define RCC_APB1ENR_TIM7EN       0x00000020
  #define RCC_APB1ENR_TIM12EN      0x00000040
  #define RCC_APB1ENR_TIM13EN      0x00000080
  #define RCC_APB1ENR_TIM14EN      0x00000100
  #define RCC_APB1ENR_WWDGEN       0x00000800
  #define RCC_APB1ENR_SPI2EN       0x00004000
  #define RCC_APB1ENR_SPI3EN       0x00008000
  #define RCC_APB1ENR_USART2EN     0x00020000
  #define RCC_APB1ENR_USART3EN     0x00040000
  #define RCC_APB1ENR_UART4EN      0x00080000
  #define RCC_APB1ENR_UART5EN      0x00100000
  #define RCC_APB1ENR_I2C1EN       0x00200000
  #define RCC_APB1ENR_I2C2EN       0x00400000
  #define RCC_APB1ENR_I2C3EN       0x00800000
  #define RCC_APB1ENR_I2C4EN       0x01000000
  #define RCC_APB1ENR_CAN1EN       0x02000000
  #define RCC_APB1ENR_CECEN        0x08000000
  #define RCC_APB1ENR_CAN2EN       0x04000000
  #define RCC_APB1ENR_PWREN        0x10000000
  #define RCC_APB1ENR_DACEN        0x20000000
  #define RCC_APB1ENR_UART7EN      0x40000000
  #define RCC_APB1ENR_UART8EN      0x80000000
#define TOFF_RCC_APB2ENR    0x0044		/* (RW) RCC APB2 peripheral clock enable register */
  #define RCC_APB2ENR_TIM1EN       0x00000001
  #define RCC_APB2ENR_TIM8EN       0x00000002
  #define RCC_APB2ENR_USART1EN     0x00000010
  #define RCC_APB2ENR_USART6EN     0x00000020
  #define RCC_APB2ENR_ADC1EN       0x00000100
  #define RCC_APB2ENR_ADC2EN       0x00000200
  #define RCC_APB2ENR_ADC3EN       0x00000400
  #define RCC_APB2ENR_SDIOEN       0x00000800
  #define RCC_APB2ENR_SPI1EN       0x00001000
  #define RCC_APB2ENR_SYSCFGEN     0x00004000
  #define RCC_APB2ENR_TIM11EN      0x00040000
  #define RCC_APB2ENR_TIM10EN      0x00020000
  #define RCC_APB2ENR_TIM9EN       0x00010000
  #define RCC_APB2ENR_TIM10EN      0x00020000
  #define RCC_APB2ENR_TIM11EN      0x00040000
  #define RCC_APB2ENR_SPI5EN       0x00100000
  #define RCC_APB2ENR_SPI6EN       0x00200000
  #define RCC_APB2ENR_SAI1EN       0x00400000
  #define RCC_APB2ENR_SAI2EN       0x00800000
  #define RCC_APB2ENR_LTDCEN       0x04000000
#define TOFF_RCC_AHB1LPENR  0x0050		/* (RW) RCC AHB1 peripheral clock enable in low power mode register */
  #define RCC_AHB1LPENR_GPIOALPEN     0x00000001
  #define RCC_AHB1LPENR_GPIOBLPEN     0x00000002
  #define RCC_AHB1LPENR_GPIOCLPEN     0x00000004
  #define RCC_AHB1LPENR_GPIODLPEN     0x00000008
  #define RCC_AHB1LPENR_GPIOELPEN     0x00000010
  #define RCC_AHB1LPENR_GPIOFLPEN     0x00000020
  #define RCC_AHB1LPENR_GPIOGLPEN     0x00000040
  #define RCC_AHB1LPENR_GPIOHLPEN     0x00000080
  #define RCC_AHB1LPENR_GPIOILPEN     0x00000100
  #define RCC_AHB1LPENR_CRCLPEN       0x00001000
  #define RCC_AHB1LPENR_FLITFLPEN     0x00008000
  #define RCC_AHB1LPENR_SRAM1LPEN     0x00010000
  #define RCC_AHB1LPENR_SRAM2LPEN     0x00020000
  #define RCC_AHB1LPENR_BKPSRAMLPEN   0x00040000
  #define RCC_AHB1LPENR_DMA1LPEN      0x00200000
  #define RCC_AHB1LPENR_DMA2LPEN      0x00400000
  #define RCC_AHB1LPENR_ETHMACLPEN    0x02000000
  #define RCC_AHB1LPENR_ETHMACTXLPEN  0x04000000
  #define RCC_AHB1LPENR_ETHMACRXLPEN  0x08000000
  #define RCC_AHB1LPENR_ETHMACPTPLPEN 0x10000000
  #define RCC_AHB1LPENR_OTGHSLPEN     0x20000000
  #define RCC_AHB1LPENR_OTGHSULPILPEN 0x40000000
#define TOFF_RCC_AHB2LPENR  0x0054		/* (RW) RCC AHB2 peripheral clock enable in low power mode register */
  #define RCC_AHB2LPENR_DCMILPEN   0x00000001
  #define RCC_AHB2LPENR_CRYPLPEN   0x00000010
  #define RCC_AHB2LPENR_HASHLPEN   0x00000020
  #define RCC_AHB2LPENR_RNGLPEN    0x00000040
  #define RCC_AHB2LPENR_OTGFSLPEN  0x00000080
#define TOFF_RCC_AHB3LPENR  0x0058		/* (RW) RCC AHB3 peripheral clock enable in low power mode register */
  #define RCC_AHB3LPENR_FSMCLPEN   0x00000001
  #define RCC_AHB3LPENR_QSPILPEN   0x00000002
#define TOFF_RCC_APB1LPENR  0x0060		/* (RW) RCC APB1 peripheral clock enable in low power mode register */
  #define RCC_APB1LPENR_TIM2LPEN   0x00000001
  #define RCC_APB1LPENR_TIM3LPEN   0x00000002
  #define RCC_APB1LPENR_TIM4LPEN   0x00000004
  #define RCC_APB1LPENR_TIM5LPEN   0x00000008
  #define RCC_APB1LPENR_TIM6LPEN   0x00000010
  #define RCC_APB1LPENR_TIM7LPEN   0x00000020
  #define RCC_APB1LPENR_TIM12LPEN  0x00000040
  #define RCC_APB1LPENR_TIM13LPEN  0x00000080
  #define RCC_APB1LPENR_TIM14LPEN  0x00000100
  #define RCC_APB1LPENR_WWDGLPEN   0x00000800
  #define RCC_APB1LPENR_SPI2LPEN   0x00004000
  #define RCC_APB1LPENR_SPI3LPEN   0x00008000
  #define RCC_APB1LPENR_USART2LPEN 0x00020000
  #define RCC_APB1LPENR_USART3LPEN 0x00040000
  #define RCC_APB1LPENR_UART4LPEN  0x00080000
  #define RCC_APB1LPENR_UART5LPEN  0x00100000
  #define RCC_APB1LPENR_I2C1LPEN   0x00200000
  #define RCC_APB1LPENR_I2C2LPEN   0x00400000
  #define RCC_APB1LPENR_I2C3LPEN   0x00800000
  #define RCC_APB1LPENR_CAN1LPEN   0x02000000
  #define RCC_APB1LPENR_CAN2LPEN   0x04000000
  #define RCC_APB1LPENR_PWRLPEN    0x10000000
  #define RCC_APB1LPENR_DACLPEN    0x20000000
  #define RCC_APB1LPENR_UART7LPEN  0x40000000
  #define RCC_APB1LPENR_UART8LPEN  0x80000000
#define TOFF_RCC_APB2LPENR  0x0064		/* (RW) RCC APB2 peripheral clock enable in low power mode register */
  #define RCC_APB2LPENR_TIM1LPEN   0x00000001
  #define RCC_APB2LPENR_TIM8LPEN   0x00000002
  #define RCC_APB2LPENR_USART1LPEN 0x00000010
  #define RCC_APB2LPENR_USART6LPEN 0x00000020
  #define RCC_APB2LPENR_ADC1LPEN   0x00000100
  #define RCC_APB2LPENR_ADC2PEN    0x00000200
  #define RCC_APB2LPENR_ADC3LPEN   0x00000400
  #define RCC_APB2LPENR_SDIOLPEN   0x00000800
  #define RCC_APB2LPENR_SPI1LPEN   0x00001000
  #define RCC_APB2LPENR_SYSCFGLPEN 0x00004000
  #define RCC_APB2LPENR_TIM9LPEN   0x00010000
  #define RCC_APB2LPENR_TIM10LPEN  0x00020000
  #define RCC_APB2LPENR_TIM11LPEN  0x00040000
  #define RCC_APB2LPENR_SPI5LPEN   0x00100000
  #define RCC_APB2LPENR_SPI6LPEN   0x00200000
  #define RCC_APB2LPENR_SAI1LPEN   0x00400000
  #define RCC_APB2LPENR_SAI2LPEN   0x00800000
  #define RCC_APB2LPENR_LTDCLPEN   0x04000000
#define TOFF_RCC_BDCR       0x0070		/* (RW) RCC Backup domain control register */
  #define RCC_BDCR_LSEON           0x00000001
  #define RCC_BDCR_LSERDY          0x00000002
  #define RCC_BDCR_LSEBYP          0x00000004
  #define RCC_BDCR_RTCSEL          0x00000300
  #define RCC_BDCR_RTCSEL_0        0x00000100
  #define RCC_BDCR_RTCSEL_1        0x00000200
  #define RCC_BDCR_RTCEN           0x00008000
  #define RCC_BDCR_BDRST           0x00010000
#define TOFF_RCC_CSR        0x0074		/* (RW) RCC clock control & status register */
  #define RCC_CSR_LSION            0x00000001
  #define RCC_CSR_LSIRDY           0x00000002
  #define RCC_CSR_RMVF             0x01000000
  #define RCC_CSR_BORRSTF          0x02000000
  #define RCC_CSR_PADRSTF          0x04000000
  #define RCC_CSR_PORRSTF          0x08000000
  #define RCC_CSR_SFTRSTF          0x10000000
  #define RCC_CSR_WDGRSTF          0x20000000
  #define RCC_CSR_WWDGRSTF         0x40000000
  #define RCC_CSR_LPWRRSTF         0x80000000
#define TOFF_RCC_SSCGR      0x0080		/* (RW) RCC spread spectrum clock generation register */
  #define RCC_SSCGR_MODPER         0x00001FFF
  #define RCC_SSCGR_INCSTEP        0x0FFFE000
  #define RCC_SSCGR_SPREADSEL      0x40000000
  #define RCC_SSCGR_SSCGEN         0x80000000
#define TOFF_RCC_PLLI2SCFGR 0x0084		/* (RW) RCC PLLI2S configuration register */
  #define RCC_PLLI2SCFGR_PLLI2SN   0x00007FC0
  #define RCC_PLLI2SCFGR_PLLI2SP   0x00030000
  #define RCC_PLLI2SCFGR_PLLI2SQ   0x0F000000
  #define RCC_PLLI2SCFGR_PLLI2SR   0x70000000
#define TOFF_RCC_PLLSAICFGR 0x0088		/* (RW) RCC PLLSAI configuration register */
  #define RCC_PLLSAICFGR_PLLSAIN   0x00007FC0
  #define RCC_PLLSAICFGR_PLLSAIP   0x00030000
  #define RCC_PLLSAICFGR_PLLSAIQ   0x0F000000
  #define RCC_PLLSAICFGR_PLLSAIR   0x70000000
#define TOFF_RCC_DCKCFGR1   0x008C		/* (RW) RCC Dedicated Clocks configuration register1 */
  #define RCC_DCKCFGR1_PLLI2SDIVQ  0x0000001F
  #define RCC_DCKCFGR1_PLLSAIDIVQ  0x00001F00
  #define RCC_DCKCFGR1_PLLSAIDIVR  0x00030000
  #define RCC_DCKCFGR1_SAI1SEL     0x00300000
  #define RCC_DCKCFGR1_SAI2SEL     0x00C00000
  #define RCC_DCKCFGR1_TIMPRE      0x01000000
#define TOFF_RCC_DCKCFGR2   0x0090		/* (RW) RCC Dedicated Clocks configuration register2 */
  #define RCC_DCKCFGR2_USART1SEL   0x00000003
  #define RCC_DCKCFGR2_USART1SEL_0 0x00000001
  #define RCC_DCKCFGR2_USART1SEL_1 0x00000002
  #define RCC_DCKCFGR2_USART2SEL   0x0000000C
  #define RCC_DCKCFGR2_USART3SEL   0x00000030
  #define RCC_DCKCFGR2_USART3SEL_0 0x00000010
  #define RCC_DCKCFGR2_USART3SEL_1 0x00000020
  #define RCC_DCKCFGR2_UART4SEL    0x000000C0
  #define RCC_DCKCFGR2_UART5SEL    0x00000300
  #define RCC_DCKCFGR2_USART6SEL   0x00000C00
  #define RCC_DCKCFGR2_USART6SEL_0 0x00000400
  #define RCC_DCKCFGR2_USART6SEL_1 0x00000800
  #define RCC_DCKCFGR2_UART7SEL    0x00003000
  #define RCC_DCKCFGR2_UART8SEL    0x0000C000
  #define RCC_DCKCFGR2_I2C1SEL     0x00030000
  #define RCC_DCKCFGR2_I2C2SEL     0x000C0000
  #define RCC_DCKCFGR2_I2C3SEL     0x00300000
  #define RCC_DCKCFGR2_I2C4SEL     0x00C00000
  #define RCC_DCKCFGR2_LPTIM1SEL   0x03000000
  #define RCC_DCKCFGR2_CECSEL      0x04000000
  #define RCC_DCKCFGR2_CK48MSEL    0x08000000
  #define RCC_DCKCFGR2_SDMMC1SEL   0x10000000

/*
 *  FLASH REGISTERS
 */
#define TADR_FLASH_R_BASE   (AHB1PERIPH_BASE + 0x3C00)
#define TOFF_FLASH_ACR      0x0000		/* (RW) FLASH access control register */
  #define FLASH_ACR_LATENCY        0x0000000F
  #define FLASH_ACR_LATENCY_0WS    0x00000000
  #define FLASH_ACR_LATENCY_1WS    0x00000001
  #define FLASH_ACR_LATENCY_2WS    0x00000002
  #define FLASH_ACR_LATENCY_3WS    0x00000003
  #define FLASH_ACR_LATENCY_4WS    0x00000004
  #define FLASH_ACR_LATENCY_5WS    0x00000005
  #define FLASH_ACR_LATENCY_6WS    0x00000006
  #define FLASH_ACR_LATENCY_7WS    0x00000007
  #define FLASH_ACR_LATENCY_8WS    0x00000008
  #define FLASH_ACR_LATENCY_9WS    0x00000009
  #define FLASH_ACR_LATENCY_10WS   0x0000000A
  #define FLASH_ACR_LATENCY_11WS   0x0000000B
  #define FLASH_ACR_LATENCY_12WS   0x0000000C
  #define FLASH_ACR_LATENCY_13WS   0x0000000D
  #define FLASH_ACR_LATENCY_14WS   0x0000000E
  #define FLASH_ACR_LATENCY_15WS   0x0000000F
  #define FLASH_ACR_PRFTEN         0x00000100
  #define FLASH_ACR_ARTEN          0x00000200
  #define FLASH_ACR_ARTRST         0x00000800
#define TOFF_FLASH_KEYR     0x0004		/* (RW) FLASH key register */
#define TOFF_FLASH_OPTKEYR  0x0008		/* (RW) FLASH option key register */
#define TOFF_FLASH_SR       0x000C		/* (RW) FLASH status register */
  #define FLASH_SR_EOP             0x00000001
  #define FLASH_SR_SOP             0x00000002
  #define FLASH_SR_WRPERR          0x00000010
  #define FLASH_SR_PGAERR          0x00000020
  #define FLASH_SR_PGPERR          0x00000040
  #define FLASH_SR_PGSERR          0x00000080
  #define FLASH_SR_BSY             0x00010000
#define TOFF_FLASH_CR       0x0010		/* (RW) FLASH control register */
  #define FLASH_CR_PG              0x00000001
  #define FLASH_CR_SER             0x00000002
  #define FLASH_CR_MER             0x00000004
  #define FLASH_CR_SNB_0           0x00000008
  #define FLASH_CR_SNB_1           0x00000010
  #define FLASH_CR_SNB_2           0x00000020
  #define FLASH_CR_SNB_3           0x00000040
  #define FLASH_CR_PSIZE_0         0x00000100
  #define FLASH_CR_PSIZE_1         0x00000200
  #define FLASH_CR_STRT            0x00010000
  #define FLASH_CR_EOPIE           0x01000000
  #define FLASH_CR_LOCK            0x80000000
#define TOFF_FLASH_OPTCR    0x0014		/* (RW) FLASH option control register */
  #define FLASH_OPTCR_OPTLOCK      0x00000001
  #define FLASH_OPTCR_OPTSTRT      0x00000002
  #define FLASH_OPTCR_BOR_LEV_0    0x00000004
  #define FLASH_OPTCR_BOR_LEV_1    0x00000008
  #define FLASH_OPTCR_BOR_LEV      0x0000000C
  #define FLASH_OPTCR_WDG_SW       0x00000020
  #define FLASH_OPTCR_nRST_STOP    0x00000040
  #define FLASH_OPTCR_nRST_STDBY   0x00000080
  #define FLASH_OPTCR_RDP_0        0x00000100
  #define FLASH_OPTCR_RDP_1        0x00000200
  #define FLASH_OPTCR_RDP_2        0x00000400
  #define FLASH_OPTCR_RDP_3        0x00000800
  #define FLASH_OPTCR_RDP_4        0x00001000
  #define FLASH_OPTCR_RDP_5        0x00002000
  #define FLASH_OPTCR_RDP_6        0x00004000
  #define FLASH_OPTCR_RDP_7        0x00008000
  #define FLASH_OPTCR_nWRP_0       0x00010000
  #define FLASH_OPTCR_nWRP_1       0x00020000
  #define FLASH_OPTCR_nWRP_2       0x00040000
  #define FLASH_OPTCR_nWRP_3       0x00080000
  #define FLASH_OPTCR_nWRP_4       0x00100000
  #define FLASH_OPTCR_nWRP_5       0x00200000
  #define FLASH_OPTCR_nWRP_6       0x00400000
  #define FLASH_OPTCR_nWRP_7       0x00800000
  #define FLASH_OPTCR_IWDG_STDBY   0x40000000
  #define FLASH_OPTCR_IWDG_STOP    0x80000000
#define TOFF_FLASH_OPTCR1   0x0018		/* (RW) FLASH option control register 1 */

/* 
 *  DMA CONTROLLER
 */
#define TADR_DMA1_BASE      (AHB1PERIPH_BASE + 0x6000)
#define TADR_DMA2_BASE      (AHB1PERIPH_BASE + 0x6400)
#define TOFF_DMAI_LISR      0x0000		/* (RW) DMA low interrupt status register */
#define TOFF_DMAI_HISR      0x0004		/* (RW) DMA high interrupt status register */
#define TOFF_DMAI_LIFCR     0x0008		/* (RW) DMA low interrupt flag clear register */
#define TOFF_DMAI_HIFCR     0x000C		/* (RW) DMA high interrupt flag clear register */

#define TADR_DMA1_STM0_BASE (DMA1_BASE + 0x010)
#define TADR_DMA1_STM1_BASE (DMA1_BASE + 0x028)
#define TADR_DMA1_STM2_BASE (DMA1_BASE + 0x040)
#define TADR_DMA1_STM3_BASE (DMA1_BASE + 0x058)
#define TADR_DMA1_STM4_BASE (DMA1_BASE + 0x070)
#define TADR_DMA1_STM5_BASE (DMA1_BASE + 0x088)
#define TADR_DMA1_STM6_BASE (DMA1_BASE + 0x0A0)
#define TADR_DMA1_STM7_BASE (DMA1_BASE + 0x0B8)
#define TADR_DMA2_STM0_BASE (DMA2_BASE + 0x010)
#define TADR_DMA2_STM1_BASE (DMA2_BASE + 0x028)
#define TADR_DMA2_STM2_BASE (DMA2_BASE + 0x040)
#define TADR_DMA2_STM3_BASE (DMA2_BASE + 0x058)
#define TADR_DMA2_STM4_BASE (DMA2_BASE + 0x070)
#define TADR_DMA2_STM5_BASE (DMA2_BASE + 0x088)
#define TADR_DMA2_STM6_BASE (DMA2_BASE + 0x0A0)
#define TADR_DMA2_STM7_BASE (DMA2_BASE + 0x0B8)
#define TOFF_DMAS_CR        0x0000		/* (RW) DMA stream x configuration register      */
#define TOFF_DMAS_NDTR      0x0004		/* (RW) DMA stream x number of data register     */
#define TOFF_DMAS_PAR       0x0008		/* (RW) DMA stream x peripheral address register */
#define TOFF_DMAS_M0AR      0x000C		/* (RW) DMA stream x memory 0 address register   */
#define TOFF_DMAS_M1AR      0x0010		/* (RW) DMA stream x memory 1 address register   */
#define TOFF_DMAS_FCR       0x0014		/* (RW) DMA stream x FIFO control register       */

/*
 *  DMA2D CONTROLLER
 */

#define DMA2D_BASE          (AHB1PERIPH_BASE + 0xB000)
#define TOFF_DMA2D_CR       0x0000	/* (RW) DMA2D Control Register */
#define TOFF_DMA2D_ISR      0x0004	/* (RW) DMA2D Interrupt Status Register */
#define TOFF_DMA2D_IFCR     0x0008	/* (RW) DMA2D Interrupt Flag Clear Register */
#define TOFF_DMA2D_FGMAR    0x000C	/* (RW) DMA2D Foreground Memory Address Register */
#define TOFF_DMA2D_FGOR     0x0010	/* (RW) DMA2D Foreground Offset Register */
#define TOFF_DMA2D_BGMAR    0x0014	/* (RW) DMA2D Background Memory Address Register */
#define TOFF_DMA2D_BGOR     0x0018	/* (RW) DMA2D Background Offset Register */
#define TOFF_DMA2D_FGPFCCR  0x001C	/* (RW) DMA2D Foreground PFC Control Register */
#define TOFF_DMA2D_FGCOLR   0x0020	/* (RW) DMA2D Foreground Color Register */
#define TOFF_DMA2D_BGPFCCR  0x0024	/* (RW) DMA2D Background PFC Control Register */
#define TOFF_DMA2D_BGCOLR   0x0028	/* (RW) DMA2D Background Color Register */
#define TOFF_DMA2D_FGCMAR   0x002C	/* (RW) DMA2D Foreground CLUT Memory Address Register */
#define TOFF_DMA2D_BGCMAR   0x0030	/* (RW) DMA2D Background CLUT Memory Address Register */
#define TOFF_DMA2D_OPFCCR   0x0034	/* (RW) DMA2D Output PFC Control Register */
#define TOFF_DMA2D_OCOLR    0x0038	/* (RW) DMA2D Output Color Register */
#define TOFF_DMA2D_OMAR     0x003C	/* (RW) DMA2D Output Memory Address Register */
#define TOFF_DMA2D_OOR      0x0040	/* (RW) DMA2D Output Offset Register */
#define TOFF_DMA2D_NLR      0x0044	/* (RW) DMA2D Number of Line Register */
#define TOFF_DMA2D_LWR      0x0048	/* (RW) DMA2D Line Watermark Register */
#define TOFF_DMA2D_AMTCR    0x004C	/* (RW) DMA2D AHB Master Timer Configuration Register */
#define TOFF_DMA2D_FGCLUT   0x0400	/* (RW) DMA2D Foreground CLUT 400-7FF */
#define TOFF_DMA2D_BGCLUT   0x0800	/* (RW) DMA2D Background CLUT 800-BFF */



#define ETH_BASE            (AHB1PERIPH_BASE + 0x8000)
#define ETH_MAC_BASE        (ETH_BASE)
#define ETH_MMC_BASE        (ETH_BASE + 0x0100)
#define ETH_PTP_BASE        (ETH_BASE + 0x0700)
#define ETH_DMA_BASE        (ETH_BASE + 0x1000)


/*
 *  SERIAL AUDIO INTERFACE
 */
#define TADR_SAI1_BASE      (APB2PERIPH_BASE + 0x5800)
#define TADR_SAI2_BASE      (APB2PERIPH_BASE + 0x5C00)
#define SAI_WINDOW_SIZE     0x0020
#define TOFF_SAI_GCR        0x0000		/* (RW) SAI global configuration register */
#define TOFF_SAI_CR1        0x0004		/* (RW) SAI block x configuration register 1 */
#define TOFF_SAI_CR2        0x0008		/* (RW) SAI block x configuration register 2 */
#define TOFF_SAI_FRCR       0x000C		/* (RW) SAI block x frame configuration register */
#define TOFF_SAI_SLOTR      0x0010		/* (RW) SAI block x slot register */
#define TOFF_SAI_IMR        0x0014		/* (RW) SAI block x interrupt mask register */
#define TOFF_SAI_SR         0x0018		/* (RW) SAI block x status register */
#define TOFF_SAI_CLRFR      0x001C		/* (RW) SAI block x clear flag register */
#define TOFF_SAI_DR         0x0020		/* (RW) SAI block x data register */


/*
 *  LCD-TFT DISPLAY CONTROLLER
 */
#define TADR_LTDC_BASE      (APB2PERIPH_BASE + 0x6800)
#define TADR_LTDC_LAYER1    (TADR_LTDC_BASE + 0x84)
#define TADR_LTDC_LAYER2    (TADR_LTDC_BASE + 0x104)
#define TOFF_LTDC_SSCR      0x0008		/* (RW) LTDC Synchronization Size Configuration Register */
#define TOFF_LTDC_BPCR      0x000C		/* (RW) LTDC Back Porch Configuration Register */
#define TOFF_LTDC_AWCR      0x0010		/* (RW) LTDC Active Width Configuration Register */
#define TOFF_LTDC_TWCR      0x0014		/* (RW) LTDC Total Width Configuration Register */
#define TOFF_LTDC_GCR       0x0018		/* (RW) LTDC Global Control Register */
#define TOFF_LTDC_SRCR      0x0024		/* (RW) LTDC Shadow Reload Configuration Register */
#define TOFF_LTDC_BCCR      0x002C		/* (RW) LTDC Background Color Configuration Register */
#define TOFF_LTDC_IER       0x0034		/* (RW) LTDC Interrupt Enable Register */
#define TOFF_LTDC_ISR       0x0038		/* (RW) LTDC Interrupt Status Register */
#define TOFF_LTDC_ICR       0x003C		/* (RW) LTDC Interrupt Clear Register */
#define TOFF_LTDC_LIPCR     0x0040		/* (RW) LTDC Line Interrupt Position Configuration Register */
#define TOFF_LTDC_CPSR      0x0044		/* (RW) LTDC Current Position Status Register */
#define TOFF_LTDC_CDSR      0x0048		/* (RW) LTDC Current Display Status Register */

/*
 *  LCD-TFT DISPLAY LAYER X CONTROLLER (WINDOW)
 */
#define TOFF_LTDCW_CR       0x0000		/* (RW) LTDC Layerx Control Register :0x84 */
#define TOFF_LTDCW_WHPCR    0x0004		/* (RW) LTDC Layerx Window Horizontal :0x88 */
#define TOFF_LTDCW_WVPCR    0x0008		/* (RW) LTDC Layerx Window Vertical Position Configuration Register :0x8C */
#define TOFF_LTDCW_CKCR     0x000C		/* (RW) LTDC Layerx Color Keying Configuration Register :0x90 */
#define TOFF_LTDCW_PFCR     0x0010		/* (RW) LTDC Layerx Pixel Format Configuration Register :0x94 */
#define TOFF_LTDCW_CACR     0x0014		/* (RW) LTDC Layerx Constant Alpha Configuration Register :0x98 */
#define TOFF_LTDCW_DCCR     0x0018		/* (RW) LTDC Layerx Default Color Configuration Register :0x9C */
#define TOFF_LTDCW_BFCR     0x001C		/* (RW) LTDC Layerx Blending Factors Configuration Register :0xA0 */
#define TOFF_LTDCW_CFBAR    0x0028		/* (RW) LTDC Layerx Color Frame Buffer Address Register :0xAC */
#define TOFF_LTDCW_CFBLR    0x002C		/* (RW) LTDC Layerx Color Frame Buffer Length Register :0xB0 */
#define TOFF_LTDCW_CFBLNR   0x0030		/* (RW) LTDC Layerx ColorFrame Buffer Line Number Register :0xB4 */
#define TOFF_LTDCW_CLUTWR   0x003C		/* (RW) LTDC Layerx CLUT Write Register :0xC0 */


/*
 *  DCMI
 */
#define TADR_DCMI_BASE      (AHB2PERIPH_BASE + 0x50000)
#define TOFF_DCMI_CR        0x0000		/* (RW) DCMI control register 1 */
#define TOFF_DCMI_SR        0x0004		/* (R)  DCMI status register */
#define TOFF_DCMI_RISR      0x0008		/* (R)  DCMI raw interrupt status register */
#define TOFF_DCMI_IER       0x000C		/* (RW) DCMI interrupt enable register */
#define TOFF_DCMI_MISR      0x0010		/* (RW) DCMI masked interrupt status register */
#define TOFF_DCMI_ICR       0x0014		/* (RW) DCMI interrupt clear register */
#define TOFF_DCMI_ESCR      0x0018		/* (RW) DCMI embedded synchronization code register */
#define TOFF_DCMI_ESUR      0x001C		/* (RW) DCMI embedded synchronization unmask register */
#define TOFF_DCMI_CWSTRTR   0x0020		/* (RW) DCMI crop window start */
#define TOFF_DCMI_CWSIZER   0x0024		/* (RW) DCMI crop window size */
#define TOFF_DCMI_DR        0x0028		/* (RW) DCMI data register */

/*
 *  CRYPTO PROCESSER
 */
#define TADR_CRYP_BASE      (AHB2PERIPH_BASE + 0x60000)
#define TOFF_CRYP_CR        0x0000		/* (RW) CRYP control register */
#define TOFF_CRYP_SR        0x0004		/* (R)  CRYP status register */
#define TOFF_CRYP_DR        0x0008		/* (RW) CRYP data input register */
#define TOFF_CRYP_DOUT      0x000C		/* (RW) CRYP data output register */
#define TOFF_CRYP_DMACR     0x0010		/* (RW) CRYP DMA control register */
#define TOFF_CRYP_IMSCR     0x0014		/* (RW) CRYP interrupt mask set/clear register */
#define TOFF_CRYP_RISR      0x0018		/* (RW) CRYP raw interrupt status register */
#define TOFF_CRYP_MISR      0x001C		/* (RW) CRYP masked interrupt status register */
#define TOFF_CRYP_K0LR      0x0020		/* (RW) CRYP key left  register 0 */
#define TOFF_CRYP_K0RR      0x0024		/* (RW) CRYP key right register 0 */
#define TOFF_CRYP_K1LR      0x0028		/* (RW) CRYP key left  register 1 */
#define TOFF_CRYP_K1RR      0x002C		/* (RW) CRYP key right register 1 */
#define TOFF_CRYP_K2LR      0x0030		/* (RW) CRYP key left  register 2 */
#define TOFF_CRYP_K2RR      0x0034		/* (RW) CRYP key right register 2 */
#define TOFF_CRYP_K3LR      0x0038		/* (RW) CRYP key left  register 3 */
#define TOFF_CRYP_K3RR      0x003C		/* (RW) CRYP key right register 3 */
#define TOFF_CRYP_IV0LR     0x0040		/* (RW) CRYP initialization vector left-word  register 0 */
#define TOFF_CRYP_IV0RR     0x0044		/* (RW) CRYP initialization vector right-word register 0 */
#define TOFF_CRYP_IV1LR     0x0048		/* (RW) CRYP initialization vector left-word  register 1 */
#define TOFF_CRYP_IV1RR     0x004C		/* (RW) CRYP initialization vector right-word register 1 */
#define TOFF_CSGCMCCM0R     0x0050		/* (RW) CRYP GCM/GMAC or CCM/CMAC context swap register 0 */
#define TOFF_CSGCMCCM1R     0x0054		/* (RW) CRYP GCM/GMAC or CCM/CMAC context swap register 1 */
#define TOFF_CSGCMCCM2R     0x0058		/* (RW) CRYP GCM/GMAC or CCM/CMAC context swap register 2 */
#define TOFF_CSGCMCCM3R     0x005C		/* (RW) CRYP GCM/GMAC or CCM/CMAC context swap register 3 */
#define TOFF_CSGCMCCM4R     0x0060		/* (RW) CRYP GCM/GMAC or CCM/CMAC context swap register 4 */
#define TOFF_CSGCMCCM5R     0x0064		/* (RW) CRYP GCM/GMAC or CCM/CMAC context swap register 5 */
#define TOFF_CSGCMCCM6R     0x0068		/* (RW) CRYP GCM/GMAC or CCM/CMAC context swap register 6 */
#define TOFF_CSGCMCCM7R     0x006C		/* (RW) CRYP GCM/GMAC or CCM/CMAC context swap register 7 */
#define TOFF_CSGCM0R        0x0070		/* (RW) CRYP GCM/GMAC context swap register */
#define TOFF_CSGCM1R        0x0074		/* (RW) CRYP GCM/GMAC context swap register */
#define TOFF_CSGCM2R        0x0078		/* (RW) CRYP GCM/GMAC context swap register */
#define TOFF_CSGCM3R        0x007C		/* (RW) CRYP GCM/GMAC context swap register */
#define TOFF_CSGCM4R        0x0080		/* (RW) CRYP GCM/GMAC context swap register */
#define TOFF_CSGCM5R        0x0084		/* (RW) CRYP GCM/GMAC context swap register */
#define TOFF_CSGCM6R        0x0088		/* (RW) CRYP GCM/GMAC context swap register */
#define TOFF_CSGCM7R        0x008C		/* (RW) CRYP GCM/GMAC context swap register */

/*
 *  HASH
 */
#define TADR_HASH_BASE      (AHB2PERIPH_BASE + 0x60400)
#define TOFF_HASH_CR        0x0000		/* (RW) HASH control register */
#define TOFF_HASH_DIN       0x0004		/* (RW) HASH data input register */
#define TOFF_HASH_STR       0x0008		/* (RW) HASH start register */
#define TOFF_HASH_HR0       0x000C		/* (RW) HASH digest registers 0 */
#define TOFF_HASH_HR1       0x0010		/* (RW) HASH digest registers 1 */
#define TOFF_HASH_HR2       0x0014		/* (RW) HASH digest registers 2 */
#define TOFF_HASH_HR3       0x0018		/* (RW) HASH digest registers 3 */
#define TOFF_HASH_HR4       0x001C		/* (RW) HASH digest registers 4 */
#define TOFF_HASH_IMR       0x0020		/* (RW) HASH interrupt enable register */
#define TOFF_HASH_SR        0x0024		/* (R)  HASH status register */
#define TOFF_HASH_CSR0      0x00F8		/* (RW) HASH context swap registers 0 */
#define TOFF_HASH_CSR1      0x00FC		/* (RW) HASH context swap registers 1 */
#define TOFF_HASH_CSR2      0x0100		/* (RW) HASH context swap registers 2 */
#define TOFF_HASH_CSR3      0x0104		/* (RW) HASH context swap registers 3 */
#define TOFF_HASH_CSR4      0x0108		/* (RW) HASH context swap registers 4 */
#define TOFF_HASH_CSR5      0x010C		/* (RW) HASH context swap registers 5 */
#define TOFF_HASH_CSR6      0x0110		/* (RW) HASH context swap registers 6 */
#define TOFF_HASH_CSR7      0x0114		/* (RW) HASH context swap registers 7 */
#define TOFF_HASH_CSR8      0x0118		/* (RW) HASH context swap registers 8 */
#define TOFF_HASH_CSR9      0x011C		/* (RW) HASH context swap registers 9 */
#define TOFF_HASH_CSR10     0x0120		/* (RW) HASH context swap registers 10 */
#define TOFF_HASH_CSR11     0x0124		/* (RW) HASH context swap registers 11 */
#define TOFF_HASH_CSR12     0x0128		/* (RW) HASH context swap registers 12 */
#define TOFF_HASH_CSR13     0x012C		/* (RW) HASH context swap registers 13 */
#define TOFF_HASH_CSR14     0x0130		/* (RW) HASH context swap registers 14 */
#define TOFF_HASH_CSR15     0x0134		/* (RW) HASH context swap registers 15 */
#define TOFF_HASH_CSR16     0x0138		/* (RW) HASH context swap registers 16 */
#define TOFF_HASH_CSR17     0x013C		/* (RW) HASH context swap registers 17 */
#define TOFF_HASH_CSR18     0x0140		/* (RW) HASH context swap registers 18 */
#define TOFF_HASH_CSR19     0x0144		/* (RW) HASH context swap registers 19 */
#define TOFF_HASH_CSR20     0x0148		/* (RW) HASH context swap registers 20 */
#define TOFF_HASH_CSR21     0x014C		/* (RW) HASH context swap registers 21 */
#define TOFF_HASH_CSR22     0x0150		/* (RW) HASH context swap registers 22 */
#define TOFF_HASH_CSR23     0x0154		/* (RW) HASH context swap registers 23 */
#define TOFF_HASH_CSR24     0x0158		/* (RW) HASH context swap registers 24 */
#define TOFF_HASH_CSR25     0x015C		/* (RW) HASH context swap registers 25 */
#define TOFF_HASH_CSR26     0x0160		/* (RW) HASH context swap registers 26 */
#define TOFF_HASH_CSR27     0x0164		/* (RW) HASH context swap registers 27 */
#define TOFF_HASH_CSR28     0x0168		/* (RW) HASH context swap registers 28 */
#define TOFF_HASH_CSR29     0x016C		/* (RW) HASH context swap registers 29 */
#define TOFF_HASH_CSR30     0x0170		/* (RW) HASH context swap registers 30 */
#define TOFF_HASH_CSR31     0x0174		/* (RW) HASH context swap registers 31 */
#define TOFF_HASH_CSR32     0x0178		/* (RW) HASH context swap registers 32 */
#define TOFF_HASH_CSR33     0x017C		/* (RW) HASH context swap registers 33 */
#define TOFF_HASH_CSR34     0x0180		/* (RW) HASH context swap registers 34 */
#define TOFF_HASH_CSR35     0x0184		/* (RW) HASH context swap registers 35 */
#define TOFF_HASH_CSR36     0x0188		/* (RW) HASH context swap registers 36 */
#define TOFF_HASH_CSR37     0x018C		/* (RW) HASH context swap registers 37 */
#define TOFF_HASH_CSR38     0x0190		/* (RW) HASH context swap registers 38 */
#define TOFF_HASH_CSR39     0x0194		/* (RW) HASH context swap registers 39 */
#define TOFF_HASH_CSR40     0x0198		/* (RW) HASH context swap registers 40 */
#define TOFF_HASH_CSR41     0x019C		/* (RW) HASH context swap registers 41 */
#define TOFF_HASH_CSR42     0x01A0		/* (RW) HASH context swap registers 42 */
#define TOFF_HASH_CSR43     0x01A4		/* (RW) HASH context swap registers 43 */
#define TOFF_HASH_CSR44     0x01A8		/* (RW) HASH context swap registers 44 */
#define TOFF_HASH_CSR45     0x01AC		/* (RW) HASH context swap registers 45 */
#define TOFF_HASH_CSR46     0x01B0		/* (RW) HASH context swap registers 46 */
#define TOFF_HASH_CSR47     0x01B4		/* (RW) HASH context swap registers 47 */
#define TOFF_HASH_CSR48     0x01B8		/* (RW) HASH context swap registers 48 */
#define TOFF_HASH_CSR49     0x01BC		/* (RW) HASH context swap registers 49 */
#define TOFF_HASH_CSR50     0x01C0		/* (RW) HASH context swap registers 50 */

/*
 *  HASH DIGEST
 */
#define TADR_HASHDIGEST_BASE (AHB2PERIPH_BASE + 0x60710)
#define TOFF_HASHDIGEST_HR0 0x0000		/* (RW) HASH digest registers, Address offset: 0x310-0x32C */

/*
 *  RNG
 */
#define TADR_RNG_BASE       (AHB2PERIPH_BASE + 0x60800)
#define TOFF_RNG_CR         0x0000		/* (RW) RNG control register */
#define TOFF_RNG_SR         0x0004		/* (RW) RNG status register */
#define TOFF_RNG_DR         0x0008		/* (RW) RNG data register */

/*
 *  FLEXIBLE STATIC MEMORY
 */
#define TADR_FSMC_R_BASE    (FSMC_R_BASE + 0x0000)

/*
 *  FLEXIBLE STATIC MEMORY CONTROLLER
 */
#define TOFF_FSMC_R_BTCR0   0x0000		/* (RW) NOR/PSRAM chip-select control register(BCR) and chip-select timing register(BTR) 0 */
#define TOFF_FSMC_R_BTCR1   0x0004		/* (RW) NOR/PSRAM chip-select control register(BCR) and chip-select timing register(BTR) 1 */
#define TOFF_FSMC_R_BTCR2   0x0008		/* (RW) NOR/PSRAM chip-select control register(BCR) and chip-select timing register(BTR) 2 */
#define TOFF_FSMC_R_BTCR3   0x000C		/* (RW) NOR/PSRAM chip-select control register(BCR) and chip-select timing register(BTR) 3 */
#define TOFF_FSMC_R_BTCR4   0x0010		/* (RW) NOR/PSRAM chip-select control register(BCR) and chip-select timing register(BTR) 4 */
#define TOFF_FSMC_R_BTCR5   0x0014		/* (RW) NOR/PSRAM chip-select control register(BCR) and chip-select timing register(BTR) 5 */
#define TOFF_FSMC_R_BTCR6   0x0018		/* (RW) NOR/PSRAM chip-select control register(BCR) and chip-select timing register(BTR) 6 */
#define TOFF_FSMC_R_BTCR7   0x001C		/* (RW) NOR/PSRAM chip-select control register(BCR) and chip-select timing register(BTR) 7 */

/*
 *  FLEXIBLE STATIC MEMORY CONTROLLER BANK1E
 */
#define TOFF_FSMC_R_BWTR0   0x0104		/* (RW) NOR/PSRAM write timing registers 0 */
#define TOFF_FSMC_R_BWTR1   0x0108		/* (RW) NOR/PSRAM write timing registers 1 */
#define TOFF_FSMC_R_BWTR2   0x010C		/* (RW) NOR/PSRAM write timing registers 2 */
#define TOFF_FSMC_R_BWTR3   0x0110		/* (RW) NOR/PSRAM write timing registers 3 */
#define TOFF_FSMC_R_BWTR4   0x0114		/* (RW) NOR/PSRAM write timing registers 4 */
#define TOFF_FSMC_R_BWTR5   0x0118		/* (RW) NOR/PSRAM write timing registers 5 */
#define TOFF_FSMC_R_BWTR6   0x011C		/* (RW) NOR/PSRAM write timing registers 6 */

/*
 *  FLEXIBLE STATIC MEMORY CONTROLLER BANK3
 */
#define TOFF_FSMC_R_PCR     0x0080		/* (RW) NAND Flash control register */
#define TOFF_FSMC_R_SR      0x0084		/* (RW) NAND Flash FIFO status and interrupt register */
#define TOFF_FSMC_R_PMEM    0x0088		/* (RW) NAND Flash Common memory space timing register */
#define TOFF_FSMC_R_PATT    0x008C		/* (RW) NAND Flash Attribute memory space timing register */
#define TOFF_FSMC_R_ECCR    0x0090		/* (RW) NAND Flash ECC result registers */

/*
 *  FLEXIBLE MEMORY CONTROLLER BANK5 6
 */
#define TOFF_FSMC_R_SDCR0	0x0140		/* (RW) SDRAM Control registers 0 */
#define TOFF_FSMC_R_SDCR1	0x0144		/* (RW) SDRAM Control registers 1 */
#define TOFF_FSMC_R_SDTR0   0x0148		/* (RW) SDRAM Timing registers 0 */
#define TOFF_FSMC_R_SDTR1   0x014C		/* (RW) SDRAM Timing registers 1 */
#define TOFF_FSMC_R_SDCMR   0x0150		/* (RW) SDRAM Command Mode register */
#define TOFF_FSMC_R_SDRTR   0x0154		/* (RW) SDRAM Refresh Timer register  */
#define TOFF_FSMC_R_SDSR    0x0158		/* (RW) SDRAM Status register */

/*
 *  DEBUG MCU
 */
#define TADR_DBGMCU_BASE    0xE0042000
#define TOFF_DBGMCU_IDCODE  0x0000		/* (RW) MCU device ID code */
#define TOFF_DBGMCU_CR      0x0004		/* (RW) Debug MCU configuration register */
#define TOFF_DBGMCU_APB1FZ  0x0008		/* (RW) Debug MCU APB1 freeze register */
#define TOFF_DBGMCU_APB2FZ  0x000C		/* (RW) Debug MCU APB2 freeze register */


/*
 *  USB REGISTERS BASE ADDRESS
 */
#define TADR_USB_OTG_HS_PERIPH_BASE     0x40040000
#define TADR_USB_OTG_FS_PERIPH_BASE     0x50000000

#define USB_OTG_GLOBAL_BASE                  ((uint32_t )0x000)
#define USB_OTG_DEVICE_BASE                  ((uint32_t )0x800)
#define USB_OTG_IN_ENDPOINT_BASE             ((uint32_t )0x900)
#define USB_OTG_OUT_ENDPOINT_BASE            ((uint32_t )0xB00)
#define USB_OTG_EP_REG_SIZE                  ((uint32_t )0x20)
#define USB_OTG_HOST_BASE                    ((uint32_t )0x400)
#define USB_OTG_HOST_PORT_BASE               ((uint32_t )0x440)
#define USB_OTG_HOST_CHANNEL_BASE            ((uint32_t )0x500)
#define USB_OTG_HOST_CHANNEL_SIZE            ((uint32_t )0x20)
#define USB_OTG_PCGCCTL_BASE                 ((uint32_t )0xE00)
#define USB_OTG_FIFO_BASE                    ((uint32_t )0x1000)
#define USB_OTG_FIFO_SIZE                    ((uint32_t )0x1000)


#if 1	/* ROI DEBUG */

#ifdef __cplusplus
 extern "C" {
#endif /* __cplusplus */
  
/** @addtogroup Device_Included
  * @{
  */
//#include "stm32f756xx.h"


#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif	/* ROI DEBUG */

#endif  /* _STM32F7XX_H_ */

