
#ifndef _SYS_DEFS_H_
#define _SYS_DEFS_H_

/*	Values	*/
#if BOARDNO == 2
#define TARGET_CPU_STR	"STM32F746 Nucleo-144"
#elif BOARDNO == 3
#define TARGET_CPU_STR	"STM32F767 Nucleo-144"
#elif BOARDNO == 4
#define TARGET_CPU_STR	"STM32F723E-Didcovery"
#elif BOARDNO == 1
#define TARGET_CPU_STR	"STM32F769I-Discovery"
#else
#define TARGET_CPU_STR	"STM32F746G-Discovery"
#endif

/* endian */
#define SIL_ENDIAN      0		/* LITTLE ENDIAN */

/*	Address		*/
#define RAM_BASE        0x20000000
#define RAM_SIZE        (128*1024)
#define VECTOR_SIZE		(4*8)
#define FIQ_DATA_SIZE   256
#define STACKINT        (RAM_BASE+RAM_SIZE-FIQ_DATA_SIZE)	/* ߥåν */
#define STACKTOP        (STACKINT-256)						/* 桼åν */

/*
 *  ԤΤ
 *  ϥåȿ˰¸롣
 */
#define SIL_DLY_TIM1    100
#define SIL_DLY_TIM2    9

/*	Default Values	*/

#define MAX_INT_NUM     82
#define DEF_DUMP_LENGTH	256
#define NOT_INITDECT
#define RESET_VECTOR    1

#ifndef TOPPERS_MACRO_ONLY

/*
 *  Value of the External oscillator in Hz
 */
#if BOARDNO == 2 || BOARDNO == 3	/* nucleo */
#define HSE_VALUE       (8000000)
#else
#define HSE_VALUE       (25000000)
#endif

/*
 *  Value of the Internal oscillator in Hz
 */
#define HSI_VALUE       (16000000)

/*
 *  Value of the Internal Low Speed oscillator (LSI) value.
 */
#define LSI_VALUE       (32000)

/*
 *  Value of the External Low Speed oscillator in Hz
 */
#define LSE_VALUE       (32768)


/*
 *  ѥ¸Υǡ
 */
#define	_int8_		char		/* 8ӥåȤ	*/
#define	_int16_		short		/* 16ӥåȤ	*/
#define	_int32_		int			/* 32ӥåȤ	*/

#include "stm32f7xx.h"

/*
 *  ѥγĥǽΤΥޥ
 */
#define	Inline          static inline

extern void SetVector(void *addr);
extern int sys_printf(const char * format, ...);
extern void sys_putc(int c);

#endif	/* TOPPERS_MACRO_ONLY */

/*	Serial Channels		*/
#define MAX_SERIAL		1
#define DEF_MON_SERIAL	0

/* serial definitions */

#define DEFAULT_SPEED		115200

#endif	/* SYS_DEFS_H_ */

