
#ifndef _SYS_DEFS_H_
#define _SYS_DEFS_H_

/*	Values	*/

#define TARGET_CPU_STR		"STM32MP157"

/* endian */
#define SIL_ENDIAN      0		/* LITTLE ENDIAN */

/*	Address		*/
#define RAM_BASE        0x10020000
#define RAM_SIZE        (128*1024)
#define VECTOR_SIZE		(4*8)
#define FIQ_DATA_SIZE   256
#define STACKINT        (RAM_BASE+RAM_SIZE-FIQ_DATA_SIZE)	/* ߥåν */
#define STACKTOP        (STACKINT-256)						/* 桼åν */

/*
 *  ԤΤ
 *  ϥåȿ˰¸롣
 */
#define SIL_DLY_TIM1    30
#define SIL_DLY_TIM2    20

/*	Default Values	*/

#define MAX_INT_NUM     150
#define DEF_DUMP_LENGTH	256
#define NOT_INITDECT
#define RESET_VECTOR    1

#define HSI_VALUE            64000000	/* Value of the Internal oscillator in Hz*/
#define HSE_VALUE            24000000	/* Value of the External oscillator in Hz */
#define CSI_VALUE            4000000	/* Value of the Internal oscillator in Hz*/
#define EXTERNAL_CLOCK_VALUE 12288000	/* Value of the External clock in Hz*/

#define HSE_STARTUP_TIMEOUT  100		/* Time out for HSE start up */
#define LOCK_RESOURCE_TIMEOUT   (100*1000U)	/* timeout in ms */

#ifndef TOPPERS_MACRO_ONLY
/*
 *  ѥ¸Υǡ
 */
#define	_int8_		char		/* 8ӥåȤ	*/
#define	_int16_		short		/* 16ӥåȤ	*/
#define	_int32_		int			/* 32ӥåȤ	*/
#define _int64_     long long	/* 64ӥåȤ */

/*
 *  ѥγĥǽΤΥޥ
 */
#define	Inline      static inline

typedef struct {
	unsigned int SYSCLK_Frequency;	/*  SYSCLK clock frequency expressed in Hz */
	unsigned int HCLK_Frequency;	/*  HCLK clock frequency expressed in Hz */
	unsigned int PCLK1_Frequency;	/*  PCLK1 clock frequency expressed in Hz */
	unsigned int PCLK2_Frequency;	/*  PCLK2 clock frequency expressed in Hz */
	unsigned int PCLK5_Frequency;	/*  PCLK5 clock frequency expressed in Hz */
	unsigned int PLL3_P_Frequency;	/*  PLL3 P clock frequency expressed in Hz */
	unsigned int PLL3_Q_Frequency;	/*  PLL3 Q clock frequency expressed in Hz */
	unsigned int PLL3_R_Frequency;	/*  PLL3 R clock frequency expressed in Hz */
	unsigned int PLL4_P_Frequency;	/*  PLL4 P clock frequency expressed in Hz */
	unsigned int PLL4_Q_Frequency;	/*  PLL4 Q clock frequency expressed in Hz */
	unsigned int PLL4_R_Frequency;	/*  PLL4 R clock frequency expressed in Hz */
} RCC_ClocksTypeDef;

#include "sil.h"

#define PERIPH_LOCK(__Periph__)       Periph_Lock(__Periph__, LOCK_RESOURCE_TIMEOUT)
#define PERIPH_UNLOCK(__Periph__)     Periph_Unlock(__Periph__)

extern void RCC_GetClocksFreq(RCC_ClocksTypeDef* pRCC_Clocks);
extern int  Periph_Lock(uint32_t periph, uint32_t timeout);
extern void Periph_Unlock(uint32_t periph);

extern uint32_t SystemCoreClock;

#endif	/* TOPPERS_MACRO_ONLY */

/*	Serial Channels		*/

#define MAX_SERIAL		1
#define DEF_MON_SERIAL	0

#include "stm32mp157xx.h"

/* serial definitions */

#define DEFAULT_SPEED		115200
#define USE_UART_FIFOMODE   0
#define UART_OVERSAMPLING   UART_OVERSAMPLING_16
#define UART_PRESCALER_DIV  UART_PRESCALER_DIV1
#define MAIN_PRIORITY       1U
#define SUB_PRIORITY        0

#endif	/* SYS_DEFS_H_ */

