/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2015-2022 by Roi Takeuchi
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 *	rommon Config Functions
 */
#include "sys_defs.h"
#include <string.h>
#include "sil.h"

/*
 *  ץstm32wb55-nucleoѡ
 */

#define sil_modw_mem(addr, mask, val)	sil_wrw_mem((addr), ((sil_rew_mem(addr) & ~(mask)) | (val)))
#define sil_andw_mem(addr, mask)			sil_wrw_mem((addr), (sil_rew_mem(addr) & ~(mask)))
#define sil_orw_mem(addr, val)			sil_wrw_mem((addr), (sil_rew_mem(addr) | (val)))


#define HSE_TIMEOUT_VALUE          (100*1000)
#define HSI_TIMEOUT_VALUE          (2000U)      /* 2 ms (minimum Tick + 1U) */
#define PLL_TIMEOUT_VALUE          (2000U)      /* 2 ms (minimum Tick + 1U) */
#define MSI_TIMEOUT_VALUE          (2000U)      /* 2 ms (minimum Tick + 1U) */
#define LSI1_TIMEOUT_VALUE         (2000U)		/* 2 ms (minimum Tick + 1)   */
#define LSI2_TIMEOUT_VALUE         (3000U)		/* to be adjusted with DS    */
#define HSI48_TIMEOUT_VALUE        (2000U)		/* 2 ms (minimum Tick + 1)   */
#define RCC_LSE_TIMEOUT_VALUE      (5000000U)	/* 5 s    */
#define RCC_DBP_TIMEOUT_VALUE      (2000U)		/* 2 ms (minimum Tick + 1)  */
#define PLLSAI1_TIMEOUT_VALUE      (2000U)		/* 2 ms (minimum Tick + 1)   */
#define CLOCKSWITCH_TIMEOUT_VALUE  (5000000U)	/* 5 s    */
#define LATENCY_TIMEOUT_VALUE      (2000U)		/* 2 ms (minimum Tick + 1)   */
#define PRESCALER_TIMEOUT_VALUE    (2000U)		/* 2 ms (minimum Tick + 1)   */

#define PLLSOURCE_NONE             (0)
#define MEGA_HZ                    1000000		/* Division factor to convert Hz in Mhz */

#if !defined(HSE_VALUE)
#define HSE_VALUE                  32000000		/* Value of the External oscillator in Hz */
#endif /* HSE_VALUE */
#if !defined(HSI_VALUE)
#define HSI_VALUE                  16000000		/* Value of the Internal oscillator in Hz*/
#endif /* HSI_VALUE */
#if !defined(LSE_VALUE)
#define LSE_VALUE                  32768		/* Value of the External low oscillator in Hz*/
#endif

#if !defined(MSI_RANGE)
#define MSI_RANGE                  0
#endif

#if !defined(RTC_CLOCK_SOURCE)
#define RTC_CLOCK_SOURCE           RCC_RTCCLKSOURCE_LSE
#endif

/*
 *  PLLå
_*/
#define PLL_M                      0		/* RCC_PLLM_DIV1 */
#define PLL_N                      32		/*  */
#if BOARNO == 2
#define PLL_P                      1		/* RCC_PLLP_DIV2 */
#define PLL_Q                      1
#else
#define PLL_P                      4		/* RCC_PLLP_DIV5 */
#define PLL_Q                      4
#endif
#define PLL_R                      1		/* RCC_PLLR_DIV2 */

/*
 *  RCC쥸ե
 */
#define PLLM_SHIFT                 4
#define PLLN_SHIFT                 8
#define PLLP_SHIFT                 17
#define PLLQ_SHIFT                 25
#define PLLR_SHIFT                 29
#define HSIDIV_SHIFT               11
#define MSIRANG_SHIFT              4
#define CFGR_SWS_SHIFT             2
#define CFGR_HPRE_SHIFT            4
#define CFGR_PPRE1_SHIFT           8
#define CFGR_PPRE2_SHIFT           11
#define MSITRIM_SHIFT              8
#define HSITRIM_SHIFT              24
#define SHDHPRE_SHIFT              0
#define HSECR_HSETUNE_SHIFT        8

#define IPCC_CHFM_SHIFT            16


/*
 *  FLASH_Latency
 */ 
#define FLASH_LATENCY_0            (FLASH_ACR_LATENCY_0WS)	/* FLASH Zero wait state   */
#define FLASH_LATENCY_1            (FLASH_ACR_LATENCY_1WS)	/* FLASH One wait state    */
#define FLASH_LATENCY_2            (FLASH_ACR_LATENCY_2WS)	/* FLASH Two wait states   */
#define FLASH_LATENCY_3            (FLASH_ACR_LATENCY_3WS)	/* FLASH Three wait states */

/*
 *  POWER Voltage scale
 */
#define PWR_REGULATOR_VOLTAGE_SCALE1 PWR_CR1_VOS_0			/* Regulator voltage output range 1 mode, typical output voltage at 1.2 V, system frequency up to 64 MHz */
#define PWR_REGULATOR_VOLTAGE_SCALE2 PWR_CR1_VOS_1			/* Regulator voltage output range 2 mode, typical output voltage at 1.0 V, system frequency up to 16 MHz */

/*
 *  RCC System Clock Source
 */
#define RCC_SYSCLKSOURCE_MSI       0x00000000				/* MSI selection as system clock */
#define RCC_SYSCLKSOURCE_HSI       RCC_CFGR_SW_0			/* HSI selection as system clock */
#define RCC_SYSCLKSOURCE_HSE       RCC_CFGR_SW_1			/* PSE selection as system clock */
#define RCC_SYSCLKSOURCE_PLLCLK    (RCC_CFGR_SW_1 | RCC_CFGR_SW_0)	/* PLL selection as system clock */

/*
 *  RCC System Clock Source Status
 */
#define RCC_SYSCLKSOURCE_STATUS_MSI    0x00000000			/* MSI used as system clock */
#define RCC_SYSCLKSOURCE_STATUS_HSI    RCC_CFGR_SWS_0		/* HSI used as system clock */
#define RCC_SYSCLKSOURCE_STATUS_HSE    RCC_CFGR_SWS_1		/* HSE used as system clock */
#define RCC_SYSCLKSOURCE_STATUS_PLLCLK (RCC_CFGR_SWS_1 | RCC_CFGR_SWS_0)   /* PLL used as system clock */

/*
 *  PLLå
 */
#define RCC_PLLSOURCE_NONE         0x00000000				/* No clock selected as PLL entry clock source  */
#define RCC_PLLSOURCE_MSI          RCC_PLLCFGR_PLLSRC_MSI	/* MSI clock selected as PLL entry clock source */
#define RCC_PLLSOURCE_HSI          RCC_PLLCFGR_PLLSRC_HSI	/* HSI clock selected as PLL entry clock source */
#define RCC_PLLSOURCE_HSE          RCC_PLLCFGR_PLLSRC_HSE	/* HSE clock selected as PLL entry clock source */


/*
 *  RCC HCLK Divided
 */
#define RCC_HCLK_DIV1              0x00000000			/* HCLK not divided */
#define RCC_HCLK_DIV2              RCC_CFGR_PPRE1_2		/* HCLK divided by 2 */
#define RCC_HCLK_DIV4              (RCC_CFGR_PPRE1_2 | RCC_CFGR_PPRE1_0)	/* HCLK divided by 4 */
#define RCC_HCLK_DIV8              (RCC_CFGR_PPRE1_2 | RCC_CFGR_PPRE1_1)	/* HCLK divided by 8 */
#define RCC_HCLK_DIV16             (RCC_CFGR_PPRE1_2 | RCC_CFGR_PPRE1_1 | RCC_CFGR_PPRE1_0)	/* HCLK divided by 16 */

/*
 *  RCC AHB Clock Source
 */
#define RCC_SYSCLK_DIV1            0x00000000			/* SYSCLK not divided */
#define RCC_SYSCLK_DIV2            RCC_CFGR_HPRE_3		/* SYSCLK divided by 2 */
#define RCC_SYSCLK_DIV3            RCC_CFGR_HPRE_0		/* SYSCLK divided by 3 */
#define RCC_SYSCLK_DIV4            (RCC_CFGR_HPRE_3 | RCC_CFGR_HPRE_0)	/* SYSCLK divided by 4 */
#define RCC_SYSCLK_DIV5            RCC_CFGR_HPRE_1		/* SYSCLK divided by 5 */
#define RCC_SYSCLK_DIV6            (RCC_CFGR_HPRE_2 | RCC_CFGR_HPRE_0)	/* SYSCLK divided by 6 */
#define RCC_SYSCLK_DIV8            (RCC_CFGR_HPRE_3 | RCC_CFGR_HPRE_1)	/* SYSCLK divided by 8 */
#define RCC_SYSCLK_DIV10           (RCC_CFGR_HPRE_2 | RCC_CFGR_HPRE_1)	/* SYSCLK divided by 10 */
#define RCC_SYSCLK_DIV16           (RCC_CFGR_HPRE_3 | RCC_CFGR_HPRE_1 | RCC_CFGR_HPRE_0)	/* SYSCLK divided by 16 */
#define RCC_SYSCLK_DIV32           (RCC_CFGR_HPRE_2 | RCC_CFGR_HPRE_1 | RCC_CFGR_HPRE_0)	/* SYSCLK divided by 32 */
#define RCC_SYSCLK_DIV64           (RCC_CFGR_HPRE_3 | RCC_CFGR_HPRE_2)	/* SYSCLK divided by 64 */
#define RCC_SYSCLK_DIV128          (RCC_CFGR_HPRE_3 | RCC_CFGR_HPRE_2 | RCC_CFGR_HPRE_0)	/* SYSCLK divided by 128 */
#define RCC_SYSCLK_DIV256          (RCC_CFGR_HPRE_3 | RCC_CFGR_HPRE_2 | RCC_CFGR_HPRE_1)	/* SYSCLK divided by 256 */
#define RCC_SYSCLK_DIV512          (RCC_CFGR_HPRE_3 | RCC_CFGR_HPRE_2 | RCC_CFGR_HPRE_1 | RCC_CFGR_HPRE_0)	/* SYSCLK divided by 512 */

/*
 *  PLLå
 */
#define RCC_PLL_SYSCLK             RCC_PLLCFGR_PLLREN	/* PLLCLK selection from main PLL */
#define RCC_PLL_USBCLK             RCC_PLLCFGR_PLLQEN	/* PLLUSBCLK selection from main PLL */
#define RCC_PLL_RNGCLK             RCC_PLLCFGR_PLLQEN	/* PLLRNGCLK selection from main PLL */
#define RCC_PLL_SAI1CLK            RCC_PLLCFGR_PLLPEN	/* PLLSAI1CLK selection from main PLL */
#define RCC_PLL_ADCCLK             RCC_PLLCFGR_PLLPEN	/* PLLADCCLK selection from main PLL */

/*
 *  RTCå
 */
#define RCC_RTCCLKSOURCE_NONE      0x00000000			/* No clock used as RTC clock */
#define RCC_RTCCLKSOURCE_LSE       RCC_BDCR_RTCSEL_0	/* LSE oscillator clock used as RTC clock */
#define RCC_RTCCLKSOURCE_LSI       RCC_BDCR_RTCSEL_1	/* LSI oscillator clock used as RTC clock */
#define RCC_RTCCLKSOURCE_HSE_DIV32 RCC_BDCR_RTCSEL		/* HSE oscillator clock divided by 32 used as RTC clock */

/*
 *  USART1å
 */
#define RCC_USART1CLKSOURCE_PCLK2  0x00000000			/* APB2 clock selected as USART 1 clock*/
#define RCC_USART1CLKSOURCE_SYSCLK RCC_CCIPR_USART1SEL_0	/* SYSCLK clock selected as USART 1 clock*/
#define RCC_USART1CLKSOURCE_HSI    RCC_CCIPR_USART1SEL_1	/* HSI clock selected as USART 1 clock*/
#define RCC_USART1CLKSOURCE_LSE    RCC_CCIPR_USART1SEL	/* LSE clock selected as USART 1 clock*/

/*
 *  LPUART1å
 */
#define RCC_LPUART1CLKSOURCE_PCLK1 0x00000000			/* APB1 clock selected as LPUART 1 clock*/
#define RCC_LPUART1CLKSOURCE_SYSCLK RCC_CCIPR_LPUART1SEL_0	/* SYSCLK clock selected as LPUART 1 clock*/
#define RCC_LPUART1CLKSOURCE_HSI   RCC_CCIPR_LPUART1SEL_1	/* HSI clock selected as LPUART 1 clock*/
#define RCC_LPUART1CLKSOURCE_LSE   RCC_CCIPR_LPUART1SEL	/* LSE clock selected as LPUART 1 clock*/

/*
 *  I2Cå
 */
#define RCC_I2C1CLKSOURCE_PCLK1    0x00000000			/* APB1 clock selected as I2C1 clock */
#define RCC_I2C1CLKSOURCE_SYSCLK   RCC_CCIPR_I2C1SEL_0	/* SYSCLK clock selected as I2C1 clock */
#define RCC_I2C1CLKSOURCE_HSI      RCC_CCIPR_I2C1SEL_1	/* HSI clock selected as I2C1 clock */
#define RCC_I2C3CLKSOURCE_PCLK1    0x00000000			/* APB1 clock selected as I2C3 clock */
#define RCC_I2C3CLKSOURCE_SYSCLK   RCC_CCIPR_I2C3SEL_0	/* SYSCLK clock selected as I2C3 clock */
#define RCC_I2C3CLKSOURCE_HSI      RCC_CCIPR_I2C3SEL_1	/* HSI clock selected as I2C3 clock */

/*
 *  USBå
 */
#define RCC_USBCLKSOURCE_HSI48     0x00000000			/* HSI48 clock selected as USB clock */
#define RCC_USBCLKSOURCE_PLLSAI1   RCC_CCIPR_CLK48SEL_0	/* PLLSAI1 "Q" clock selected as USB clock */
#define RCC_USBCLKSOURCE_PLL       RCC_CCIPR_CLK48SEL_1	/* PLL "Q" clock selected as USB clock */
#define RCC_USBCLKSOURCE_MSI       RCC_CCIPR_CLK48SEL	/* MSI clock selected as USB clock */

/*
 *  RFWKPå
 */
#define RCC_RFWKPCLKSOURCE_NONE    0x00000000			/* None clock selected as RF system wakeup clock */
#define RCC_RFWKPCLKSOURCE_LSE     RCC_CSR_RFWKPSEL_0	/* LSE clock selected as RF system wakeup clock */
#define RCC_RFWKPCLKSOURCE_LSI     RCC_CSR_RFWKPSEL_1	/* LSI clock selected as RF system wakeup clock */
#define RCC_RFWKPCLKSOURCE_HSE_DIV1024 RCC_CSR_RFWKPSEL	/* HSE clock divided by 1024 selected as RF system wakeup clock */

/*
 *  SMPSå
 */
#define RCC_SMPSCLKSOURCE_HSI      0x00000000			/* HSI selection as smps clock */
#define RCC_SMPSCLKSOURCE_MSI      RCC_SMPSCR_SMPSSEL_0	/* MSI selection as smps clock */
#define RCC_SMPSCLKSOURCE_HSE      RCC_SMPSCR_SMPSSEL_1	/* HSE selection as smps clock */

/*
 *  SMPS Clock Division Factor
 */
#define RCC_SMPSCLKDIV_RANGE0      0x00000000			/* PLLM division factor = 0 */
#define RCC_SMPSCLKDIV_RANGE1      RCC_SMPSCR_SMPSDIV_0	/* PLLM division factor = 1 */
#define RCC_SMPSCLKDIV_RANGE2      RCC_SMPSCR_SMPSDIV_1	/* PLLM division factor = 2 */
#define RCC_SMPSCLKDIV_RANGE3      (RCC_SMPSCR_SMPSDIV_0|RCC_SMPSCR_SMPSDIV_1)	/* PLLM division factor = 3 */

/*
 *  IPCC_EC Channel
 */
#define IPCC_CHANNEL_1             0x00000001			/* IPCC Channel 1 */
#define IPCC_CHANNEL_2             0x00000002			/* IPCC Channel 2 */
#define IPCC_CHANNEL_3             0x00000004			/* IPCC Channel 3 */
#define IPCC_CHANNEL_4             0x00000008			/* IPCC Channel 4 */
#define IPCC_CHANNEL_5             0x00000010			/* IPCC Channel 5 */
#define IPCC_CHANNEL_6             0x00000020			/* IPCC Channel 6 */

/*
 *  CRS SynchroDivider
 */
#define CRS_SYNC_DIV1             0x00000000			/* Synchro Signal not divided (default) */
#define CRS_SYNC_DIV2             CRS_CFGR_SYNCDIV_0	/* Synchro Signal divided by 2 */
#define CRS_SYNC_DIV4             CRS_CFGR_SYNCDIV_1	/* Synchro Signal divided by 4 */
#define CRS_SYNC_DIV8             (CRS_CFGR_SYNCDIV_1 | CRS_CFGR_SYNCDIV_0)	/* Synchro Signal divided by 8 */
#define CRS_SYNC_DIV16            CRS_CFGR_SYNCDIV_2	/* Synchro Signal divided by 16 */
#define CRS_SYNC_DIV32            (CRS_CFGR_SYNCDIV_2 | CRS_CFGR_SYNCDIV_0)	/* Synchro Signal divided by 32 */
#define CRS_SYNC_DIV64            (CRS_CFGR_SYNCDIV_2 | CRS_CFGR_SYNCDIV_1)	/* Synchro Signal divided by 64 */
#define CRS_SYNC_DIV128           CRS_CFGR_SYNCDIV		/* Synchro Signal divided by 128 */

/*
 *  CRS SynchroSource
 */
#define CRS_SYNC_SOURCE_GPIO       0x00000000			/* Synchro Signal source GPIO */
#define CRS_SYNC_SOURCE_LSE        CRS_CFGR_SYNCSRC_0	/* Synchro Signal source LSE */
#define CRS_SYNC_SOURCE_USB        CRS_CFGR_SYNCSRC_1	/* Synchro Signal source USB SOF (default)*/

/*
 *  CRS SynchroPolarity
 */
#define CRS_SYNC_POLARITY_RISING   0x00000000			/* Synchro Active on rising edge (default) */
#define CRS_SYNC_POLARITY_FALLING  CRS_CFGR_SYNCPOL		/* Synchro Active on falling edge */

#define CRS_ERRORLIMIT_DEFAULT     (0x00000022 << 16)	/* CRS Default Frequency error limit */
#define CRS_RELOADVALUE_DEFAULT    0x0000BB7F			/* CRS ReloadValueDefault value */

#define HSI48CALIBRATION_DEFAULT   (0x00000020 << 8)	/* CRS HSI48CalibrationDefault value */


#define HSE_CONTROL_UNLOCK_KEY     0xCAFECAFE


#define RCC_CR_RESET               (RCC_CR_PLLSAI1ON | RCC_CR_PLLON | RCC_CR_CSSON | \
									RCC_CR_HSEON | RCC_CR_HSION | RCC_CR_MSIPLLEN)

#define RCC_PLL_DEFAULT            (RCC_PLLCFGR_PLLN_4 | RCC_PLLCFGR_PLLP_1 | \
									RCC_PLLCFGR_PLLQ_0 | RCC_PLLCFGR_PLLR_0)

#define RCC_PLL_MASK               (RCC_PLLCFGR_PLLSRC | RCC_PLLCFGR_PLLM | RCC_PLLCFGR_PLLN | \
									RCC_PLLCFGR_PLLP   | RCC_PLLCFGR_PLLQ | RCC_PLLCFGR_PLLR)

#define RCC_PLL_MSI                ((PLL_M<<PLLM_SHIFT) | (PLL_N<<PLLN_SHIFT) | (PLL_P<<PLLP_SHIFT) | \
									(PLL_Q<<PLLQ_SHIFT) | (PLL_R<<PLLR_SHIFT))

#define RCC_MSICALIB_DEFAULT       (0 << MSITRIM_SHIFT)
#define RCC_HSICALIB_DEFAULT       (64 << HSITRIM_SHIFT)

#define IPCC_CHANNEL_ALL           (IPCC_CHANNEL_1 | IPCC_CHANNEL_2 | IPCC_CHANNEL_3 | \
									IPCC_CHANNEL_4 | IPCC_CHANNEL_5 | IPCC_CHANNEL_6)

#define CRS_CFGR_DEFAULT           (CRS_SYNC_DIV1 | CRS_SYNC_SOURCE_USB | CRS_SYNC_POLARITY_RISING | \
									CRS_ERRORLIMIT_DEFAULT | CRS_RELOADVALUE_DEFAULT)


/*
 *  OTPΰ
 */
typedef struct OTP_ID0_s
{
    uint8_t   bd_address[6];
    uint8_t   hse_tuning;
    uint8_t   id;
} OTP_ID0_t;

static const uint32_t AHBPrescTable[16] = {1, 3, 5, 1, 1, 6, 10, 32, 2, 4, 8, 16, 64, 128, 256, 512};

static const uint32_t APBPrescTable[8] =  {0U, 0U, 0U, 0U, 1U, 2U, 3U, 4U};
static const uint32_t MSIRangeTable[16] = {100000UL, 200000UL, 400000UL, 800000UL, 1000000UL, 2000000UL, \
                                   4000000UL, 8000000UL, 16000000UL, 24000000UL, 32000000UL, 48000000UL, 0UL, 0UL, 0UL, 0UL}; /* 0UL values are incorrect cases */

  /* Flash Clock source (HCLK4) range in MHz with a VCORE is range1 */
static const uint32_t FLASH_CLK_SRC_RANGE_VOS1[] = {18UL, 36UL, 54UL, 64UL};
  /* Flash Clock source (HCLK4) range in MHz with a VCORE is range2 */
static const uint32_t FLASH_CLK_SRC_RANGE_VOS2[] = {6UL, 12UL, 16UL};

#define NUM_RANGE_VOS1             (sizeof(FLASH_CLK_SRC_RANGE_VOS1)/sizeof(uint32_t))
#define NUM_RANGE_VOS2             (sizeof(FLASH_CLK_SRC_RANGE_VOS2)/sizeof(uint32_t))


uint32_t SystemCoreClock;


/*
 *  ƥ९å׻
 */
static uint32_t
RCC_GetSysClockFreq(void)
{
	uint32_t pllsource;
	uint32_t sysclockfreq, pllinputfreq, msirange;
	uint32_t pllm, plln, pllr;
	const uint32_t sysclksrc = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & RCC_CFGR_SWS;
	uint32_t pllcfgr = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLCFGR));
	msirange = MSIRangeTable[(sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_MSIRANGE) >> MSIRANG_SHIFT];

	if(sysclksrc == RCC_SYSCLKSOURCE_STATUS_MSI){
		/* MSI å System Clock */
		sysclockfreq = msirange;
	}
	else if(sysclksrc == RCC_SYSCLKSOURCE_STATUS_HSI){
		/* HSI å System Clock */
		sysclockfreq = HSI_VALUE;
	}
	else if(sysclksrc == RCC_SYSCLKSOURCE_STATUS_HSE){
		/* HSE å System Clock */
		if((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_HSEPRE) != 0)
			sysclockfreq = HSE_VALUE / 2;
		else
			sysclockfreq = HSE_VALUE;
	}
	else{
		/* PLL å System Clock */
		pllsource = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLCFGR)) & RCC_PLLCFGR_PLLSRC;
		switch (pllsource){
		case RCC_PLLSOURCE_HSI:  /* HSI PLLå */
			pllinputfreq = HSI_VALUE;
			break;
		case RCC_PLLSOURCE_HSE:  /* HSE PLLå */
			if((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_HSEPRE) != 0)
				pllinputfreq = HSE_VALUE / 2;
			else
				pllinputfreq = HSE_VALUE;
			break;
		case RCC_PLLSOURCE_MSI:  /* MSI PLLå */
		default:
			pllinputfreq = msirange;
			break;
		}
		pllm = (pllcfgr & RCC_PLLCFGR_PLLM) >> PLLM_SHIFT;
		plln = (pllcfgr & RCC_PLLCFGR_PLLN) >> PLLN_SHIFT;
		pllr = (pllcfgr & RCC_PLLCFGR_PLLR) >> PLLR_SHIFT;
		sysclockfreq = pllinputfreq * plln / ((pllm + 1)) / (pllr + 1);
	}
	return sysclockfreq / AHBPrescTable[((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & RCC_CFGR_HPRE) >> CFGR_HPRE_SHIFT)];
}

/*
 *  FLASH Latencyꤹ
 */
static int
RCC_SetFlashLatency(uint32_t latency)
{
	uint32_t tick = 0;

	/*
	 *  Latency
	 */
	sil_modw_mem((uint32_t *)(TADR_FLASH_R_BASE+TOFF_FLASH_ACR), FLASH_ACR_LATENCY, latency);

    /*
	 *  LatencyγԤ
	 */
	while((sil_rew_mem((uint32_t *)(TADR_FLASH_R_BASE+TOFF_FLASH_ACR)) & FLASH_ACR_LATENCY) != latency){
		if(tick > LATENCY_TIMEOUT_VALUE)
			return -1;
		tick++;
		sil_dly_nse(1000);
	}
	return 0;
}

/*
 *  MSIѤFLASH Latencyꤹ
 */
static int
RCC_SetFlashLatencyMSI(uint32_t Flash_ClkSrcFreq, uint32_t VCORE_Voltage)
{
	const uint32_t FLASH_LATENCY_RANGE[] = {FLASH_LATENCY_0, FLASH_LATENCY_1, FLASH_LATENCY_2, FLASH_LATENCY_3};
	uint32_t latency = FLASH_LATENCY_0;	/* ǥե 0WS */
	uint32_t index;

	if(VCORE_Voltage == PWR_REGULATOR_VOLTAGE_SCALE1){
		for(index = 0 ; index < NUM_RANGE_VOS1 ; index++){
			if(Flash_ClkSrcFreq <= FLASH_CLK_SRC_RANGE_VOS1[index]){
				latency = FLASH_LATENCY_RANGE[index];
				break;
			}
		}
	}
	else{		/* PWR_REGULATOR_VOLTAGE_SCALE2 */
		for(index = 0 ; index < NUM_RANGE_VOS2 ; index++){
			if(Flash_ClkSrcFreq <= FLASH_CLK_SRC_RANGE_VOS2[index]){
				latency = FLASH_LATENCY_RANGE[index];
				break;
			}
		}
	}
	return RCC_SetFlashLatency(latency);
}

#if MSI_RANGE == 0
/*
 *  OTPΰɤ߽Фؿ
 */
static uint8_t * OTP_Read(uint8_t id)
{
	uint8_t *p_id;

	p_id = (uint8_t*)(OTP_AREA_END_ADDR - 7) ;

	while( ((*(p_id + 7)) != id) && ( p_id != (uint8_t*)OTP_AREA_BASE)){
		p_id -= 8 ;
	}

	if((*(p_id + 7)) != id){
		p_id = 0 ;
	}
	return p_id;
}
#endif


/*
 *  HSEƥ९å
 *  ͤϰʲ̤
 *      System Clock source            = PLL (HSE)
 *      SYSCLK(Hz)                     = 32000000
 *      HCLK(Hz)                       = 32000000
 *      AHB Prescaler                  = 1
 *      AHB2 Prescaler                 = 1
 *      AHB4 Prescaler                 = 1
 *      APB1 Prescaler                 = 1
 *      APB2 Prescaler                 = 1
 *      HSI Frequency(Hz)              = 32000000
 *      PLL                            = NONE
 *      Flash Latency(WS)              = 1
 *  return  ｪλʤ0֤
 */
static int
SetSysClock(void)
{
	uint32_t tick, rtcclocksource, tmp;
	int status  = 0;

#if BOARDNO < 2
	/*
     *  POWER Voltage scale1
	 */
	sil_modw_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR1), PWR_CR1_VOS, PWR_REGULATOR_VOLTAGE_SCALE1);
	tmp = sil_rew_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR1));
#endif

	/*
	 *  HSEå
	 */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_HSEON);

	/*  HSEåԤ */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_HSERDY) == 0){
		if(tick > HSE_TIMEOUT_VALUE)
			return -1;
		tick++;
		sil_dly_nse(1000);
	}

	/*
	 *  HSIå
	 */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_HSION);

	/*  HSIԤ */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_HSIRDY) == 0){
		if(tick > HSI_TIMEOUT_VALUE)
			return -2;
		tick++;
		sil_dly_nse(1000);
	}

	/*  HSI calibration default */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_ICSCR), RCC_ICSCR_HSITRIM, RCC_HSICALIB_DEFAULT);

	/*
	 *  LSEå
	 */
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR), RCC_BDCR_LSEDRV);
    if((sil_rew_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR1)) & PWR_CR1_DBP) == 0){
		/*  Backup domain˽ͭ */
		sil_orw_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR1), PWR_CR1_DBP);

		/*  Backup domain ͭԤ */
		tick = 0;
		while((sil_rew_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR1)) & PWR_CR1_DBP) == 0){
			if(tick > RCC_DBP_TIMEOUT_VALUE)
				return -4;
			tick++;
			sil_dly_nse(1000);
		}
	}

	/*  LSEå */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR), RCC_BDCR_LSEON);

	/*  LSE READYԤ */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR)) & RCC_BDCR_LSERDY) == 0){
		if(tick > RCC_LSE_TIMEOUT_VALUE)
			return -5;
		tick++;
		sil_dly_nse(1000);
	}

	/*
	 *  LSI2å
	 */
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CSR), RCC_CSR_LSI2ON);

	/*  LSI2Ԥ */
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CSR)) & RCC_CSR_LSI2RDY) != 0){
		if(tick > LSI2_TIMEOUT_VALUE)
			return -5;
		tick++;
		sil_dly_nse(1000);
	}

	/*
	 *  LSI1å
	 */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CSR), RCC_CSR_LSI1ON);

	/*  LSI1Ԥ */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CSR)) & RCC_CSR_LSI1RDY) == 0){
		if(tick > LSI1_TIMEOUT_VALUE)
			return -6;
		tick++;
		sil_dly_nse(1000);
	}

#if BOARDNO < 2
	/*
	 *  HSI48
	 */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CRRCR), RCC_CRRCR_HSI48ON);
	tick = 0;

	/*  HSI48Ԥ */
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CRRCR)) & RCC_CRRCR_HSI48RDY) == 0){
		if(tick > HSI48_TIMEOUT_VALUE)
			return -7;
		tick++;
		sil_dly_nse(1000);
	}
#endif

	/*
	 *  FLASH Latency1̤ξ硢1
	 */
	if(FLASH_LATENCY_1 > (sil_rew_mem((uint32_t *)(TADR_FLASH_R_BASE+TOFF_FLASH_ACR)) & FLASH_ACR_LATENCY)){
		if(RCC_SetFlashLatency(FLASH_LATENCY_1) != 0)
			return -8;
	}

	/*
	 *  HCLK1
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), RCC_CFGR_HPRE, RCC_SYSCLK_DIV1);

	/*  HCLK1 Prescalerե饰ΥåȤԤ */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & RCC_CFGR_HPREF) == 0){
		if(tick > PRESCALER_TIMEOUT_VALUE)
			return -9;
		tick++;
		sil_dly_nse(1000);
	}

	/*
	 *  HCLK2
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_EXTCFGR), RCC_EXTCFGR_C2HPRE, RCC_SYSCLK_DIV1);

    /*  HCLK2 Prescalerե饰ΥåȤԤ */
    tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_EXTCFGR)) & RCC_EXTCFGR_C2HPREF) == 0){
		if(tick > PRESCALER_TIMEOUT_VALUE)
			return -10;
		tick++;
		sil_dly_nse(1000);
	}

	/*
	 *  HCLK4
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_EXTCFGR), RCC_EXTCFGR_SHDHPRE, RCC_SYSCLK_DIV1 >> 4);

    /*  AHB Prescalerե饰ΥåȤԤ */
    tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_EXTCFGR)) & RCC_EXTCFGR_SHDHPREF) == 0){
		if(tick > PRESCALER_TIMEOUT_VALUE)
			return -11;
		tick++;
		sil_dly_nse(1000);
	}

	/*
	 *  PCLK1
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), RCC_CFGR_PPRE1, RCC_HCLK_DIV1);

	/*  APB1 Prescalerե饰ΥåȤԤ */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & RCC_CFGR_PPRE1F) == 0){
		if(tick > PRESCALER_TIMEOUT_VALUE)
			return -12;
		tick++;
		sil_dly_nse(1000);
	}

	/*
	 *  PCLK2
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), RCC_CFGR_PPRE2, RCC_HCLK_DIV1 << 3);

	/*  APB2 Prescalerե饰ΥåȤԤ */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & RCC_CFGR_PPRE2F) == 0){
		if(tick > PRESCALER_TIMEOUT_VALUE)
			return -13;
		tick++;
		sil_dly_nse(1000);
	}

	/*
	 *  SYSCLK
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), RCC_CFGR_SW, RCC_SYSCLKSOURCE_HSE);

	/*  System Clock sourceԤ */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & RCC_CFGR_SWS) != (RCC_SYSCLKSOURCE_HSE << CFGR_SWS_SHIFT)){
		if(tick > CLOCKSWITCH_TIMEOUT_VALUE)
			return -14;
		tick++;
		sil_dly_nse(1000);
	}

	/*
	 *  FLASH Latency1礭硢1
	 */
	if(FLASH_LATENCY_1 < (sil_rew_mem((uint32_t *)(TADR_FLASH_R_BASE+TOFF_FLASH_ACR)) & FLASH_ACR_LATENCY)){
		if(RCC_SetFlashLatency(FLASH_LATENCY_1) != 0)
			return -15;
	}

	/*
	 *  ꥯåSystemCoreClock˥å
	 */
	SystemCoreClock = RCC_GetSysClockFreq();

	/*
	 *  PLLå
	 */
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_PLLON);

	/*  PLL */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLCFGR), RCC_PLLCFGR_PLLSRC, PLLSOURCE_NONE);
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLCFGR), (RCC_PLL_SYSCLK | RCC_PLL_USBCLK | RCC_PLL_SAI1CLK));

	/*  PLLåԤ */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_PLLRDY) != 0){
		if(tick > PLL_TIMEOUT_VALUE)
			return -16;
		tick++;
		sil_dly_nse(1000);
	}


	/*  RTCå */
	rtcclocksource = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR)) & RCC_BDCR_RTCSEL;
    if(rtcclocksource != RTC_CLOCK_SOURCE){
		/*  Backup domain˥Ǥ褦DBP򥻥å */
		sil_orw_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR1), PWR_CR1_DBP);
		if(rtcclocksource == RCC_RTCCLKSOURCE_NONE)
			sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR), RCC_BDCR_RTCSEL, RTC_CLOCK_SOURCE);
		else{
			/*
			 *  RTCΥ꤬ƤʤСBackup Domainꥻå
			 */
			uint32_t bdcr = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR));
			sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR), RCC_BDCR_BDRST);
			sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR), RCC_BDCR_BDRST);
			sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR), RCC_BDCR_RTCSEL, RTC_CLOCK_SOURCE);
			sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR), bdcr);
		}
	}

	/*  USART1å */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CCIPR), RCC_CCIPR_USART1SEL, RCC_USART1CLKSOURCE_PCLK2);

	/*  LPUART1å */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CCIPR), RCC_CCIPR_LPUART1SEL, RCC_LPUART1CLKSOURCE_PCLK1);

	/*  I2C1å(SYSCLK) */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CCIPR), RCC_CCIPR_I2C1SEL, RCC_I2C1CLKSOURCE_SYSCLK);

	/*  I2C3å(HSI) */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CCIPR), RCC_CCIPR_I2C3SEL, RCC_I2C3CLKSOURCE_HSI);

	/*  RFWKPå */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CSR), RCC_CSR_RFWKPSEL, RCC_RFWKPCLKSOURCE_LSI);

	/*  SMPSå */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_SMPSCR), RCC_SMPSCR_SMPSDIV, RCC_SMPSCLKDIV_RANGE1);
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_SMPSCR), RCC_SMPSCR_SMPSSEL, RCC_SMPSCLKSOURCE_HSE);

	(void)(tmp);
	return status;
}

/*
 *  祷ƥ९å(rang6)
 *  ͤϰʲ̤
 *      System Clock source            = PLL (MSI)
 *      SYSCLK(Hz)                     = 64000000
 *      HCLK(Hz)                       = 64000000
 *      AHB Prescaler                  = 1
 *      AHB2 Prescaler                 = 2
 *      AHB4 Prescaler                 = 1
 *      APB1 Prescaler                 = 1
 *      APB2 Prescaler                 = 1
 *      HSI Frequency(Hz)              = 64000000
 *      PLLM                           = 0 RCC_PLLM_DIV1
 *      PLLN                           = 32
 *      PLLP                           = 4 RCC_PLLP_DIV5(WB55) 1 RCC_PLLP_DIV2(WB51)
 *      PLLR                           = 1 RCC_PLLR_DIV2
 *      PLLQ                           = 4 RCC_PLLQ_DIV5(WB55) 1 RCC_PLLQ_DIV2(WB51) 
 *      Flash Latency(WS)              = 3
 *  return  ｪλʤ0֤
 */
static int
SetSysClock2(uint8_t range)
{
	uint32_t tick, rtcclocksource;
	int status  = 0;

#if BOARDNO == 2
	/*
	 *  HSIå
	 */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_HSION);

	/*  HSIԤ */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_HSIRDY) == 0){
		if(tick > HSI_TIMEOUT_VALUE)
			return -2;
		tick++;
		sil_dly_nse(1000);
	}

	/*  HSI calibration default */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_ICSCR), RCC_ICSCR_HSITRIM, RCC_HSICALIB_DEFAULT);
#endif

	/*
	 *  MSIå
	 */
	range <<= 4;
	if((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_MSIRDY) != 0){
		uint32_t flash_clksrcfreq;
		uint32_t msifreq   = MSIRangeTable[(range & RCC_CR_MSIRANGE) >> MSIRANG_SHIFT];
		uint32_t prescaler = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_EXTCFGR)) & RCC_EXTCFGR_SHDHPRE;
		uint32_t volrange  = sil_rew_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR1)) & PWR_CR1_VOS;
		flash_clksrcfreq = msifreq / AHBPrescTable[prescaler >>  SHDHPRE_SHIFT];

		if(range > (sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_MSIRANGE)){
	        /*
			 *  MSI Range夬, FLASH Latency夲ѹ
			 */
			if(RCC_SetFlashLatencyMSI((flash_clksrcfreq / MEGA_HZ), volrange) != 0)
				return -1;

			sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_MSIRANGE, range);
			sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_ICSCR), RCC_ICSCR_MSITRIM, RCC_MSICALIB_DEFAULT);
		}
		else{
	        /*
			 *  MSI Range, FLASH Latency򲼤ѹ
			 */
			sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_MSIRANGE, range);
			sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_ICSCR), RCC_ICSCR_MSITRIM, RCC_MSICALIB_DEFAULT);

			if(RCC_SetFlashLatencyMSI((flash_clksrcfreq / MEGA_HZ), volrange) != 0)
				return -1;
		}
	}
	else{
		/*
		 *  MSIͭ
		 */
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_MSIPLLEN);

		/*  MSIͭȤʤޤԤ */
		tick = 0;
		while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_MSIRDY) == 0){
			if(tick > MSI_TIMEOUT_VALUE)
				return -1;
			tick++;
			sil_dly_nse(1000);
		}

        /*
		 *  MSIRangeԤCalibrationǥեꤹ
		 */
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_MSIRANGE, range);
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_ICSCR), RCC_ICSCR_MSITRIM, RCC_MSICALIB_DEFAULT);
    }

	/*
	 *  HSIå
	 */
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_HSION);

	/*  HSIߤޤԤ */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_HSIRDY) != 0){
		if(tick > HSI_TIMEOUT_VALUE)
			return -2;
		tick++;
		sil_dly_nse(1000);
	}

	/*
	 *  LSI1å
	 */
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CSR), RCC_CSR_LSI1ON);

	/*  LSI1Ԥ */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CSR)) & RCC_CSR_LSI1RDY) != 0){
		if(tick > LSI1_TIMEOUT_VALUE)
			return -3;
		tick++;
		sil_dly_nse(1000);
	}

	/*
	 *  LSEå
	 */
    if((sil_rew_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR1)) & PWR_CR1_DBP) == 0){
		/*  Backup domain˽ͭ */
		sil_orw_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR1), PWR_CR1_DBP);

		/*  Backup domain ͭԤ */
		tick = 0;
		while((sil_rew_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR1)) & PWR_CR1_DBP) == 0){
			if(tick > RCC_DBP_TIMEOUT_VALUE)
				return -4;
			tick++;
			sil_dly_nse(1000);
		}
	}

	/*  LSEå */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR), RCC_BDCR_LSEON);

	/*  LSE READYԤ */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR)) & RCC_BDCR_LSERDY) == 0){
		if(tick > RCC_LSE_TIMEOUT_VALUE)
			return -5;
		tick++;
		sil_dly_nse(1000);
	}


#ifdef USE_HSI48_USB
	/*
	 *  HSI48
	 */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CRRCR), RCC_CRRCR_HSI48ON);
	tick = 0;

	/*  HSI48Ԥ */
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CRRCR)) & RCC_CRRCR_HSI48RDY) == 0){
		if(tick > HSI48_TIMEOUT_VALUE)
			return -6;
		tick++;
		sil_dly_nse(1000);
	}
#endif

	/*
	 *  PLLå
	 */
	if((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & RCC_CFGR_SWS) != RCC_SYSCLKSOURCE_STATUS_PLLCLK){
		/*
		 *  PLLå
		 */
		sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_PLLON);

		/*  ReadyԤ */
		tick = 0;
		while ((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_PLLRDY) != 0){
			if(tick > PLL_TIMEOUT_VALUE)
				return -7;
			tick++;
			sil_dly_nse(1000);
		}

        /*
		 *  PLLƥå
		 */
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLCFGR), RCC_PLL_MASK, (RCC_PLL_MSI | RCC_PLLSOURCE_MSI));

        /*  PLLͭ */
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_PLLON);

        /*  ƥ९åȥץå */
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLCFGR), RCC_PLL_SYSCLK);

		/*  ReadyˤʤޤԤ */
        tick = 0;
		while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_PLLRDY) == 0){
			if(tick > PLL_TIMEOUT_VALUE)
				return -8;
			tick++;
			sil_dly_nse(1000);
		}
	}
	else{
		/*
		 *  ƥ९åǻʤСPLLѹХ顼
		 */
		if((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLCFGR)) & RCC_PLL_MASK)
				!= (RCC_PLL_MSI | RCC_PLLSOURCE_MSI))
			return -9;
    }

	/*
	 *  FLASH Latency3̤ξ硢3
	 */
	if(FLASH_LATENCY_3 > (sil_rew_mem((uint32_t *)(TADR_FLASH_R_BASE+TOFF_FLASH_ACR)) & FLASH_ACR_LATENCY)){
		if(RCC_SetFlashLatency(FLASH_LATENCY_3) != 0)
			return -10;
	}

	/*
	 *  HCLK1
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), RCC_CFGR_HPRE, RCC_SYSCLK_DIV1);

	/*  HCLK1 Prescalerե饰ΥåȤԤ */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & RCC_CFGR_HPREF) == 0){
		if(tick > PRESCALER_TIMEOUT_VALUE)
			return -11;
		tick++;
		sil_dly_nse(1000);
	}

	/*
	 *  HCLK2
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_EXTCFGR), RCC_EXTCFGR_C2HPRE, RCC_SYSCLK_DIV2);

    /*  HCLK2 Prescalerե饰ΥåȤԤ */
    tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_EXTCFGR)) & RCC_EXTCFGR_C2HPREF) == 0){
		if(tick > PRESCALER_TIMEOUT_VALUE)
			return -12;
		tick++;
		sil_dly_nse(1000);
	}

	/*
	 *  HCLK4
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_EXTCFGR), RCC_EXTCFGR_SHDHPRE, RCC_SYSCLK_DIV1 >> 4);

    /*  AHB Prescalerե饰ΥåȤԤ */
    tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_EXTCFGR)) & RCC_EXTCFGR_SHDHPREF) == 0){
		if(tick > PRESCALER_TIMEOUT_VALUE)
			return -13;
		tick++;
		sil_dly_nse(1000);
	}

	/*
	 *  PCLK1
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), RCC_CFGR_PPRE1, RCC_HCLK_DIV1);

	/*  APB1 Prescalerե饰ΥåȤԤ */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & RCC_CFGR_PPRE1F) == 0){
		if(tick > PRESCALER_TIMEOUT_VALUE)
			return -14;
		tick++;
		sil_dly_nse(1000);
	}

	/*
	 *  PCLK2
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), RCC_CFGR_PPRE2, RCC_HCLK_DIV1 << 3);

	/*  APB2 Prescalerե饰ΥåȤԤ */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & RCC_CFGR_PPRE2F) == 0){
		if(tick > PRESCALER_TIMEOUT_VALUE)
			return -15;
		tick++;
		sil_dly_nse(1000);
	}

	/*
	 *  SYSCLK
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), RCC_CFGR_SW, RCC_SYSCLKSOURCE_PLLCLK);

	/*  System Clock source statusΰפԤ */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR)) & RCC_CFGR_SWS) != (RCC_SYSCLKSOURCE_PLLCLK << CFGR_SWS_SHIFT)){
		if(tick > CLOCKSWITCH_TIMEOUT_VALUE)
			return -16;
		tick++;
		sil_dly_nse(1000);
	}

	/*
	 *  FLASH Latency3礭硢3
	 */
	if(FLASH_LATENCY_3 < (sil_rew_mem((uint32_t *)(TADR_FLASH_R_BASE+TOFF_FLASH_ACR)) & FLASH_ACR_LATENCY)){
		if(RCC_SetFlashLatency(FLASH_LATENCY_3) != 0)
			return -1;
	}

	/*
	 *  ꥯåSystemCoreClock˥å
	 */
	SystemCoreClock = RCC_GetSysClockFreq();


	/*
	 *  HSEå
	 */
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_HSEON);
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_HSEBYP);

	/*  HSEߤԤ */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR)) & RCC_CR_HSERDY) != 0){
		if(tick > HSE_TIMEOUT_VALUE)
			return -17;
		tick++;
		sil_dly_nse(1000);
	}


	/*  RTCå */
	rtcclocksource = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR)) & RCC_BDCR_RTCSEL;
    if(rtcclocksource != RCC_RTCCLKSOURCE_LSE){
		/*  Backup domain˥Ǥ褦DBP򥻥å */
		sil_orw_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR1), PWR_CR1_DBP);

		/*
		 *  RTCΥ꤬ƤʤСBackup Domainꥻå
		 */
		if(rtcclocksource == RCC_RTCCLKSOURCE_NONE)
			sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR), RCC_BDCR_RTCSEL, RCC_RTCCLKSOURCE_LSE);
		else{
			/*
			 *  RTCΥ꤬ƤʤСBackup Domainꥻå
			 */
			uint32_t bdcr = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR));
			sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR), RCC_BDCR_BDRST);
			sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR), RCC_BDCR_BDRST);
			sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR), RCC_BDCR_RTCSEL, RCC_RTCCLKSOURCE_LSE);
			sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR), bdcr);
		}
	}

	/*  USART1å */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CCIPR), RCC_CCIPR_USART1SEL, RCC_USART1CLKSOURCE_PCLK2);

	/*  LPUART1å */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CCIPR), RCC_CCIPR_LPUART1SEL, RCC_LPUART1CLKSOURCE_PCLK1);

	/*  I2C1å(SYSCLK) */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CCIPR), RCC_CCIPR_I2C1SEL, RCC_I2C1CLKSOURCE_SYSCLK);

#if BOARDNO == 2
	/*  SMPSå */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_SMPSCR), RCC_SMPSCR_SMPSDIV, RCC_SMPSCLKDIV_RANGE1);
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_SMPSCR), RCC_SMPSCR_SMPSSEL, RCC_SMPSCLKSOURCE_HSE);
#else
	/*  I2C3å(HSI) */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CCIPR), RCC_CCIPR_I2C3SEL, RCC_I2C3CLKSOURCE_HSI);
#endif
	return status;
}


/*
 *  ƥ९åѹ
 */
int
sysclock_change(uint8_t range)
{
	if(range == 0 || range > 11)
		return SetSysClock();
	else
		return SetSysClock2(range);
}

/*
 *  ٥ΥåȰ¸ν
 *
 *  ȥåץ⥸塼ǡν˸ƤӽФ롥
 */
void
SystemInit(void)
{
#if MSI_RANGE == 0
	OTP_ID0_t *p_otp;
	uint32_t csr;
#endif
	uint32_t tmp;

	/* FPU settings */
#if FPU_USED == 1
	sil_orw_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_CPACR), (3 << (10*2)) | (3 << (11*2)));
#endif

	/*
	 *  RCCν
	 */
	/*  MSION */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_MSION);

	/*  CFGR쥸ͥꥻå */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR), 0x00070000);

	/*  PLLSAI1ON, PLLON, HSECSSON, HSEON, HSION, MSIPLLONӥåȥꥻå */
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_RESET);

	/*  LSI1 and LSI2åꥢ */
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CSR), (RCC_CSR_LSI2ON | RCC_CSR_LSION));

	/*  HSI48ONåꥢ */
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CRRCR), RCC_CRRCR_HSI48ON);

	/*  PLLCFGR쥸ꥻå */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLCFGR), RCC_PLL_DEFAULT);

	/*  PLLSAI1CFGR쥸ꥻå */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLLSAI1CFGR), RCC_PLL_DEFAULT);

	/*  HSEBYPӥåȥꥢ */
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CR), RCC_CR_HSEBYP);

	/*  RCC̵ */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CIER), 0x00000000);

#if MSI_RANGE == 0
	/*
	 *  ץåط, RF
	 */
	csr = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CSR));

	if(((csr & RCC_CSR_PINRSTF) != 0) && ((csr & RCC_CSR_SFTRSTF) == 0)){
		/*  RTC쥸 */
		sil_orw_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR1), PWR_CR1_DBP);

		/*  APB-AHB֥åեå */
		sil_orw_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR1), PWR_CR1_DBP);

		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR), RCC_BDCR_BDRST);
		sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR), RCC_BDCR_BDRST);
	}

	/*
	 *  IPCCΥꥻå
	 */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB3ENR), RCC_AHB3ENR_IPCCEN);
	/* Delay after an RCC peripheral clock enabling */
	tmp = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB3ENR));

	sil_wrw_mem((uint32_t *)(TADR_IPCC_BASE+TOFF_IPCC_C1SCR), IPCC_CHANNEL_ALL);
	sil_wrw_mem((uint32_t *)(TADR_IPCC_BASE+TOFF_IPCC_C2SCR), IPCC_CHANNEL_ALL);
	sil_orw_mem((uint32_t *)(TADR_IPCC_BASE+TOFF_IPCC_C1MR), (IPCC_CHANNEL_ALL << IPCC_CHFM_SHIFT));
	sil_orw_mem((uint32_t *)(TADR_IPCC_BASE+TOFF_IPCC_C2MR), (IPCC_CHANNEL_ALL << IPCC_CHFM_SHIFT));
	sil_orw_mem((uint32_t *)(TADR_IPCC_BASE+TOFF_IPCC_C1MR), IPCC_CHANNEL_ALL);
	sil_orw_mem((uint32_t *)(TADR_IPCC_BASE+TOFF_IPCC_C2MR), IPCC_CHANNEL_ALL);

	if((p_otp = (OTP_ID0_t *)OTP_Read(0)) != NULL){
		sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_HSECR), HSE_CONTROL_UNLOCK_KEY);
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_HSECR), RCC_HSECR_HSETUNE, p_otp->hse_tuning << HSECR_HSETUNE_SHIFT);
	}
#endif

	if(sysclock_change(MSI_RANGE) != 0){
		while(1){}
	}
#ifdef USE_HSI48_USB
	/*  USBå(HSI48) */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CCIPR), RCC_CCIPR_CLK48SEL, RCC_USBCLKSOURCE_HSI48);

	/*  CRSå */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB1ENR1), RCC_APB1ENR1_CRSEN);
	tmp = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB1ENR1));

	/*
	 *  CRSꥻå
	 */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB1RSTR1), RCC_APB1RSTR1_CRSRST);
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB1RSTR1), RCC_APB1RSTR1_CRSRST);

	/*  CRS CFG쥸 */
	sil_wrw_mem((uint32_t *)(TADR_CRS_BASE+TOFF_CRS_CFGR), CRS_CFGR_DEFAULT);

	/*  HSI48 oscillator smooth trimming */
	sil_modw_mem((uint32_t *)(TADR_CRS_BASE+TOFF_CRS_CR), CRS_CR_TRIM, HSI48CALIBRATION_DEFAULT);

	/*
	 *  CRSͭ
	 */
	sil_orw_mem((uint32_t *)(TADR_CRS_BASE+TOFF_CRS_CR), (CRS_CR_AUTOTRIMEN | CRS_CR_CEN));
#endif
	(void)(tmp);
}

/*
 *  CortexM4ϥ٥ѹ
 */
void SetVector(void *addr)
{
	sil_wrw_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_VTOR), (uint32_t)addr);
}

/*
 *  ߤSYSCLK, HCLK, PCLK1, PCLK2ͤФؿ
 */
void
RCC_GetClocksFreq(RCC_ClocksTypeDef* RCC_Clocks)
{
	uint32_t cfgr;

	RCC_Clocks->SYSCLK_Frequency = SystemCoreClock = RCC_GetSysClockFreq();
	RCC_Clocks->HCLK_Frequency  = SystemCoreClock;
	cfgr = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_CFGR));
	RCC_Clocks->PCLK1_Frequency = (SystemCoreClock >> (APBPrescTable[((cfgr & RCC_CFGR_PPRE1) >>  CFGR_PPRE1_SHIFT)] & 31));
	RCC_Clocks->PCLK2_Frequency = (SystemCoreClock >> (APBPrescTable[((cfgr & RCC_CFGR_PPRE2) >>  CFGR_PPRE2_SHIFT)] & 31));
}

