/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2015-2016 by 3rd Designing Center
 *              Imageing System Development Division RICOH COMPANY, LTD.
 *  Copyright (C) 2017-2021 by TOPPERS PROJECT Educational Working Group.
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: stm32g0xx.h,v 1.3 2021/10/27 17:00:09 roi Exp $
 */

#ifndef _STM32G0XX_H_
#define _STM32G0XX_H_

#include <sil.h>
#include "cmsis_m0.h"

/*
 *  ֹκ
 */
#define TMAX_INTNO          (16 + 31)

/*
 *  ͥ٤Υӥå
 */
#define TBITW_IPRI          2

/*
 *  INTERRUPT NUMBER
 */
#define IRQ_VECTOR_WWDG             (16 + 0)	/* Window WatchDog Interrupt */
#define IRQ_VECTOR_PVD              (16 + 1)	/* PVD through EXTI Line detection Interrupt */
#define IRQ_VECTOR_RTC_WKUP         (16 + 2)	/* RTC Wakeup interrupt through the EXTI line */
#define IRQ_VECTOR_FLASH            (16 + 3)	/* FLASH global Interrupt */
#define IRQ_VECTOR_RCC              (16 + 4)	/* RCC global Interrupt */
#define IRQ_VECTOR_EXTI0_1          (16 + 5)	/* EXTI Line0 and 1 Interrupt */
#define IRQ_VECTOR_EXTI2_3          (16 + 6)	/* EXTI Line2 and 3 Interrupt */
#define IRQ_VECTOR_EXTI4_15         (16 + 7)	/* EXTI Line4 to 15 Interrupt */
#define IRQ_VECTOR_USB_UCPD1_2      (16 + 8)	/* USB UPD1 and 2 global Interrupts */
#define IRQ_VECTOR_UCPD1_2          (16 + 8)	/* UPD1 and 2 global Interrupts */
#define IRQ_VECTOR_DMA1_CH1         (16 + 9)	/* DMA1 Channel 1 global Interrupt */
#define IRQ_VECTOR_DMA1_CH_LOW      (16 + 10)	/* DMA1 Channel 2 and 3 global Interrupt */
#define IRQ_VECTOR_DMA1_CH_HI_DMA2  (16 + 11)	/* DMA1 Channel 4 to 7 DMA2 Ch1 to Ch5 and DMAMUX1 global Interrupt */
#define IRQ_VECTOR_DMA1_CH_HIGH     (16 + 11)	/* DMA1 Channel 4 to 7 and DMAMUX1 global Interrupt */
#define IRQ_VECTOR_ADC1_COMP        (16 + 12)	/* ADC1, COMP1 and COMP2 Interrupts */
#define IRQ_VECTOR_TIM1_BRK_UP_TRG  (16 + 13)	/* TIM1 Break, Update, Trigger and Commutation Interrupt */
#define IRQ_VECTOR_TIM1_CC          (16 + 14)	/* TIM1 Capture Compare Interrupt */
#define IRQ_VECTOR_TIM2             (16 + 15)	/* TIM2 global Interrupt */
#define IRQ_VECTOR_TIM3             (16 + 16)	/* TIM3 global Interrupt */
#define IRQ_VECTOR_TIM6_DAC_LPTM1   (16 + 17)	/* TIM6, DAC and LPTIM1 global Interrupt */
#define IRQ_VECTOR_TIM7_LPTIM2      (16 + 18)	/* TIM7 and LPTIM2 global Interrupt */
#define IRQ_VECTOR_TIM14            (16 + 19)	/* TIM14 global Interrupt */
#define IRQ_VECTOR_TIM15            (16 + 20)	/* TIM15 global Interrupt */
#define IRQ_VECTOR_TIM16            (16 + 21)	/* TIM16 global Interrupt */
#define IRQ_VECTOR_TIM17            (16 + 22)	/* TIM17 global Interrupt */
#define IRQ_VECTOR_I2C1             (16 + 23)	/* I2C1 global Interrupt  */
#define IRQ_VECTOR_I2C2_3           (16 + 24)	/* I2C2,3 global Interrupt */
#define IRQ_VECTOR_I2C2             (16 + 24)	/* I2C2 global Interrupt */
#define IRQ_VECTOR_SPI1             (16 + 25)	/* SPI1 global Interrupt */
#define IRQ_VECTOR_SPI2_3           (16 + 26)	/* SPI2,3 global Interrupt */
#define IRQ_VECTOR_SPI2             (16 + 26)	/* SPI2 global Interrupt */
#define IRQ_VECTOR_USART1           (16 + 27)	/* USART1 global Interrupt */
#define IRQ_VECTOR_USART2           (16 + 28)	/* USART2 global Interrupt */
#define IRQ_VECTOR_USART2_LPUART2   (16 + 28)	/* USART2 LPUART2 global Interrupt */
#define IRQ_VECTOR_USART3_LPUART1   (16 + 29)	/* USART3 ang LPUART1 global Interrupt */
#define IRQ_VECTOR_USART3_4_5_6_LPUART1 (16 + 29)	/* USART3,4,5,6 LPUART1 global Interrupt */
#define IRQ_VECTOR_CEC              (16 + 30)	/* CEC Interrupt(combined with EXTI 27) */

/*
 *  PERIPHERAL MEMORY MAP
 */
#define FLASH_BASE          0x08000000	/* FLASH base address in the alias region */
#define SRAM_BASE           0x20000000	/* SRAM base address in the alias region */
#define PERIPH_BASE         0x40000000	/* Peripheral base address in the alias region */
#define IOPORT_BASE         0x50000000	/* IOPORT base address */

/* Peripheral memory map */
#define APBPERIPH_BASE      PERIPH_BASE
#define AHBPERIPH_BASE      (PERIPH_BASE + 0x00020000)

/*
 *  TIMER
 */
#define TADR_TIM2_BASE      (APBPERIPH_BASE + 0x0000)
#define TADR_TIM3_BASE      (APBPERIPH_BASE + 0x0400)
#define TADR_TIM6_BASE      (APBPERIPH_BASE + 0x1000)
#define TADR_TIM7_BASE      (APBPERIPH_BASE + 0x1400)
#define TADR_TIM14_BASE     (APBPERIPH_BASE + 0x2000)
#define TADR_TIM15_BASE     (APBPERIPH_BASE + 0x00014000)
#define TADR_TIM16_BASE     (APBPERIPH_BASE + 0x00014400)
#define TADR_TIM17_BASE     (APBPERIPH_BASE + 0x00014800)
#define TOFF_TIM_CR1        0x0000		/* (RW) TIM control register 1 */
  #define TIM_CR1_CEN        0x00000001	/* Counter enable */
  #define TIM_CR1_UDIS       0x00000002	/* Update disable */
  #define TIM_CR1_URS        0x00000004	/* Update request source */
  #define TIM_CR1_OPM        0x00000008	/* One pulse mode */
  #define TIM_CR1_DIR        0x00000010	/* Direction */
  #define TIM_CR1_CMS        0x00000030	/* CMS[1:0] bits (Center-aligned mode selection) */
  #define TIM_CR1_CMS_0      0x00000020	/* CMS[1:0] bit 0 */
  #define TIM_CR1_CMS_1      0x00000040	/* CMS[1:0] bit 1 */
  #define TIM_CR1_ARPE       0x00000080	/* Auto-reload preload enable */
  #define TIM_CR1_CKD        0x00000300	/* CKD[1:0] bits (clock division) */
  #define TIM_CR1_CKD_0      0x00000100	/* CKD[1:0] bit 0 */
  #define TIM_CR1_CKD_1      0x00000200	/* CKD[1:0] bit 1 */
  #define TIM_CR1_UIFREMAP   0x00000800	/* Update interrupt flag remap */
#define TOFF_TIM_CR2        0x0004		/* (RW) TIM control register 2 */
#define TOFF_TIM_SMCR       0x0008		/* (RW) TIM slave mode control register */
#define TOFF_TIM_DIER       0x000C		/* (RW) TIM DMA/interrupt enable register */
  #define TIM_DIER_UIE       0x00000001	/* Update interrupt enable */
  #define TIM_DIER_CC1IE     0x00000002	/* Capture/Compare 1 interrupt enable */
  #define TIM_DIER_CC2IE     0x00000004	/* Capture/Compare 2 interrupt enable */
  #define TIM_DIER_CC3IE     0x00000008	/* Capture/Compare 3 interrupt enable */
  #define TIM_DIER_CC4IE     0x00000010	/* Capture/Compare 4 interrupt enable */
  #define TIM_DIER_COMIE     0x00000020	/* COM interrupt enable */
  #define TIM_DIER_TIE       0x00000040	/* Trigger interrupt enable */
  #define TIM_DIER_BIE       0x00000080	/* Break interrupt enable */
  #define TIM_DIER_UDE       0x00000100	/* Update DMA request enable */
  #define TIM_DIER_CC1DE     0x00000200	/* Capture/Compare 1 DMA request enable */
  #define TIM_DIER_CC2DE     0x00000400	/* Capture/Compare 2 DMA request enable */
  #define TIM_DIER_CC3DE     0x00000800	/* Capture/Compare 3 DMA request enable */
  #define TIM_DIER_CC4DE     0x00001000	/* Capture/Compare 4 DMA request enable */
  #define TIM_DIER_COMDE     0x00002000	/* COM DMA request enable */
  #define TIM_DIER_TDE       0x00004000	/* Trigger DMA request enable */
#define TOFF_TIM_SR         0x0010		/* (RW) TIM status register */
  #define TIM_SR_UIF         0x00000001	/* Update interrupt Flag */
  #define TIM_SR_CC1IF       0x00000002	/* Capture/Compare 1 interrupt Flag */
  #define TIM_SR_CC2IF       0x00000004	/* Capture/Compare 2 interrupt Flag */
  #define TIM_SR_CC3IF       0x00000008	/* Capture/Compare 3 interrupt Flag */
  #define TIM_SR_CC4IF       0x00000010	/* Capture/Compare 4 interrupt Flag */
  #define TIM_SR_COMIF       0x00000020	/* COM interrupt Flag */
  #define TIM_SR_TIF         0x00000040	/* Trigger interrupt Flag */
  #define TIM_SR_BIF         0x00000080	/* Break interrupt Flag */
  #define TIM_SR_B2IF        0x00000100	/* Break 2 interrupt Flag */
  #define TIM_SR_CC1OF       0x00000200	/* Capture/Compare 1 Overcapture Flag */
  #define TIM_SR_CC2OF       0x00000400	/* Capture/Compare 2 Overcapture Flag */
  #define TIM_SR_CC3OF       0x00000800	/* Capture/Compare 3 Overcapture Flag */
  #define TIM_SR_CC4OF       0x00001000	/* Capture/Compare 4 Overcapture Flag */
  #define TIM_SR_SBIF        0x00002000	/* System Break interrupt Flag */
  #define TIM_SR_CC5IF       0x00010000	/* Capture/Compare 5 interrupt Flag */
  #define TIM_SR_CC6IF       0x00020000	/* Capture/Compare 6 interrupt Flag */
#define TOFF_TIM_EGR        0x0014		/* (RW) TIM event generation register */
#define TOFF_TIM_CCMR1      0x0018		/* (RW) TIM capture/compare mode register 1 */
#define TOFF_TIM_CCMR2      0x001C		/* (RW) TIM capture/compare mode register 2 */
#define TOFF_TIM_CCER       0x0020		/* (RW) TIM capture/compare enable register */
#define TOFF_TIM_CNT        0x0024		/* (RW) TIM counter register */
#define TOFF_TIM_PSC        0x0028		/* (RW) TIM prescaler */
#define TOFF_TIM_ARR        0x002C		/* (RW) TIM auto-reload register */
#define TOFF_TIM_RCR        0x0030		/* (RW) TIM repetition counter register */
#define TOFF_TIM_CCR1       0x0034		/* (RW) TIM capture/compare register 1 */
#define TOFF_TIM_CCR2       0x0038		/* (RW) TIM capture/compare register 2 */
#define TOFF_TIM_CCR3       0x003C		/* (RW) TIM capture/compare register 3 */
#define TOFF_TIM_CCR4       0x0040		/* (RW) TIM capture/compare register 4 */
#define TOFF_TIM_BDTR       0x0044		/* (RW) TIM break and dead-time register */
#define TOFF_TIM_DCR        0x0048		/* (RW) TIM DMA control register */
#define TOFF_TIM_DMAR       0x004C		/* (RW) TIM DMA address for full transfer */
#define TOFF_TIM_OR         0x0050		/* (RW) TIM option register */
#define TOFF_TIM_CCMR3      0x0054		/* (RW) TIM capture/compare mode register 3 */
#define TOFF_TIM_CCR5       0x0058		/* (RW) TIM capture/compare register5 */
#define TOFF_TIM_CCR6       0x005C		/* (RW) TIM capture/compare register6 */
#define TOFF_TIM_AF1        0x0060		/* (RW) TIM alternate function register 1 */
#define TOFF_TIM_AF2        0x0064		/* (RW) TIM alternate function register 2 */
#define TOFF_TIM_TISEL      0x0068		/* (RW) TIM Input Selection register */


/*
 *  REAL-TIME CLOCK
 */
#define TADR_RTC_BASE       (APBPERIPH_BASE + 0x2800)
#define TOFF_RTC_TR         0x0000		/* (RW) RTC time register */
  #define RTC_TR_PM                0x00400000
  #define RTC_TR_HT                0x00300000
  #define RTC_TR_HT_0              0x00100000
  #define RTC_TR_HT_1              0x00200000
  #define RTC_TR_HU                0x000F0000
  #define RTC_TR_HU_0              0x00010000
  #define RTC_TR_HU_1              0x00020000
  #define RTC_TR_HU_2              0x00040000
  #define RTC_TR_HU_3              0x00080000
  #define RTC_TR_MNT               0x00007000
  #define RTC_TR_MNT_0             0x00001000
  #define RTC_TR_MNT_1             0x00002000
  #define RTC_TR_MNT_2             0x00004000
  #define RTC_TR_MNU               0x00000F00
  #define RTC_TR_MNU_0             0x00000100
  #define RTC_TR_MNU_1             0x00000200
  #define RTC_TR_MNU_2             0x00000400
  #define RTC_TR_MNU_3             0x00000800
  #define RTC_TR_ST                0x00000070
  #define RTC_TR_ST_0              0x00000010
  #define RTC_TR_ST_1              0x00000020
  #define RTC_TR_ST_2              0x00000040
  #define RTC_TR_SU                0x0000000F
  #define RTC_TR_SU_0              0x00000001
  #define RTC_TR_SU_1              0x00000002
  #define RTC_TR_SU_2              0x00000004
  #define RTC_TR_SU_3              0x00000008
#define TOFF_RTC_DR         0x0004		/* (RW) RTC date register */
  #define RTC_DR_YT                0x00F00000
  #define RTC_DR_YT_0              0x00100000
  #define RTC_DR_YT_1              0x00200000
  #define RTC_DR_YT_2              0x00400000
  #define RTC_DR_YT_3              0x00800000
  #define RTC_DR_YU                0x000F0000
  #define RTC_DR_YU_0              0x00010000
  #define RTC_DR_YU_1              0x00020000
  #define RTC_DR_YU_2              0x00040000
  #define RTC_DR_YU_3              0x00080000
  #define RTC_DR_WDU               0x0000E000
  #define RTC_DR_WDU_0             0x00002000
  #define RTC_DR_WDU_1             0x00004000
  #define RTC_DR_WDU_2             0x00008000
  #define RTC_DR_MT                0x00001000
  #define RTC_DR_MU                0x00000F00
  #define RTC_DR_MU_0              0x00000100
  #define RTC_DR_MU_1              0x00000200
  #define RTC_DR_MU_2              0x00000400
  #define RTC_DR_MU_3              0x00000800
  #define RTC_DR_DT                0x00000030
  #define RTC_DR_DT_0              0x00000010
  #define RTC_DR_DT_1              0x00000020
  #define RTC_DR_DU                0x0000000F
  #define RTC_DR_DU_0              0x00000001
  #define RTC_DR_DU_1              0x00000002
  #define RTC_DR_DU_2              0x00000004
  #define RTC_DR_DU_3              0x00000008
#define TOFF_RTC_SSR        0x0008		/* (RW) RTC sub second register */
#define TOFF_RTC_ICSR       0x000C		/* (RW) RTC initialization control and status register */
  #define RTC_ICSR_RECALPF         0x00010000
  #define RTC_ICSR_INIT            0x00000080
  #define RTC_ICSR_INITF           0x00000040
  #define RTC_ICSR_RSF             0x00000020
  #define RTC_ICSR_INITS           0x00000010
  #define RTC_ICSR_SHPF            0x00000008
  #define RTC_ICSR_WUTWF           0x00000004
  #define RTC_ICSR_ALRBWF          0x00000002
  #define RTC_ICSR_ALRAWF          0x00000001
#define TOFF_RTC_PRER       0x0010		/* (RW) RTC prescaler register */
#define TOFF_RTC_WUTR       0x0014		/* (RW) RTC wakeup timer register */
#define TOFF_RTC_CR         0x0018		/* (RW) RTC control register */
  #define RTC_CR_OUT2EN            0x80000000	/* RTC_OUT2 output enable */
  #define RTC_CR_TAMPALRM          0x40000000	/* TAMPALARM output type  */
  #define RTC_CR_TAMPALRM_PU       0x20000000	/* TAMPALARM output pull-up config */
  #define RTC_CR_TAMPOE            0x04000000	/* Tamper detection output enable on TAMPALARM  */
  #define RTC_CR_TAMPTS            0x02000000	/* Activate timestamp on tamper detection event  */
  #define RTC_CR_ITSE              0x01000000	/* Timestamp on internal event enable  */
  #define RTC_CR_COE               0x00800000
  #define RTC_CR_OSEL              0x00600000
  #define RTC_CR_OSEL_0            0x00200000
  #define RTC_CR_OSEL_1            0x00400000
  #define RTC_CR_POL               0x00100000
  #define RTC_CR_COSEL             0x00060000
  #define RTC_CR_BCK               0x00040000
  #define RTC_CR_SUB1H             0x00020000
  #define RTC_CR_ADD1H             0x00010000
  #define RTC_CR_TSIE              0x00008000
  #define RTC_CR_WUTIE             0x00004000
  #define RTC_CR_ALRBIE            0x00002000
  #define RTC_CR_ALRAIE            0x00001000
  #define RTC_CR_TSE               0x00000800
  #define RTC_CR_WUTE              0x00000400
  #define RTC_CR_ALRBE             0x00000200
  #define RTC_CR_ALRAE             0x00000100
  #define RTC_CR_FMT               0x00000040
  #define RTC_CR_BYPSHAD           0x00000020
  #define RTC_CR_REFCKON           0x00000010
  #define RTC_CR_TSEDGE            0x00000008
  #define RTC_CR_WUCKSEL           0x00000007
  #define RTC_CR_WUCKSEL_0         0x00000001
  #define RTC_CR_WUCKSEL_1         0x00000002
  #define RTC_CR_WUCKSEL_2         0x00000004
#define TOFF_RTC_WPR        0x0024		/* (RW) RTC write protection register */
#define TOFF_RTC_CALR       0x0028		/* (RW) RTC calibration register */
  #define RTC_CALR_CALP            0x00008000
  #define RTC_CALR_CALW8           0x00004000
  #define RTC_CALR_CALW16          0x00002000
  #define RTC_CALR_CALM            0x000001FF
  #define RTC_CALR_CALM_0          0x00000001
  #define RTC_CALR_CALM_1          0x00000002
  #define RTC_CALR_CALM_2          0x00000004
  #define RTC_CALR_CALM_3          0x00000008
  #define RTC_CALR_CALM_4          0x00000010
  #define RTC_CALR_CALM_5          0x00000020
  #define RTC_CALR_CALM_6          0x00000040
  #define RTC_CALR_CALM_7          0x00000080
  #define RTC_CALR_CALM_8          0x00000100
#define TOFF_RTC_SHIFTR     0x002C		/* (RW) RTC shift control register */
#define TOFF_RTC_TSTR       0x0030		/* (RW) RTC time stamp time register */
  #define RTC_TSTR_PM              0x00400000	/* AM-PM notation */
  #define RTC_TSTR_HT              0x00300000
  #define RTC_TSTR_HT_0            0x00100000
  #define RTC_TSTR_HT_1            0x00200000
  #define RTC_TSTR_HU              0x000F0000
  #define RTC_TSTR_HU_0            0x00010000
  #define RTC_TSTR_HU_1            0x00020000
  #define RTC_TSTR_HU_2            0x00040000
  #define RTC_TSTR_HU_3            0x00080000
  #define RTC_TSTR_MNT             0x00007000
  #define RTC_TSTR_MNT_0           0x00001000
  #define RTC_TSTR_MNT_1           0x00002000
  #define RTC_TSTR_MNT_2           0x00004000
  #define RTC_TSTR_MNU             0x00000F00
  #define RTC_TSTR_MNU_0           0x00000100
  #define RTC_TSTR_MNU_1           0x00000200
  #define RTC_TSTR_MNU_2           0x00000400
  #define RTC_TSTR_MNU_3           0x00000800
  #define RTC_TSTR_ST              0x00000070
  #define RTC_TSTR_ST_0            0x00000010
  #define RTC_TSTR_ST_1            0x00000020
  #define RTC_TSTR_ST_2            0x00000040
  #define RTC_TSTR_SU              0x0000000F
  #define RTC_TSTR_SU_0            0x00000001
  #define RTC_TSTR_SU_1            0x00000002
  #define RTC_TSTR_SU_2            0x00000004
  #define RTC_TSTR_SU_3            0x00000008
#define TOFF_RTC_TSDR       0x0034		/* (RW) RTC time stamp date register */
  #define RTC_TSDR_WDU             0x0000E000	/* Week day units */
  #define RTC_TSDR_WDU_0           0x00002000
  #define RTC_TSDR_WDU_1           0x00004000
  #define RTC_TSDR_WDU_2           0x00008000
  #define RTC_TSDR_MT              0x00001000
  #define RTC_TSDR_MU              0x00000F00
  #define RTC_TSDR_MU_0            0x00000100
  #define RTC_TSDR_MU_1            0x00000200
  #define RTC_TSDR_MU_2            0x00000400
  #define RTC_TSDR_MU_3            0x00000800
  #define RTC_TSDR_DT              0x00000030
  #define RTC_TSDR_DT_0            0x00000010
  #define RTC_TSDR_DT_1            0x00000020
  #define RTC_TSDR_DU_Pos          0x0000000F
  #define RTC_TSDR_DU_0            0x00000001
  #define RTC_TSDR_DU_1            0x00000002
  #define RTC_TSDR_DU_2            0x00000004
  #define RTC_TSDR_DU_3            0x00000008
#define TOFF_RTC_TSSSR      0x0038		/* (RW) RTC time-stamp sub second register */
#define TOFF_RTC_ALRMAR     0x0040		/* (RW) RTC alarm A register */
  #define RTC_ALRMAR_MSK4          0x80000000
  #define RTC_ALRMAR_WDSEL         0x40000000
  #define RTC_ALRMAR_DT            0x30000000
  #define RTC_ALRMAR_DT_0          0x10000000
  #define RTC_ALRMAR_DT_1          0x20000000
  #define RTC_ALRMAR_DU            0x0F000000
  #define RTC_ALRMAR_DU_0          0x01000000
  #define RTC_ALRMAR_DU_1          0x02000000
  #define RTC_ALRMAR_DU_2          0x04000000
  #define RTC_ALRMAR_DU_3          0x08000000
  #define RTC_ALRMAR_MSK3          0x00800000
  #define RTC_ALRMAR_PM            0x00400000
  #define RTC_ALRMAR_HT            0x00300000
  #define RTC_ALRMAR_HT_0          0x00100000
  #define RTC_ALRMAR_HT_1          0x00200000
  #define RTC_ALRMAR_HU            0x000F0000
  #define RTC_ALRMAR_HU_0          0x00010000
  #define RTC_ALRMAR_HU_1          0x00020000
  #define RTC_ALRMAR_HU_2          0x00040000
  #define RTC_ALRMAR_HU_3          0x00080000
  #define RTC_ALRMAR_MSK2          0x00008000
  #define RTC_ALRMAR_MNT           0x00007000
  #define RTC_ALRMAR_MNT_0         0x00001000
  #define RTC_ALRMAR_MNT_1         0x00002000
  #define RTC_ALRMAR_MNT_2         0x00004000
  #define RTC_ALRMAR_MNU           0x00000F00
  #define RTC_ALRMAR_MNU_0         0x00000100
  #define RTC_ALRMAR_MNU_1         0x00000200
  #define RTC_ALRMAR_MNU_2         0x00000400
  #define RTC_ALRMAR_MNU_3         0x00000800
  #define RTC_ALRMAR_MSK1          0x00000080
  #define RTC_ALRMAR_ST            0x00000070
  #define RTC_ALRMAR_ST_0          0x00000010
  #define RTC_ALRMAR_ST_1          0x00000020
  #define RTC_ALRMAR_ST_2          0x00000040
  #define RTC_ALRMAR_SU            0x0000000F
  #define RTC_ALRMAR_SU_0          0x00000001
  #define RTC_ALRMAR_SU_1          0x00000002
  #define RTC_ALRMAR_SU_2          0x00000004
  #define RTC_ALRMAR_SU_3          0x00000008
#define TOFF_RTC_ALRMASSR   0x0044		/* (RW) RTC alarm A sub second register */
  #define RTC_ALRMASSR_MASKSS      0x0F000000
  #define RTC_ALRMASSR_MASKSS_0    0x01000000
  #define RTC_ALRMASSR_MASKSS_1    0x02000000
  #define RTC_ALRMASSR_MASKSS_2    0x04000000
  #define RTC_ALRMASSR_MASKSS_3    0x08000000
  #define RTC_ALRMASSR_SS          0x00007FFF
#define TOFF_RTC_ALRMBR     0x0048		/* (RW) RTC alarm B register */
  #define RTC_ALRMBR_MSK4          0x80000000
  #define RTC_ALRMBR_WDSEL         0x40000000
  #define RTC_ALRMBR_DT            0x30000000
  #define RTC_ALRMBR_DT_0          0x10000000
  #define RTC_ALRMBR_DT_1          0x20000000
  #define RTC_ALRMBR_DU            0x0F000000
  #define RTC_ALRMBR_DU_0          0x01000000
  #define RTC_ALRMBR_DU_1          0x02000000
  #define RTC_ALRMBR_DU_2          0x04000000
  #define RTC_ALRMBR_DU_3          0x08000000
  #define RTC_ALRMBR_MSK3          0x00800000
  #define RTC_ALRMBR_PM            0x00400000
  #define RTC_ALRMBR_HT            0x00300000
  #define RTC_ALRMBR_HT_0          0x00100000
  #define RTC_ALRMBR_HT_1          0x00200000
  #define RTC_ALRMBR_HU            0x000F0000
  #define RTC_ALRMBR_HU_0          0x00010000
  #define RTC_ALRMBR_HU_1          0x00020000
  #define RTC_ALRMBR_HU_2          0x00040000
  #define RTC_ALRMBR_HU_3          0x00080000
  #define RTC_ALRMBR_MSK2          0x00008000
  #define RTC_ALRMBR_MNT           0x00007000
  #define RTC_ALRMBR_MNT_0         0x00001000
  #define RTC_ALRMBR_MNT_1         0x00002000
  #define RTC_ALRMBR_MNT_2         0x00004000
  #define RTC_ALRMBR_MNU           0x00000F00
  #define RTC_ALRMBR_MNU_0         0x00000100
  #define RTC_ALRMBR_MNU_1         0x00000200
  #define RTC_ALRMBR_MNU_2         0x00000400
  #define RTC_ALRMBR_MNU_3         0x00000800
  #define RTC_ALRMBR_MSK1          0x00000080
  #define RTC_ALRMBR_ST            0x00000070
  #define RTC_ALRMBR_ST_0          0x00000010
  #define RTC_ALRMBR_ST_1          0x00000020
  #define RTC_ALRMBR_ST_2          0x00000040
  #define RTC_ALRMBR_SU            0x0000000F
  #define RTC_ALRMBR_SU_0          0x00000001
  #define RTC_ALRMBR_SU_1          0x00000002
  #define RTC_ALRMBR_SU_2          0x00000004
  #define RTC_ALRMBR_SU_3          0x00000008
#define TOFF_RTC_ALRMBSSR   0x004C		/* (RW) RTC alarm B sub second register */
  #define RTC_ALRMBSSR_MASKSS      0x0F000000
  #define RTC_ALRMBSSR_MASKSS_0    0x01000000
  #define RTC_ALRMBSSR_MASKSS_1    0x02000000
  #define RTC_ALRMBSSR_MASKSS_2    0x04000000
  #define RTC_ALRMBSSR_MASKSS_3    0x08000000
  #define RTC_ALRMBSSR_SS          0x00007FFF
#define TOFF_RTC_SR         0x0050		/* (RW) RTC Status register */
#define TOFF_RTC_MISR       0x0054		/* (RW) RTC Masked Interrupt Status register */
#define TOFF_RTC_SCR        0x005C		/* (RW) RTC Status Clear register */
#define TOFF_RTC_OR         0x0060		/* (RW) RTC option register */

/*
 *  WINDOW WATCHDOG
 */
#define TADR_WWDG_BASE      (APBPERIPH_BASE + 0x2C00)
#define TOFF_WWDG_CR        0x0000		/* (RW) WWDG Control register */
#define TOFF_WWDG_CFR       0x0004		/* (RW) WWDG Configuration register */
#define TOFF_WWDG_SR        0x0008		/* (R)  WWDG Status register */

/*
 *  INDEPENDENT WATCHDOG
 */
#define TADR_IWDG_BASE      (APBPERIPH_BASE + 0x3000)
#define TOFF_IWDG_KR        0x0000		/* (RW) IWDG Key register */
#define TOFF_IWDG_PR        0x0004		/* (RW) IWDG Prescaler register */
#define TOFF_IWDG_RLR       0x0008		/* (RW) IWDG Reload register */
#define TOFF_IWDG_SR        0x000C		/* (RW) IWDG Status register */
#define TOFF_IWDG_WINR      0x0010		/* (RW) IWDG Window register */

/*
 *  SERIAL PERIPHERAL IINTERFACE
 */
#define TADR_SPI2_BASE      (APBPERIPH_BASE + 0x3800)
#if BOARDNO == 1
#define TADR_SPI3_BASE      (APBPERIPH_BASE + 0x3C00)
#endif
#define TADR_SPI1_BASE      (APBPERIPH_BASE + 0x00013000)
#define TOFF_SPI_CR1        0x0000		/* (RW) SPI control register 1 (not used in I2S mode) */
  #define SPI_CR1_CPHA             0x00000001	/* Clock Phase */
  #define SPI_CR1_CPOL             0x00000002	/* Clock Polarity */
  #define SPI_CR1_MSTR             0x00000004	/* Master Selection */
  #define SPI_CR1_BR               0x00000038	/* Baud Rate Control */
  #define SPI_CR1_BR_0             0x00000008	/* Bit 0 */
  #define SPI_CR1_BR_1             0x00000010	/* Bit 1 */
  #define SPI_CR1_BR_2             0x00000020	/* Bit 2 */
  #define SPI_CR1_SPE              0x00000040	/* SPI Enable */
  #define SPI_CR1_LSBFIRST         0x00000080	/* Frame Format */
  #define SPI_CR1_SSI              0x00000100	/* Internal slave select */
  #define SPI_CR1_SSM              0x00000200	/* Software slave management */
  #define SPI_CR1_RXONLY           0x00000400	/* Receive only */
  #define SPI_CR1_CRCL             0x00000800	/* CRC Length */
  #define SPI_CR1_CRCNEXT          0x00001000	/* Transmit CRC next */
  #define SPI_CR1_CRCEN            0x00002000	/* Hardware CRC calculation enable */
  #define SPI_CR1_BIDIOE           0x00004000	/* Output enable in bidirectional mode */
  #define SPI_CR1_BIDIMODE         0x00008000	/* Bidirectional data mode enable */
#define TOFF_SPI_CR2        0x0004		/* (RW) SPI control register 2 */
  #define SPI_CR2_RXDMAEN          0x00000001	/* Rx Buffer DMA Enable */
  #define SPI_CR2_TXDMAEN          0x00000002	/* Tx Buffer DMA Enable */
  #define SPI_CR2_SSOE             0x00000004	/* SS Output Enable */
  #define SPI_CR2_FRF              0x00000010	/* Frame Format */
  #define SPI_CR2_ERRIE            0x00000020	/* Error Interrupt Enable */
  #define SPI_CR2_RXNEIE           0x00000040	/* RX buffer Not Empty Interrupt Enable */
  #define SPI_CR2_TXEIE            0x00000080	/* Tx buffer Empty Interrupt Enable */
  #define SPI_CR2_DS               0x00000F00	/* DS[3:0] Data Size */
  #define SPI_CR2_DS_0             0x00000100
  #define SPI_CR2_DS_1             0x00000200
  #define SPI_CR2_DS_2             0x00000400
  #define SPI_CR2_DS_3             0x00000800
  #define SPI_CR2_FRXTH            0x00001000	/* FIFO reception Threshold */
  #define SPI_CR2_LDMARX           0x00002000	/* Last DMA transfer for reception */
  #define SPI_CR2_LDMATX           0x00004000	/* Last DMA transfer for transmission */
#define TOFF_SPI_SR         0x0008		/* (RW) SPI status register */
  #define SPI_SR_RXNE              0x00000001	/* Receive buffer Not Empty */
  #define SPI_SR_TXE               0x00000002	/* Transmit buffer Empty */
  #define SPI_SR_CHSIDE            0x00000004	/* Channel side */
  #define SPI_SR_UDR               0x00000008	/* Underrun flag */
  #define SPI_SR_CRCERR            0x00000010	/* CRC Error flag */
  #define SPI_SR_MODF              0x00000020	/* Mode fault */
  #define SPI_SR_OVR               0x00000040	/* Overrun flag */
  #define SPI_SR_BSY               0x00000080	/* Busy flag */
  #define SPI_SR_FRE               0x00000100	/* Frame format error flag */
  #define SPI_SR_FRLVL             0x00000600	/* FIFO Reception Level */
  #define SPI_SR_FRLVL_0           0x00000200
  #define SPI_SR_FRLVL_1           0x00000400
  #define SPI_SR_FTLVL             0x00001800	/* FIFO Transmission Level */
  #define SPI_SR_FTLVL_0           0x00000800
  #define SPI_SR_FTLVL_1           0x00001000
#define TOFF_SPI_DR         0x000C		/* (RW) SPI data register */
#define TOFF_SPI_CRCPR      0x0010		/* (RW) SPI CRC polynomial register (not used in I2S mode) */
#define TOFF_SPI_RXCRCR     0x0014		/* (RW) SPI RX CRC register (not used in I2S mode) */
#define TOFF_SPI_TXCRCR     0x0018		/* (RW) SPI TX CRC register (not used in I2S mode) */
#define TOFF_SPI_I2SCFGR    0x001C		/* (RW) SPI_I2S configuration register */
  #define SPI_I2SCFGR_CHLEN        0x00000001	/* Channel length (number of bits per audio channel) */
  #define SPI_I2SCFGR_DATLEN       0x00000006	/* DATLEN[1:0] bits (Data length to be transferred)  */
  #define SPI_I2SCFGR_DATLEN_0     0x00000002	/* Bit 0 */
  #define SPI_I2SCFGR_DATLEN_1     0x00000004	/* Bit 1 */
  #define SPI_I2SCFGR_CKPOL        0x00000008	/* steady state clock polarity */
  #define SPI_I2SCFGR_I2SSTD       0x00000030	/* I2SSTD[1:0] bits (I2S standard selection) */
  #define SPI_I2SCFGR_I2SSTD_0     0x00000010	/* Bit 0 */
  #define SPI_I2SCFGR_I2SSTD_1     0x00000020	/* Bit 1 */
  #define SPI_I2SCFGR_PCMSYNC      0x00000080	/* PCM frame synchronization */
  #define SPI_I2SCFGR_I2SCFG       0x00000300	/* I2SCFG[1:0] bits (I2S configuration mode) */
  #define SPI_I2SCFGR_I2SCFG_0     0x00000100	/* Bit 0 */
  #define SPI_I2SCFGR_I2SCFG_1     0x00000200	/* Bit 1 */
  #define SPI_I2SCFGR_I2SE         0x00000400	/* I2S Enable */
  #define SPI_I2SCFGR_I2SMOD       0x00000800	/* I2S mode selection */
  #define SPI_I2SCFGR_ASTRTEN      0x00001000	/* Asynchronous start enable */
#define TOFF_SPI_I2SPR      0x0020		/* (RW) SPI_I2S prescaler register */

/*
 *  UNIVERSAL SYNCHRONOUS ASYNCHORONOUS RECEIVER TRANSMITTER
 */
#define TADR_USART2_BASE    (APBPERIPH_BASE + 0x4400)
#define TADR_USART3_BASE    (APBPERIPH_BASE + 0x4800)
#define TADR_USART4_BASE    (APBPERIPH_BASE + 0x4C00)
#if BOARDNO == 1
#define TADR_USART5_BASE    (APBPERIPH_BASE + 0x5000)
#endif
#define TADR_LPUART1_BASE   (APBPERIPH_BASE + 0x8000)
#if BOARDNO == 1
#define TADR_LPUART2_BASE   (APBPERIPH_BASE + 0x8400)
#endif
#define TADR_USART1_BASE    (APBPERIPH_BASE + 0x00013800)
#if BOARDNO == 1
#define TADR_USART6_BASE    (APBPERIPH_BASE + 0x00013C00)
#endif
#define TOFF_USART_CR1      0x0000		/* (RW-32) USART Control register 1 */
  #define USART_CR1_UE       0x00000001	/* USART Enable */
  #define USART_CR1_UESM     0x00000002	/* USART Enable in STOP Mode */
  #define USART_CR1_RE       0x00000004	/* Receiver Enable */
  #define USART_CR1_TE       0x00000008	/* Transmitter Enable */
  #define USART_CR1_IDLEIE   0x00000010	/* IDLE Interrupt Enable */
  #define USART_CR1_RXNEIE_RXFNEIE 0x00000020	/* RXNE/RXFIFO Interrupt Enable */
  #define USART_CR1_TCIE     0x00000040	/* Transmission Complete Interrupt Enable */
  #define USART_CR1_TXEIE_TXFNFIE  0x00000080	/* TXE/TXFIFO  Interrupt Enable */
  #define USART_CR1_PEIE     0x00000100	/* PE Interrupt Enable */
  #define USART_CR1_PS       0x00000200	/* Parity Selection */
  #define USART_CR1_PCE      0x00000400	/* Parity Control Enable */
  #define USART_CR1_WAKE     0x00000800	/* Wakeup method */
  #define USART_CR1_M0       0x00001000	/* Word length bit 0 */
  #define USART_CR1_MME      0x00002000	/* Mute Mode Enable */
  #define USART_CR1_CMIE     0x00004000	/* Character match interrupt enable */
  #define USART_CR1_OVER8    0x00008000	/* Oversampling by 8-bit or 16-bit mode */
  #define USART_CR1_DEDT     0x001F0000	/* DEDT[4:0] bits (Driver Enable Deassertion Time) */
  #define USART_CR1_DEDT_0   0x00010000
  #define USART_CR1_DEDT_1   0x00020000
  #define USART_CR1_DEDT_2   0x00040000
  #define USART_CR1_DEDT_3   0x00080000
  #define USART_CR1_DEDT_4   0x00100000
  #define USART_CR1_DEAT     0x03E00000	/* DEAT[4:0] bits (Driver Enable Assertion Time) */
  #define USART_CR1_DEAT_0   0x00200000
  #define USART_CR1_DEAT_1   0x00400000
  #define USART_CR1_DEAT_2   0x00800000
  #define USART_CR1_DEAT_3   0x01000000
  #define USART_CR1_DEAT_4   0x02000000
  #define USART_CR1_RTOIE    0x04000000	/* Receive Time Out interrupt enable */
  #define USART_CR1_EOBIE    0x08000000	/* End of Block interrupt enable */
  #define USART_CR1_M1       0x10000000	/* Word length bit 1 */
  #define USART_CR1_FIFOEN   0x20000000	/* FIFO mode enable */
  #define USART_CR1_TXFEIE   0x40000000	/* TXFIFO empty interrupt enable */
  #define USART_CR1_RXFFIE   0x80000000	/* RXFIFO Full interrupt enable */
  #define USART_CR1_M        (USART_CR1_M0 | USART_CR1_M1)
#define TOFF_USART_CR2      0x0004		/* (RW-32) USART Control register 2 */
  #define USART_CR2_SLVEN    0x00000001	/* Synchronous Slave mode enable */
  #define USART_CR2_DIS_NSS  0x00000008	/* NSS input pin disable for SPI slave selection */
  #define USART_CR2_ADDM7    0x00000010	/* 7-bit or 4-bit Address Detection */
  #define USART_CR2_LBDL     0x00000020	/* LIN Break Detection Length */
  #define USART_CR2_LBDIE    0x00000040	/* LIN Break Detection Interrupt Enable */
  #define USART_CR2_LBCL     0x00000100	/* Last Bit Clock pulse */
  #define USART_CR2_CPHA     0x00000200	/* Clock Phase */
  #define USART_CR2_CPOL     0x00000400	/* Clock Polarity */
  #define USART_CR2_CLKEN    0x00000800	/* Clock Enable */
  #define USART_CR2_STOP     0x00003000	/* STOP[1:0] bits (STOP bits) */
  #define USART_CR2_STOP_0   0x00001000	/* Bit 0 */
  #define USART_CR2_STOP_1   0x00002000	/* Bit 1 */
  #define USART_CR2_LINEN    0x00004000	/* LIN mode enable */
  #define USART_CR2_SWAP     0x00008000	/* SWAP TX/RX pins */
  #define USART_CR2_RXINV    0x00010000	/* RX pin active level inversion */
  #define USART_CR2_TXINV    0x00020000	/* TX pin active level inversion */
  #define USART_CR2_DATAINV  0x00040000	/* Binary data inversion */
  #define USART_CR2_MSBFIRST 0x00080000	/* Most Significant Bit First */
  #define USART_CR2_ABREN    0x00100000	/* Auto Baud-Rate Enable*/
  #define USART_CR2_ABRMODE  0x00600000	/* ABRMOD[1:0] bits (Auto Baud-Rate Mode) */
  #define USART_CR2_ABRMODE_0 0x00200000
  #define USART_CR2_ABRMODE_1 0x00400000
  #define USART_CR2_RTOEN    0x00800000	/* Receiver Time-Out enable */
  #define USART_CR2_ADD      0xFF000000	/* Address of the USART node */
#define TOFF_USART_CR3      0x0008		/* (RW-32) USART Control register 3 */
  #define USART_CR3_EIE      0x00000001	/* Error Interrupt Enable */
  #define USART_CR3_IREN     0x00000002	/* IrDA mode Enable */
  #define USART_CR3_IRLP     0x00000004	/* IrDA Low-Power */
  #define USART_CR3_HDSEL    0x00000008	/* Half-Duplex Selection */
  #define USART_CR3_NACK     0x00000010	/* Smartcard NACK enable */
  #define USART_CR3_SCEN     0x00000020	/* Smartcard mode enable */
  #define USART_CR3_DMAR     0x00000040	/* DMA Enable Receiver */
  #define USART_CR3_DMAT     0x00000080	/* DMA Enable Transmitter */
  #define USART_CR3_RTSE     0x00000100	/* RTS Enable */
  #define USART_CR3_CTSE     0x00000200	/* CTS Enable */
  #define USART_CR3_CTSIE    0x00000400	/* CTS Interrupt Enable */
  #define USART_CR3_ONEBIT   0x00000800	/* USART One bit method enable */
  #define USART_CR3_OVRDIS   0x00001000	/* Overrun Disable */
  #define USART_CR3_DDRE     0x00002000	/* DMA Disable on Reception Error */
  #define USART_CR3_DEM      0x00004000	/* Driver Enable Mode */
  #define USART_CR3_DEP      0x00008000	/* Driver Enable Polarity Selection */
  #define USART_CR3_SCARCNT  0x000E0000	/* SCARCNT[2:0] bits (SmartCard Auto-Retry Count) */
  #define USART_CR3_SCARCNT_0 0x00020000
  #define USART_CR3_SCARCNT_1 0x00040000
  #define USART_CR3_SCARCNT_2 0x00080000
  #define USART_CR3_WUS      0x00300000	/* WUS[1:0] bits (Wake UP Interrupt Flag Selection) */
  #define USART_CR3_WUS_0    0x00100000
  #define USART_CR3_WUS_1    0x00200000
  #define USART_CR3_WUFIE    0x00400000	/* Wake Up Interrupt Enable */
  #define USART_CR3_TXFTIE   0x00800000	/* TXFIFO threshold interrupt enable */
  #define USART_CR3_TCBGTIE  0x01000000	/* Transmission Complete Before Guard Time Interrupt Enable */
  #define USART_CR3_RXFTCFG  0x0E000000	/* RXFIFO FIFO threshold configuration */
  #define USART_CR3_RXFTCFG_0 0x02000000
  #define USART_CR3_RXFTCFG_1 0x04000000
  #define USART_CR3_RXFTCFG_2 0x08000000
  #define USART_CR3_RXFTIE   0x10000000	/* RXFIFO threshold interrupt enable */
  #define USART_CR3_TXFTCFG  0xE0000000	/* TXFIFO threshold configuration */
  #define USART_CR3_TXFTCFG_0 0x20000000
  #define USART_CR3_TXFTCFG_1 0x40000000
  #define USART_CR3_TXFTCFG_2 0x80000000
#define TOFF_USART_BRR      0x000C		/* (RW-32) USART Baud rate register */
  #define USART_BRR_LPUART   0x000FFFFF	/* LPUART Baud rate register [19:0] */
  #define USART_BRR_BRR      0x0000FFFF	/* USART  Baud rate register [15:0] */
#define TOFF_USART_GTPR     0x0010		/* (RW-32) USART Guard time and prescaler register */
  #define USART_GTPR_PSC     0x000000FF	/* PSC[7:0] bits (Prescaler value) */
  #define USART_GTPR_PSC_0   0x00000001	/* Bit 0 */
  #define USART_GTPR_PSC_1   0x00000002	/* Bit 1 */
  #define USART_GTPR_PSC_2   0x00000004	/* Bit 2 */
  #define USART_GTPR_PSC_3   0x00000008	/* Bit 3 */
  #define USART_GTPR_PSC_4   0x00000010	/* Bit 4 */
  #define USART_GTPR_PSC_5   0x00000020	/* Bit 5 */
  #define USART_GTPR_PSC_6   0x00000040	/* Bit 6 */
  #define USART_GTPR_PSC_7   0x00000080	/* Bit 7 */
  #define USART_GTPR_GT      0x0000FF00	/* Guard time value */
#define TOFF_USART_RTOR     0x0014		/* (RW) USART Receiver Time Out register */
  #define USART_RTOR_RTO     0x00FFFFFF	/* Receiver Time Out Value */
  #define USART_RTOR_BLEN    0xFF000000	/* Block Length */
#define TOFF_USART_RQR      0x0018		/* (RW) USART Request register */
  #define USART_RQR_ABRRQ    0x00000001	/* Auto-Baud Rate Request */
  #define USART_RQR_SBKRQ    0x00000002	/* Send Break Request */
  #define USART_RQR_MMRQ     0x00000004	/* Mute Mode Request */
  #define USART_RQR_RXFRQ    0x00000008	/* Receive Data flush Request */
  #define USART_RQR_TXFRQ    0x00000010	/* Transmit data flush Request */
#define TOFF_USART_ISR      0x001C		/* (RW) USART Interrupt and status register */
  #define USART_ISR_PE       0x00000001	/* Parity Error */
  #define USART_ISR_FE       0x00000002	/* Framing Error */
  #define USART_ISR_NE       0x00000004	/* Noise detected Flag */
  #define USART_ISR_ORE      0x00000008	/* OverRun Error */
  #define USART_ISR_IDLE     0x00000010	/* IDLE line detected */
  #define USART_ISR_RXNE_RXFNE 0x00000020	/* Read Data Register Not Empty/RXFIFO Not Empty */
  #define USART_ISR_TC       0x00000040	/* Transmission Complete */
  #define USART_ISR_TXE_TXFNF  0x00000080	/* Transmit Data Register Empty/TXFIFO Not Full */
  #define USART_ISR_LBDF     0x00000100	/* LIN Break Detection Flag */
  #define USART_ISR_CTSIF    0x00000200	/* CTS interrupt flag */
  #define USART_ISR_CTS      0x00000400	/* CTS flag */
  #define USART_ISR_RTOF     0x00000800	/* Receiver Time Out */
  #define USART_ISR_EOBF     0x00001000	/* End Of Block Flag */
  #define USART_ISR_UDR      0x00002000	/* SPI Slave Underrun Error Flag */
  #define USART_ISR_ABRE     0x00004000	/* Auto-Baud Rate Error */
  #define USART_ISR_ABRF     0x00008000	/* Auto-Baud Rate Flag */
  #define USART_ISR_BUSY     0x00010000	/* Busy Flag */
  #define USART_ISR_CMF      0x00020000	/* Character Match Flag */
  #define USART_ISR_SBKF     0x00040000	/* Send Break Flag */
  #define USART_ISR_RWU      0x00080000	/* Receive Wake Up from mute mode Flag */
  #define USART_ISR_WUF      0x00100000	/* Wake Up from stop mode Flag */
  #define USART_ISR_TEACK    0x00200000	/* Transmit Enable Acknowledge Flag */
  #define USART_ISR_REACK    0x00400000	/* Receive Enable Acknowledge Flag */
  #define USART_ISR_TXFE     0x00800000	/* TXFIFO Empty Flag */
  #define USART_ISR_RXFF     0x01000000	/* RXFIFO Full Flag */
  #define USART_ISR_TCBGT    0x02000000	/* Transmission Complete Before Guard Time Completion Flag */
  #define USART_ISR_RXFT     0x04000000	/* RXFIFO Threshold Flag */
  #define USART_ISR_TXFT     0x08000000	/* TXFIFO Threshold Flag */
#define TOFF_USART_ICR      0x0020		/* (RW) USART Interrupt flag Clear register */
  #define USART_ICR_PECF     0x00000001	/* Parity Error Clear Flag */
  #define USART_ICR_FECF     0x00000002	/* Framing Error Clear Flag */
  #define USART_ICR_NCF      0x00000004	/* Noise detected Clear Flag */
  #define USART_ICR_ORECF    0x00000008	/* OverRun Error Clear Flag */
  #define USART_ICR_IDLECF   0x00000010	/* IDLE line detected Clear Flag */
  #define USART_ICR_TCCF     0x00000040	/* Transmission Complete Clear Flag */
  #define USART_ICR_TCBGTCF  0x00000080	/* Transmission Complete Before Guard Time Clear Flag */
  #define USART_ICR_LBDCF    0x00000100	/* LIN Break Detection Clear Flag */
  #define USART_ICR_CTSCF    0x00000200	/* CTS Interrupt Clear Flag */
  #define USART_ICR_RTOCF    0x00000800	/* Receiver Time Out Clear Flag */
  #define USART_ICR_EOBCF    0x00001000	/* End Of Block Clear Flag */
  #define USART_ICR_CMCF     0x00020000	/* Character Match Clear Flag */
  #define USART_ICR_WUCF     0x00100000	/* Wake Up from stop mode Clear Flag */
#define TOFF_USART_RDR      0x0024		/* (RW-16) USART Receive Data register */
  #define USART_RDR_RDR      0x01FF		/* RDR[8:0] bits (Receive Data value) */
#define TOFF_USART_TDR      0x0028		/* (RW-16) USART Transmit Data register */
  #define USART_TDR_TDR      0x01FF		/* TDR[8:0] bits (Transmit Data value) */
#define TOFF_USART_PRESC    0x002C		/* USART Prescaler register */
  #define USART_PRESC_PRESCALER   0x0000000F	/* PRESCALER[3:0] bits (Clock prescaler) */
  #define USART_PRESC_PRESCALER_0 0x00000001
  #define USART_PRESC_PRESCALER_1 0x00000002
  #define USART_PRESC_PRESCALER_2 0x00000004
  #define USART_PRESC_PRESCALER_3 0x00000008


/*
 *  INTER-INTERATED CIRCUIT IINTERFACE
 */
#define TADR_I2C1_BASE      (APBPERIPH_BASE + 0x5400)
#define TADR_I2C2_BASE      (APBPERIPH_BASE + 0x5800)
#if BOARDNO == 1
#define TADR_I2C3_BASE      (APBPERIPH_BASE + 0x8800)
#endif
#define TOFF_I2C_CR1        0x0000		/* (RW) I2C Control register 1 */
  #define I2C_CR1_PE         0x00000001	/* Peripheral Enable */
  #define I2C_CR1_TXIE       0x00000002	/* TX interrupt enable */
  #define I2C_CR1_RXIE       0x00000004	/* RX interrupt enable */
  #define I2C_CR1_ADDRIE     0x00000008	/* Address match interrupt enable */
  #define I2C_CR1_NACKIE     0x00000010	/* NACK received interrupt enable */
  #define I2C_CR1_STOPIE     0x00000020	/* STOP detection interrupt enable */
  #define I2C_CR1_TCIE       0x00000040	/* Transfer complete interrupt enable */
  #define I2C_CR1_ERRIE      0x00000080	/* Errors interrupt enable */
  #define I2C_CR1_DNF        0x00000F00	/* Digital noise filter */
  #define I2C_CR1_ANFOFF     0x00001000	/* Analog noise filter OFF */
  #define I2C_CR1_SWRST      0x00002000	/* Software reset */
  #define I2C_CR1_TXDMAEN    0x00004000	/* DMA transmission requests enable */
  #define I2C_CR1_RXDMAEN    0x00008000	/* DMA reception requests enable */
  #define I2C_CR1_SBC        0x00010000	/* Slave byte control */
  #define I2C_CR1_NOSTRETCH  0x00020000	/* Clock stretching disable */
  #define I2C_CR1_WUPEN      0x00040000	/* Wakeup from STOP enable */
  #define I2C_CR1_GCEN       0x00080000	/* General call enable */
  #define I2C_CR1_SMBHEN     0x00100000	/* SMBus host address enable */
  #define I2C_CR1_SMBDEN     0x00200000	/* SMBus device default address enable */
  #define I2C_CR1_ALERTEN    0x00400000	/* SMBus alert enable */
  #define I2C_CR1_PECEN      0x00800000	/* PEC enable */
#define TOFF_I2C_CR2        0x0004		/* (RW) I2C Control register 2 */
  #define I2C_CR2_SADD       0x000003FF	/* Slave address (master mode) */
  #define I2C_CR2_RD_WRN     0x00000400	/* Transfer direction (master mode) */
  #define I2C_CR2_ADD10      0x00000800	/* 10-bit addressing mode (master mode) */
  #define I2C_CR2_HEAD10R    0x00001000	/* 10-bit address header only read direction (master mode) */
  #define I2C_CR2_START      0x00002000	/* START generation */
  #define I2C_CR2_STOP       0x00004000	/* STOP generation (master mode) */
  #define I2C_CR2_NACK       0x00008000	/* NACK generation (slave mode) */
  #define I2C_CR2_NBYTES     0x00FF0000	/* Number of bytes */
  #define I2C_CR2_RELOAD     0x01000000	/* NBYTES reload mode */
  #define I2C_CR2_AUTOEND    0x02000000	/* Automatic end mode (master mode) */
  #define I2C_CR2_PECBYTE    0x04000000	/* Packet error checking byte */
#define TOFF_I2C_OAR1       0x0008		/* (RW) I2C Own address register 1 */
  #define I2C_OAR1_OA1      0x000003FF	/* Interface own address 1 */
  #define I2C_OAR1_OA1MODE  0x00000400	/* Own address 1 10-bit mode */
  #define I2C_OAR1_OA1EN    0x00008000	/* Own address 1 enable */
#define TOFF_I2C_OAR2       0x000C		/* (RW) I2C Own address register 2 */
  #define I2C_OAR2_OA2       0x000000FE	/* Interface own address 2 */
  #define I2C_OAR2_OA2MSK    0x00000700	/* Own address 2 masks */
  #define I2C_OAR2_OA2NOMASK 0x00000000	/* No mask */
  #define I2C_OAR2_OA2MASK01 0x00000100	/* OA2[1] is masked, Only OA2[7:2] are compared */
  #define I2C_OAR2_OA2MASK02 0x00000200	/* OA2[2:1] is masked, Only OA2[7:3] are compared */
  #define I2C_OAR2_OA2MASK03 0x00000300	/* OA2[3:1] is masked, Only OA2[7:4] are compared */
  #define I2C_OAR2_OA2MASK04 0x00000400	/* OA2[4:1] is masked, Only OA2[7:5] are compared */
  #define I2C_OAR2_OA2MASK05 0x00000500	/* OA2[5:1] is masked, Only OA2[7:6] are compared */
  #define I2C_OAR2_OA2MASK06 0x00000600	/* OA2[6:1] is masked, Only OA2[7] are compared */
  #define I2C_OAR2_OA2MASK07 0x00000700	/* OA2[7:1] is masked, No comparison is done */
  #define I2C_OAR2_OA2EN     0x00008000	/* Own address 2 enable */
#define TOFF_I2C_TIMINGR    0x0010		/* (RW) I2C Timing register */
  #define I2C_TIMINGR_SCLL   0x000000FF	/* SCL low period (master mode) */
  #define I2C_TIMINGR_SCLH   0x0000FF00	/* SCL high period (master mode) */
  #define I2C_TIMINGR_SDADEL 0x000F0000	/* Data hold time */
  #define I2C_TIMINGR_SCLDEL 0x00F00000	/* Data setup time */
  #define I2C_TIMINGR_PRESC  0xF0000000	/* Timings prescaler */
#define TOFF_I2C_TIMEOUTR   0x0014		/* (RW) I2C Timeout register */
  #define I2C_TIMEOUTR_TIMEOUTA 0x00000FFF	/* Bus timeout A */
  #define I2C_TIMEOUTR_TIDLE    0x00001000	/* Idle clock timeout detection */
  #define I2C_TIMEOUTR_TIMOUTEN 0x00008000	/* Clock timeout enable */
  #define I2C_TIMEOUTR_TIMEOUTB 0x0FFF0000	/* Bus timeout B*/
  #define I2C_TIMEOUTR_TEXTEN   0x80000000	/* Extended clock timeout enable */
#define TOFF_I2C_ISR        0x0018		/* (RW) I2C Interrupt and status register */
  #define I2C_ISR_TXE        0x00000001	/* Transmit data register empty */
  #define I2C_ISR_TXIS       0x00000002	/* Transmit interrupt status */
  #define I2C_ISR_RXNE       0x00000004	/* Receive data register not empty */
  #define I2C_ISR_ADDR       0x00000008	/* Address matched (slave mode)*/
  #define I2C_ISR_NACKF      0x00000010	/* NACK received flag */
  #define I2C_ISR_STOPF      0x00000020	/* STOP detection flag */
  #define I2C_ISR_TC         0x00000040	/* Transfer complete (master mode) */
  #define I2C_ISR_TCR        0x00000080	/* Transfer complete reload */
  #define I2C_ISR_BERR       0x00000100	/* Bus error */
  #define I2C_ISR_ARLO       0x00000200	/* Arbitration lost */
  #define I2C_ISR_OVR        0x00000400	/* Overrun/Underrun */
  #define I2C_ISR_PECERR     0x00000800	/* PEC error in reception */
  #define I2C_ISR_TIMEOUT    0x00001000	/* Timeout or Tlow detection flag */
  #define I2C_ISR_ALERT      0x00002000	/* SMBus alert */
  #define I2C_ISR_BUSY       0x00008000	/* Bus busy */
  #define I2C_ISR_DIR        0x00010000	/* Transfer direction (slave mode) */
  #define I2C_ISR_ADDCODE    0x00FE0000	/* Address match code (slave mode) */
#define TOFF_I2C_ICR        0x001C		/* (RW) I2C Interrupt clear register */
  #define I2C_ICR_ADDRCF     0x00000008	/* Address matched clear flag */
  #define I2C_ICR_NACKCF     0x00000010	/* NACK clear flag */
  #define I2C_ICR_STOPCF     0x00000020	/* STOP detection clear flag */
  #define I2C_ICR_BERRCF     0x00000100	/* Bus error clear flag */
  #define I2C_ICR_ARLOCF     0x00000200	/* Arbitration lost clear flag */
  #define I2C_ICR_OVRCF      0x00000400	/* Overrun/Underrun clear flag */
  #define I2C_ICR_PECCF      0x00000800	/* PAC error clear flag */
  #define I2C_ICR_TIMOUTCF   0x00001000	/* Timeout clear flag */
  #define I2C_ICR_ALERTCF    0x00002000	/* Alert clear flag */
#define TOFF_I2C_PECR       0x0020		/* (RW) I2C PEC register */
  #define I2C_PECR_PEC       0x000000FF	/* PEC register */
#define TOFF_I2C_RXDR       0x0024		/* (RW) I2C Receive data register */
  #define I2C_RXDR_RXDATA    0x000000FF	/* 8-bit receive data */
#define TOFF_I2C_TXDR       0x0028		/* (RW) I2C Transmit data register */
  #define I2C_TXDR_TXDATA    0x000000FF	/* 8-bit transmit data */

/*
 *  POWER CONTROL
 */
#define TADR_PWR_BASE       (APBPERIPH_BASE + 0x7000)
#define TOFF_PWR_CR1        0x0000		/* (RW) PWR Power Control Register 1 */
  #define PWR_CR1_LPMS       0x00000007	/* Low Power Mode Selection */
  #define PWR_CR1_LPMS_0     0x00000001
  #define PWR_CR1_LPMS_1     0x00000002
  #define PWR_CR1_LPMS_2     0x00000004
  #define PWR_CR1_FPD_STOP   0x00000008	/* Flash power down mode during stop */
  #define PWR_CR1_FPD_LPRUN  0x00000010	/* Flash power down mode during run */
  #define PWR_CR1_FPD_LPSLP  0x00000020	/* Flash power down mode during sleep */
  #define PWR_CR1_DBP        0x00000100	/* Disable Backup Domain write protection */
  #define PWR_CR1_VOS        0x00000600	/* Voltage scaling */
  #define PWR_CR1_VOS_0      0x00000200	/* Voltage scaling bit 0 */
  #define PWR_CR1_VOS_1      0x00000400	/* Voltage scaling bit 1 */
  #define PWR_CR1_LPR        0x00004000	/* Regulator Low-Power Run mode */
#define TOFF_PWR_CR2        0x0004		/* (RW) PWR Power Control Register 2 */
  #define PWR_CR2_PVDE       0x00000001	/* Programmable Voltage Detector Enable */
  #define PWR_CR2_PVDFT      0x0000000E	/* PVD Falling Threshold Selection bit field */
  #define PWR_CR2_PVDFT_0    0x00000002
  #define PWR_CR2_PVDFT_1    0x00000004
  #define PWR_CR2_PVDFT_2    0x00000008
  #define PWR_CR2_PVDRT      0x00000070	/* PVD Rising Threshold Selection bit field */
  #define PWR_CR2_PVDRT_0    0x00000010
  #define PWR_CR2_PVDRT_1    0x00000020
  #define PWR_CR2_PVDRT_2    0x00000040
#define TOFF_PWR_CR3        0x0008		/* (RW) PWR Power Control Register 3 */
  #define PWR_CR3_EWUP       0x0000003B	/* Enable all Wake-Up Pins  */
  #define PWR_CR3_EWUP1      0x00000001	/* Enable WKUP pin 1 */
  #define PWR_CR3_EWUP2      0x00000002	/* Enable WKUP pin 2 */
  #define PWR_CR3_EWUP4      0x00000008	/* Enable WKUP pin 4 */
  #define PWR_CR3_EWUP5      0x00000010	/* Enable WKUP pin 5 */
  #define PWR_CR3_EWUP6      0x00000020	/* Enable WKUP pin 6 */
  #define PWR_CR3_RRS        0x00000100	/* RAM retention in Standby mode */
  #define PWR_CR3_ENB_ULP    0x00000200	/* Enable sampling resistor bridge in the LPMU_RESET block */
  #define PWR_CR3_APC        0x00000400	/* Apply pull-up and pull-down configuration */
  #define PWR_CR3_EIWUL      0x00008000	/* Enable Internal Wake-up line */
#define TOFF_PWR_CR4        0x000C		/* (RW) PWR Power Control Register 4 */
  #define PWR_CR4_WP         0x0000003B	/* all Wake-Up Pin polarity */
  #define PWR_CR4_WP1        0x00000001	/* Wake-Up Pin 1 polarity */
  #define PWR_CR4_WP2        0x00000002	/* Wake-Up Pin 2 polarity */
  #define PWR_CR4_WP4        0x00000008	/* Wake-Up Pin 4 polarity */
  #define PWR_CR4_WP5        0x00000010	/* Wake-Up Pin 5 polarity */
  #define PWR_CR4_WP6        0x00000020	/* Wake-Up Pin 6 polarity */
  #define PWR_CR4_VBE        0x00000100	/* VBAT Battery charging Enable  */
  #define PWR_CR4_VBRS       0x00000200	/* VBAT Battery charging Resistor Selection */
#define TOFF_PWR_SR1        0x0010		/* (RW) PWR Power Status Register 1 */
  #define PWR_SR1_WUF        0x0000003B	/* Wakeup Flags  */
  #define PWR_SR1_WUF1       0x00000001	/* Wakeup Flag 1 */
  #define PWR_SR1_WUF2       0x00000002	/* Wakeup Flag 2 */
  #define PWR_SR1_WUF4       0x00000008	/* Wakeup Flag 4 */
  #define PWR_SR1_WUF5       0x00000010	/* Wakeup Flag 5 */
  #define PWR_SR1_WUF6       0x00000020	/* Wakeup Flag 6 */
  #define PWR_SR1_SBF        0x00000100	/* Standby Flag  */
  #define PWR_SR1_WUFI       0x00008000	/* Wakeup Flag Internal */
#define TOFF_PWR_SR2        0x0014		/* (RW) PWR Power Status Register 2 */
  #define PWR_SR2_FLASH_RDY  0x00000080	/* Flash Ready */
  #define PWR_SR2_REGLPS     0x00000100	/* Regulator Low Power started */
  #define PWR_SR2_REGLPF     0x00000200	/* Regulator Low Power flag    */
  #define PWR_SR2_VOSF       0x00000400	/* Voltage Scaling Flag */
  #define PWR_SR2_PVDO       0x00000800	/* Power voltage detector output */
#define TOFF_PWR_SCR        0x0018		/* (RW) PWR Power Status Clear Register */
  #define PWR_SCR_CWUF       0x0000003B	/* Clear Wake-up Flags  */
  #define PWR_SCR_CWUF1      0x00000001	/* Clear Wake-up Flag 1 */
  #define PWR_SCR_CWUF2      0x00000002	/* Clear Wake-up Flag 2 */
  #define PWR_SCR_CWUF4      0x00000008	/* Clear Wake-up Flag 4 */
  #define PWR_SCR_CWUF5      0x00000010	/* Clear Wake-up Flag 5 */
  #define PWR_SCR_CWUF6      0x00000020	/* Clear Wake-up Flag 6 */
  #define PWR_SCR_CSBF       0x00000100	/* Clear Standby Flag  */
#define TOFF_PWR_PUCRA      0x0020		/* (RW) PWR Pull-Up Control Register of port A */
  #define PWR_PUCRA_PU0      0x00000001	/* Pin PA0 Pull-Up set */
  #define PWR_PUCRA_PU1      0x00000002	/* Pin PA1 Pull-Up set */
  #define PWR_PUCRA_PU2      0x00000004	/* Pin PA2 Pull-Up set */
  #define PWR_PUCRA_PU3      0x00000008	/* Pin PA3 Pull-Up set */
  #define PWR_PUCRA_PU4      0x00000010	/* Pin PA4 Pull-Up set */
  #define PWR_PUCRA_PU5      0x00000020	/* Pin PA5 Pull-Up set */
  #define PWR_PUCRA_PU6      0x00000040	/* Pin PA6 Pull-Up set */
  #define PWR_PUCRA_PU7      0x00000080	/* Pin PA7 Pull-Up set */
  #define PWR_PUCRA_PU8      0x00000100	/* Pin PA8 Pull-Up set */
  #define PWR_PUCRA_PU9      0x00000200	/* Pin PA9 Pull-Up set */
  #define PWR_PUCRA_PU10     0x00000400	/* Pin PA10 Pull-Up set */
  #define PWR_PUCRA_PU11     0x00000800	/* Pin PA11 Pull-Up set */
  #define PWR_PUCRA_PU12     0x00001000	/* Pin PA12 Pull-Up set */
  #define PWR_PUCRA_PU13     0x00002000	/* Pin PA13 Pull-Up set */
  #define PWR_PUCRA_PU14     0x00004000	/* Pin PA14 Pull-Up set */
  #define PWR_PUCRA_PU15     0x00008000	/* Pin PA15 Pull-Up set */
#define TOFF_PWR_PDCRA      0x0024		/* (RW) PWR Pull-Down Control Register of port A */
  #define PWR_PDCRA_PD0      0x00000001	/* Pin PA0 Pull-Down set */
  #define PWR_PDCRA_PD1      0x00000002	/* Pin PA1 Pull-Down set */
  #define PWR_PDCRA_PD2      0x00000004	/* Pin PA2 Pull-Down set */
  #define PWR_PDCRA_PD3      0x00000008	/* Pin PA3 Pull-Down set */
  #define PWR_PDCRA_PD4      0x00000010	/* Pin PA4 Pull-Down set */
  #define PWR_PDCRA_PD5      0x00000020	/* Pin PA5 Pull-Down set */
  #define PWR_PDCRA_PD6      0x00000040	/* Pin PA6 Pull-Down set */
  #define PWR_PDCRA_PD7      0x00000080	/* Pin PA7 Pull-Down set */
  #define PWR_PDCRA_PD8      0x00000100	/* Pin PA8 Pull-Down set */
  #define PWR_PDCRA_PD9      0x00000200	/* Pin PA9 Pull-Down set */
  #define PWR_PDCRA_PD10     0x00000400	/* Pin PA10 Pull-Down set */
  #define PWR_PDCRA_PD11     0x00000800	/* Pin PA11 Pull-Down set */
  #define PWR_PDCRA_PD12     0x00001000	/* Pin PA12 Pull-Down set */
  #define PWR_PDCRA_PD13     0x00002000	/* Pin PA13 Pull-Down set */
  #define PWR_PDCRA_PD14     0x00004000	/* Pin PA14 Pull-Down set */
  #define PWR_PDCRA_PD15     0x00008000	/* Pin PA15 Pull-Down set */
#define TOFF_PWR_PUCRB      0x0028		/* (RW) PWR Pull-Up Control Register of port B */
  #define PWR_PUCRB_PU0      0x00000001	/* Pin PB0 Pull-Up set */
  #define PWR_PUCRB_PU1      0x00000002	/* Pin PB1 Pull-Up set */
  #define PWR_PUCRB_PU2      0x00000004	/* Pin PB2 Pull-Up set */
  #define PWR_PUCRB_PU3      0x00000008	/* Pin PB3 Pull-Up set */
  #define PWR_PUCRB_PU4      0x00000010	/* Pin PB4 Pull-Up set */
  #define PWR_PUCRB_PU5      0x00000020	/* Pin PB5 Pull-Up set */
  #define PWR_PUCRB_PU6      0x00000040	/* Pin PB6 Pull-Up set */
  #define PWR_PUCRB_PU7      0x00000080	/* Pin PB7 Pull-Up set */
  #define PWR_PUCRB_PU8      0x00000100	/* Pin PB8 Pull-Up set */
  #define PWR_PUCRB_PU9      0x00000200	/* Pin PB9 Pull-Up set */
  #define PWR_PUCRB_PU10     0x00000400	/* Pin PB10 Pull-Up set */
  #define PWR_PUCRB_PU11     0x00000800	/* Pin PB11 Pull-Up set */
  #define PWR_PUCRB_PU12     0x00001000	/* Pin PB12 Pull-Up set */
  #define PWR_PUCRB_PU13     0x00002000	/* Pin PB13 Pull-Up set */
  #define PWR_PUCRB_PU14     0x00004000	/* Pin PB14 Pull-Up set */
  #define PWR_PUCRB_PU15     0x00008000	/* Pin PB15 Pull-Up set */
#define TOFF_PWR_PDCRB      0x002C		/* (RW) PWR Pull-Down Control Register of port B */
  #define PWR_PDCRB_PD0      0x00000001	/* Pin PB0 Pull-Down set */
  #define PWR_PDCRB_PD1      0x00000002	/* Pin PB1 Pull-Down set */
  #define PWR_PDCRB_PD2      0x00000004	/* Pin PB2 Pull-Down set */
  #define PWR_PDCRB_PD3      0x00000008	/* Pin PB3 Pull-Down set */
  #define PWR_PDCRB_PD4      0x00000010	/* Pin PB4 Pull-Down set */
  #define PWR_PDCRB_PD5      0x00000020	/* Pin PB5 Pull-Down set */
  #define PWR_PDCRB_PD6      0x00000040	/* Pin PB6 Pull-Down set */
  #define PWR_PDCRB_PD7      0x00000080	/* Pin PB7 Pull-Down set */
  #define PWR_PDCRB_PD8      0x00000100	/* Pin PB8 Pull-Down set */
  #define PWR_PDCRB_PD9      0x00000200	/* Pin PB9 Pull-Down set */
  #define PWR_PDCRB_PD10     0x00000400	/* Pin PB10 Pull-Down set */
  #define PWR_PDCRB_PD11     0x00000800	/* Pin PB11 Pull-Down set */
  #define PWR_PDCRB_PD12     0x00001000	/* Pin PB12 Pull-Down set */
  #define PWR_PDCRB_PD13     0x00002000	/* Pin PB13 Pull-Down set */
  #define PWR_PDCRB_PD14     0x00004000	/* Pin PB14 Pull-Down set */
  #define PWR_PDCRB_PD15     0x00008000	/* Pin PB15 Pull-Down set */
#define TOFF_PWR_PUCRC      0x0030		/* (RW) PWR Pull-Up Control Register of port C */
  #define PWR_PUCRC_PU0      0x00000001	/* Pin PC0 Pull-Up set */
  #define PWR_PUCRC_PU1      0x00000002	/* Pin PC1 Pull-Up set */
  #define PWR_PUCRC_PU2      0x00000004	/* Pin PC2 Pull-Up set */
  #define PWR_PUCRC_PU3      0x00000008	/* Pin PC3 Pull-Up set */
  #define PWR_PUCRC_PU4      0x00000010	/* Pin PC4 Pull-Up set */
  #define PWR_PUCRC_PU5      0x00000020	/* Pin PC5 Pull-Up set */
  #define PWR_PUCRC_PU6      0x00000040	/* Pin PC6 Pull-Up set */
  #define PWR_PUCRC_PU7      0x00000080	/* Pin PC7 Pull-Up set */
  #define PWR_PUCRC_PU8      0x00000100	/* Pin PC8 Pull-Up set */
  #define PWR_PUCRC_PU9      0x00000200	/* Pin PC9 Pull-Up set */
  #define PWR_PUCRC_PU10     0x00000400	/* Pin PC10 Pull-Up set */
  #define PWR_PUCRC_PU11     0x00000800	/* Pin PC11 Pull-Up set */
  #define PWR_PUCRC_PU12     0x00001000	/* Pin PC12 Pull-Up set */
  #define PWR_PUCRC_PU13     0x00002000	/* Pin PC13 Pull-Up set */
  #define PWR_PUCRC_PU14     0x00004000	/* Pin PC14 Pull-Up set */
  #define PWR_PUCRC_PU15     0x00008000	/* Pin PC15 Pull-Up set */
#define TOFF_PWR_PDCRC      0x0034		/* (RW) PWR Pull-Down Control Register of port C */
  #define PWR_PDCRC_PD0      0x00000001	/* Pin PC0 Pull-Down set */
  #define PWR_PDCRC_PD1      0x00000002	/* Pin PC1 Pull-Down set */
  #define PWR_PDCRC_PD2      0x00000004	/* Pin PC2 Pull-Down set */
  #define PWR_PDCRC_PD3      0x00000008	/* Pin PC3 Pull-Down set */
  #define PWR_PDCRC_PD4      0x00000010	/* Pin PC4 Pull-Down set */
  #define PWR_PDCRC_PD5      0x00000020	/* Pin PC5 Pull-Down set */
  #define PWR_PDCRC_PD6      0x00000040	/* Pin PC6 Pull-Down set */
  #define PWR_PDCRC_PD7      0x00000080	/* Pin PC7 Pull-Down set */
  #define PWR_PDCRC_PD8      0x00000100	/* Pin PC8 Pull-Down set */
  #define PWR_PDCRC_PD9      0x00000200	/* Pin PC9 Pull-Down set */
  #define PWR_PDCRC_PD10     0x00000400	/* Pin PC10 Pull-Down set */
  #define PWR_PDCRC_PD11     0x00000800	/* Pin PC11 Pull-Down set */
  #define PWR_PDCRC_PD12     0x00001000	/* Pin PC12 Pull-Down set */
  #define PWR_PDCRC_PD13     0x00002000	/* Pin PC13 Pull-Down set */
  #define PWR_PDCRC_PD14     0x00004000	/* Pin PC14 Pull-Down set */
  #define PWR_PDCRC_PD15     0x00008000	/* Pin PC15 Pull-Down set */
#define TOFF_PWR_PUCRD      0x0038		/* (RW) PWR Pull-Up Control Register of port D */
  #define PWR_PUCRD_PU0      0x00000001	/* Pin PD0 Pull-Up set */
  #define PWR_PUCRD_PU1      0x00000002	/* Pin PD1 Pull-Up set */
  #define PWR_PUCRD_PU2      0x00000004	/* Pin PD2 Pull-Up set */
  #define PWR_PUCRD_PU3      0x00000008	/* Pin PD3 Pull-Up set */
  #define PWR_PUCRD_PU4      0x00000010	/* Pin PD4 Pull-Up set */
  #define PWR_PUCRD_PU5      0x00000020	/* Pin PD5 Pull-Up set */
  #define PWR_PUCRD_PU6      0x00000040	/* Pin PD6 Pull-Up set */
  #define PWR_PUCRD_PU7      0x00000080	/* Pin PD7 Pull-Up set */
  #define PWR_PUCRD_PU8      0x00000100	/* Pin PD8 Pull-Up set */
  #define PWR_PUCRD_PU9      0x00000200	/* Pin PD9 Pull-Up set */
  #define PWR_PUCRD_PU10     0x00000400	/* Pin PD10 Pull-Up set */
  #define PWR_PUCRD_PU11     0x00000800	/* Pin PD11 Pull-Up set */
  #define PWR_PUCRD_PU12     0x00001000	/* Pin PD12 Pull-Up set */
  #define PWR_PUCRD_PU13     0x00002000	/* Pin PD13 Pull-Up set */
  #define PWR_PUCRD_PU14     0x00004000	/* Pin PD14 Pull-Up set */
  #define PWR_PUCRD_PU15     0x00008000	/* Pin PD15 Pull-Up set */
#define TOFF_PWR_PDCRD      0x003C		/* (RW) PWR Pull-Down Control Register of port D */
  #define PWR_PDCRD_PD0      0x00000001	/* Pin PD0 Pull-Down set */
  #define PWR_PDCRD_PD1      0x00000002	/* Pin PD1 Pull-Down set */
  #define PWR_PDCRD_PD2      0x00000004	/* Pin PD2 Pull-Down set */
  #define PWR_PDCRD_PD3      0x00000008	/* Pin PD3 Pull-Down set */
  #define PWR_PDCRD_PD4      0x00000010	/* Pin PD4 Pull-Down set */
  #define PWR_PDCRD_PD5      0x00000020	/* Pin PD5 Pull-Down set */
  #define PWR_PDCRD_PD6      0x00000040	/* Pin PD6 Pull-Down set */
  #define PWR_PDCRD_PD7      0x00000080	/* Pin PD7 Pull-Down set */
  #define PWR_PDCRD_PD8      0x00000100	/* Pin PD8 Pull-Down set */
  #define PWR_PDCRD_PD9      0x00000200	/* Pin PD9 Pull-Down set */
  #define PWR_PDCRD_PD10     0x00000400	/* Pin PD10 Pull-Down set */
  #define PWR_PDCRD_PD11     0x00000800	/* Pin PD11 Pull-Down set */
  #define PWR_PDCRD_PD12     0x00001000	/* Pin PD12 Pull-Down set */
  #define PWR_PDCRD_PD13     0x00002000	/* Pin PD13 Pull-Down set */
  #define PWR_PDCRD_PD14     0x00004000	/* Pin PD14 Pull-Down set */
  #define PWR_PDCRD_PD15     0x00008000	/* Pin PD15 Pull-Down set */
#define TOFF_PWR_PUCRF      0x0048		/* (RW) PWR Pull-Up Control Register of port F */
  #define PWR_PUCRF_PU0      0x00000001	/* Pin PF0 Pull-Up set */
  #define PWR_PUCRF_PU1      0x00000002	/* Pin PF1 Pull-Up set */
  #define PWR_PUCRF_PU2      0x00000004	/* Pin PF2 Pull-Up set */
  #define PWR_PUCRF_PU3      0x00000008	/* Pin PF3 Pull-Up set */
  #define PWR_PUCRF_PU4      0x00000010	/* Pin PF4 Pull-Up set */
#define TOFF_PWR_PDCRF      0x004C		/* (RW) PWR Pull-Down Control Register of port F */
  #define PWR_PDCRF_PD0      0x00000001	/* Pin PF0 Pull-Down set */
  #define PWR_PDCRF_PD1      0x00000002	/* Pin PF1 Pull-Down set */
  #define PWR_PDCRF_PD2      0x00000004	/* Pin PF2 Pull-Down set */
  #define PWR_PDCRF_PD3      0x00000008	/* Pin PF3 Pull-Down set */
  #define PWR_PDCRF_PD4      0x00000010	/* Pin PF4 Pull-Down set */


#if BOARDNO == 1
/*
 *  USB FULL SPEED DUAL ROLE DEVICE
 */
#define TADR_USB_BASE       (APBPERIPH_BASE + 0x5C00)	/* USB_IP Peripheral Registers base address */
#define TADR_USB_PMAADDR    (APBPERIPH_BASE + 0x9800)	/* USB_IP Packet Memory Area base address */
#define TOFF_USB_CHEP0R     0x0000	/* (RW) USB Channel/Endpoint 0 register */
#define TOFF_USB_CHEP1R     0x0004	/* (RW) USB Channel/Endpoint 1 register */
#define TOFF_USB_CHEP2R     0x0008	/* (RW) USB Channel/Endpoint 2 register */
#define TOFF_USB_CHEP3R     0x000C	/* (RW) USB Channel/Endpoint 3 register */
#define TOFF_USB_CHEP4R     0x0010	/* (RW) USB Channel/Endpoint 4 register */
#define TOFF_USB_CHEP5R     0x0014	/* (RW) USB Channel/Endpoint 5 register */
#define TOFF_USB_CHEP6R     0x0018	/* (RW) USB Channel/Endpoint 6 register */
#define TOFF_USB_CHEP7R     0x001C	/* (RW) USB Channel/Endpoint 7 register */
#define TOFF_USB_EP0R       TOFF_USB_CHEP0R
#define TOFF_USB_EP1R       TOFF_USB_CHEP1R
#define TOFF_USB_EP2R       TOFF_USB_CHEP2R
#define TOFF_USB_EP3R       TOFF_USB_CHEP3R
#define TOFF_USB_EP4R       TOFF_USB_CHEP4R
#define TOFF_USB_EP5R       TOFF_USB_CHEP5R
#define TOFF_USB_EP6R       TOFF_USB_CHEP6R
#define TOFF_USB_EP7R       TOFF_USB_CHEP7R
#define TOFF_USB_CNTR       0x0040	/* (RW) Control register */
  #define USB_CNTR_USBRST    0x00000001	/* USB Reset Mask */
  #define USB_CNTR_FRES      USB_CNTR_USBRST
  #define USB_CNTR_PDWN      0x00000002	/* Power DoWN Mask */
  #define USB_CNTR_SUSPRDY   0x00000004	/* Suspend state effective Mask */
  #define USB_CNTR_LPMODE    USB_CNTR_SUSPRDY
  #define USB_CNTR_SUSPEN    0x00000008	/* Suspend state enable Mask */
  #define USB_CNTR_FSUSP     USB_CNTR_SUSPEN
  #define USB_CNTR_L2RES     0x00000010	/* L2 Remote Wakeup / Resume driver Mask */
  #define USB_CNTR_RESUME    USB_CNTR_L2RES
  #define USB_CNTR_L1RES     0x00000020	/* LPM L1 Resume request/ Remote Wakeup Mask */
  #define USB_CNTR_L1RESUME  USB_CNTR_L1RES
  #define USB_CNTR_L1XACT    0x00000040	/* Host LPM L1 transaction request Mask */
  #define USB_CNTR_L1REQM    0x00000080	/* LPM L1 state request interrupt Mask */
  #define USB_CNTR_ESOFM     0x00000100	/* Expected Start Of Frame Mask */
  #define USB_CNTR_SOFM      0x00000200	/* Start Of Frame Mask */
  #define USB_CNTR_RESETM    0x00000400	/* RESET Mask */
  #define USB_CNTR_DCON      USB_CNTR_RESETM
  #define USB_CNTR_SUSPM     0x00000800	/* SUSPend Mask */
  #define USB_CNTR_WKUPM     0x00001000	/* WaKe UP Mask */
  #define USB_CNTR_ERRM      0x00002000	/* ERRor Mask */
  #define USB_CNTR_PMAOVRM   0x00004000	/* DMA OVeR/underrun Mask */
  #define USB_CNTR_CTRM      0x00008000	/* Correct Transfer Mask */
  #define USB_CNTR_THR512M   0x00010000	/* 512byte Threshold interrupt mask */
  #define USB_CNTR_HOST      0x80000000	/* Host Mode  */
#define TOFF_USB_ISTR       0x0044	/* (RW) Interrupt status register */
  #define USB_ISTR_IDN       0x0000000F	/* EndPoint IDentifier (read-only bit) Mask */
  #define USB_ISTR_EP_ID     USB_ISTR_IDN
  #define USB_ISTR_DIR       0x00000010	/* DIRection of transaction (read-only bit) Mask */
  #define USB_ISTR_L1REQ     0x00000080	/* LPM L1 state request Mask */
  #define USB_ISTR_ESOF      0x00000100	/* Expected Start Of Frame (clear-only bit) Mask */
  #define USB_ISTR_SOF       0x00000200	/* Start Of Frame (clear-only bit) Mask */
  #define USB_ISTR_RESET     0x00000400	/* RESET Mask */
  #define USB_ISTR_DCON      0x00000400	/* HOST MODE-Device Connection or disconnection Mask */
  #define USB_ISTR_SUSP      0x00000800	/* SUSPend (clear-only bit) Mask */
  #define USB_ISTR_WKUP      0x00001000	/* WaKe UP (clear-only bit) Mask */
  #define USB_ISTR_ERR       0x00002000	/* ERRor (clear-only bit) Mask */
  #define USB_ISTR_PMAOVR    0x00004000	/* PMA OVeR/underrun (clear-only bit) Mask */
  #define USB_ISTR_CTR       0x00008000	/* Correct TRansfer (clear-only bit) Mask */
  #define USB_ISTR_THR512    0x00010000	/* 512byte threshold interrupt (used with isochrnous single buffer ) */
  #define USB_ISTR_DCON_STAT 0x20000000	/* Device Connection status (connected/Disconnected) don't cause an interrupt */
  #define USB_ISTR_LS_DCONN  0x40000000	/* LS_DCONN Mask */

  #define USB_CLR_L1REQ      (~USB_ISTR_L1REQ)	/* clear LPM L1  bit */
  #define USB_CLR_ESOF       (~USB_ISTR_ESOF)	/* clear Expected Start Of Frame bit */
  #define USB_CLR_SOF        (~USB_ISTR_SOF)	/* clear Start Of Frame bit */
  #define USB_CLR_RESET      (~USB_ISTR_RESET)	/* clear RESET bit */
  #define USB_CLR_SUSP       (~USB_ISTR_SUSP)	/* clear SUSPend bit */
  #define USB_CLR_WKUP       (~USB_ISTR_WKUP)	/* clear WaKe UP bit */
  #define USB_CLR_ERR        (~USB_ISTR_ERR)	/* clear ERRor bit */
  #define USB_CLR_PMAOVR     (~USB_ISTR_PMAOVR)	/* clear DMA OVeR/underrun bit*/
  #define USB_CLR_CTR        (~USB_ISTR_CTR)	/* clear Correct TRansfer bit */
#define TOFF_USB_FNR        0x0048	/* (RW) Frame number register */
  #define USB_FNR_FN         0x000007FF	/* Frame Number Mask */
  #define USB_FNR_LSOF       0x00001800	/* Lost SOF  Mask */
  #define USB_FNR_LCK        0x00002000	/* LoCKed Mask */
  #define USB_FNR_RXDM       0x00004000	/* status of D- data line Mask */
  #define USB_FNR_RXDP       0x00008000	/* status of D+ data line Mask */
#define TOFF_USB_DADDR      0x004C	/* (RW) Device address register */
  #define USB_DADDR_ADD      0x0000007F	/*  ADD[6:0] bits (Device Address)Mask */
  #define USB_DADDR_ADD0     0x00000001	/* Bit 0 Mask */
  #define USB_DADDR_ADD1     0x00000002	/* Bit 1 Mask */
  #define USB_DADDR_ADD2     0x00000004	/* Bit 2 Mask */
  #define USB_DADDR_ADD3     0x00000008	/* Bit 3 Mask */
  #define USB_DADDR_ADD4     0x00000010	/* Bit 4 Mask */
  #define USB_DADDR_ADD5     0x00000020	/* Bit 5 Mask */
  #define USB_DADDR_ADD6     0x00000040	/* Bit 6 Mask */
  #define USB_DADDR_EF       0x00000080	/* Enable Function Mask */
#define TOFF_USB_BTABLE     0x0050	/* (RW) Buffer Table address register */
#define TOFF_USB_LPMCSR     0x0054	/* (RW) LPM Control and Status register */
  #define USB_LPMCSR_LMPEN   0x00000001	/* LPM support enable Mask */
  #define USB_LPMCSR_LPMACK  0x00000002	/* LPM Token acknowledge enable Mask */
  #define USB_LPMCSR_REMWAKE 0x00000008	/* bRemoteWake value received with last ACKed LPM Token Mask */
  #define USB_LPMCSR_BESL    0x000000F0	/* BESL value received with last ACKed LPM Token Mask */
#define TOFF_USB_BCDR       0x0058	/* (RW) Battery Charging detector register */
  #define USB_BCDR_BCDEN     0x00000001	/* Battery charging detector (BCD) enable Mask */
  #define USB_BCDR_DCDEN     0x00000002	/* Data contact detection (DCD) mode enable Mask */
  #define USB_BCDR_PDEN      0x00000004	/* Primary detection (PD) mode enable Mask */
  #define USB_BCDR_SDEN      0x00000008	/* Secondary detection (SD) mode enable Mask */
  #define USB_BCDR_DCDET     0x00000010	/* Data contact detection (DCD) status Mask */
  #define USB_BCDR_PDET      0x00000020	/* Primary detection (PD) status Mask */
  #define USB_BCDR_SDET      0x00000040	/* Secondary detection (SD) status Mask */
  #define USB_BCDR_PS2DET    0x00000080	/* PS2 port or proprietary charger detected Mask */
  #define USB_BCDR_DPPU      0x00008000	/* DP Pull-up Enable Mask */
  #define USB_BCDR_DPPD      0x00008000	/* DP Pull-Down Enable Mask */

#define TOFF_USB_PMAA_TXBDR 0x0000	/* Transmission buffer address offset */
#define TOFF_USB_PMAA_RXBDR 0x0004	/* Reception buffer address offset */
#define USB_PMA_TX_ADDRMSK   0x0000FFFFUL
#define USB_PMA_TX_COUNTMSK  0xFFFF0000UL
#define USB_PMA_RX_ADDRMSK   0x0000FFFFUL
#define USB_PMA_RX_COUNTMSK  0xFFFF0000UL


/*
 *  FD CONTROLLER AREA NETWORK
 */
#define TADR_FDCAN_CONFIG_BASE  (APBPERIPH_BASE + 0x6500)  /* FDCAN configuration registers base address */
#define TOFF_FDCAN_CONDIG_CKDIV 0x0000	/* FDCAN clock divider register */
  #define FDCAN_CKDIV_PDIV        0x0000000F	/* Input Clock Divider */

#define TADR_FDCAN1_BASE    (APBPERIPH_BASE + 0x6400)
#define TADR_FDCAN2_BASE    (APBPERIPH_BASE + 0x6800)
#define TOFF_FDCAN_CREL     0x0000		/* (RW) FDCAN Core Release register */
  #define FDCAN_CREL_DAY      0x000000FF	/* Timestamp Day */
  #define FDCAN_CREL_MON      0x0000FF00	/* Timestamp Month */
  #define FDCAN_CREL_YEAR     0x000F0000	/* Timestamp Year */
  #define FDCAN_CREL_SUBSTEP  0x00F00000	/* Sub-step of Core release */
  #define FDCAN_CREL_STEP     0x0F000000	/* Step of Core release */
  #define FDCAN_CREL_REL      0xF0000000	/* Core release */
#define TOFF_FDCAN_ENDN     0x0004		/* (RW) FDCAN Endian register */
#define TOFF_FDCAN_DBTP     0x000C		/* (RW) FDCAN Data Bit Timing & Prescaler register */
  #define FDCAN_DBTP_DSJW     0x0000000F	/* Synchronization Jump Width */
  #define FDCAN_DBTP_DTSEG2   0x000000F0	/* Data time segment after sample point */
  #define FDCAN_DBTP_DTSEG1   0x00001F00	/* Data time segment before sample point   */
  #define FDCAN_DBTP_DBRP     0x001F0000	/* Data BIt Rate Prescaler */
  #define FDCAN_DBTP_TDC      0x00800000	/* Transceiver Delay Compensation */
#define TOFF_FDCAN_TEST     0x0010		/* (RW) FDCAN Test register */
  #define FDCAN_TEST_LBCK     0x00000010	/* Loop Back mode */
  #define FDCAN_TEST_TX       0x00000060	/* Control of Transmit Pin */
  #define FDCAN_TEST_RX       0x00000080	/* Receive Pin */
#define TOFF_FDCAN_RWD      0x0014		/* (RW) FDCAN RAM Watchdog register */
  #define FDCAN_RWD_WDC       0x000000FF	/* Watchdog configuration */
  #define FDCAN_RWD_WDV       0x0000FF00	/* Watchdog value */
#define TOFF_FDCAN_CCCR     0x0018		/* (RW) FDCAN CC Control register */
  #define FDCAN_CCCR_INIT     0x00000001	/* Initialization */
  #define FDCAN_CCCR_CCE      0x00000002	/* Configuration Change Enable */
  #define FDCAN_CCCR_ASM      0x00000004	/* ASM Restricted Operation Mode */
  #define FDCAN_CCCR_CSA      0x00000008	/* Clock Stop Acknowledge */
  #define FDCAN_CCCR_CSR      0x00000010	/* Clock Stop Request */
  #define FDCAN_CCCR_MON      0x00000020	/* Bus Monitoring Mode */
  #define FDCAN_CCCR_DAR      0x00000040	/* Disable Automatic Retransmission */
  #define FDCAN_CCCR_TEST     0x00000080	/* Test Mode Enable */
  #define FDCAN_CCCR_FDOE     0x00000100	/* FD Operation Enable */
  #define FDCAN_CCCR_BRSE     0x00000200	/* FDCAN Bit Rate Switching */
  #define FDCAN_CCCR_PXHD     0x00001000	/* Protocol Exception Handling Disable */
  #define FDCAN_CCCR_EFBI     0x00002000	/* Edge Filtering during Bus Integration */
  #define FDCAN_CCCR_TXP      0x00004000	/* Two CAN bit times Pause */
  #define FDCAN_CCCR_NISO     0x00008000	/* Non ISO Operation */
#define TOFF_FDCAN_NBTP     0x001C		/* (RW) FDCAN Nominal Bit Timing & Prescaler register */
  #define FDCAN_NBTP_NTSEG2   0x0000007F	/* Nominal Time segment after sample point  */
  #define FDCAN_NBTP_NTSEG1   0x0000FF00	/* Nominal Time segment before sample point */
  #define FDCAN_NBTP_NBRP     0x01FF0000	/* Bit Rate Prescaler */
  #define FDCAN_NBTP_NSJW     0xFE000000	/* Nominal (Re)Synchronization Jump Width */
#define TOFF_FDCAN_TSCC     0x0020		/* (RW) FDCAN Timestamp Counter Configuration register */
  #define FDCAN_TSCC_TSS      0x00000003	/* Timestamp Select */
  #define FDCAN_TSCC_TCP      0x000F0000	/* Timestamp Counter Prescaler */
#define TOFF_FDCAN_TSCV     0x0024		/* (RW) FDCAN Timestamp Counter Value register */
  #define FDCAN_TSCV_TSC      0x0000FFFF	/* Timestamp Counter */
#define TOFF_FDCAN_TOCC     0x0028		/* (RW) FDCAN Timeout Counter Configuration register */
  #define FDCAN_TOCC_ETOC     0x00000001	/* Enable Timeout Counter */
  #define FDCAN_TOCC_TOS      0x00000006	/* Timeout Select */
  #define FDCAN_TOCC_TOP      0xFFFF0000	/* Timeout Period */
#define TOFF_FDCAN_TOCV     0x002C		/* (RW) FDCAN Timeout Counter Value register */
  #define FDCAN_TOCV_TOC      0x0000FFFF	/* Timeout Counter */
#define TOFF_FDCAN_ECR      0x0040		/* (RW) FDCAN Error Counter register */
  #define FDCAN_ECR_TEC       0x000000FF	/* Transmit Error Counter */
  #define FDCAN_ECR_REC       0x00007F00	/* Receive Error Counter */
  #define FDCAN_ECR_RP        0x00008000	/* Receive Error Passive */
  #define FDCAN_ECR_CEL       0x00FF0000	/* CAN Error Logging */
#define TOFF_FDCAN_PSR      0x0044		/* (RW) FDCAN Protocol Status register */
  #define FDCAN_PSR_LEC       0x00000007	/* Last Error Code */
  #define FDCAN_PSR_ACT       0x00000018	/* Activity */
  #define FDCAN_PSR_EP        0x00000020	/* Error Passive */
  #define FDCAN_PSR_EW        0x00000040	/* Warning Status */
  #define FDCAN_PSR_BO        0x00000080	/* Bus_Off Status */
  #define FDCAN_PSR_DLEC      0x00000700	/* Data Last Error Code */
  #define FDCAN_PSR_RESI      0x00000800	/* ESI flag of last received FDCAN Message */
  #define FDCAN_PSR_RBRS      0x00001000	/* BRS flag of last received FDCAN Message */
  #define FDCAN_PSR_REDL      0x00002000	/* Received FDCAN Message */
  #define FDCAN_PSR_PXE       0x00004000	/* Protocol Exception Event */
  #define FDCAN_PSR_TDCV      0x007F0000	/* Transmitter Delay Compensation Value */
#define TOFF_FDCAN_TDCR     0x0048		/* (RW) FDCAN Transmitter Delay Compensation register */
  #define FDCAN_TDCR_TDCF     0x0000007F	/* Transmitter Delay Compensation Filter */
  #define FDCAN_TDCR_TDCO     0x00007F00	/* Transmitter Delay Compensation Offset */
#define TOFF_FDCAN_IR       0x0050		/* (RW) FDCAN Interrupt register */
  #define FDCAN_IR_RF0N       0x00000001	/* Rx FIFO 0 New Message */
  #define FDCAN_IR_RF0F       0x00000002	/* Rx FIFO 0 Full */
  #define FDCAN_IR_RF0L       0x00000004	/* Rx FIFO 0 Message Lost */
  #define FDCAN_IR_RF1N       0x00000008	/* Rx FIFO 1 New Message */
  #define FDCAN_IR_RF1F       0x00000010	/* Rx FIFO 1 Full */
  #define FDCAN_IR_RF1L       0x00000020	/* Rx FIFO 1 Message Lost */
  #define FDCAN_IR_HPM        0x00000040	/* High Priority Message */
  #define FDCAN_IR_TC         0x00000080	/* Transmission Completed */
  #define FDCAN_IR_TCF        0x00000100	/* Transmission Cancellation Finished */
  #define FDCAN_IR_TFE        0x00000200	/* Tx FIFO Empty */
  #define FDCAN_IR_TEFN       0x00000400	/* Tx Event FIFO New Entry */
  #define FDCAN_IR_TEFF       0x00000800	/* Tx Event FIFO Full */
  #define FDCAN_IR_TEFL       0x00001000	/* Tx Event FIFO Element Lost */
  #define FDCAN_IR_TSW        0x00002000	/* Timestamp Wraparound */
  #define FDCAN_IR_MRAF       0x00004000	/* Message RAM Access Failure */
  #define FDCAN_IR_TOO        0x00008000	/* Timeout Occurred */
  #define FDCAN_IR_ELO        0x00010000	/* Error Logging Overflow */
  #define FDCAN_IR_EP         0x00020000	/* Error Passive */
  #define FDCAN_IR_EW         0x00040000	/* Warning Status */
  #define FDCAN_IR_BO         0x00080000	/* Bus_Off Status */
  #define FDCAN_IR_WDI        0x00100000	/* Watchdog Interrupt */
  #define FDCAN_IR_PEA        0x00200000	/* Protocol Error in Arbitration Phase */
  #define FDCAN_IR_PED        0x00400000	/* Protocol Error in Data Phase */
  #define FDCAN_IR_ARA        0x00800000	/* Access to Reserved Address */
#define TOFF_FDCAN_IE       0x0054		/* (RW) FDCAN Interrupt Enable register */
  #define FDCAN_IE_RF0NE      0x00000001	/* Rx FIFO 0 New Message Enable */
  #define FDCAN_IE_RF0FE      0x00000002	/* Rx FIFO 0 Full Enable */
  #define FDCAN_IE_RF0LE      0x00000004	/* Rx FIFO 0 Message Lost Enable */
  #define FDCAN_IE_RF1NE      0x00000008	/* Rx FIFO 1 New Message Enable */
  #define FDCAN_IE_RF1FE      0x00000010	/* Rx FIFO 1 Full Enable */
  #define FDCAN_IE_RF1LE      0x00000020	/* Rx FIFO 1 Message Lost Enable */
  #define FDCAN_IE_HPME       0x00000040	/* High Priority Message Enable */
  #define FDCAN_IE_TCE        0x00000080	/* Transmission Completed Enable */
  #define FDCAN_IE_TCFE       0x00000100	/* Transmission Cancellation Finished Enable */
  #define FDCAN_IE_TFEE       0x00000200	/* Tx FIFO Empty Enable */
  #define FDCAN_IE_TEFNE      0x00000400	/* Tx Event FIFO New Entry Enable */
  #define FDCAN_IE_TEFFE      0x00000800	/* Tx Event FIFO Full Enable */
  #define FDCAN_IE_TEFLE      0x00001000	/* Tx Event FIFO Element Lost Enable */
  #define FDCAN_IE_TSWE       0x00002000	/* Timestamp Wraparound Enable */
  #define FDCAN_IE_MRAFE      0x00004000	/* Message RAM Access Failure Enable */
  #define FDCAN_IE_TOOE       0x00008000	/* Timeout Occurred Enable */
  #define FDCAN_IE_ELOE       0x00010000	/* Error Logging Overflow Enable */
  #define FDCAN_IE_EPE        0x00020000	/* Error Passive Enable */
  #define FDCAN_IE_EWE        0x00040000	/* Warning Status Enable */
  #define FDCAN_IE_BOE        0x00080000	/* Bus_Off Status Enable */
  #define FDCAN_IE_WDIE       0x00100000	/* Watchdog Interrupt Enable */
  #define FDCAN_IE_PEAE       0x00200000	/* Protocol Error in Arbitration Phase Enable*/
  #define FDCAN_IE_PEDE       0x00400000	/* Protocol Error in Data Phase Enable */
  #define FDCAN_IE_ARAE       0x00800000	/* Access to Reserved Address Enable */
#define TOFF_FDCAN_ILS      0x0058		/* (RW) FDCAN Interrupt Line Select register */
  #define FDCAN_ILS_RXFIFO0   0x00000001	/* Rx FIFO 0 Message Lost/Rx FIFO 0 is Full/Rx FIFO 0 Has New Message */
  #define FDCAN_ILS_RXFIFO1   0x00000002	/* Rx FIFO 1 Message Lost/Rx FIFO 1 is Full/Rx FIFO 1 Has New Message */
  #define FDCAN_ILS_SMSG      0x00000004	/* Transmission Cancellation Finished/Transmission Completed/High Priority Message */
  #define FDCAN_ILS_TFERR     0x00000008	/* Tx Event FIFO Element Lost/Tx Event FIFO Full/Tx Event FIFO New Entry/Tx FIFO Empty Interrupt Line */
  #define FDCAN_ILS_MISC      0x00000010	/* Timeout Occurred/Message RAM Access Failure/Timestamp Wraparound */
  #define FDCAN_ILS_BERR      0x00000020	/* Error Passive/Error Logging Overflow */
  #define FDCAN_ILS_PERR      0x00000040	/* Access to Reserved Address Line/Protocol Error in Data Phase Line/Protocol Error in Arbitration Phase Line */
											/* Watchdog Interrupt Line/Bus_Off Status/Warning Status */
#define TOFF_FDCAN_ILE      0x005C		/* (RW) FDCAN Interrupt Line Enable register */
  #define FDCAN_ILE_EINT0     0x00000001	/* Enable Interrupt Line 0 */
  #define FDCAN_ILE_EINT1     0x00000002	/* Enable Interrupt Line 1 */
#define TOFF_FDCAN_RXGFC    0x0080		/* (RW) FDCAN Global Filter Configuration register */
  #define FDCAN_RXGFC_RRFE    0x00000001	/* Reject Remote Frames Extended */
  #define FDCAN_RXGFC_RRFS    0x00000002	/* Reject Remote Frames Standard */
  #define FDCAN_RXGFC_ANFE    0x0000000C	/* Accept Non-matching Frames Extended */
  #define FDCAN_RXGFC_ANFS    0x00000030	/* Accept Non-matching Frames Standard */
  #define FDCAN_RXGFC_F1OM    0x00000100	/* FIFO 1 operation mode */
  #define FDCAN_RXGFC_F0OM    0x00000200	/* FIFO 0 operation mode */
  #define FDCAN_RXGFC_LSS     0x001F0000	/* List Size Standard */
  #define FDCAN_RXGFC_LSE     0x0F000000	/* List Size Extended */
#define TOFF_FDCAN_XIDAM    0x0084		/* (RW) FDCAN Extended ID AND Mask register */
  #define FDCAN_XIDAM_EIDM    0x1FFFFFFF	/* Extended ID Mask */
#define TOFF_FDCAN_HPMS     0x0088		/* (RW) FDCAN High Priority Message Status register */
  #define FDCAN_HPMS_BIDX     0x00000007	/* Buffer Index */
  #define FDCAN_HPMS_MSI      0x000000C0	/* Message Storage Indicator */
  #define FDCAN_HPMS_FIDX     0x00001F00	/* Filter Index */
  #define FDCAN_HPMS_FLST     0x00008000	/* Filter List */
#define TOFF_FDCAN_RXF0S    0x0090		/* (RW) FDCAN Rx FIFO 0 Status register */
  #define FDCAN_RXF0S_F0FL    0x0000000F	/* Rx FIFO 0 Fill Level */
  #define FDCAN_RXF0S_F0GI    0x00000300	/* Rx FIFO 0 Get Index */
  #define FDCAN_RXF0S_F0PI    0x00030000	/* Rx FIFO 0 Put Index */
  #define FDCAN_RXF0S_F0F     0x01000000	/* Rx FIFO 0 Full */
  #define FDCAN_RXF0S_RF0L    0x02000000	/* Rx FIFO 0 Message Lost */
#define TOFF_FDCAN_RXF0A    0x0094		/* (RW) FDCAN Rx FIFO 0 Acknowledge register */
  #define FDCAN_RXF0A_F0AI    0x00000007	/* Rx FIFO 0 Acknowledge Index */
#define TOFF_FDCAN_RXF1S    0x0098		/* (RW) FDCAN Rx FIFO 1 Status register */
  #define FDCAN_RXF1S_F1FL    0x0000000F	/* Rx FIFO 1 Fill Level */
  #define FDCAN_RXF1S_F1GI    0x00000300	/* Rx FIFO 1 Get Index */
  #define FDCAN_RXF1S_F1PI    0x00030000	/* Rx FIFO 1 Put Index */
  #define FDCAN_RXF1S_F1F     0x01000000	/* Rx FIFO 1 Full */
  #define FDCAN_RXF1S_RF1L    0x02000000	/* Rx FIFO 1 Message Lost */
#define TOFF_FDCAN_RXF1A    0x009C		/* (RW) FDCAN Rx FIFO 1 Acknowledge register */
  #define FDCAN_RXF1A_F1AI    0x00000007	/* Rx FIFO 1 Acknowledge Index */
#define TOFF_FDCAN_TXBC     0x00C0		/* (RW) FDCAN Tx Buffer Configuration register */
  #define FDCAN_TXBC_TFQM     0x01000000	/* Tx FIFO/Queue Mode */
#define TOFF_FDCAN_TXFQS    0x00C4		/* (RW) FDCAN Tx FIFO/Queue Status register */
  #define FDCAN_TXFQS_TFFL    0x00000007	/* Tx FIFO Free Level */
  #define FDCAN_TXFQS_TFGI    0x00000300	/* Tx FIFO Get Index */
  #define FDCAN_TXFQS_TFQPI   0x00030000	/* Tx FIFO/Queue Put Index */
  #define FDCAN_TXFQS_TFQF    0x00200000	/* Tx FIFO/Queue Full */
#define TOFF_FDCAN_TXBRP    0x00C8		/* (RW) FDCAN Tx Buffer Request Pending register */
  #define FDCAN_TXBRP_TRP     0x00000007	/* Transmission Request Pending */
#define TOFF_FDCAN_TXBAR    0x00CC		/* (RW) FDCAN Tx Buffer Add Request register */
  #define FDCAN_TXBAR_AR      0x00000007	/* Add Request */
#define TOFF_FDCAN_TXBCR    0x00D0		/* (RW) FDCAN Tx Buffer Cancellation Request register */
  #define FDCAN_TXBCR_CR      0x00000007	/* Cancellation Request */
#define TOFF_FDCAN_TXBTO    0x00D4		/* (RW) FDCAN Tx Buffer Transmission Occurred register */
  #define FDCAN_TXBTO_TO      0x00000007	/* Transmission Occurred */
#define TOFF_FDCAN_TXBCF    0x00D8		/* (RW) FDCAN Tx Buffer Cancellation Finished register */
  #define FDCAN_TXBCF_CF      0x00000007	/* Cancellation Finished */
#define TOFF_FDCAN_TXBTIE   0x00DC		/* (RW) FDCAN Tx Buffer Transmission Interrupt Enable register */
  #define FDCAN_TXBTIE_TIE    0x00000007	/* Transmission Interrupt Enable */
#define TOFF_FDCAN_TXBCIE   0x00E0		/* (RW) FDCAN Tx Buffer Cancellation Finished Interrupt Enable register */
  #define FDCAN_TXBCIE_CFIE   0x00000007	/* Cancellation Finished Interrupt Enable */
#define TOFF_FDCAN_TXEFS    0x00E4		/* (RW) FDCAN Tx Event FIFO Status register */
  #define FDCAN_TXEFS_EFFL    0x00000007	/* Event FIFO Fill Level */
  #define FDCAN_TXEFS_EFGI    0x00000300	/* Event FIFO Get Index */
  #define FDCAN_TXEFS_EFPI    0x00030000	/* Event FIFO Put Index */
  #define FDCAN_TXEFS_EFF     0x01000000	/* Event FIFO Full */
  #define FDCAN_TXEFS_TEFL    0x02000000	/* Tx Event FIFO Element Lost */
#define TOFF_FDCAN_TXEFA    0x00E8		/* (RW) FDCAN Tx Event FIFO Acknowledge register */
  #define FDCAN_TXEFA_EFAI    0x00000003	/* Event FIFO Acknowledge Index */


/*
 *  CLOCK RECOVERY SYSTEM
 */
#define TADR_CRS_BASE       (APBPERIPH_BASE + 0x6C00)
#define TOFF_CRS_CR         0x0000		/* (RW) CRS ccontrol register */
  #define CRS_CR_SYNCOKIE    0x00000001	/* SYNC event OK interrupt enable */
  #define CRS_CR_SYNCWARNIE  0x00000002	/* SYNC warning interrupt enable */
  #define CRS_CR_ERRIE       0x00000004	/* SYNC error or trimming error interrupt enable */
  #define CRS_CR_ESYNCIE     0x00000008	/* Expected SYNC interrupt enable */
  #define CRS_CR_CEN         0x00000020	/* Frequency error counter enable */
  #define CRS_CR_AUTOTRIMEN  0x00000040	/* Automatic trimming enable */
  #define CRS_CR_SWSYNC      0x00000080	/* Generate software SYNC event */
  #define CRS_CR_TRIM        0x00003F00	/* HSI48 oscillator smooth trimming */
#define TOFF_CRS_CFGR       0x0004		/* (RW) CRS configuration register */
  #define CRS_CFGR_RELOAD    0x0000FFFF	/* Counter reload value */
  #define CRS_CFGR_FELIM     0x00FF0000	/* Frequency error limit */
  #define CRS_CFGR_SYNCDIV   0x07000000	/* SYNC divider */
  #define CRS_CFGR_SYNCDIV_0 0x01000000
  #define CRS_CFGR_SYNCDIV_1 0x02000000
  #define CRS_CFGR_SYNCDIV_2 0x04000000
  #define CRS_CFGR_SYNCSRC   0x30000000	/* SYNC signal source selection */
  #define CRS_CFGR_SYNCSRC_0 0x10000000
  #define CRS_CFGR_SYNCSRC_1 0x20000000
  #define CRS_CFGR_SYNCPOL   0x80000000	/* SYNC polarity selection */
#define TOFF_CRS_ISR        0x0008		/* (RW) CRS interrupt and status register */
  #define CRS_ISR_SYNCOKF    0x00000001	/* SYNC event OK flag */
  #define CRS_ISR_SYNCWARNF  0x00000002	/* SYNC warning flag */
  #define CRS_ISR_ERRF       0x00000004	/* Error flag */
  #define CRS_ISR_ESYNCF     0x00000008	/* Expected SYNC flag */
  #define CRS_ISR_SYNCERR    0x00000100	/* SYNC error */
  #define CRS_ISR_SYNCMISS   0x00000200	/* SYNC missed */
  #define CRS_ISR_TRIMOVF    0x00000400	/* Trimming overflow or underflow */
  #define CRS_ISR_FEDIR      0x00008000	/* Frequency error direction */
  #define CRS_ISR_FECAP      0xFFFF0000	/* Frequency error capture */
#define TOFF_CRS_ICR        0x000C		/* (RW) CRS interrupt flag clear register */
  #define CRS_ICR_SYNCOKC    0x00000001	/* SYNC event OK clear flag */
  #define CRS_ICR_SYNCWARNC  0x00000002	/* SYNC warning clear flag */
  #define CRS_ICR_ERRC       0x00000004	/* Error clear flag */
  #define CRS_ICR_ESYNCC     0x00000008	/* Expected SYNC clear flag */
#endif

/*
 *  DIGITAL TO ANALOG CONVTER
 */
#define TADR_DAC_BASE       (APBPERIPH_BASE + 0x7400)
#define TOFF_DAC_CR         0x0000		/* (RW) DAC control register */
#define TOFF_DAC_SWTRIGR	0x0004		/* (RW) DAC software trigger register */
#define TOFF_DAC_DHR12R1    0x0008		/* (RW) DAC channel1 12-bit right-aligned data holding register */
#define TOFF_DAC_DHR12L1    0x000C		/* (RW) DAC channel1 12-bit left aligned data holding register */
#define TOFF_DAC_DHR8R1     0x0010		/* (RW) DAC channel1 8-bit right aligned data holding register */
#define TOFF_DAC_DHR12R2    0x0014		/* (RW) DAC channel2 12-bit right aligned data holding register */
#define TOFF_DAC_DHR12L2    0x0018		/* (RW) DAC channel2 12-bit left aligned data holding register */
#define TOFF_DAC_DHR8R2     0x001C		/* (RW) DAC channel2 8-bit right-aligned data holding register */
#define TOFF_DAC_DHR12RD    0x0020		/* (RW) Dual DAC 12-bit right-aligned data holding register */
#define TOFF_DAC_DHR12LD    0x0024		/* (RW) DUAL DAC 12-bit left aligned data holding register */
#define TOFF_DAC_DHR8RD     0x0028		/* (RW) DUAL DAC 8-bit right aligned data holding register */
#define TOFF_DAC_DOR1       0x002C		/* (RW) DAC channel1 data output register */
#define TOFF_DAC_DOR2       0x0030		/* (RW) DAC channel2 data output register */
#define TOFF_DAC_SR         0x0034		/* (RW) DAC status register */
#define TOFF_DAC_CCR        0x0038		/* (RW) DAC calibration control register */
#define TOFF_DAC_MCR        0x003C		/* (RW) DAC mode control register */
#define TOFF_DAC_SHSR       0x0040		/* (RW) DAC Sample and Hold sample time register 1 */
#define TOFF_DAC_SHSR2      0x0044		/* (RW) DAC Sample and Hold sample time register 2 */
#define TOFF_DAC_SHHR       0x0048		/* (RW) DAC Sample and Hold hold time register */
#define TOFF_DAC_SHRR       0x004C		/* (RW) DAC Sample and Hold refresh time register */

/*
 *  HDMI-CEC
 */
#define TADR_CEC_BASE       (APBPERIPH_BASE + 0x7800)
#define TOFF_CEC_CR         0x0000		/* (RW) CEC control register */
#define TOFF_CEC_CFGR       0x0004		/* (RW) CEC configuration register */
#define TOFF_CEC_TXDR       0x0008		/* (RW) CEC Tx data register */
#define TOFF_CEC_RXDR       0x000C		/* (RW) CEC Rx Data Register */
#define TOFF_CEC_ISR        0x0010		/* (RW) CEC Interrupt and Status Register */
#define TOFF_CEC_IER        0x0014		/* (RW) CEC interrupt enable register */

/*
 *  LPTIMIMER
 */
#define TADR_LPTIM1_BASE    (APBPERIPH_BASE + 0x7C00)
#define TADR_LPTIM2_BASE    (APBPERIPH_BASE + 0x9400)
#define TOFF_LPTIM_ISR      0x0000		/* (RW) LPTIM Interrupt and Status register */
#define TOFF_LPTIM_ICR      0x0004		/* (RW) LPTIM Interrupt Clear register */
#define TOFF_LPTIM_IER      0x0008		/* (RW) LPTIM Interrupt Enable register */
#define TOFF_LPTIM_CFGR     0x000C		/* (RW) LPTIM Configuration register */
#define TOFF_LPTIM_CR       0x0010		/* (RW) LPTIM Control register */
#define TOFF_LPTIM_CMP      0x0014		/* (RW) LPTIM Compare register */
#define TOFF_LPTIM_ARR      0x0018		/* (RW) LPTIM Autoreload register */
#define TOFF_LPTIM_CNT      0x001C		/* (RW) LPTIM Counter register */
#define TOFF_LPTIM_CFGR2    0x0024		/* (RW) LPTIM Option register */


/*
 *  UCPD
 */
#define TADR_UCPD1_BASE     (APBPERIPH_BASE + 0xA000)
#define TADR_UCPD2_BASE     (APBPERIPH_BASE + 0xA400)
#define TOFF_UCPD_CFG1      0x0000		/* (RW) UCPD configuration register 1 */
#define TOFF_UCPD_CFG2      0x0004		/* (RW) UCPD configuration register 2 */
#define TOFF_UCPD_CR        0x000C		/* (RW) UCPD control register */
#define TOFF_UCPD_IMR       0x0010		/* (RW) UCPD interrupt mask register */
#define TOFF_UCPD_SR        0x0014		/* (RW) UCPD status register */
#define TOFF_UCPD_ICR       0x0018		/* (RW) UCPD interrupt flag clear register */
#define TOFF_UCPD_TX_ORDSET 0x001C		/* (RW) UCPD Tx ordered set type register */
#define TOFF_UCPD_TX_PAYSZ  0x0020		/* (RW) UCPD Tx payload size register */
#define TOFF_UCPD_TXDR      0x0024		/* (RW) UCPD Tx data register */
#define TOFF_UCPD_RX_ORDSET 0x0028		/* (RW) UCPD Rx ordered set type register */
#define TOFF_UCPD_RX_PAYSZ  0x002C		/* (RW) UCPD Rx payload size register */
#define TOFF_UCPD_RXDR      0x0030		/* (RW) UCPD Rx data register */
#define TOFF_UCPD_RX_ORDEXT1 0x0034		/* (RW) UCPD Rx ordered set extension 1 register */
#define TOFF_UCPD_RX_ORDEXT2 0x0038		/* (RW) UCPD Rx ordered set extension 2 register */

/*
 *  TAMPER AND BACKUP REGISTER
 */
#define TADR_TAMP_BASE      (APBPERIPH_BASE + 0xB000)
#define TOFF_TAMP_CR1       0x0000		/* (RW) TAMP configuration register 1 */
#define TOFF_TAMP_CR2       0x0004		/* (RW) TAMP configuration register 2 */
#define TOFF_TAMP_FLTCR     0x000C		/*      Reserved */
#define TOFF_TAMP_IER       0x0028		/* (RW) TAMP Interrupt enable register */
#define TOFF_TAMP_SR        0x0030		/* (RW) TAMP Status register */
#define TOFF_TAMP_MISR      0x0034		/* (RW) TAMP Masked Interrupt Status register */
#define TOFF_TAMP_SCR       0x003C		/* (RW) TAMP Status clear register */
#define TOFF_TAMP_BKP0R     0x0100		/* (RW) TAMP backup register 0 */
#define TOFF_TAMP_BKP1R     0x0104		/* (RW) TAMP backup register 1 */
#define TOFF_TAMP_BKP2R     0x0108		/* (RW) TAMP backup register 2 */
#define TOFF_TAMP_BKP3R     0x010C		/* (RW) TAMP backup register 3 */
#define TOFF_TAMP_BKP4R     0x0110		/* (RW) TAMP backup register 4 */


/*
 *  SYSTEM CONFIGURATION CONTROLLER
 */
#define TADR_SYSCFG_BASE    (APBPERIPH_BASE + 0x00010000)
#define TOFF_SYSCFG_CFGR1   0x0000		/* (RW) SYSCFG configuration register 1 */
  #define SYSCFG_CFGR1_MEM_MODE     0x00000003	/* SYSCFG_Memory Remap Config */
  #define SYSCFG_CFGR1_MEM_MODE_0   0x00000001
  #define SYSCFG_CFGR1_MEM_MODE_1   0x00000002
  #define SYSCFG_CFGR1_PA11_RMP     0x00000008	/* PA11 Remap */
  #define SYSCFG_CFGR1_PA12_RMP     0x00000010	/* PA12 Remap */
  #define SYSCFG_CFGR1_IR_POL       0x00000020	/* IROut Polarity Selection */
  #define SYSCFG_CFGR1_IR_MOD       0x000000C0	/* IRDA Modulation Envelope signal source selection */
  #define SYSCFG_CFGR1_IR_MOD_0     0x00000040
  #define SYSCFG_CFGR1_IR_MOD_1     0x00000080
  #define SYSCFG_CFGR1_BOOSTEN      0x00000100	/* I/O analog switch voltage booster enable */
  #define SYSCFG_CFGR1_UCPD1_STROBE 0x00000200	/* Strobe signal bit for UCPD1 */
  #define SYSCFG_CFGR1_UCPD2_STROBE 0x00000400	/* Strobe signal bit for UCPD2 */
  #define SYSCFG_CFGR1_I2C_PB6_FMP  0x00010000	/* I2C PB6 Fast mode plus */
  #define SYSCFG_CFGR1_I2C_PB7_FMP  0x00020000	/* I2C PB7 Fast mode plus */
  #define SYSCFG_CFGR1_I2C_PB8_FMP  0x00040000	/* I2C PB8 Fast mode plus */
  #define SYSCFG_CFGR1_I2C_PB9_FMP  0x00080000	/* I2C PB9 Fast mode plus */
  #define SYSCFG_CFGR1_I2C1_FMP     0x00100000	/* Enable Fast Mode Plus on PB10, PB11, PF6 and PF7  */
  #define SYSCFG_CFGR1_I2C2_FMP     0x00200000	/* Enable I2C2 Fast mode plus  */
  #define SYSCFG_CFGR1_I2C_PA9_FMP  0x00400000	/* Enable Fast Mode Plus on PA9  */
  #define SYSCFG_CFGR1_I2C_PA10_FMP 0x00800000	/* Enable Fast Mode Plus on PA10 */
#if BOARDNO == 1
  #define SYSCFG_CFGR1_I2C3_FMP     0x01000000	/* Enable I2C3 Fast mode plus  */
#endif
#define TOFF_SYSCFG_CFGR2   0x0018		/* (RW) SYSCFG configuration register 2 */
  #define SYSCFG_CFGR2_CLL          0x00000001	/* Enables and locks the LOCKUP (Hardfault) output of CortexM0 with Break Input of TIMER1 */
  #define SYSCFG_CFGR2_SPL          0x00000002	/* Enables and locks the SRAM_PARITY error signal with Break Input of TIMER1 */
  #define SYSCFG_CFGR2_PVDL         0x00000004	/* Enables and locks the PVD connection with Timer1 Break Input and also the PVD_EN and PVDSEL[2:0] bits of the Power Control Interface */
  #define SYSCFG_CFGR2_ECCL         0x00000008	/* ECCL */
  #define SYSCFG_CFGR2_SPF          0x00000100	/* SRAM Parity error flag */
#if BOARDNO == 1
  #define SYSCFG_CFGR2_PA1_CDEN     0x00010000	/* PA[1] Clamping Diode Enable */
  #define SYSCFG_CFGR2_PA3_CDEN     0x00020000	/* PA[3] Clamping Diode Enable */
  #define SYSCFG_CFGR2_PA5_CDEN     0x00040000	/* PA[5] Clamping Diode Enable */
  #define SYSCFG_CFGR2_PA6_CDEN     0x00080000	/* PA[6] Clamping Diode Enable */
  #define SYSCFG_CFGR2_PA13_CDEN    0x00100000	/* PA[13] Clamping Diode Enable */
  #define SYSCFG_CFGR2_PB0_CDEN     0x00200000	/* PB[0] Clamping Diode Enable */
  #define SYSCFG_CFGR2_PB1_CDEN     0x00400000	/* PB[1] Clamping Diode Enable */
  #define SYSCFG_CFGR2_PB2_CDEN     0x00800000	/* PB[2] Clamping Diode Enable */
#endif
  #define SYSCFG_CFGR2_SRAM_PE      SYSCFG_CFGR2_SPF
#define TOFF_SYSCFG_IT_LINE_SR 0x0080	/* (RW) SYSCFG configuration IT_LINE register 0-31 */
  #define SYSCFG_ITLINE0_SR_EWDG        0x00000001	/* EWDG interrupt */
  #define SYSCFG_ITLINE1_SR_PVDOUT      0x00000001	/* Power voltage detection -> exti[16] Interrupt */
  #define SYSCFG_ITLINE2_SR_TAMPER      0x00000001	/* TAMPER -> exti[21] interrupt */
  #define SYSCFG_ITLINE2_SR_RTC_WAKEUP  0x00000002	/* RTC_WAKEUP -> exti[19] interrupt .... */
  #define SYSCFG_ITLINE3_SR_FLASH_ECC   0x00000001	/* Flash ITF ECC interrupt */
  #define SYSCFG_ITLINE3_SR_FLASH_ITF   0x00000002	/* FLASH ITF interrupt */
  #define SYSCFG_ITLINE4_SR_CLK_CTRL    0x00000001	/* RCC interrupt */
  #define SYSCFG_ITLINE5_SR_EXTI0       0x00000001	/* External Interrupt 0 */
  #define SYSCFG_ITLINE5_SR_EXTI1       0x00000002	/* External Interrupt 1 */
  #define SYSCFG_ITLINE6_SR_EXTI2       0x00000001	/* External Interrupt 2 */
  #define SYSCFG_ITLINE6_SR_EXTI3       0x00000002	/* External Interrupt 3 */
  #define SYSCFG_ITLINE7_SR_EXTI4       0x00000001	/* External Interrupt 4 */
  #define SYSCFG_ITLINE7_SR_EXTI5       0x00000002	/* External Interrupt 5 */
  #define SYSCFG_ITLINE7_SR_EXTI6       0x00000004	/* External Interrupt 6 */
  #define SYSCFG_ITLINE7_SR_EXTI7       0x00000008	/* External Interrupt 7 */
  #define SYSCFG_ITLINE7_SR_EXTI8       0x00000010	/* External Interrupt 8 */
  #define SYSCFG_ITLINE7_SR_EXTI9       0x00000020	/* External Interrupt 9 */
  #define SYSCFG_ITLINE7_SR_EXTI10      0x00000040	/* External Interrupt 10 */
  #define SYSCFG_ITLINE7_SR_EXTI11      0x00000080	/* External Interrupt 11 */
  #define SYSCFG_ITLINE7_SR_EXTI12      0x00000100	/* External Interrupt 12 */
  #define SYSCFG_ITLINE7_SR_EXTI13      0x00000200	/* External Interrupt 13 */
  #define SYSCFG_ITLINE7_SR_EXTI14      0x00000400	/* External Interrupt 14 */
  #define SYSCFG_ITLINE7_SR_EXTI15      0x00000800	/* External Interrupt 15 */
  #define SYSCFG_ITLINE8_SR_UCPD1       0x00000001	/* UCPD1 -> exti[32] Interrupt */
  #define SYSCFG_ITLINE8_SR_UCPD2       0x00000002	/* UCPD2 -> exti[33] Interrupt */
  #define SYSCFG_ITLINE9_SR_DMA1_CH1    0x00000001	/* DMA1 Channel 1 Interrupt */
  #define SYSCFG_ITLINE10_SR_DMA1_CH2   0x00000001	/* DMA1 Channel 2 Interrupt */
  #define SYSCFG_ITLINE10_SR_DMA1_CH3   0x00000002	/* DMA2 Channel 3 Interrupt */
  #define SYSCFG_ITLINE11_SR_DMAMUX1    0x00000001	/* DMAMUX Interrupt */
  #define SYSCFG_ITLINE11_SR_DMA1_CH4   0x00000002	/* DMA1 Channel 4 Interrupt */
  #define SYSCFG_ITLINE11_SR_DMA1_CH5   0x00000004	/* DMA1 Channel 5 Interrupt */
  #define SYSCFG_ITLINE11_SR_DMA1_CH6   0x00000008	/* DMA1 Channel 6 Interrupt */
  #define SYSCFG_ITLINE11_SR_DMA1_CH7   0x00000010	/* DMA1 Channel 7 Interrupt */
#if BOARDNO == 1
  #define SYSCFG_ITLINE11_SR_DMA2_CH1   0x00000020	/* DMA2 Channel 1 Interrupt */
  #define SYSCFG_ITLINE11_SR_DMA2_CH2   0x00000040	/* DMA2 Channel 2 Interrupt */
  #define SYSCFG_ITLINE11_SR_DMA2_CH3   0x00000080	/* DMA2 Channel 3 Interrupt */
  #define SYSCFG_ITLINE11_SR_DMA2_CH4   0x00000100	/* DMA2 Channel 4 Interrupt */
  #define SYSCFG_ITLINE11_SR_DMA2_CH5   0x00000200	/* DMA2 Channel 5 Interrupt */
#endif
  #define SYSCFG_ITLINE12_SR_ADC        0x00000001	/* ADC Interrupt */
  #define SYSCFG_ITLINE12_SR_COMP1      0x00000002	/* COMP1 Interrupt -> exti[17] */
  #define SYSCFG_ITLINE12_SR_COMP2      0x00000004	/* COMP2 Interrupt -> exti[18] */
#if BOARDNO == 1
  #define SYSCFG_ITLINE12_SR_COMP3      0x00000008	/* COMP3 Interrupt -> exti[20] */
#endif
  #define SYSCFG_ITLINE13_SR_TIM1_CCU   0x00000001	/* TIM1 CCU Interrupt */
  #define SYSCFG_ITLINE13_SR_TIM1_TRG   0x00000002	/* TIM1 TRG Interrupt */
  #define SYSCFG_ITLINE13_SR_TIM1_UPD   0x00000004	/* TIM1 UPD Interrupt */
  #define SYSCFG_ITLINE13_SR_TIM1_BRK   0x00000008	/* TIM1 BRK Interrupt */
  #define SYSCFG_ITLINE14_SR_TIM1_CC    0x00000001	/* TIM1 CC Interrupt */
  #define SYSCFG_ITLINE15_SR_TIM2_GLB   0x00000001	/* TIM2 GLB Interrupt */
  #define SYSCFG_ITLINE16_SR_TIM3_GLB   0x00000001	/* TIM3 GLB Interrupt */
#if BOARDNO == 1
  #define SYSCFG_ITLINE16_SR_TIM4_GLB   0x00000002	/* TIM4 GLB Interrupt */
#endif
  #define SYSCFG_ITLINE17_SR_TIM6_GLB   0x00000001	/* TIM6 GLB Interrupt */
  #define SYSCFG_ITLINE17_SR_DAC        0x00000002	/* DAC Interrupt */
  #define SYSCFG_ITLINE17_SR_LPTIM1_GLB 0x00000004	/* LPTIM1 -> exti[29] Interrupt */
  #define SYSCFG_ITLINE18_SR_TIM7       0x00000001	/* TIM7 GLB Interrupt */
  #define SYSCFG_ITLINE18_SR_LPTIM2_GLB 0x00000002	/* LPTIM2 -> exti[30] Interrupt */
  #define SYSCFG_ITLINE19_SR_TIM14_GLB  0x00000001	/* TIM14 GLB Interrupt */
  #define SYSCFG_ITLINE20_SR_TIM15_GLB  0x00000001	/* TIM15 GLB Interrupt */
  #define SYSCFG_ITLINE21_SR_TIM16_GLB  0x00000001	/* TIM16 GLB Interrupt */
  #define SYSCFG_ITLINE22_SR_TIM17_GLB  0x00000001	/* TIM17 GLB Interrupt */
  #define SYSCFG_ITLINE23_SR_I2C1_GLB   0x00000001	/* I2C1 GLB Interrupt -> exti[23] */
  #define SYSCFG_ITLINE24_SR_I2C2_GLB   0x00000001	/* I2C2 GLB Interrupt */
#if BOARDNO == 1
  #define SYSCFG_ITLINE24_SR_I2C3_GLB   0x00000002	/* I2C3 GLB Interrupt  -> exti[24]*/
#endif
  #define SYSCFG_ITLINE25_SR_SPI1       0x00000001	/* SPI1 Interrupt */
  #define SYSCFG_ITLINE26_SR_SPI2       0x00000001	/* SPI2  Interrupt */
#if BOARDNO == 1
  #define SYSCFG_ITLINE26_SR_SPI3       0x00000002	/* SPI3  Interrupt */
#endif
  #define SYSCFG_ITLINE27_SR_USART1_GLB 0x00000001	/* USART1 GLB Interrupt -> exti[25] */
  #define SYSCFG_ITLINE28_SR_USART2_GLB 0x00000001	/* USART2 GLB Interrupt -> exti[26] */
  #define SYSCFG_ITLINE29_SR_USART3_GLB 0x00000001	/* USART3 GLB Interrupt */
  #define SYSCFG_ITLINE29_SR_USART4_GLB 0x00000002	/* USART4 GLB Interrupt */
  #define SYSCFG_ITLINE29_SR_LPUART1_GLB 0x00000004	/* LPUART1 GLB Interrupt -> exti[28] */
#if BOARDNO == 1
  #define SYSCFG_ITLINE29_SR_USART5_GLB 0x00000008	/* USART5 GLB Interrupt */
  #define SYSCFG_ITLINE29_SR_USART6_GLB 0x00000010	/* USART6 GLB Interrupt */
#endif
  #define SYSCFG_ITLINE30_SR_CEC        0x00000001	/* CEC Interrupt-> exti[27] */


/*
 *  VREFBUF
 */
#define TADR_VREFBUF_BASE   (APBPERIPH_BASE + 0x00010030)
#define TOFF_VREFBUF_CSR    0x0000		/* (RW) VREFBUF control and status register */
  #define VREFBUF_CSR_ENVR   0x00000001	/* Voltage reference buffer enable */
  #define VREFBUF_CSR_HIZ    0x00000002	/* High impedance mode */
  #define VREFBUF_CSR_VRS    0x00000004	/* Voltage reference scale */
  #define VREFBUF_CSR_VRR    0x00000008	/* Voltage reference buffer ready  */
#define TOFF_VREFBUF_CCR    0x0004		/* (RW) VREFBUF calibration and control register */
  #define VREFBUF_CCR_TRIM   0x0000003F	/* TRIM[5:0] bits (Trimming code)  */


/*
 *  COMPARATOR
 */
#define TADR_COMP1_BASE     (TADR_SYSCFG_BASE + 0x0200)
#define TADR_COMP2_BASE     (TADR_SYSCFG_BASE + 0x0204)
#if BOARDNO == 1
#define TADR_COMP3_BASE     (TADR_SYSCFG_BASE + 0x0208)
#endif
#define TOFF_COMP_CSR       0x0000		/* (RW) COMP control and status register */
  #define COMP_CSR_EN        0x00000001	/* Comparator enable */
  #define COMP_CSR_INMSEL    0x000000F0	/* Comparator input minus selection */
  #define COMP_CSR_INMSEL_0  0x00000010
  #define COMP_CSR_INMSEL_1  0x00000020
  #define COMP_CSR_INMSEL_2  0x00000040
  #define COMP_CSR_INMSEL_3  0x00000080
  #define COMP_CSR_INPSEL    0x00000300	/* Comparator plus minus selection */
  #define COMP_CSR_INPSEL_0  0x00000100
  #define COMP_CSR_INPSEL_1  0x00000200
  #define COMP_CSR_WINMODE   0x00000800	/* Pair of comparators window mode. Bit intended to be used with COMP common instance (COMP_Common_TypeDef) */
  #define COMP_CSR_WINOUT    0x00004000	/* Pair of comparators window output level. Bit intended to be used with COMP common instance (COMP_Common_TypeDef) */
  #define COMP_CSR_POLARITY  0x00008000	/* Comparator output polarity */
  #define COMP_CSR_HYST      0x00030000	/* Comparator input hysteresis */
  #define COMP_CSR_HYST_0    0x00010000
  #define COMP_CSR_HYST_1    0x00020000
  #define COMP_CSR_PWRMODE   0x000C0000	/* Comparator power mode */
  #define COMP_CSR_PWRMODE_0 0x00040000
  #define COMP_CSR_PWRMODE_1 0x00080000
  #define COMP_CSR_BLANKING  0x01F00000	/* Comparator blanking source */
  #define COMP_CSR_BLANKING_0 0x00100000
  #define COMP_CSR_BLANKING_1 0x00200000
  #define COMP_CSR_BLANKING_2 0x00400000
  #define COMP_CSR_BLANKING_3 0x00800000
  #define COMP_CSR_BLANKING_4 0x01000000
  #define COMP_CSR_VALUE     0x40000000	/* Comparator output level */
  #define COMP_CSR_LOCK      0x80000000	/* Comparator lock */


/*
 *  ANALOG TO DIGITAL CONVERTER
 */
#define TADR_ADC1_BASE      (APBPERIPH_BASE + 0x00012400)
#define TOFF_ADC_ISR        0x0000		/* (RW) ADC interrupt and status register */
  #define ADC_ISR_ADRDY      0x00000001	/* ADC ready flag */
  #define ADC_ISR_EOSMP      0x00000002	/* ADC group regular end of sampling flag */
  #define ADC_ISR_EOC        0x00000004	/* ADC group regular end of unitary conversion flag */
  #define ADC_ISR_EOS        0x00000008	/* ADC End of Sequence flag */
  #define ADC_ISR_OVR        0x00000010	/* ADC group regular overrun flag */
  #define ADC_ISR_AWD1       0x00000080	/* ADC Analog watchdog 1 flag */
  #define ADC_ISR_AWD2       0x00000100	/* ADC analog watchdog 2 flag */
  #define ADC_ISR_AWD3       0x00000200	/* ADC analog watchdog 3 flag */
  #define ADC_ISR_EOCAL      0x00000800	/* ADC End of calibration flag */
  #define ADC_ISR_CCRDY      0x00002000	/* ADC channel configuration ready flag */
  #define ADC_ISR_EOSEQ      (ADC_ISR_EOS)
#define TOFF_ADC_IER        0x0004		/* (RW) ADC interrupt enable register */
  #define ADC_IER_ADRDYIE    0x00000001	/* ADC ready interrupt */
  #define ADC_IER_EOSMPIE    0x00000002	/* ADC group regular end of sampling interrupt */
  #define ADC_IER_EOCIE      0x00000004	/* ADC group regular end of unitary conversion interrupt */
  #define ADC_IER_EOSIE      0x00000008	/* ADC End of Sequence of conversion interrupt enable */
  #define ADC_IER_OVRIE      0x00000010	/* ADC group regular overrun interrupt */
  #define ADC_IER_AWD1IE     0x00000080	/* ADC Analog Watchdog interrupt 1 enable */
  #define ADC_IER_AWD2IE     0x00000100	/* ADC analog watchdog 2 interrupt */
  #define ADC_IER_AWD3IE     0x00000200	/* ADC analog watchdog 3 interrupt */
  #define ADC_IER_EOCALIE    0x00000800	/* ADC Enf Of Calibration interrupt enable */
  #define ADC_IER_CCRDYIE    0x00002000	/* ADC channel configuration ready interrupt */
  #define ADC_IER_EOSEQIE    (ADC_IER_EOSIE)
#define TOFF_ADC_CR         0x0008		/* (RW) ADC control register */
  #define ADC_CR_ADEN        0x00000001	/* ADC enable */
  #define ADC_CR_ADDIS       0x00000002	/* ADC disable */
  #define ADC_CR_ADSTART     0x00000004	/* ADC group regular conversion start */
  #define ADC_CR_ADSTP       0x00000010	/* ADC group regular conversion stop */
  #define ADC_CR_ADVREGEN    0x10000000	/* ADC Voltage Regulator Enable */
  #define ADC_CR_ADCAL       0x80000000	/* ADC calibration */
#define TOFF_ADC_CFGR1      0x000C		/* (RW) ADC configuration register 1 */
  #define ADC_CFGR1_DMAEN    0x00000001	/* ADC DMA transfer enable */
  #define ADC_CFGR1_DMACFG   0x00000002	/* ADC DMA transfer configuration */
  #define ADC_CFGR1_SCANDIR  0x00000004	/* ADC group regular sequencer scan direction */
  #define ADC_CFGR1_RES      0x00000018	/* ADC data resolution */
  #define ADC_CFGR1_RES_0    0x00000008
  #define ADC_CFGR1_RES_1    0x00000010
  #define ADC_CFGR1_ALIGN    0x00000020	/* ADC data alignement */
  #define ADC_CFGR1_EXTSEL   0x000001C0	/* ADC group regular external trigger source */
  #define ADC_CFGR1_EXTSEL_0 0x00000040
  #define ADC_CFGR1_EXTSEL_1 0x00000080
  #define ADC_CFGR1_EXTSEL_2 0x00000100
  #define ADC_CFGR1_EXTEN    0x00000C00	/* ADC group regular external trigger polarity */
  #define ADC_CFGR1_EXTEN_0  0x00000400
  #define ADC_CFGR1_EXTEN_1  0x00000800
  #define ADC_CFGR1_OVRMOD   0x00001000	/* ADC group regular overrun configuration */
  #define ADC_CFGR1_CONT     0x00002000	/* ADC group regular continuous conversion mode */
  #define ADC_CFGR1_WAIT     0x00004000	/* ADC low power auto wait */
  #define ADC_CFGR1_AUTOFF   0x00008000	/* ADC low power auto power off */
  #define ADC_CFGR1_DISCEN   0x00010000	/* ADC group regular sequencer discontinuous mode */
  #define ADC_CFGR1_AWDSGL   0x00400000	/* ADC analog watchdog 1 monitoring a single channel or all channels */
  #define ADC_CFGR1_AWDEN    0x00800000	/* ADC analog watchdog 1 enable on scope ADC group regular */
  #define ADC_CFGR1_AWDCH    0x7C000000	/* ADC analog watchdog 1 monitored channel selection */
  #define ADC_CFGR1_AWDCH_0  0x04000000
  #define ADC_CFGR1_AWDCH_1  0x08000000
  #define ADC_CFGR1_AWDCH_2  0x10000000
  #define ADC_CFGR1_AWDCH_3  0x20000000
  #define ADC_CFGR1_AWDCH_4  0x40000000
  #define ADC_CFGR1_AUTDLY   (ADC_CFGR1_WAIT)
#define TOFF_ADC_CFGR2      0x0010	/* (RW) ADC configuration register 2 */
  #define ADC_CFGR2_OVSE     0x00000001	/* Oversampler Enable */
  #define ADC_CFGR2_OVSR     0x0000001C	/* OVSR  [2:0] bits (Oversampling ratio) */
  #define ADC_CFGR2_OVSR_0   0x00000004
  #define ADC_CFGR2_OVSR_1   0x00000008
  #define ADC_CFGR2_OVSR_2   0x00000010
  #define ADC_CFGR2_OVSS     0x000001E0	/* OVSS [3:0] bits (Oversampling shift) */
  #define ADC_CFGR2_OVSS_0   0x00000020
  #define ADC_CFGR2_OVSS_1   0x00000040
  #define ADC_CFGR2_OVSS_2   0x00000080
  #define ADC_CFGR2_OVSS_3   0x00000100
  #define ADC_CFGR2_TOVS     0x00000200	/* Triggered Oversampling */
  #define ADC_CFGR2_LFTRIG   0x20000000	/* ADC low frequency trigger mode */
  #define ADC_CFGR2_CKMODE   0xC0000000	/* ADC clock source and prescaler (prescaler only for clock source synchronous) */
  #define ADC_CFGR2_CKMODE_1 0x80000000
  #define ADC_CFGR2_CKMODE_0 0x40000000
#define TOFF_ADC_SMPR       0x0014	/* (RW) ADC sampling time register */
  #define ADC_SMPR_SMP       0x00000007	/* ADC group of channels sampling time 2 */
  #define ADC_SMPR_SMP_0     0x00000001
  #define ADC_SMPR_SMP_1     0x00000002
  #define ADC_SMPR_SMP_2     0x00000004
  #define ADC_SMPR_SMPSEL    0x07FFFF00	/* ADC all channels sampling time selection */
  #define ADC_SMPR_SMPSEL0   0x00000100	/* ADC channel 0 sampling time selection */
  #define ADC_SMPR_SMPSEL1   0x00000200	/* ADC channel 1 sampling time selection */
  #define ADC_SMPR_SMPSEL2   0x00000400	/* ADC channel 2 sampling time selection */
  #define ADC_SMPR_SMPSEL3   0x00000800	/* ADC channel 3 sampling time selection */
  #define ADC_SMPR_SMPSEL4   0x00001000	/* ADC channel 4 sampling time selection */
  #define ADC_SMPR_SMPSEL5   0x00002000	/* ADC channel 5 sampling time selection */
  #define ADC_SMPR_SMPSEL6   0x00004000	/* ADC channel 6 sampling time selection */
  #define ADC_SMPR_SMPSEL7   0x00008000	/* ADC channel 7 sampling time selection */
  #define ADC_SMPR_SMPSEL8   0x00010000	/* ADC channel 8 sampling time selection */
  #define ADC_SMPR_SMPSEL9   0x00020000	/* ADC channel 9 sampling time selection */
  #define ADC_SMPR_SMPSEL10  0x00040000	/* ADC channel 10 sampling time selection */
  #define ADC_SMPR_SMPSEL11  0x00080000	/* ADC channel 11 sampling time selection */
  #define ADC_SMPR_SMPSEL12  0x00100000	/* ADC channel 12 sampling time selection */
  #define ADC_SMPR_SMPSEL13  0x00200000	/* ADC channel 13 sampling time selection */
  #define ADC_SMPR_SMPSEL14  0x00400000	/* ADC channel 14 sampling time selection */
  #define ADC_SMPR_SMPSEL15  0x00800000	/* ADC channel 15 sampling time selection */
  #define ADC_SMPR_SMPSEL16  0x01000000	/* ADC channel 16 sampling time selection */
  #define ADC_SMPR_SMPSEL17  0x02000000	/* ADC channel 17 sampling time selection */
  #define ADC_SMPR_SMPSEL18  0x04000000	/* ADC channel 18 sampling time selection */
#define TOFF_ADC_TR1        0x0020	/* (RW) ADC analog watchdog 1 threshold register */
  #define ADC_TR1_LT1        0x00000FFF	/* ADC analog watchdog 1 threshold low */
  #define ADC_TR1_LT1_0      0x00000001
  #define ADC_TR1_LT1_1      0x00000002
  #define ADC_TR1_LT1_2      0x00000004
  #define ADC_TR1_LT1_3      0x00000008
  #define ADC_TR1_LT1_4      0x00000010
  #define ADC_TR1_LT1_5      0x00000020
  #define ADC_TR1_LT1_6      0x00000040
  #define ADC_TR1_LT1_7      0x00000080
  #define ADC_TR1_LT1_8      0x00000100
  #define ADC_TR1_LT1_9      0x00000200
  #define ADC_TR1_LT1_10     0x00000400
  #define ADC_TR1_LT1_11     0x00000800
  #define ADC_TR1_HT1        0x0FFF0000	/* ADC Analog watchdog 1 threshold high */
  #define ADC_TR1_HT1_0      0x00010000
  #define ADC_TR1_HT1_1      0x00020000
  #define ADC_TR1_HT1_2      0x00040000
  #define ADC_TR1_HT1_3      0x00080000
  #define ADC_TR1_HT1_4      0x00100000
  #define ADC_TR1_HT1_5      0x00200000
  #define ADC_TR1_HT1_6      0x00400000
  #define ADC_TR1_HT1_7      0x00800000
  #define ADC_TR1_HT1_8      0x01000000
  #define ADC_TR1_HT1_9      0x02000000
  #define ADC_TR1_HT1_10     0x04000000
  #define ADC_TR1_HT1_11     0x08000000
#define TOFF_ADC_TR2        0x0024	/* (RW) ADC analog watchdog 2 threshold register */
  #define ADC_TR2_LT2        0x00000FFF	/* ADC analog watchdog 2 threshold low */
  #define ADC_TR2_LT2_0      0x00000001
  #define ADC_TR2_LT2_1      0x00000002
  #define ADC_TR2_LT2_2      0x00000004
  #define ADC_TR2_LT2_3      0x00000008
  #define ADC_TR2_LT2_4      0x00000010
  #define ADC_TR2_LT2_5      0x00000020
  #define ADC_TR2_LT2_6      0x00000040
  #define ADC_TR2_LT2_7      0x00000080
  #define ADC_TR2_LT2_8      0x00000100
  #define ADC_TR2_LT2_9      0x00000200
  #define ADC_TR2_LT2_10     0x00000400
  #define ADC_TR2_LT2_11     0x00000800
  #define ADC_TR2_HT2        0x0FFF0000	/* ADC Analog watchdog 2 threshold high */
  #define ADC_TR2_HT2_0      0x00010000
  #define ADC_TR2_HT2_1      0x00020000
  #define ADC_TR2_HT2_2      0x00040000
  #define ADC_TR2_HT2_3      0x00080000
  #define ADC_TR2_HT2_4      0x00100000
  #define ADC_TR2_HT2_5      0x00200000
  #define ADC_TR2_HT2_6      0x00400000
  #define ADC_TR2_HT2_7      0x00800000
  #define ADC_TR2_HT2_8      0x01000000
  #define ADC_TR2_HT2_9      0x02000000
  #define ADC_TR2_HT2_10     0x04000000
  #define ADC_TR2_HT2_11     0x08000000
#define TOFF_ADC_CHSELR     0x0028	/* (RW) ADC group regular sequencer register */
  #define ADC_CHSELR_CHSEL   0x0007FFFF	/* ADC group regular sequencer channels, available when ADC_CFGR1_CHSELRMOD is reset */
  #define ADC_CHSELR_CHSEL0  0x00000001	/* Channel 0 selection */
  #define ADC_CHSELR_CHSEL1  0x00000002	/* Channel 1 selection */
  #define ADC_CHSELR_CHSEL2  0x00000004	/* Channel 2 selection */
  #define ADC_CHSELR_CHSEL3  0x00000008	/* Channel 3 selection */
  #define ADC_CHSELR_CHSEL4  0x00000010	/* Channel 4 selection */
  #define ADC_CHSELR_CHSEL5  0x00000020	/* Channel 5 selection */
  #define ADC_CHSELR_CHSEL6  0x00000040	/* Channel 6 selection */
  #define ADC_CHSELR_CHSEL7  0x00000080	/* Channel 7 selection */
  #define ADC_CHSELR_CHSEL8  0x00000100	/* Channel 8 selection */
  #define ADC_CHSELR_CHSEL9  0x00000200	/* Channel 9 selection */
  #define ADC_CHSELR_CHSEL10 0x00000400	/* Channel 10 selection */
  #define ADC_CHSELR_CHSEL11 0x00000800	/* Channel 11 selection */
  #define ADC_CHSELR_CHSEL12 0x00001000	/* Channel 12 selection */
  #define ADC_CHSELR_CHSEL13 0x00002000	/* Channel 13 selection */
  #define ADC_CHSELR_CHSEL14 0x00004000	/* Channel 14 selection */
  #define ADC_CHSELR_CHSEL15 0x00008000	/* Channel 15 selection */
  #define ADC_CHSELR_CHSEL16 0x00010000	/* Channel 16 selection */
  #define ADC_CHSELR_CHSEL17 0x00020000	/* Channel 17 selection */
  #define ADC_CHSELR_CHSEL18 0x00040000	/* Channel 18 selection */

  #define ADC_CHSELR_SQ_ALL  0xFFFFFFFF	/* ADC group regular sequencer all ranks, available when ADC_CFGR1_CHSELRMOD is set */
  #define ADC_CHSELR_SQ1     0x0000000F	/* ADC group regular sequencer rank 1, available when ADC_CFGR1_CHSELRMOD is set */
  #define ADC_CHSELR_SQ1_0   0x00000001
  #define ADC_CHSELR_SQ1_1   0x00000002
  #define ADC_CHSELR_SQ1_2   0x00000004
  #define ADC_CHSELR_SQ1_3   0x00000008
  #define ADC_CHSELR_SQ2     0x000000F0	/* ADC group regular sequencer rank 2, available when ADC_CFGR1_CHSELRMOD is set */
  #define ADC_CHSELR_SQ2_0   0x00000010
  #define ADC_CHSELR_SQ2_1   0x00000020
  #define ADC_CHSELR_SQ2_2   0x00000040
  #define ADC_CHSELR_SQ2_3   0x00000080
  #define ADC_CHSELR_SQ3     0x00000F00	/* ADC group regular sequencer rank 3, available when ADC_CFGR1_CHSELRMOD is set */
  #define ADC_CHSELR_SQ3_0   0x00000100
  #define ADC_CHSELR_SQ3_1   0x00000200
  #define ADC_CHSELR_SQ3_2   0x00000400
  #define ADC_CHSELR_SQ3_3   0x00000800
  #define ADC_CHSELR_SQ4     0x0000F000	/* ADC group regular sequencer rank 4, available when ADC_CFGR1_CHSELRMOD is set */
  #define ADC_CHSELR_SQ4_0   0x00001000
  #define ADC_CHSELR_SQ4_1   0x00002000
  #define ADC_CHSELR_SQ4_2   0x00004000
  #define ADC_CHSELR_SQ4_3   0x00008000
  #define ADC_CHSELR_SQ5     0x000F0000	/* ADC group regular sequencer rank 5, available when ADC_CFGR1_CHSELRMOD is set */
  #define ADC_CHSELR_SQ5_0   0x00010000
  #define ADC_CHSELR_SQ5_1   0x00020000
  #define ADC_CHSELR_SQ5_2   0x00040000
  #define ADC_CHSELR_SQ5_3   0x00080000
  #define ADC_CHSELR_SQ6     0x00F00000	/* ADC group regular sequencer rank 6, available when ADC_CFGR1_CHSELRMOD is set */
  #define ADC_CHSELR_SQ6_0   0x00100000
  #define ADC_CHSELR_SQ6_1   0x00200000
  #define ADC_CHSELR_SQ6_2   0x00400000
  #define ADC_CHSELR_SQ6_3   0x00800000
  #define ADC_CHSELR_SQ7     0x0F000000	/* ADC group regular sequencer rank 7, available when ADC_CFGR1_CHSELRMOD is set */
  #define ADC_CHSELR_SQ7_0   0x01000000
  #define ADC_CHSELR_SQ7_1   0x02000000
  #define ADC_CHSELR_SQ7_2   0x04000000
  #define ADC_CHSELR_SQ7_3   0x08000000
  #define ADC_CHSELR_SQ8     0xF0000000	/* ADC group regular sequencer rank 8, available when ADC_CFGR1_CHSELRMOD is set */
  #define ADC_CHSELR_SQ8_0   0x10000000
  #define ADC_CHSELR_SQ8_1   0x20000000
  #define ADC_CHSELR_SQ8_2   0x40000000
  #define ADC_CHSELR_SQ8_3   0x80000000
#define TOFF_ADC_TR3        0x002C	/* (RW) ADC analog watchdog 3 threshold register */
  #define ADC_TR3_LT3        0x00000FFF	/* ADC analog watchdog 3 threshold low */
  #define ADC_TR3_LT3_0      0x00000001
  #define ADC_TR3_LT3_1      0x00000002
  #define ADC_TR3_LT3_2      0x00000004
  #define ADC_TR3_LT3_3      0x00000008
  #define ADC_TR3_LT3_4      0x00000010
  #define ADC_TR3_LT3_5      0x00000020
  #define ADC_TR3_LT3_6      0x00000040
  #define ADC_TR3_LT3_7      0x00000080
  #define ADC_TR3_LT3_8      0x00000100
  #define ADC_TR3_LT3_9      0x00000200
  #define ADC_TR3_LT3_10     0x00000400
  #define ADC_TR3_LT3_11     0x00000800
  #define ADC_TR3_HT3        0x0FFF0000	/* ADC Analog watchdog 3 threshold high */
  #define ADC_TR3_HT3_0      0x00010000
  #define ADC_TR3_HT3_1      0x00020000
  #define ADC_TR3_HT3_2      0x00040000
  #define ADC_TR3_HT3_3      0x00080000
  #define ADC_TR3_HT3_4      0x00100000
  #define ADC_TR3_HT3_5      0x00200000
  #define ADC_TR3_HT3_6      0x00400000
  #define ADC_TR3_HT3_7      0x00800000
  #define ADC_TR3_HT3_8      0x01000000
  #define ADC_TR3_HT3_9      0x02000000
  #define ADC_TR3_HT3_10     0x04000000
  #define ADC_TR3_HT3_11     0x08000000
#define TOFF_ADC_DR         0x0040		/* (RW) ADC group regular data register */
  #define ADC_DR_DATA        0x0000FFFF	/* ADC group regular conversion data */
#define TOFF_ADC_AWD2CR     0x00A0		/* (RW) ADC analog watchdog 2 configuration register */
  #define ADC_AWD2CR_AWD2CH  0x0007FFFF	/* ADC analog watchdog 2 monitored channel selection */
#define TOFF_ADC_AWD3CR     0x00A4		/* (RW) ADC analog watchdog 3 configuration register */
  #define ADC_AWD3CR_AWD3CH  0x0007FFFF	/* ADC analog watchdog 3 monitored channel selection */
#define TOFF_ADC_CALFACT    0x00B4		/* ADC data register */
  #define ADC_CALFACT_CALFACT 0x0000007F	/* Calibration factor */

#define TADR_ADC_BASE      (APBPERIPH_BASE + 0x00012708)
#define TOFF_ADC_CCR        0x0000
  #define ADC_CCR_PRESC      0x003C0000	/* PRESC  [3:0] bits (ADC prescaler) */
  #define ADC_CCR_PRESC_0    0x00040000
  #define ADC_CCR_PRESC_1    0x00080000
  #define ADC_CCR_PRESC_2    0x00100000
  #define ADC_CCR_PRESC_3    0x00200000
  #define ADC_CCR_VREFEN     0x00400000	/* Vrefint enable */
  #define ADC_CCR_TSEN       0x00800000	/* Temperature sensore enable */
  #define ADC_CCR_VLCDEN     0x01000000	/* Voltage LCD enable */
  #define ADC_CCR_LFMEN      0x02000000	/* Low Frequency Mode enable */


/*
 *  DEBUG MCU
 */
#define TADR_DBGMCU_BASE    (APBPERIPH_BASE + 0x00015800)
#define TOFF_DBGMCU_IDCODE  0x0000		/* (RW) MCU device ID code */
#define TOFF_DBGMCU_CR      0x0004		/* (RW) Debug MCU configuration register */
#define TOFF_DBGMCU_APB1FZ  0x0008		/* (RW) Debug MCU APB1 freeze register */
#define TOFF_DBGMCU_APB2FZ  0x000C		/* (RW) Debug MCU APB2 freeze register */


/* 
 *  DMA CONTROLLER
 */
#define TADR_DMA1_BASE      (AHBPERIPH_BASE + 0x0000)
#if BOARDNO == 1
#define TADR_DMA2_BASE      (AHBPERIPH_BASE + 0x0400)
#endif
#define TOFF_DMA_ISR        0x0000		/* (RW) DMA interrupt status register */
  #define DMA_ISR_GIF        0x1		/* Channel Global interrupt flag */
  #define DMA_ISR_TCIF       0x2		/* Channel Transfer Complete flag */
  #define DMA_ISR_HTIF       0x4		/* Channel Half Transfer flag */
  #define DMA_ISR_TEIF       0x8		/* Channel Transfer Error flag */
#define TOFF_DMA_IFCR       0x0004		/* (RW) DMA interrupt flag clear register */
  #define DMA_IFCR_CGIF      0x1		/* Channel Global interrupt clear    */
  #define DMA_IFCR_CTCIF     0x2		/* Channel Transfer Complete clear   */
  #define DMA_IFCR_CHTIF     0x4		/* Channel Half Transfer clear       */
  #define DMA_IFCR_CTEIF     0x8		/* Channel Transfer Error clear      */

#define TADR_DMA1_CH1_BASE  (TADR_DMA1_BASE + 0x008)
#define TADR_DMA1_CH2_BASE  (TADR_DMA1_BASE + 0x01C)
#define TADR_DMA1_CH3_BASE  (TADR_DMA1_BASE + 0x030)
#define TADR_DMA1_CH4_BASE  (TADR_DMA1_BASE + 0x044)
#define TADR_DMA1_CH5_BASE  (TADR_DMA1_BASE + 0x058)
#define TADR_DMA1_CH6_BASE  (TADR_DMA1_BASE + 0x06C)
#define TADR_DMA1_CH7_BASE  (TADR_DMA1_BASE + 0x080)
#if BOARDNO == 1
#define TADR_DMA2_CH1_BASE  (TADR_DMA2_BASE + 0x008)
#define TADR_DMA2_CH2_BASE  (TADR_DMA2_BASE + 0x01C)
#define TADR_DMA2_CH3_BASE  (TADR_DMA2_BASE + 0x030)
#define TADR_DMA2_CH4_BASE  (TADR_DMA2_BASE + 0x044)
#define TADR_DMA2_CH5_BASE  (TADR_DMA2_BASE + 0x058)
#endif
#define TOFF_DMACH_CCR      0x0000		/* (RW) DMA channel x configuration register */
  #define DMA_CCR_EN         0x00000001	/* Channel enable */
  #define DMA_CCR_TCIE       0x00000002	/* Transfer complete interrupt enable */
  #define DMA_CCR_HTIE       0x00000004	/* Half Transfer interrupt enable */
  #define DMA_CCR_TEIE       0x00000008	/* Transfer error interrupt enable */
  #define DMA_CCR_DIR        0x00000010	/* Data transfer direction */
  #define DMA_CCR_CIRC       0x00000020	/* Circular mode */
  #define DMA_CCR_PINC       0x00000040	/* Peripheral increment mode */
  #define DMA_CCR_MINC       0x00000080	/* Memory increment mode */
  #define DMA_CCR_PSIZE      0x00000300	/* PSIZE[1:0] bits (Peripheral size) */
  #define DMA_CCR_PSIZE_0    0x00000100
  #define DMA_CCR_PSIZE_1    0x00000200
  #define DMA_CCR_MSIZE      0x00000C00	/* MSIZE[1:0] bits (Memory size) */
  #define DMA_CCR_MSIZE_0    0x00000400
  #define DMA_CCR_MSIZE_1    0x00000800
  #define DMA_CCR_PL         0x00003000	/* PL[1:0] bits(Channel Priority level) */
  #define DMA_CCR_PL_0       0x00001000
  #define DMA_CCR_PL_1       0x00002000
  #define DMA_CCR_MEM2MEM    0x00004000	/* Memory to memory mode */
#define TOFF_DMACH_CNDTR    0x0004		/* (RW) DMA channel x number of data register */
  #define DMA_CNDTR_NDT      0x0000FFFF	/* Number of data to Transfer */
#define TOFF_DMACH_CPAR     0x0008		/* (RW) DMA channel x peripheral address register   */
#define TOFF_DMACH_CMAR     0x000C		/* (RW) DMA channel x memory address register */


/*
 *  DMAMUTEX
 */
#define TADR_DMAMUX1_BASE   (AHB1PERIPH_BASE + 0x0800)
#define TOFF_DMAMUX_CHANNEL_CR      0x0000
  #define DMAMUX_CxCR_DMAREQ_ID     0x000000FF
  #define DMAMUX_CxCR_DMAREQ_ID_0   0x00000001
  #define DMAMUX_CxCR_DMAREQ_ID_1   0x00000002
  #define DMAMUX_CxCR_DMAREQ_ID_2   0x00000004
  #define DMAMUX_CxCR_DMAREQ_ID_3   0x00000008
  #define DMAMUX_CxCR_DMAREQ_ID_4   0x00000010
  #define DMAMUX_CxCR_DMAREQ_ID_5   0x00000020
  #define DMAMUX_CxCR_DMAREQ_ID_6   0x00000040
  #define DMAMUX_CxCR_DMAREQ_ID_7   0x00000080
  #define DMAMUX_CxCR_SOIE          0x00000100
  #define DMAMUX_CxCR_EGE           0x00000200
  #define DMAMUX_CxCR_SE            0x00010000
  #define DMAMUX_CxCR_SPOL          0x00060000
  #define DMAMUX_CxCR_SPOL_0        0x00020000
  #define DMAMUX_CxCR_SPOL_1        0x00040000
  #define DMAMUX_CxCR_NBREQ         0x00F80000
  #define DMAMUX_CxCR_NBREQ_0       0x00080000
  #define DMAMUX_CxCR_NBREQ_1       0x00100000
  #define DMAMUX_CxCR_NBREQ_2       0x00200000
  #define DMAMUX_CxCR_NBREQ_3       0x00400000
  #define DMAMUX_CxCR_NBREQ_4       0x00800000
  #define DMAMUX_CxCR_SYNC_ID       0x1F000000
  #define DMAMUX_CxCR_SYNC_ID_0     0x01000000
  #define DMAMUX_CxCR_SYNC_ID_1     0x02000000
  #define DMAMUX_CxCR_SYNC_ID_2     0x04000000
  #define DMAMUX_CxCR_SYNC_ID_3     0x08000000
  #define DMAMUX_CxCR_SYNC_ID_4     0x10000000
#define TOFF_DMAMUX_REQUEST_GEN     0x0100
  #define DMAMUX_RGxCR_SIG_ID       0x0000001F
  #define DMAMUX_RGxCR_SIG_ID_0     0x00000001
  #define DMAMUX_RGxCR_SIG_ID_1     0x00000002
  #define DMAMUX_RGxCR_SIG_ID_2     0x00000004
  #define DMAMUX_RGxCR_SIG_ID_3     0x00000008
  #define DMAMUX_RGxCR_SIG_ID_4     0x00000010
  #define DMAMUX_RGxCR_OIE          0x00000100
  #define DMAMUX_RGxCR_GE           0x00010000
  #define DMAMUX_RGxCR_GPOL         0x00060000
  #define DMAMUX_RGxCR_GPOL_0       0x00020000
  #define DMAMUX_RGxCR_GPOL_1       0x00040000
  #define DMAMUX_RGxCR_GNBREQ       0x00F80000
  #define DMAMUX_RGxCR_GNBREQ_0     0x00080000
  #define DMAMUX_RGxCR_GNBREQ_1     0x00100000
  #define DMAMUX_RGxCR_GNBREQ_2     0x00200000
  #define DMAMUX_RGxCR_GNBREQ_3     0x00400000
  #define DMAMUX_RGxCR_GNBREQ_4     0x00800000
#define TOFF_DMAMUX_CHANNEL_STS     0x0080
#define TOFF_DMAMUX_CHANNEL_STS_CSR TOFF_DMAMUX_CHANNEL_STS
#define TOFF_DMAMUX_CHANNEL_STS_CFR (TOFF_DMAMUX_CHANNEL_STS+4)
#define TOFF_DMAMUX_REQUEST_GENSTS  0x0140
#define TOFF_DMAMUX_REQUEST_GENSTS_RGSR  TOFF_DMAMUX_REQUEST_GENSTS
#define TOFF_DMAMUX_REQUEST_GENSTS_RGCFR (TOFF_DMAMUX_REQUEST_GENSTS+4)
#define TOFF_DMAMUX1_IdREG_BASE     0x03EC


/*
 *  RESET AND CLOCK CONTROL
 */
#define TADR_RCC_BASE       (AHBPERIPH_BASE + 0x1000)
#define TOFF_RCC_CR         0x0000		/* (RW) RCC clock control register */
  #define RCC_CR_HSION             0x00000100	/* Internal High Speed clock enable */
  #define RCC_CR_HSIKERON          0x00000200	/* Internal High Speed clock enable for some IPs Kernel */
  #define RCC_CR_HSIRDY            0x00000400	/* Internal High Speed clock ready flag */
  #define RCC_CR_HSIDIV            0x00003800	/* HSIDIV[13:11] Internal High Speed clock division factor */
  #define RCC_CR_HSIDIV_0          0x00000800
  #define RCC_CR_HSIDIV_1          0x00001000
  #define RCC_CR_HSIDIV_2          0x00002000
  #define RCC_CR_HSEON             0x00010000	/* External High Speed clock enable */
  #define RCC_CR_HSERDY            0x00020000	/* External High Speed clock ready */
  #define RCC_CR_HSEBYP            0x00040000	/* External High Speed clock Bypass */
  #define RCC_CR_CSSON             0x00080000	/* HSE Clock Security System enable */
#if BOARDNO == 1
  #define RCC_CR_HSI48ON           0x00400000	/* RC48 clock enable */
  #define RCC_CR_HSI48RDY          0x00800000	/* RC48 clock ready */
#endif
  #define RCC_CR_PLLON             0x01000000	/* System PLL clock enable */
  #define RCC_CR_PLLRDY            0x02000000	/* System PLL clock ready */
  #define RCC_CR_CSSHSEON          (RCC_CR_CSSON)
#define TOFF_RCC_ICSCR      0x0004		/* (RW) RCC Internal clock sources calibration register */
  #define RCC_ICSCR_HSICAL         0x000000FF	/* HSICAL[7:0] bits */
  #define RCC_ICSCR_HSICAL_0       0x00000001
  #define RCC_ICSCR_HSICAL_1       0x00000002
  #define RCC_ICSCR_HSICAL_2       0x00000004
  #define RCC_ICSCR_HSICAL_3       0x00000008
  #define RCC_ICSCR_HSICAL_4       0x00000010
  #define RCC_ICSCR_HSICAL_5       0x00000020
  #define RCC_ICSCR_HSICAL_6       0x00000040
  #define RCC_ICSCR_HSICAL_7       0x00000080
  #define RCC_ICSCR_HSITRIM        0x00007F00	/* HSITRIM[14:8] bits */
  #define RCC_ICSCR_HSITRIM_0      0x00000100
  #define RCC_ICSCR_HSITRIM_1      0x00000200
  #define RCC_ICSCR_HSITRIM_2      0x00000400
  #define RCC_ICSCR_HSITRIM_3      0x00000800
  #define RCC_ICSCR_HSITRIM_4      0x00001000
  #define RCC_ICSCR_HSITRIM_5      0x00002000
  #define RCC_ICSCR_HSITRIM_6      0x00004000
#define TOFF_RCC_CFGR       0x0008		/* (RW) RCC clock configuration register */
  #define RCC_CFGR_SW              0x00000007	/* SW[2:0] bits (System clock Switch) */
  #define RCC_CFGR_SW_0            0x00000001
  #define RCC_CFGR_SW_1            0x00000002
  #define RCC_CFGR_SW_2            0x00000004
  #define RCC_CFGR_SW_HSI          0x00000000	/* HSI selected as system clock */
  #define RCC_CFGR_SW_HSE          0x00000001	/* HSE selected as system clock */
  #define RCC_CFGR_SW_PLL          0x00000002	/* PLL selected as system clock */
  #define RCC_CFGR_SW_LSI          0x00000003	/* LSI selected as system clock */
  #define RCC_CFGR_SW_LSE          0x00000004	/* LSE selected as system clock */
  #define RCC_CFGR_SWS             0x00000038	/* SWS[2:0] bits (System Clock Switch Status) */
  #define RCC_CFGR_SWS_0           0x00000008
  #define RCC_CFGR_SWS_1           0x00000010
  #define RCC_CFGR_SWS_2           0x00000020
  #define RCC_CFGR_SWS_HSI         0x00000000	/* HSI used as system clock */
  #define RCC_CFGR_SWS_HSE         0x00000008	/* HSE used as system clock */
  #define RCC_CFGR_SWS_PLL         0x00000010	/* PLL used as system clock */
  #define RCC_CFGR_SWS_LSI         0x00000018	/* LSI used as system clock */
  #define RCC_CFGR_SWS_LSE         0x00000020	/* LSE used as system clock */
  #define RCC_CFGR_HPRE            0x00000F00	/* HPRE[3:0] bits (AHB prescaler) */
  #define RCC_CFGR_HPRE_0          0x00000100
  #define RCC_CFGR_HPRE_1          0x00000200
  #define RCC_CFGR_HPRE_2          0x00000400
  #define RCC_CFGR_HPRE_3          0x00000800
  #define RCC_CFGR_PPRE            0x00007000	/* PRE1[2:0] bits (APB prescaler) */
  #define RCC_CFGR_PPRE_0          0x00001000
  #define RCC_CFGR_PPRE_1          0x00002000
  #define RCC_CFGR_PPRE_2          0x00004000
#if BOARDNO == 1
  #define RCC_CFGR_MCO2SEL         0x000F0000	/* MCO2SEL [3:0] bits (Clock output selection) */
  #define RCC_CFGR_MCO2SEL_0       0x00010000
  #define RCC_CFGR_MCO2SEL_1       0x00020000
  #define RCC_CFGR_MCO2SEL_2       0x00040000
  #define RCC_CFGR_MCO2SEL_3       0x00080000
  #define RCC_CFGR_MCO2PRE         0x00F00000	/* MCO2 prescaler [3:0] */
  #define RCC_CFGR_MCO2PRE_0       0x00100000
  #define RCC_CFGR_MCO2PRE_1       0x00200000
  #define RCC_CFGR_MCO2PRE_2       0x00400000
  #define RCC_CFGR_MCO2PRE_3       0x00800000
#endif
  #define RCC_CFGR_MCOSEL          0x0F000000	/* MCOSEL [2:0] bits (Clock output selection) */
  #define RCC_CFGR_MCOSEL_0        0x01000000
  #define RCC_CFGR_MCOSEL_1        0x02000000
  #define RCC_CFGR_MCOSEL_2        0x04000000
  #define RCC_CFGR_MCOPRE          0x70000000	/* MCO prescaler [2:0] */
  #define RCC_CFGR_MCOPRE_0        0x10000000
  #define RCC_CFGR_MCOPRE_1        0x20000000
  #define RCC_CFGR_MCOPRE_2        0x40000000
#define TOFF_RCC_PLLCFGR    0x000C		/* (RW) RCC System PLL configuration Register */
  #define RCC_PLLCFGR_PLLSRC       0x00000003
  #define RCC_PLLCFGR_PLLSRC_0     0x00000001
  #define RCC_PLLCFGR_PLLSRC_1     0x00000002
  #define RCC_PLLCFGR_PLLSRC_NONE  0x00000000	/* No clock sent to PLL      */
  #define RCC_PLLCFGR_PLLSRC_HSI   0x00000002	/* HSI source clock selected */
  #define RCC_PLLCFGR_PLLSRC_HSE   0x00000003	/* HSE source clock selected */
  #define RCC_PLLCFGR_PLLM         0x00000070
  #define RCC_PLLCFGR_PLLM_0       0x00000010
  #define RCC_PLLCFGR_PLLM_1       0x00000020
  #define RCC_PLLCFGR_PLLM_2       0x00000040
  #define RCC_PLLCFGR_PLLN         0x00007F00
  #define RCC_PLLCFGR_PLLN_0       0x00000100
  #define RCC_PLLCFGR_PLLN_1       0x00000200
  #define RCC_PLLCFGR_PLLN_2       0x00000400
  #define RCC_PLLCFGR_PLLN_3       0x00000800
  #define RCC_PLLCFGR_PLLN_4       0x00001000
  #define RCC_PLLCFGR_PLLN_5       0x00002000
  #define RCC_PLLCFGR_PLLN_6       0x00004000
  #define RCC_PLLCFGR_PLLPEN       0x00010000
  #define RCC_PLLCFGR_PLLP         0x003E0000
  #define RCC_PLLCFGR_PLLP_0       0x00020000
  #define RCC_PLLCFGR_PLLP_1       0x00040000
  #define RCC_PLLCFGR_PLLP_2       0x00080000
  #define RCC_PLLCFGR_PLLP_3       0x00100000
  #define RCC_PLLCFGR_PLLP_4       0x00200000
  #define RCC_PLLCFGR_PLLQEN       0x01000000
  #define RCC_PLLCFGR_PLLQ         0x0E000000
  #define RCC_PLLCFGR_PLLQ_0       0x02000000
  #define RCC_PLLCFGR_PLLQ_1       0x04000000
  #define RCC_PLLCFGR_PLLQ_2       0x08000000
  #define RCC_PLLCFGR_PLLREN       0x10000000
  #define RCC_PLLCFGR_PLLR         0xE0000000
  #define RCC_PLLCFGR_PLLR_0       0x20000000
  #define RCC_PLLCFGR_PLLR_1       0x40000000
  #define RCC_PLLCFGR_PLLR_2       0x80000000
#if BOARDNO == 1
#define TOFF_RCC_CRRCR      0x0014		/* (RW) RCC Clock Configuration Register */
  #define RCC_CRRCR_HSI48CAL       0x000001FF	/* RC48CAL[8:0] bits */
  #define RCC_CRRCR_HSI48CAL_0     0x00000001
  #define RCC_CRRCR_HSI48CAL_1     0x00000002
  #define RCC_CRRCR_HSI48CAL_2     0x00000004
  #define RCC_CRRCR_HSI48CAL_3     0x00000008
  #define RCC_CRRCR_HSI48CAL_4     0x00000010
  #define RCC_CRRCR_HSI48CAL_5     0x00000020
  #define RCC_CRRCR_HSI48CAL_6     0x00000040
  #define RCC_CRRCR_HSI48CAL_7     0x00000080
  #define RCC_CRRCR_HSI48CAL_8     0x00000100
#endif
#define TOFF_RCC_CIER       0x0018		/* (RW) RCC Clock interrupt enable register */
  #define RCC_CIER_LSIRDYIE        0x00000001	/* LSI Ready Interrupt Enable */
  #define RCC_CIER_LSERDYIE        0x00000002	/* LSE Ready Interrupt Enable */
#if BOARDNO == 1
  #define RCC_CIER_HSI48RDYIE      0x00000004	/* HSI48 Ready Interrupt Enable */
#endif
  #define RCC_CIER_HSIRDYIE        0x00000008	/* HSI Ready Interrupt Enable */
  #define RCC_CIER_HSERDYIE        0x00000010	/* HSE Ready Interrupt Enable */
  #define RCC_CIER_PLLRDYIE        0x00000020	/* PLL Ready Interrupt Enable */
#define TOFF_RCC_CIFR       0x001C		/* (RW) RCC Clock interrupt flag register */
  #define RCC_CIFR_LSIRDYF         0x00000001	/* LSI Ready Interrupt flag */
  #define RCC_CIFR_LSERDYF         0x00000002	/* LSE Ready Interrupt flag */
#if BOARDNO == 1
  #define RCC_CIFR_HSI48RDYF       0x00000004	/* HSI48 Ready Interrupt flag */
#endif
  #define RCC_CIFR_HSIRDYF         0x00000008	/* HSI Ready Interrupt flag */
  #define RCC_CIFR_HSERDYF         0x00000010	/* HSE Ready Interrupt flag */
  #define RCC_CIFR_PLLRDYF         0x00000020	/* PLL Ready Interrupt flag */
  #define RCC_CIFR_CSSF            0x00000100	/* Clock Security System Interrupt flag */
  #define RCC_CIFR_LSECSSF         0x00000200	/* LSE Clock Security System Interrupt flag */
  #define RCC_CIFR_CSSLSEF         (RCC_CIFR_LSECSSF)
  #define RCC_CIFR_CSSHSEF         (RCC_CIFR_CSSF)
#define TOFF_RCC_CICR       0x0020		/* (RW) RCC Clock interrupt clear register */
  #define RCC_CICR_LSIRDYC         0x00000001	/* LSI Ready Interrupt Clear */
  #define RCC_CICR_LSERDYC         0x00000002	/* LSE Ready Interrupt Clear */
#if BOARDNO == 1
  #define RCC_CICR_HSI48RDYC       0x00000004	/* HSI48 Ready Interrupt Clear */
#endif
  #define RCC_CICR_HSIRDYC         0x00000008	/* HSI Ready Interrupt Clear */
  #define RCC_CICR_HSERDYC         0x00000010	/* HSE Ready Interrupt Clear */
  #define RCC_CICR_PLLRDYC         0x00000020	/* PLL Ready Interrupt Clear */
  #define RCC_CICR_CSSC            0x00000100	/* LSE Clock Security System Interrupt Clear */
  #define RCC_CICR_LSECSSC         0x00000200	/* HSE Clock Security System Interrupt Clear */
  #define RCC_CICR_CSSLSEC         (RCC_CICR_LSECSSC)
  #define RCC_CICR_CSSHSEC         (RCC_CICR_CSSC)
#define TOFF_RCC_IOPRSTR    0x0024		/* (RW) RCC IO port reset register */
  #define RCC_IOPRSTR_GPIOARST     0x00000001	/* GPIO port A reset */
  #define RCC_IOPRSTR_GPIOBRST     0x00000002	/* GPIO port B reset */
  #define RCC_IOPRSTR_GPIOCRST     0x00000004	/* GPIO port C reset */
  #define RCC_IOPRSTR_GPIODRST     0x00000008	/* GPIO port D reset */
#if BOARDNO == 1
  #define RCC_IOPRSTR_GPIOERST     0x00000010	/* GPIO port E reset */
#endif
  #define RCC_IOPRSTR_GPIOFRST     0x00000020	/* GPIO port F reset */
  #define RCC_IOPRSTR_IOPARST      (RCC_IOPRSTR_GPIOARST)
  #define RCC_IOPRSTR_IOPBRST      (RCC_IOPRSTR_GPIOBRST)
  #define RCC_IOPRSTR_IOPCRST      (RCC_IOPRSTR_GPIOCRST)
  #define RCC_IOPRSTR_IOPDRST      (RCC_IOPRSTR_GPIODRST)
  #define RCC_IOPRSTR_IOPFRST      (RCC_IOPRSTR_GPIOFRST)
#define TOFF_RCC_AHBRSTR    0x0028		/* (RW) RCC AHB peripheral reset register */
  #define RCC_AHBRSTR_DMA1RST      0x00000001	/* DMA1 reset */
#if BOARDNO == 1
  #define RCC_AHBRSTR_DMA2RST      0x00000002	/* DMA2 reset */
#endif
  #define RCC_AHBRSTR_FLASHRST     0x00000100	/* FLASH reset */
  #define RCC_AHBRSTR_CRCRST       0x00001000	/* CRC reset */
  #define RCC_AHBRSTR_DMARST       (RCC_AHBRSTR_DMA1RST)
#define TOFF_RCC_APBRSTR1   0x002C		/* (RW) RCC APB peripheral reset register 1 */
  #define RCC_APBRSTR1_TIM2RST     0x00000001	/* TIM2 clock reset */
  #define RCC_APBRSTR1_TIM3RST     0x00000002	/* TIM3 clock reset */
  #define RCC_APBRSTR1_TIM6RST     0x00000010	/* TIM6 clock reset */
  #define RCC_APBRSTR1_TIM7RST     0x00000020	/* TIM7 clock reset */
#if BOARDNO == 1
  #define RCC_APBRSTR1_LPUART2RST  0x00000080	/* LPUART2 clock reset */
  #define RCC_APBRSTR1_USART5RST   0x00000100	/* USART5 clock reset */
  #define RCC_APBRSTR1_USART6RST   0x00000200	/* USART6 clock reset */
  #define RCC_APBRSTR1_USBRST      0x00002000	/* USB clock reset */
#endif
  #define RCC_APBRSTR1_SPI2RST     0x00004000	/* SPI2 clock reset */
#if BOARDNO == 1
  #define RCC_APBRSTR1_SPI3RST     0x00008000	/* SPI3 clock reset */
  #define RCC_APBRSTR1_CRSRST      0x00010000	/* CRS clock reset */
#endif
  #define RCC_APBRSTR1_USART2RST   0x00020000	/* USART2 clock reset */
  #define RCC_APBRSTR1_USART3RST   0x00040000	/* USART3 clock reset */
  #define RCC_APBRSTR1_USART4RST   0x00080000	/* USART4 clock reset */
  #define RCC_APBRSTR1_LPUART1RST  0x00100000	/* LPUART1 clock reset */
  #define RCC_APBRSTR1_I2C1RST     0x00200000	/* I2C1 clock reset */
  #define RCC_APBRSTR1_I2C2RST     0x00400000	/* I2C2 clock reset */
#if BOARDNO == 1
  #define RCC_APBRSTR1_I2C3RST     0x00800000	/* I2C3 clock reset */
#endif
  #define RCC_APBRSTR1_CECRST      0x01000000	/* CEC clock reset */
  #define RCC_APBRSTR1_UCPD1RST    0x02000000	/* UCPD1 clock reset */
  #define RCC_APBRSTR1_UCPD2RST    0x04000000	/* UCPD2 clock reset */
  #define RCC_APBRSTR1_DBGRST      0x08000000	/* DBG clock reset */
  #define RCC_APBRSTR1_PWRRST      0x10000000	/* PWR clock reset */
  #define RCC_APBRSTR1_DAC1RST     0x20000000	/* DAC1 clock reset */
  #define RCC_APBRSTR1_LPTIM2RST   0x40000000	/* LPTIM2 clock reset */
  #define RCC_APBRSTR1_LPTIM1RST   0x80000000	/* LPTIM1 clock reset */
#define TOFF_RCC_APBRSTR2   0x0030		/* (RW) RCC APB peripheral reset register 2 */
  #define RCC_APBRSTR2_SYSCFGRST   0x00000001	/* SYSCFG clock reset */
  #define RCC_APBRSTR2_TIM1RST     0x00000800	/* TIM1 clock reset */
  #define RCC_APBRSTR2_SPI1RST     0x00001000	/* SPI1 clock reset */
  #define RCC_APBRSTR2_USART1RST   0x00004000	/* USART1 clock reset */
  #define RCC_APBRSTR2_TIM14RST    0x00008000	/* TIM14 clock reset */
  #define RCC_APBRSTR2_TIM15RST    0x00010000	/* TIM15 clock reset */
  #define RCC_APBRSTR2_TIM16RST    0x00020000	/* TIM16 clock reset */
  #define RCC_APBRSTR2_TIM17RST    0x00040000	/* TIM17 clock reset */
  #define RCC_APBRSTR2_ADCRST      0x00100000	/* ADC clock reset */
#define TOFF_RCC_IOPENR     0x0034		/* (RW) RCC Clock IO port enable register */
  #define RCC_IOPENR_GPIOAEN       0x00000001	/* GPIO port A clock enable */
  #define RCC_IOPENR_GPIOBEN       0x00000002	/* GPIO port B clock enable */
  #define RCC_IOPENR_GPIOCEN       0x00000004	/* GPIO port C clock enable */
  #define RCC_IOPENR_GPIODEN       0x00000008	/* GPIO port D clock enable */
#if BOARDNO == 1
  #define RCC_IOPENR_GPIOEEN       0x00000010	/* GPIO port E clock enable */
#endif
  #define RCC_IOPENR_GPIOFEN       0x00000020	/* GPIO port F clock enable */
  #define RCC_IOPENR_IOPAEN        (RCC_IOPENR_GPIOAEN)
  #define RCC_IOPENR_IOPBEN        (RCC_IOPENR_GPIOBEN)
  #define RCC_IOPENR_IOPCEN        (RCC_IOPENR_GPIOCEN)
  #define RCC_IOPENR_IOPDEN        (RCC_IOPENR_GPIODEN)
  #define RCC_IOPENR_IOPFEN        (RCC_IOPENR_GPIOFEN)
#define TOFF_RCC_AHBENR     0x0038		/* (RW) RCC AHB peripheral clock enable register */
  #define RCC_AHBENR_DMA1EN        0x00000001	/* DMA1 clock enable */
#if BOARDNO == 1
  #define RCC_AHBENR_DMA2EN        0x00000002	/* DMA2 clock enable */
#endif
  #define RCC_AHBENR_FLASHEN       0x00000100	/* FLASH clock enable */
  #define RCC_AHBENR_CRCEN         0x00001000	/* CRC clock enable */
  #define RCC_AHBENR_DMAEN         (RCC_AHBENR_DMA1EN)
#define TOFF_RCC_APBENR1    0x003C		/* (RW) RCC APB peripheral enable register 1 */
  #define RCC_APBENR1_TIM2EN       0x00000001	/* TIM2 clock enable */
  #define RCC_APBENR1_TIM3EN       0x00000002	/* TIM3 clock enable */
  #define RCC_APBENR1_TIM6EN       0x00000010	/* TIM6 clock enable */
  #define RCC_APBENR1_TIM7EN       0x00000020	/* TIM7 clock enable */
#if BOARDNO == 1
  #define RCC_APBENR1_LPUART2EN    0x00000080	/* LPUART2 clock enable */
  #define RCC_APBENR1_USART5EN     0x00000100	/* USART5 clock enable */
  #define RCC_APBENR1_USART6EN     0x00000200	/* USART6 clock enable */
#endif
  #define RCC_APBENR1_RTCAPBEN     0x00000400	/* RTCAP clock enable */
  #define RCC_APBENR1_WWDGEN       0x00000800	/* WWDG clock enable */
#if BOARDNO == 1
  #define RCC_APBENR1_USBEN        0x00002000	/* USB clock enable */
#endif
  #define RCC_APBENR1_SPI2EN       0x00004000	/* SPI2 clock enable */
#if BOARDNO == 1
  #define RCC_APBENR1_SPI3EN       0x00008000	/* SPI3 clock enable */
  #define RCC_APBENR1_CRSEN        0x00010000	/* CRS clock enable */
#endif
  #define RCC_APBENR1_USART2EN     0x00020000	/* USART2 clock enable */
  #define RCC_APBENR1_USART3EN     0x00040000	/* USART3 clock enable */
  #define RCC_APBENR1_USART4EN     0x00080000	/* USART4 clock enable */
  #define RCC_APBENR1_LPUART1EN    0x00100000	/* LPUART1 clock enable */
  #define RCC_APBENR1_I2C1EN       0x00200000	/* I2C1 clock enable */
  #define RCC_APBENR1_I2C2EN       0x00400000	/* I2C2 clock enable */
#if BOARDNO == 1
  #define RCC_APBENR1_I2C3EN       0x00800000	/* I2C3 clock enable */
#endif
  #define RCC_APBENR1_CECEN        0x01000000	/* CEC clock enable */
  #define RCC_APBENR1_UCPD1EN      0x02000000	/* UCPD1 clock enable */
  #define RCC_APBENR1_UCPD2EN      0x04000000	/* UCPD2 clock enable */
  #define RCC_APBENR1_DBGEN        0x08000000	/* DBG clock enable */
  #define RCC_APBENR1_PWREN        0x10000000	/* PWR clock enable */
  #define RCC_APBENR1_DAC1EN       0x20000000	/* DAC1 clock enable */
  #define RCC_APBENR1_LPTIM2EN     0x40000000	/* LPTIM2 clock enable */
  #define RCC_APBENR1_LPTIM1EN     0x80000000	/* LPTIM1 clock enable */
  #define RCC_APB2ENR_DBGEN        (RCC_APB2ENR_DBGMCUEN)
#define TOFF_RCC_APBENR2    0x0040		/* (RW) RCC APB peripheral enable register 2 */
  #define RCC_APBENR2_SYSCFGEN     0x00000001	/* SYSCFG clock enable */
  #define RCC_APBENR2_TIM1EN       0x00000800	/* TIM1 clock enable */
  #define RCC_APBENR2_SPI1EN       0x00001000	/* SPI1 clock enable */
  #define RCC_APBENR2_USART1EN     0x00004000	/* USART1 clock enable */
  #define RCC_APBENR2_TIM14EN      0x00008000	/* TIM14 clock enable */
  #define RCC_APBENR2_TIM15EN      0x00010000	/* TIM15 clock enable */
  #define RCC_APBENR2_TIM16EN      0x00020000	/* TIM16 clock enable */
  #define RCC_APBENR2_TIM17EN      0x00040000	/* TIM17 clock enable */
  #define RCC_APBENR2_ADCEN        0x00100000	/* ADC1 clock enable */
  #define RCC_APB2ENR_ADC1EN       (RCC_APB2ENR_ADCEN)
#define TOFF_RCC_IOPSMENR   0x0044		/* (RW) RCC IO port clock enable in sleep mode register */
  #define RCC_IOPSMENR_GPIOASMEN   0x00000001	/* GPIO port A clock enabled in sleep mode */
  #define RCC_IOPSMENR_GPIOBSMEN   0x00000002	/* GPIO port B clock enabled in sleep mode */
  #define RCC_IOPSMENR_GPIOCSMEN   0x00000004	/* GPIO port C clock enabled in sleep mode */
  #define RCC_IOPSMENR_GPIODSMEN   0x00000008	/* GPIO port D clock enabled in sleep mode */
#if BOARDNO == 1
  #define RCC_IOPSMENR_GPIOESMEN   0x00000010	/* GPIO port E clock enabled in sleep mode */
#endif
  #define RCC_IOPSMENR_GPIOFSMEN   0x00000020	/* GPIO port F clock enabled in sleep mode */
  #define RCC_IOPSMENR_IOPASMEN    (RCC_IOPSMENR_GPIOASMEN)
  #define RCC_IOPSMENR_IOPBSMEN    (RCC_IOPSMENR_GPIOBSMEN)
  #define RCC_IOPSMENR_IOPCSMEN    (RCC_IOPSMENR_GPIOCSMEN)
  #define RCC_IOPSMENR_IOPDSMEN    (RCC_IOPSMENR_GPIODSMEN)
  #define RCC_IOPSMENR_IOPFSMEN    (RCC_IOPSMENR_GPIOFSMEN)
#define TOFF_RCC_AHBSMENR   0x0048		/* (RW) RCC AHB peripheral clock enable in sleep mode register */
  #define RCC_AHBSMENR_DMA1SMEN    0x00000001	/* DMA1 clock enabled in sleep mode */
#if BOARDNO == 1
  #define RCC_AHBSMENR_DMA2SMEN    0x00000002	/* DMA2 clock enabled in sleep mode */
#endif
  #define RCC_AHBSMENR_FLASHSMEN   0x00000100	/* FLASH clock enabled in sleep mode */
  #define RCC_AHBSMENR_SRAMSMEN    0x00000200	/* SRAM clock enabled in sleep mode */
  #define RCC_AHBSMENR_CRCSMEN     0x00001000	/* CRC clock enabled in sleep mode */
  #define RCC_AHBSMENR_DMASMEN     (RCC_AHBSMENR_DMA1SMEN)
#define TOFF_RCC_APBSMENR1  0x004C		/* (RW) RCC APB peripheral clock enable in sleep mode register 1 */
  #define RCC_APBSMENR1_TIM2SMEN   0x00000001	/* TIM2 clock enabled in sleep mode */
  #define RCC_APBSMENR1_TIM3SMEN   0x00000002	/* TIM3 clock enabled in sleep mode */
  #define RCC_APBSMENR1_TIM6SMEN   0x00000010	/* TIM6 clock enabled in sleep mode */
  #define RCC_APBSMENR1_TIM7SMEN   0x00000020	/* TIM7 clock enabled in sleep mode */
#if BOARDNO == 1
  #define RCC_APBSMENR1_LPUART2SMEN 0x00000080	/* LPUART2 clock enabled in sleep mode */
  #define RCC_APBSMENR1_USART5SMEN 0x00000100	/* USART5 clock enabled in sleep mode */
  #define RCC_APBSMENR1_USART6SMEN 0x00000200	/* USART6 clock enabled in sleep mode */
#endif
  #define RCC_APBSMENR1_RTCAPBSMEN 0x00000400	/* RTCAP clock enabled in sleep mode */
  #define RCC_APBSMENR1_WWDGSMEN   0x00000800	/* WWDG clock enabled in sleep mode */
#if BOARDNO == 1
  #define RCC_APBSMENR1_USBSMEN    0x00002000	/* USB clock enabled in sleep mode */
#endif
  #define RCC_APBSMENR1_SPI2SMEN   0x00004000	/* SPI2 clock enabled in sleep mode */
#if BOARDNO == 1
  #define RCC_APBSMENR1_SPI3SMEN   0x00008000	/* SPI3 clock enabled in sleep mode */
  #define RCC_APBSMENR1_CRSSMEN    0x00010000	/* CRS clock enabled in sleep mode */
#endif
  #define RCC_APBSMENR1_USART2SMEN 0x00020000	/* USART2 clock enabled in sleep mode */
  #define RCC_APBSMENR1_USART3SMEN 0x00040000	/* USART3 clock enabled in sleep mode */
  #define RCC_APBSMENR1_USART4SMEN 0x00080000	/* USART4 clock enabled in sleep mode */
  #define RCC_APBSMENR1_LPUART1SMEN 0x00100000	/* LPUART1 clock enabled in sleep mode */
  #define RCC_APBSMENR1_I2C1SMEN   0x00200000	/* I2C1 clock enabled in sleep mode */
  #define RCC_APBSMENR1_I2C2SMEN   0x00400000	/* I2C2 clock enabled in sleep mode */
#if BOARDNO == 1
  #define RCC_APBSMENR1_I2C3SMEN   0x00800000	/* I2C3 clock enabled in sleep mode */
#endif
  #define RCC_APBSMENR1_CECSMEN    0x01000000	/* CEC clock enabled in sleep mode */
  #define RCC_APBSMENR1_UCPD1SMEN  0x02000000	/* UCPD1 clock enabled in sleep mode */
  #define RCC_APBSMENR1_UCPD2SMEN  0x04000000	/* UCPD2 clock enabled in sleep mode */
  #define RCC_APBSMENR1_DBGSMEN    0x08000000	/* DBG clock enabled in sleep mode */
  #define RCC_APBSMENR1_PWRSMEN    0x10000000	/* PWR clock enabled in sleep mode */
  #define RCC_APBSMENR1_DAC1SMEN   0x20000000	/* DAC1 clock enabled in sleep mode */
  #define RCC_APBSMENR1_LPTIM2SMEN 0x40000000	/* LPTIM2 clock enabled in sleep mode */
  #define RCC_APBSMENR1_LPTIM1SMEN 0x80000000	/* LPTIM1 clock enabled in sleep mode */
  #define RCC_APB2SMENR_DBGMCUSMEN (RCC_APB2SMENR_DBGSMEN)
#define TOFF_RCC_APBSMENR2  0x0050		/* (RW) RCC APB peripheral clock enable in sleep mode register 2 */
  #define RCC_APBSMENR2_SYSCFGSMEN 0x00000001	/* SYSCFG clock enabled in sleep mode */
  #define RCC_APBSMENR2_TIM1SMEN   0x00000800	/* TIM1 clock enabled in sleep mode */
  #define RCC_APBSMENR2_SPI1SMEN   0x00001000	/* SPI1 clock enabled in sleep mode */
  #define RCC_APBSMENR2_USART1SMEN 0x00004000	/* USART1 clock enabled in sleep mode */
  #define RCC_APBSMENR2_TIM14SMEN  0x00008000	/* TIM14 clock enabled in sleep mode */
  #define RCC_APBSMENR2_TIM15SMEN  0x00010000	/* TIM15 clock enabled in sleep mode */
  #define RCC_APBSMENR2_TIM16SMEN  0x00020000	/* TIM16 clock enabled in sleep mode */
  #define RCC_APBSMENR2_TIM17SMEN  0x00040000	/* TIM17 clock enabled in sleep mode */
  #define RCC_APBSMENR2_ADCSMEN    0x00100000	/* ADC1 clock enabled in sleep mode */
  #define RCC_APB2SMENR_ADC1SMEN   RCC_APB2SMENR_ADCSMEN	/* ADC1 clock enabled in sleep mode */
#define TOFF_RCC_CCIPR      0x0054		/* (RW) RCC clock configuration register */
  #define RCC_CCIPR_USART1SEL      0x00000003	/* USART1SEL[1:0] bits */
  #define RCC_CCIPR_USART1SEL_0    0x00000001
  #define RCC_CCIPR_USART1SEL_1    0x00000002
  #define RCC_CCIPR_USART2SEL      0x0000000C	/* USART2SEL[1:0] bits */
  #define RCC_CCIPR_USART2SEL_0    0x00000004
  #define RCC_CCIPR_USART2SEL_1    0x00000008
#if BOARDNO == 1
  #define RCC_CCIPR_USART3SEL      0x00000030	/* USART3SEL[1:0] bits */
  #define RCC_CCIPR_USART3SEL_0    0x00000010
  #define RCC_CCIPR_USART3SEL_1    0x00000020
#endif
  #define RCC_CCIPR_CECSEL         0x00000040	/* CECSEL bits */
#if BOARDNO == 1
  #define RCC_CCIPR_LPUART2SEL     0x00000300	/* LPUART2SEL[1:0] bits */
  #define RCC_CCIPR_LPUART2SEL_0   0x00000100
  #define RCC_CCIPR_LPUART2SEL_1   0x00000200
#endif
  #define RCC_CCIPR_LPUART1SEL     0x00000C00	/* LPUART1SEL[1:0] bits */
  #define RCC_CCIPR_LPUART1SEL_0   0x00000400
  #define RCC_CCIPR_LPUART1SEL_1   0x00000800
  #define RCC_CCIPR_I2C1SEL        0x00003000	/* I2C1SEL [1:0] bits */
  #define RCC_CCIPR_I2C1SEL_0      0x00001000
  #define RCC_CCIPR_I2C1SEL_1      0x00002000
#if BOARDNO == 1
  #define RCC_CCIPR_I2C2SEL        0x0000C000	/* I2C2SEL [1:0] bits */
  #define RCC_CCIPR_I2C2SEL_0      0x00004000
  #define RCC_CCIPR_I2C2SEL_1      0x00008000
#else
  #define RCC_CCIPR_I2S1SEL        0x0000C000	/* I2S1SEL [1:0] bits */
  #define RCC_CCIPR_I2S1SEL_0      0x00004000
  #define RCC_CCIPR_I2S1SEL_1      0x00008000
#endif
  #define RCC_CCIPR_LPTIM1SEL      0x000C0000	/* LPTIM1SEL [1:0] bits */
  #define RCC_CCIPR_LPTIM1SEL_0    0x00040000
  #define RCC_CCIPR_LPTIM1SEL_1    0x00080000
  #define RCC_CCIPR_LPTIM2SEL      0x00300000	/* LPTIM2SEL [1:0] bits */
  #define RCC_CCIPR_LPTIM2SEL_0    0x00100000
  #define RCC_CCIPR_LPTIM2SEL_1    0x00200000
  #define RCC_CCIPR_TIM1SEL        0x00400000	/* TIM1SEL bits */
  #define RCC_CCIPR_TIM15SEL       0x01000000	/* TIM15SEL bits */
  #define RCC_CCIPR_ADCSEL         0xC0000000	/* ADCSEL [1:0] bits */
  #define RCC_CCIPR_ADCSEL_0       0x40000000
  #define RCC_CCIPR_ADCSEL_1       0x80000000
#if BOARDNO == 1
#define TOFF_RCC_CCIPR2      0x0058		/* (RW) RCC clock configuration register #2 */
  #define RCC_CCIPR2_I2S1SE        0x00000003	/* I2S1SEL [1:0] bits */
  #define RCC_CCIPR2_I2S1SEL_0     0x00000001
  #define RCC_CCIPR2_I2S1SEL_1     0x00000002
  #define RCC_CCIPR2_I2S2SEL       0x0000000C	/* I2S2SEL [1:0] bits */
  #define RCC_CCIPR2_I2S2SEL_0     0x00000004
  #define RCC_CCIPR2_I2S2SEL_1     0x00000008
  #define RCC_CCIPR2_FDCANSEL      0x00000300	/* FDCANSEL [1:0] bits */
  #define RCC_CCIPR2_FDCANSEL_0    0x00000100
  #define RCC_CCIPR2_FDCANSEL_1    0x00000200
  #define RCC_CCIPR2_USBSEL        0x00003000	/* USBSEL [1:0] bits */
  #define RCC_CCIPR2_USBSEL_0      0x00001000
  #define RCC_CCIPR2_USBSEL_1      0x00002000
  #define RCC_USBCLKSOURCE_HSI48   0x00000000	/* HSI48 oscillator clock selected as USB clock */
  #define RCC_USBCLKSOURCE_HSE     RCC_CCIPR2_USBSEL_0	/* HSE oscillator clock selected as USB clock */
  #define RCC_USBCLKSOURCE_PLL     RCC_CCIPR2_USBSEL_1  /* PLL "Q" selected as USB clock */
#endif
#define TOFF_RCC_BDCR       0x005C		/* (RW) RCC Backup Domain Control Register */
  #define RCC_BDCR_LSEON           0x00000001
  #define RCC_BDCR_LSERDY          0x00000002
  #define RCC_BDCR_LSEBYP          0x00000004
  #define RCC_BDCR_LSEDRV          0x00000018
  #define RCC_BDCR_LSEDRV_0        0x00000008
  #define RCC_BDCR_LSEDRV_1        0x00000010
  #define RCC_BDCR_LSECSSON        0x00000020
  #define RCC_BDCR_LSECSSD         0x00000040
  #define RCC_BDCR_RTCSEL          0x00000300
  #define RCC_BDCR_RTCSEL_0        0x00000100
  #define RCC_BDCR_RTCSEL_1        0x00000200
  #define RCC_BDCR_RTCEN           0x00008000
  #define RCC_BDCR_BDRST           0x00010000
  #define RCC_BDCR_LSCOEN          0x01000000
  #define RCC_BDCR_LSCOSEL         0x02000000
#define TOFF_RCC_CSR        0x0060		/* (RW) RCC Control/status register */
  #define RCC_CSR_LSION            0x00000001	/* Internal Low Speed oscillator enable */
  #define RCC_CSR_LSIRDY           0x00000002	/* Internal Low Speed oscillator Ready */
  #define RCC_CSR_RMVF             0x00800000	/* Remove reset flag */
  #define RCC_CSR_OBLRSTF          0x02000000	/* OBL reset flag */
  #define RCC_CSR_PINRSTF          0x04000000	/* PIN reset flag */
  #define RCC_CSR_PWRRSTF          0x08000000	/* PWR reset flag */
  #define RCC_CSR_SFTRSTF          0x10000000	/* Software Reset flag */
  #define RCC_CSR_IWDGRSTF         0x20000000	/* Independent Watchdog reset flag */
  #define RCC_CSR_WWDGRSTF         0x40000000	/* Window watchdog reset flag */
  #define RCC_CSR_LPWRRSTF         0x80000000	/* Low-Power reset flag */


/*
 *  EXTERNAL INTERRUPT/EVENT CONTROLLER
 */
#define TADR_EXTI_BASE      (AHBPERIPH_BASE + 0x1800)
#define TOFF_EXTI_RTSR1     0x0000		/* (RW) EXTI Rising trigger selection register 1 */
  #define EXTI_RTSR1_TR0     0x00000001	/* Rising trigger event configuration bit of line 0 */
  #define EXTI_RTSR1_TR1     0x00000002	/* Rising trigger event configuration bit of line 1 */
  #define EXTI_RTSR1_TR2     0x00000004	/* Rising trigger event configuration bit of line 2 */
  #define EXTI_RTSR1_TR3     0x00000008	/* Rising trigger event configuration bit of line 3 */
  #define EXTI_RTSR1_TR4     0x00000010	/* Rising trigger event configuration bit of line 4 */
  #define EXTI_RTSR1_TR5     0x00000020	/* Rising trigger event configuration bit of line 5 */
  #define EXTI_RTSR1_TR6     0x00000040	/* Rising trigger event configuration bit of line 6 */
  #define EXTI_RTSR1_TR7     0x00000080	/* Rising trigger event configuration bit of line 7 */
  #define EXTI_RTSR1_TR8     0x00000100	/* Rising trigger event configuration bit of line 8 */
  #define EXTI_RTSR1_TR9     0x00000200	/* Rising trigger event configuration bit of line 9 */
  #define EXTI_RTSR1_TR10    0x00000400	/* Rising trigger event configuration bit of line 10 */
  #define EXTI_RTSR1_TR11    0x00000800	/* Rising trigger event configuration bit of line 11 */
  #define EXTI_RTSR1_TR12    0x00001000	/* Rising trigger event configuration bit of line 12 */
  #define EXTI_RTSR1_TR13    0x00002000	/* Rising trigger event configuration bit of line 13 */
  #define EXTI_RTSR1_TR14    0x00004000	/* Rising trigger event configuration bit of line 14 */
  #define EXTI_RTSR1_TR15    0x00008000	/* Rising trigger event configuration bit of line 15 */
  #define EXTI_RTSR1_TR16    0x00010000	/* Rising trigger event configuration bit of line 16 */
  #define EXTI_RTSR1_TR17    0x00020000	/* Rising trigger event configuration bit of line 17 */
  #define EXTI_RTSR1_TR18    0x00040000	/* Rising trigger event configuration bit of line 18 */
  #define EXTI_RTSR1_TR19    0x00080000	/* Rising trigger event configuration bit of line 19 */
  #define EXTI_RTSR1_TR20    0x00100000	/* Rising trigger event configuration bit of line 20 */
  #define EXTI_RTSR1_TR21    0x00200000	/* Rising trigger event configuration bit of line 21 */
  #define EXTI_RTSR1_TR22    0x00400000	/* Rising trigger event configuration bit of line 22 */
  #define EXTI_RTSR1_TR31    0x80000000	/* Rising trigger event configuration bit of line 31 */
#define TOFF_EXTI_FTSR1     0x0004		/* (RW) EXTI Falling trigger selection register 1 */
  #define EXTI_FTSR1_TR0     0x00000001	/* Falling trigger event configuration bit of line 0 */
  #define EXTI_FTSR1_TR1     0x00000002	/* Falling trigger event configuration bit of line 1 */
  #define EXTI_FTSR1_TR2     0x00000004	/* Falling trigger event configuration bit of line 2 */
  #define EXTI_FTSR1_TR3     0x00000008	/* Falling trigger event configuration bit of line 3 */
  #define EXTI_FTSR1_TR4     0x00000010	/* Falling trigger event configuration bit of line 4 */
  #define EXTI_FTSR1_TR5     0x00000020	/* Falling trigger event configuration bit of line 5 */
  #define EXTI_FTSR1_TR6     0x00000040	/* Falling trigger event configuration bit of line 6 */
  #define EXTI_FTSR1_TR7     0x00000080	/* Falling trigger event configuration bit of line 7 */
  #define EXTI_FTSR1_TR8     0x00000100	/* Falling trigger event configuration bit of line 8 */
  #define EXTI_FTSR1_TR9     0x00000200	/* Falling trigger event configuration bit of line 9 */
  #define EXTI_FTSR1_TR10    0x00000400	/* Falling trigger event configuration bit of line 10 */
  #define EXTI_FTSR1_TR11    0x00000800	/* Falling trigger event configuration bit of line 11 */
  #define EXTI_FTSR1_TR12    0x00001000	/* Falling trigger event configuration bit of line 12 */
  #define EXTI_FTSR1_TR13    0x00002000	/* Falling trigger event configuration bit of line 13 */
  #define EXTI_FTSR1_TR14    0x00004000	/* Falling trigger event configuration bit of line 14 */
  #define EXTI_FTSR1_TR15    0x00008000	/* Falling trigger event configuration bit of line 15 */
  #define EXTI_FTSR1_TR16    0x00010000	/* Falling trigger event configuration bit of line 16 */
  #define EXTI_FTSR1_TR17    0x00020000	/* Falling trigger event configuration bit of line 17 */
  #define EXTI_FTSR1_TR18    0x00040000	/* Falling trigger event configuration bit of line 18 */
  #define EXTI_FTSR1_TR19    0x00080000	/* Falling trigger event configuration bit of line 19 */
  #define EXTI_FTSR1_TR20    0x00100000	/* Falling trigger event configuration bit of line 20 */
  #define EXTI_FTSR1_TR21    0x00200000	/* Falling trigger event configuration bit of line 21 */
  #define EXTI_FTSR1_TR22    0x00400000	/* Falling trigger event configuration bit of line 22 */
  #define EXTI_FTSR1_TR31    0x80000000	/* Falling trigger event configuration bit of line 31 */
#define TOFF_EXTI_SWIER1    0x0008		/* (RW) EXTI Software interrupt event register 1 */
  #define EXTI_SWIER1_SWIER0 0x00000000	/* Software Interrupt on line 0  */
  #define EXTI_SWIER1_SWIER1 0x00000002	/* Software Interrupt on line 1  */
  #define EXTI_SWIER1_SWIER2 0x00000004	/* Software Interrupt on line 2  */
  #define EXTI_SWIER1_SWIER3 0x00000008	/* Software Interrupt on line 3  */
  #define EXTI_SWIER1_SWIER4 0x00000010	/* Software Interrupt on line 4  */
  #define EXTI_SWIER1_SWIER5 0x00000020	/* Software Interrupt on line 5  */
  #define EXTI_SWIER1_SWIER6 0x00000040	/* Software Interrupt on line 6  */
  #define EXTI_SWIER1_SWIER7 0x00000080	/* Software Interrupt on line 7  */
  #define EXTI_SWIER1_SWIER8 0x00000100	/* Software Interrupt on line 8  */
  #define EXTI_SWIER1_SWIER9 0x00000200	/* Software Interrupt on line 9  */
  #define EXTI_SWIER1_SWIER10 0x00000400	/* Software Interrupt on line 10 */
  #define EXTI_SWIER1_SWIER11 0x00000800	/* Software Interrupt on line 11 */
  #define EXTI_SWIER1_SWIER12 0x00001000	/* Software Interrupt on line 12 */
  #define EXTI_SWIER1_SWIER13 0x00002000	/* Software Interrupt on line 13 */
  #define EXTI_SWIER1_SWIER14 0x00004000	/* Software Interrupt on line 14 */
  #define EXTI_SWIER1_SWIER15 0x00008000	/* Software Interrupt on line 15 */
  #define EXTI_SWIER1_SWIER16 0x00010000	/* Software Interrupt on line 16 */
  #define EXTI_SWIER1_SWIER17 0x00020000	/* Software Interrupt on line 17 */
  #define EXTI_SWIER1_SWIER19 0x00080000	/* Software Interrupt on line 19 */
  #define EXTI_SWIER1_SWIER20 0x00100000	/* Software Interrupt on line 20 */
  #define EXTI_SWIER1_SWIER21 0x00200000	/* Software Interrupt on line 21 */
  #define EXTI_SWIER1_SWIER22 0x00400000	/* Software Interrupt on line 22 */
  #define EXTI_SWIER1_SWIER31 0x80000000	/* Software Interrupt on line 31 */
#define TOFF_EXTI_RPR1      0x000C		/* (RW) EXTI Rising Pending Register 1 */
  #define EXTI_RPR1_RPIF0    0x00000001	/* Rising Pending Interrupt Flag on line 0 */
  #define EXTI_RPR1_RPIF1    0x00000002	/* Rising Pending Interrupt Flag on line 1 */
  #define EXTI_RPR1_RPIF2    0x00000004	/* Rising Pending Interrupt Flag on line 2 */
  #define EXTI_RPR1_RPIF3    0x00000008	/* Rising Pending Interrupt Flag on line 3 */
  #define EXTI_RPR1_RPIF4    0x00000010	/* Rising Pending Interrupt Flag on line 4 */
  #define EXTI_RPR1_RPIF5    0x00000020	/* Rising Pending Interrupt Flag on line 5 */
  #define EXTI_RPR1_RPIF6    0x00000040	/* Rising Pending Interrupt Flag on line 6 */
  #define EXTI_RPR1_RPIF7    0x00000080	/* Rising Pending Interrupt Flag on line 7 */
  #define EXTI_RPR1_RPIF8    0x00000100	/* Rising Pending Interrupt Flag on line 8 */
  #define EXTI_RPR1_RPIF9    0x00000200	/* Rising Pending Interrupt Flag on line 9 */
  #define EXTI_RPR1_RPIF10   0x00000400	/* Rising Pending Interrupt Flag on line 10 */
  #define EXTI_RPR1_RPIF11   0x00000800	/* Rising Pending Interrupt Flag on line 11 */
  #define EXTI_RPR1_RPIF12   0x00001000	/* Rising Pending Interrupt Flag on line 12 */
  #define EXTI_RPR1_RPIF13   0x00002000	/* Rising Pending Interrupt Flag on line 13 */
  #define EXTI_RPR1_RPIF14   0x00004000	/* Rising Pending Interrupt Flag on line 14 */
  #define EXTI_RPR1_RPIF15   0x00008000	/* Rising Pending Interrupt Flag on line 15 */
  #define EXTI_RPR1_RPIF16   0x00010000	/* Rising Pending Interrupt Flag on line 16 */
  #define EXTI_RPR1_RPIF17   0x00020000	/* Rising Pending Interrupt Flag on line 17 */
  #define EXTI_RPR1_RPIF18   0x00040000	/* Rising Pending Interrupt Flag on line 18 */
#define TOFF_EXTI_FPR1      0x0010		/* (RW) EXTI Falling Pending Register 1 */
  #define EXTI_FPR1_FPIF0    0x00000001	/* Falling Pending Interrupt Flag on line 0 */
  #define EXTI_FPR1_FPIF1    0x00000002	/* Falling Pending Interrupt Flag on line 1 */
  #define EXTI_FPR1_FPIF2    0x00000004	/* Falling Pending Interrupt Flag on line 2 */
  #define EXTI_FPR1_FPIF3    0x00000008	/* Falling Pending Interrupt Flag on line 3 */
  #define EXTI_FPR1_FPIF4    0x00000010	/* Falling Pending Interrupt Flag on line 4 */
  #define EXTI_FPR1_FPIF5    0x00000020	/* Falling Pending Interrupt Flag on line 5 */
  #define EXTI_FPR1_FPIF6    0x00000040	/* Falling Pending Interrupt Flag on line 6 */
  #define EXTI_FPR1_FPIF7    0x00000080	/* Falling Pending Interrupt Flag on line 7 */
  #define EXTI_FPR1_FPIF8    0x00000100	/* Falling Pending Interrupt Flag on line 8 */
  #define EXTI_FPR1_FPIF9    0x00000200	/* Falling Pending Interrupt Flag on line 9 */
  #define EXTI_FPR1_FPIF10   0x00000400	/* Falling Pending Interrupt Flag on line 10 */
  #define EXTI_FPR1_FPIF11   0x00000800	/* Falling Pending Interrupt Flag on line 11 */
  #define EXTI_FPR1_FPIF12   0x00001000	/* Falling Pending Interrupt Flag on line 12 */
  #define EXTI_FPR1_FPIF13   0x00002000	/* Falling Pending Interrupt Flag on line 13 */
  #define EXTI_FPR1_FPIF14   0x00004000	/* Falling Pending Interrupt Flag on line 14 */
  #define EXTI_FPR1_FPIF15   0x00008000	/* Falling Pending Interrupt Flag on line 15 */
  #define EXTI_FPR1_FPIF16   0x00010000	/* Falling Pending Interrupt Flag on line 16 */
  #define EXTI_FPR1_FPIF17   0x00020000	/* Falling Pending Interrupt Flag on line 17 */
  #define EXTI_FPR1_FPIF18   0x00040000	/* Falling Pending Interrupt Flag on line 18 */
#define TOFF_EXTI_EXTICR    0x0060		/* (RW) EXTI External Interrupt Configuration Register 0-3 */
  #define EXTI_EXTICR1_EXTI0 0x00000007	/* EXTI 0 configuration */
  #define EXTI_EXTICR1_EXTI0_0 0x00000001
  #define EXTI_EXTICR1_EXTI0_1 0x00000002
  #define EXTI_EXTICR1_EXTI0_2 0x00000004
  #define EXTI_EXTICR1_EXTI1 0x00000700	/* EXTI 1 configuration */
  #define EXTI_EXTICR1_EXTI1_0 0x00000100
  #define EXTI_EXTICR1_EXTI1_1 0x00000200
  #define EXTI_EXTICR1_EXTI1_2 0x00000400
  #define EXTI_EXTICR1_EXTI2 0x00070000	/* EXTI 2 configuration */
  #define EXTI_EXTICR1_EXTI2_0 0x00010000
  #define EXTI_EXTICR1_EXTI2_1 0x00020000
  #define EXTI_EXTICR1_EXTI2_2 0x00040000
  #define EXTI_EXTICR1_EXTI3 0x07000000	/* EXTI 3 configuration */
  #define EXTI_EXTICR1_EXTI3_0 0x01000000
  #define EXTI_EXTICR1_EXTI3_1 0x02000000
  #define EXTI_EXTICR1_EXTI3_2 0x04000000

  #define EXTI_EXTICR2_EXTI4 0x00000007	/* EXTI 4 configuration */
  #define EXTI_EXTICR2_EXTI4_0 0x00000001
  #define EXTI_EXTICR2_EXTI4_1 0x00000002
  #define EXTI_EXTICR2_EXTI4_2 0x00000004
  #define EXTI_EXTICR2_EXTI5 0x00000700	/* EXTI 5 configuration */
  #define EXTI_EXTICR2_EXTI5_0 0x00000100
  #define EXTI_EXTICR2_EXTI5_1 0x00000200
  #define EXTI_EXTICR2_EXTI5_2 0x00000400
  #define EXTI_EXTICR2_EXTI6 0x00070000	/* EXTI 6 configuration */
  #define EXTI_EXTICR2_EXTI6_0 0x00010000
  #define EXTI_EXTICR2_EXTI6_1 0x00020000
  #define EXTI_EXTICR2_EXTI6_2 0x00040000
  #define EXTI_EXTICR2_EXTI7 0x07000000	/* EXTI 7 configuration */
  #define EXTI_EXTICR2_EXTI7_0 0x01000000
  #define EXTI_EXTICR2_EXTI7_1 0x02000000
  #define EXTI_EXTICR2_EXTI7_2 0x04000000

  #define EXTI_EXTICR3_EXTI8 0x00000007	/* EXTI 8 configuration */
  #define EXTI_EXTICR3_EXTI8_0 0x00000001
  #define EXTI_EXTICR3_EXTI8_1 0x00000002
  #define EXTI_EXTICR3_EXTI8_2 0x00000004
  #define EXTI_EXTICR3_EXTI9 0x00000700	/* EXTI 9 configuration */
  #define EXTI_EXTICR3_EXTI9_0 0x00000100
  #define EXTI_EXTICR3_EXTI9_1 0x00000200
  #define EXTI_EXTICR3_EXTI9_2 0x00000400
  #define EXTI_EXTICR3_EXTI10 0x00070000	/* EXTI 10 configuration */
  #define EXTI_EXTICR3_EXTI10_0 0x00010000
  #define EXTI_EXTICR3_EXTI10_1 0x00020000
  #define EXTI_EXTICR3_EXTI10_2 0x00040000
  #define EXTI_EXTICR3_EXTI11 0x07000000	/* EXTI 11 configuration */
  #define EXTI_EXTICR3_EXTI11_0 0x01000000
  #define EXTI_EXTICR3_EXTI11_1 0x02000000
  #define EXTI_EXTICR3_EXTI11_2 0x04000000

  #define EXTI_EXTICR4_EXTI12 0x00000007	/* EXTI 12 configuration */
  #define EXTI_EXTICR4_EXTI12_0 0x00000001
  #define EXTI_EXTICR4_EXTI12_1 0x00000002
  #define EXTI_EXTICR4_EXTI12_2 0x00000004
  #define EXTI_EXTICR4_EXTI13 0x00000700	/* EXTI 13 configuration */
  #define EXTI_EXTICR4_EXTI13_0 0x00000100
  #define EXTI_EXTICR4_EXTI13_1 0x00000200
  #define EXTI_EXTICR4_EXTI13_2 0x00000400
  #define EXTI_EXTICR4_EXTI14 0x00070000	/* EXTI 14 configuration */
  #define EXTI_EXTICR4_EXTI14_0 0x00010000
  #define EXTI_EXTICR4_EXTI14_1 0x00020000
  #define EXTI_EXTICR4_EXTI14_2 0x00040000
  #define EXTI_EXTICR4_EXTI15 0x07000000	/* EXTI 15 configuration */
  #define EXTI_EXTICR4_EXTI15_0 0x01000000
  #define EXTI_EXTICR4_EXTI15_1 0x02000000
  #define EXTI_EXTICR4_EXTI15_2 0x04000000
#define TOFF_EXTI_IMR1      0x0080		/* (RW) EXTI Interrupt mask register 1 */
  #define EXTI_IMR1_MR0      0x00000001	/* Interrupt Mask on line 0 */
  #define EXTI_IMR1_MR1      0x00000002	/* Interrupt Mask on line 1 */
  #define EXTI_IMR1_MR2      0x00000004	/* Interrupt Mask on line 2 */
  #define EXTI_IMR1_MR3      0x00000008	/* Interrupt Mask on line 3 */
  #define EXTI_IMR1_MR4      0x00000010	/* Interrupt Mask on line 4 */
  #define EXTI_IMR1_MR5      0x00000020	/* Interrupt Mask on line 5 */
  #define EXTI_IMR1_MR6      0x00000040	/* Interrupt Mask on line 6 */
  #define EXTI_IMR1_MR7      0x00000080	/* Interrupt Mask on line 7 */
  #define EXTI_IMR1_MR8      0x00000100	/* Interrupt Mask on line 8 */
  #define EXTI_IMR1_MR9      0x00000200	/* Interrupt Mask on line 9 */
  #define EXTI_IMR1_MR10     0x00000400	/* Interrupt Mask on line 10 */
  #define EXTI_IMR1_MR11     0x00000800	/* Interrupt Mask on line 11 */
  #define EXTI_IMR1_MR12     0x00001000	/* Interrupt Mask on line 12 */
  #define EXTI_IMR1_MR13     0x00002000	/* Interrupt Mask on line 13 */
  #define EXTI_IMR1_MR14     0x00004000	/* Interrupt Mask on line 14 */
  #define EXTI_IMR1_MR15     0x00008000	/* Interrupt Mask on line 15 */
  #define EXTI_IMR1_MR16     0x00010000	/* Interrupt Mask on line 16 */
  #define EXTI_IMR1_MR17     0x00020000	/* Interrupt Mask on line 17 */
  #define EXTI_IMR1_MR18     0x00040000	/* Interrupt Mask on line 18 */
  #define EXTI_IMR1_MR19     0x00080000	/* Interrupt Mask on line 19 */
  #define EXTI_IMR1_MR20     0x00100000	/* Interrupt Mask on line 20 */
  #define EXTI_IMR1_MR21     0x00200000	/* Interrupt Mask on line 21 */
  #define EXTI_IMR1_MR22     0x00400000	/* Interrupt Mask on line 22 */
  #define EXTI_IMR1_MR23     0x00800000	/* Interrupt Mask on line 23 */
  #define EXTI_IMR1_MR25     0x02000000	/* Interrupt Mask on line 25 */
  #define EXTI_IMR1_MR26     0x04000000	/* Interrupt Mask on line 26 */
  #define EXTI_IMR1_MR27     0x08000000	/* Interrupt Mask on line 27 */
  #define EXTI_IMR1_MR28     0x10000000	/* Interrupt Mask on line 28 */
  #define EXTI_IMR1_MR31     0x80000000	/* Interrupt Mask on line 31 */
  #define EXTI_IMR1_IM       0xFEAFFFFF	/* Interrupt Mask All */
#define TOFF_EXTI_EMR1      0x0084		/* (RW) EXTI Event mask register 1 */
  #define EXTI_EMR1_MR0      0x00000001	/* Event Mask on line 0  */
  #define EXTI_EMR1_MR1      0x00000002	/* Event Mask on line 1  */
  #define EXTI_EMR1_MR2      0x00000004	/* Event Mask on line 2  */
  #define EXTI_EMR1_MR3      0x00000008	/* Event Mask on line 3  */
  #define EXTI_EMR1_MR4      0x00000010	/* Event Mask on line 4  */
  #define EXTI_EMR1_MR5      0x00000020	/* Event Mask on line 5  */
  #define EXTI_EMR1_MR6      0x00000040	/* Event Mask on line 6  */
  #define EXTI_EMR1_MR7      0x00000080	/* Event Mask on line 7  */
  #define EXTI_EMR1_MR8      0x00000100	/* Event Mask on line 8  */
  #define EXTI_EMR1_MR9      0x00000200	/* Event Mask on line 9  */
  #define EXTI_EMR1_MR10     0x00000400	/* Event Mask on line 10 */
  #define EXTI_EMR1_MR11     0x00000800	/* Event Mask on line 11 */
  #define EXTI_EMR1_MR12     0x00001000	/* Event Mask on line 12 */
  #define EXTI_EMR1_MR13     0x00002000	/* Event Mask on line 13 */
  #define EXTI_EMR1_MR14     0x00004000	/* Event Mask on line 14 */
  #define EXTI_EMR1_MR15     0x00008000	/* Event Mask on line 15 */
  #define EXTI_EMR1_MR16     0x00010000	/* Event Mask on line 16 */
  #define EXTI_EMR1_MR17     0x00020000	/* Event Mask on line 17 */
  #define EXTI_EMR1_MR18     0x00040000	/* Event Mask on line 18 */
  #define EXTI_EMR1_MR19     0x00080000	/* Event Mask on line 19 */
  #define EXTI_EMR1_MR20     0x00100000	/* Event Mask on line 20 */
  #define EXTI_EMR1_MR21     0x00200000	/* Event Mask on line 21 */
  #define EXTI_EMR1_MR22     0x00400000	/* Event Mask on line 22 */
  #define EXTI_EMR1_MR23     0x00800000	/* Event Mask on line 23 */
  #define EXTI_EMR1_MR25     0x02000000	/* Event Mask on line 25 */
  #define EXTI_EMR1_MR26     0x04000000	/* Event Mask on line 26 */
  #define EXTI_EMR1_MR27     0x08000000	/* Event Mask on line 27 */
  #define EXTI_EMR1_MR28     0x10000000	/* Event Mask on line 28 */
  #define EXTI_EMR1_MR31     0x80000000	/* Event Mask on line 31 */
#define TOFF_EXTI_IMR2      0x0090		/* (RW) EXTI Interrupt Mask Register 2 */
  #define EXTI_IMR2_IM32     0x00000001	/* Interrupt Mask on line 32 */
  #define EXTI_IMR2_IM33     0x00000002	/* Interrupt Mask on line 33 */
  #define EXTI_IMR2_IM       0x00000003	/* Interrupt Mask All */
#define TOFF_EXTI_EMR2      0x0094		/* (RW) EXTI Event Mask Register 2 */
  #define EXTI_EMR2_EM32     0x00000001	/* Event Mask on line 32 */
  #define EXTI_EMR2_EM33     0x00000002	/* Event Mask on line 33 */


/*
 *  FLASH REGISTERS
 */
#define TADR_FLASH_R_BASE   (AHBPERIPH_BASE + 0x2000)
#define TOFF_FLASH_ACR      0x0000		/* (RW) FLASH access control register */
  #define FLASH_ACR_LATENCY  0x00000007	/* LATENCY bit (Latency) */
  #define FLASH_ACR_LATENCY_0 0x00000001
  #define FLASH_ACR_LATENCY_1 0x00000002
  #define FLASH_ACR_LATENCY_2 0x00000004
  #define FLASH_ACR_PRFTEN   0x00000002	/* Prefetch Buffer Enable */
  #define FLASH_ACR_SLEEP    0x00000008	/* Flash mode during sleep mode */
  #define FLASH_ACR_RUN_PD   0x00000010	/* Flash mode during RUN mode */
  #define FLASH_ACR_DISAB_BUF 0x00000020	/* Disable Buffer */
  #define FLASH_ACR_PRE_READ 0x00000040	/* Pre-read data address */
#define TOFF_FLASH_PECR     0x0004		/* (RW) Program/erase control register */
  #define FLASH_PECR_PELOCK  0x00000001	/* FLASH_PECR and Flash data Lock */
  #define FLASH_PECR_PRGLOCK 0x00000002	/* Program matrix Lock */
  #define FLASH_PECR_OPTLOCK 0x00000004	/* Option byte matrix Lock */
  #define FLASH_PECR_PROG    0x00000008	/* Program matrix selection */
  #define FLASH_PECR_DATA    0x00000010	/* Data matrix selection */
  #define FLASH_PECR_FIX     0x00000100	/* Fixed Time Data write for Word/Half Word/Byte programming */
  #define FLASH_PECR_ERASE   0x00000200	/* Page erasing mode */
  #define FLASH_PECR_FPRG    0x00000400	/* Fast Page/Half Page programming mode */
  #define FLASH_PECR_PARALLBANK  0x00008000	/* Parallel Bank mode */
  #define FLASH_PECR_EOPIE   0x00010000	/* End of programming interrupt */ 
  #define FLASH_PECR_ERRIE   0x00020000	/* Error interrupt */ 
  #define FLASH_PECR_OBL_LAUNCH  0x00040000	/* Launch the option byte loading */
  #define FLASH_PECR_HALF_ARRAY  0x00080000	/* Half array mode */
  #define FLASH_PECR_NZDISABLE   0x00400000	/* Non-Zero check disable */
#define TOFF_FLASH_PDKEYR   0x0008		/* (RW) Power down key register */
#define TOFF_FLASE_PEKEYR   0x000C		/* (RW) Program/erase key register */
#define TOFF_FLASH_PRGKEYR  0x0010		/* (RW) Program memory key register */
#define TOFF_FLASH_OPTKEYR  0x0014		/* (RW) Option byte key register */
#define TOFF_FLASH_SR       0x0018		/* (RW) Status register */
  #define FLASH_SR_BSY       0x00000001	/* Busy */
  #define FLASH_SR_EOP       0x00000002	/* End Of Programming*/
  #define FLASH_SR_HVOFF     0x00000004	/* End of high voltage */
  #define FLASH_SR_READY     0x00000008	/* Flash ready after low power mode */
  #define FLASH_SR_WRPERR    0x00000100	/* Write protection error */
  #define FLASH_SR_PGAERR    0x00000200	/* Programming Alignment Error */
  #define FLASH_SR_SIZERR    0x00000400	/* Size error */
  #define FLASH_SR_OPTVERR   0x00000800	/* Option Valid error */
  #define FLASH_SR_RDERR     0x00002000	/* Read protected error */
  #define FLASH_SR_NOTZEROERR 0x00010000	/* Not Zero error */
  #define FLASH_SR_FWWERR    0x00020000	/* Write/Errase operation aborted */
  #define FLASH_SR_FWWER     FLASH_SR_FWWERR
  #define FLASH_SR_ENHV      FLASH_SR_HVOFF
  #define FLASH_SR_ENDHV     FLASH_SR_HVOFF
#define TOFF_FLASH_OPTR     0x001C		/* (RW) Option byte register */
  #define FLASH_OPTR_RDPROT  0x000000FF	/* Read Protection */
  #define FLASH_OPTR_WPRMOD  0x00000100	/* Selection of protection mode of WPR bits */
  #define FLASH_OPTR_BOR_LEV 0x000F0000	/* BOR_LEV[3:0] Brown Out Reset Threshold Level*/
  #define FLASH_OPTR_IWDG_SW 0x00100000	/* IWDG_SW */
  #define FLASH_OPTR_nRST_STOP   0x00200000	/* nRST_STOP */
  #define FLASH_OPTR_nRST_STDBY  0x00400000	/* nRST_STDBY */
  #define FLASH_OPTR_BFB2    0x00800000	/* BFB2 */
  #define FLASH_OPTR_USER    0x00700000	/* User Option Bytes */
  #define FLASH_OPTR_BOOT1   0x80000000	/* BOOT1 */
#define TOFF_FLASH_WRPR     0x0020		/* (RW) Write protection register */
  #define FLASH_WRPR_WRP     0x0000FFFF	/* Write Protection bits */
#define TOFF_FLASH_WRPR2    0x0080		/* (RW) Write protection register 2 */

#define TOFF_FLASH_AR       0x0014		/* (RW) FLASH address register */
#define TOFF_FLASH_OBR      0x001C		/* (RW) FLASH option bytes register */
  #define FLASH_OBR_OPTERR   0x00000001	/* Option Byte Error */
  #define FLASH_OBR_RDPRT1   0x00000002	/* Read protection Level 1 */
  #define FLASH_OBR_RDPRT2   0x00000004	/* Read protection Level 2 */
  #define FLASH_OBR_USER     0x0000FF00	/* User Option Bytes */
  #define FLASH_OBR_IWDG_SW  0x00000100	/* IWDG SW */
  #define FLASH_OBR_nRST_STOP    0x00000200	/* nRST_STOP */
  #define FLASH_OBR_nRST_STDBY   0x00000400	/* nRST_STDBY */
  #define FLASH_OBR_nBOOT0   0x00000800	/* nBOOT0 */
  #define FLASH_OBR_nBOOT1   0x00001000	/* nBOOT1 */
  #define FLASH_OBR_VDDA_MONITOR 0x00002000	/* VDDA power supply supervisor */
  #define FLASH_OBR_RAM_PARITY_CHECK 0x00004000	/* RAM parity check */
  #define FLASH_OBR_BOOT_SEL 0x00008000	/* BOOT selection */
  #define FLASH_OBR_DATA0    0x00FF0000	/* Data0 */
  #define FLASH_OBR_DATA1    0xFF000000	/* Data1 */
#define TOFF_FLASH_WRPR     0x0020		/* (RW) FLASH option bytes register */
  #define FLASH_WRPR_WRP     0x0000FFFF	/* Write Protect */


/*
 *  CRC CALCULATION UNIT
 */
#define TADR_CRC_BASE       (AHBPERIPH_BASE + 0x3000)
#define TOFF_CRC_DR         0x0000		/* (RW) CRC Data register */
#define TOFF_CRC_IDR        0x0004		/* (RW-8) CRC Independent data register */
#define TOFF_CRC_CR         0x0008		/* (RW) CRC Control register */
#define TOFF_CRC_INIT       0x0010		/* (RW) Initial CRC value register */
#define TOFF_CRC_POL        0x0014		/* (RW) CRC polynomial register */


/*
 *  GENERAL PURPOSE I/O
 */
#define TADR_GPIOA_BASE     (IOPORT_BASE + 0x0000)
#define TADR_GPIOB_BASE     (IOPORT_BASE + 0x0400)
#define TADR_GPIOC_BASE     (IOPORT_BASE + 0x0800)
#define TADR_GPIOD_BASE     (IOPORT_BASE + 0x0C00)
#if BOARDNO == 1
#define TADR_GPIOE_BASE     (IOPORT_BASE + 0x1000)
#endif
#define TADR_GPIOF_BASE     (IOPORT_BASE + 0x1400)
#define TOFF_GPIO_MODER     0x0000		/* (RW) GPIO port mode register */
  #define GPIO_MODER_MODER0  0x1
  #define GPIO_MODER_MODER1  0x2
  #define GPIO_MODER_MODER2  0x3
#define TOFF_GPIO_OTYPER    0x0004		/* (RW) GPIO port output type register */
  #define GPIO_OTYPER_OT     0x1
#define TOFF_GPIO_OSPEEDR   0x0008		/* (RW) GPIO port output speed register */
  #define GPIO_OSPEEDER_OSPEEDR0 0x1
  #define GPIO_OSPEEDER_OSPEEDR1 0x2
  #define GPIO_OSPEEDER_OSPEEDR2 0x3
#define TOFF_GPIO_PUPDR     0x000C		/* (RW) GPIO port pull-up/pull-down register */
  #define GPIO_PUPDR_PUPDR0  0x1
  #define GPIO_PUPDR_PUPDR1  0x2
  #define GPIO_PUPDR_PUPDR2  0x3
#define TOFF_GPIO_IDR       0x0010		/* (R)  GPIO port input data register */
#define TOFF_GPIO_ODR       0x0014		/* (RW) GPIO port output data register */
#define TOFF_GPIO_BSRR      0x0018		/* (RW) GPIO port bit set/reset low register */
#define TOFF_GPIO_LCKR      0x001C		/* (RW) GPIO port configuration lock register */
#define TOFF_GPIO_AFR0      0x0020		/* (RW) GPIO alternate function registers */
#define TOFF_GPIO_AFR1      0x0024		/* (RW) GPIO alternate function registers */
#define TOFF_GPIO_BRR       0x0028		/* (RW) GPIO Bit Reset register */


#endif  /* _STM32G0XX_H_ */

